#!/bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

## Last arg should be a .c or .cpp file.
## It's basename should correspond to the full scoped java Class, 
## with each '.' replaced by '_'
## For instance, for a "foo.bar.MyClass" class, the expected C filename is
## "foo_bar_MyClass.c (or .cpp)"

# save args
ARGS=$*

# shift args until the last argument
shift $(($# -1))

# get last arg which is $1 now
FILENAME=$1

# remove last arg from $ARGS
ARGS=${ARGS%%$FILENAME}




## now convert C filename in expected Java class

# remove path, .c or .cpp extension
CLASSNAME=`basename $FILENAME .c | xargs -iresult basename result .cpp`

# replace '_' with '.'
CLASSNAME=${CLASSNAME//_/.}

echo "Generate JNI header for class $CLASSNAME"
$JAVA_HOME/bin/javah $ARGS $CLASSNAME

