# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

# add flag for traces level
CPPFLAGS += -DCDMW_TRACE_LEVEL=$(CDMW_TRACE_LEVEL)

# add flag for call traces in Cardamom processes (if unset or if disabled, add flag)
ifeq (,$(CDMW_CALL_TRACES))
  CPPFLAGS += -DCDMW_DISABLE_LOG_FUNCTION
endif
ifeq (0,$(CDMW_CALL_TRACES))
  CPPFLAGS += -DCDMW_DISABLE_LOG_FUNCTION
endif

ifeq (1,$(CDMW_CPP_GCOV))
  CPPFLAGS += -fprofile-arcs 
  CPPFLAGS += -ftest-coverage
  
  LDFLAGS += -fprofile-arcs
  LDFLAGS += -DCDMW_USE_GCOV
  LDFLAGS += -lgcov  
endif


## redefine generated headers extentions (this is for "realclean" target)
IDL_CLIENT_HDR_EXT = .stub.hpp
IDL_SERVER_HDR_EXT = .skel.hpp


## Make $ACE_ROOT/include/makeinclude/wrapper_macros.GNU to include an
## alternalte platform_macros.GNU instead of the ACE's one.
## This allows for instance to set "debug=1" even if ACE/TAO is compiled with "debug=0" 
alternate_platform_macros=$(CDMW_HOME)/Build/MPC/makeinclude/platform_macros.GNU



