#!/bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

########################################################################
# Environment variables
########################################################################
if [ -z "$CDMW_HOME" ];then
    echo "Error addcsc.sh : CDMW_HOME is not intialised" 
    exit 1
fi


echo "A new CSC must be created in an existing CSCI. In which CSCI would you like to create your new CSC ?" 

INPUT=none
while [ "$INPUT" = "none" ]; do
    echo -n "> " ; read INPUT
    if [ -z "$INPUT" ]; then
        INPUT=none
    else
        if [ ! -d "$CDMW_HOME/$INPUT" ]; then
            echo "'$INPUT' is not a valid CSCI. Please enter an existing CSCI."
            INPUT=none
        fi
    fi
done

CSCI=$INPUT

echo "Please enter the name of the new CSC (By convention, CSC names are lowercase):"
 
INPUT=none
while [ "$INPUT" = "none" ]; do
    echo -n "> " ; read INPUT
    if [ -z "$INPUT" ]; then
        INPUT=none
    else
        if [ -d "$CDMW_HOME/$CSCI/c++/src/$INPUT" ]; then
            echo "'$INPUT' already exists in $CSCI. Please enter a non existing CSC name."
            INPUT=none
        fi
    
    fi
done

CSC=$INPUT

mkdir $CDMW_HOME/$CSCI/c++/src/$CSC
mkdir $CDMW_HOME/$CSCI/c++/include/$CSCI/$CSC
cp $CDMW_HOME/Build/configuration/data/templates/Template.mpc $CDMW_HOME/$CSCI/c++/src/$CSC
cp $CDMW_HOME/Build/configuration/data/templates/Template_IDL_Compilation.mpc $CDMW_HOME/$CSCI/c++/src/$CSC
cp $CDMW_HOME/Build/configuration/data/templates/Template_CodeGen.mpc $CDMW_HOME/$CSCI/c++/src/$CSC

echo "C++ CSC  \"$CSC\" created in CSCI \"$CSCI\"."
echo "Look in $CDMW_HOME/$CSCI/c++/src/$CSC."

