#!/bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

if [ -z "$CDMW_HOME" ]; then
    echo "ERROR: \$CDMW_HOME must be defined"
    exit 1
fi

echo "Selected package is :"
echo "   [$CDMW_PACKAGES_LIST]"
echo

echo "DEBUG mode is :"
if [ "$CDMW_CPP_DEBUG" = "1" ]
then
   echo "   [activated]"
else
   echo "   [disabled]"
fi   
echo

echo "The optimisation flag is :"
if [ "$CDMW_CPP_OPTIM" = "1" ]
then
   echo "   [set]"
else
   echo "   [unset]"
fi   
echo

echo "The trace level is set to :"
case "$CDMW_TRACE_LEVEL" in
    0) 
      echo "   [0] No trace"
      ;;
    1)
      echo "   [1] Fatal"
      ;;
    2)
      echo "   [2] Error"
      ;;
    3)
      echo "   [3] Warning"
      ;;
    4)
      echo "   [4] Info"
      ;;
    5)
      echo "   [5] Debug"
      ;;
    6)
      echo "   [6] All"
      ;;
esac
echo

echo "The Call-Traces messages are :"
if [ "$CDMW_CALL_TRACES" = "1" ]
then
   echo "   [activated]"
else
   echo "   [disabled]"
fi  
echo

echo "The installation directory is :"
echo "   [$CDMW_INSTALL_DIR]"
echo

echo "The ACE installation directory is :"
echo "   [$ACE_ROOT]"
echo

echo "The TAO installation directory is :"
echo "   [$TAO_ROOT]"
echo

echo "The JAVA installation directory is :"
echo "   [$JAVA_HOME]"
echo

echo "The Ant installation directory is :"
echo "   [$ANT_HOME]"
echo

echo "The JacORB installation directory is :"
echo "   [$JACORB_HOME]"
echo

echo "The CPPUnit installation directory is :"
echo "   [$CPPUNIT_ROOT]"
echo

echo "The JUnit installation directory is :"
echo "   [$JUNIT_HOME]"
echo

echo "The Saxon installation directory is :"
echo "   [$SAXON_HOME]"
echo

echo "The XercesC installation directory is :"
echo "   [$XERCESCROOT]"
echo

