#! /bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

current_date=`date +%e%m%Y_%H%M%S`
result_file=$CDMW_HOME/"unit-tests-results_$current_date.html"
testid=""
lang=""
status=""

gettestid() {
    testid=`basename $1 | sed 's/\.pl//'`
}

gettestlang() {
    grep_str=`echo $1 | grep "c++"`
    if [ "$grep_str" ]; then
	lang="C++"
    else
	lang="JAVA"
    fi
}

getteststatus() {
    result=`dirname $1`"/runtest/"$testid"/results/result.txt"
    if [ ! -f $result ]; then
        status="NOT EXECUTED"
    else
        grep "Test OK" $result 2>&1 >/dev/null
        if [ $? -eq 0 ];then
            status="TEST OK"
        else
            status="TEST FAILED"
        fi
    fi
}

echo "Generating HTML report in ${result_file}..."
cat > $result_file <<_EOF                                                                                                                          
<html>
    <head>
	<title>Results of execution unit tests</title>
    </head>
    <body>
	<p>Results of execution unit tests from `date +%D` `date +%T`</p>
	<table align="left" border="1" width="50%">
	    <tr align="left"><th>TEST</th><th>LANGUAGE</th><th>STATUS</th></tr>
_EOF

while [ $# -ne 0 ];
do
    gettestid $1
    gettestlang $1
    getteststatus $1
    cat >> $result_file <<_EOF
	    <tr>
		<td>
		    <a href="`dirname $1`/runtest/$testid/results/output.txt"">$testid</a>
		</td>
		<td>
		    $lang
		</td>
		<td>
		    <a href="`dirname $1`/runtest/$testid/results">$status</a>
		</td>
	    </tr>
_EOF
    shift
done

cat >> $result_file <<_EOF                                                                                                                          
	</table>
    </body>
</html>
_EOF

