#!/bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

if [ -z "$CDMW_HOME" ]; then
    echo "ERROR: \$CDMW_HOME must be defined"
    exit 1
fi

if [ ! -d "$CDMW_HOME/qualification" ]
then
   mkdir $CDMW_HOME/qualification
fi

inspection_dir=$CDMW_HOME/qualification/inspection
rm -rf ${inspection_dir}
mkdir -p ${inspection_dir}

inspection_test_dir=${inspection_dir}/Q-034-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/CCMContainer/idl/CdmwCcmContainer.idl ${inspection_test_dir}
ln -s $CDMW_HOME/CCMContainer/idl/CdmwCcmCif.idl ${inspection_test_dir}
ln -s $CDMW_HOME/CCMContainer/idl/CdmwCcmComponentServer.idl ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/Q-019-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/Event/idl/CdmwEvent.idl ${inspection_test_dir}
ln -s $CDMW_HOME/Event/c++/src/eventinterface/EventChannelInterface.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/Event/c++/src/eventinterface/TypedEventChannelInterface.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/Event/java/cdmw/event/EventChannelInterface.java ${inspection_test_dir}
ln -s $CDMW_HOME/Event/java/cdmw/event/TypedEventChannelInterface.java ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/Q-051-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/Event/c++/src/eventinterface/EventChannelInterface.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/Event/c++/src/eventsupport/EventChannelFactory_impl_TAOOpenFusion.cpp ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/Q-032-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/idl/FT.idl ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/idl/CdmwFTReplicationManager.idl ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/c++/src/ftmanager/FaultNotifier_impl.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/c++/src/ftmanager/FTManager_impl.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/ProdTests/qualif/share/Q-032-data/Q-032.cfg ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/Q-011-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/src/commonsvcs/naming/NamingInterface.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/java/cdmw/commonsvcs/naming/NamingInterface.java ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/Q-013-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/java/cdmw/orbsupport/CORBASystemExceptionWrapper.java ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/java/cdmw/commonsvcs/naming/InvalidNameException.java ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/java/cdmw/common/Assert.java ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/java/cdmw/common/Exception.java ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/java/cdmw/common/InternalErrorException.java ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/java/cdmw/common/PermissionDeniedException.java ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/java/cdmw/common/AssertionFailedException.java ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/java/cdmw/common/TypeMismatchException.java ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/java/cdmw/common/AlreadyDoneException.java ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/java/cdmw/common/BadParameterException.java ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/java/cdmw/common/BadOrderException.java ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/commonsvcs/naming/InvalidNameException.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/common/Assert.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/common/Exception.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/common/TypeMismatchException.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/osthreads/Thread.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/ProdTests/qualif/share/Q-013-data/Q-013.cfg ${inspection_test_dir}
ln -s $CDMW_HOME/ProdTests/qualif/share/Q-013-data/classes.tag ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/Q-056-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/logging/Logger.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/src/logging/Logger_impl.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/src/logging/FilterMngr.cpp ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/Q-063-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/src/ossupport/OS.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/Time/c++/src/clockservice/Util.cpp ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/Q-081-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/osthreads/Thread.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/osthreads/Mutex.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/osthreads/MutexGuard.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/osthreads/Condition.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/osthreads/ReaderLockGuard.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/osthreads/WriterLockGuard.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/osthreads/ReaderWriterLock.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/osthreads/Barrier.hpp ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/Q-360-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/LoadBalancing/c++/include/LoadBalancing/lbgroupmanager/LBGroupManager_impl.hpp ${inspection_test_dir}


inspection_test_dir=${inspection_dir}/Q-111-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/Time/tests/c++/clockservice/testpolicies/ControllerUpdateAdminTest.cpp ${inspection_test_dir}
