#!/bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

if [ -z "$CDMW_HOME" ]; then
    echo "ERROR: \$CDMW_HOME must be defined"
    exit 1
fi

if [ ! -d "$CDMW_HOME/validation" ]
then
   mkdir $CDMW_HOME/validation
fi

inspection_dir=$CDMW_HOME/validation/inspection
rm -rf ${inspection_dir}
mkdir -p ${inspection_dir}

inspection_test_dir=${inspection_dir}/V-RPS-003-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/Repository/idl/CdmwNamingAndRepository.idl ${inspection_test_dir}
ln -s $CDMW_HOME/Repository/c++/src/namingandrepository/NamingContext_impl.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Repository/c++/src/namingandrepository/NamingContext_impl.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/Repository/c++/src/namingandrepository/BindingIterator_impl.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Repository/c++/src/namingandrepository/BindingIterator_impl.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/Repository/valid/share/V-RPS-003-data/V-RPS-003.cfg ${inspection_test_dir}
ln -s $CDMW_HOME/Repository/valid/share/V-RPS-003-data/classes.tag ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/V--EVT-002-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/Event/idl/CdmwEvent.idl ${inspection_test_dir}
ln -s $CDMW_HOME/Event/java/cdmw/event/EventChannelInterface.java ${inspection_test_dir}
ln -s $CDMW_HOME/Event/java/cdmw/event/TypedEventChannelInterface.java ${inspection_test_dir}
ln -s $CDMW_HOME/Event/c++/src/eventinterface/EventChannelInterface.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/Event/c++/src/eventinterface/TypedEventChannelInterface.cpp ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/V-TRC-019-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/TraceAndPerf/c++/src/recordinglibrary/ObjectMap.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/TraceAndPerf/c++/src/recordinglibrary/PacketStore.cpp ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/V-CMC-001-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/CCMContainer/idl/CdmwCcmContainer.idl ${inspection_test_dir}
ln -s $CDMW_HOME/CCMContainer/idl/CdmwCcmCif.idl ${inspection_test_dir}
ln -s $CDMW_HOME/CCMContainer/idl/CdmwCcmComponentServer.idl ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/V-CMC-003-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/CCMContainer/idl/CdmwCcmContainer.idl ${inspection_test_dir}
ln -s $CDMW_HOME/CCMContainer/idl/CdmwCcmCif.idl ${inspection_test_dir}
ln -s $CDMW_HOME/CCMContainer/idl/CdmwCcmComponentServer.idl ${inspection_test_dir}
ln -s $CDMW_HOME/CCMContainer/valid/share/V-CMC-003-data/V-CMC-003.cfg ${inspection_test_dir}
ln -s $CDMW_HOME/CCMContainer/valid/share/V-CMC-003-data/interfaces.tag ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/V-FDS-003-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/commonsvcs/datastore/DataStoreInterface.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/commonsvcs/datastore/StorageHome.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/commonsvcs/datastore/StorageObject.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/c++/include/Foundation/commonsvcs/datastore/StdMapDataStore.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/valid/share/V-FDS-003-data/DataStoreInterface.cfg ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/valid/share/V-FDS-003-data/StdMapDataStore.cfg ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/valid/share/V-FDS-003-data/StorageHome.cfg ${inspection_test_dir}
ln -s $CDMW_HOME/Foundation/valid/share/V-FDS-003-data/StorageObject.cfg ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/V-FLT-002-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/idl/FT.idl ${inspection_test_dir}/FT.idl
ln -s $CDMW_HOME/FaultTolerance/idl/CdmwFTReplicationManager.idl ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/c++/src/ftmanager/FaultNotifier_impl.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/c++/src/ftmanager/FaultDetector_impl.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/c++/src/ftmanager/FTManager_impl.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/c++/src/ftmanager/SimpleMonitoringObserver_impl.cpp ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/valid/share/V-FLT-002-data/V-FLT-002.cfg ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/V-V-FLT-005-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/c++/include/FaultTolerance/ftstatemanager/DataStore.hpp ${inspection_test_dir}

inspection_test_dir=${inspection_dir}/V-FLT-010-inspected-data
mkdir ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/c++/include/FaultTolerance/ftstatemanager/DataStore.hpp ${inspection_test_dir}
ln -s $CDMW_HOME/FaultTolerance/valid/share/V-FLT-010-data/V-FLT-010.cfg ${inspection_test_dir}
