#!/bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

if [ "$VALGRIND_CHECK" != "1" ] || [ "$1" = "java" ]
then
    eval $*
else
    if [ -n "`expr "$1" : '\(.*\)\.sh'`" ]
    then
        echo '+------------------------------------------------------------+'
        echo 'valgrind can not be run for: $1'
        echo 'Please export the variable:'
        echo 'CDMW_CHECKTEST="valgrind --tool=memcheck --log-file=test.log --show-reachable=yes --leak-check=yes -v '
        echo '                 --gen-suppressions=all'
        echo '                 --suppressions=$CDMW_HOME/Build/testmemory/Valgrind_ignored_warnings.supp'
        echo '                 --suppressions=$CDMW_HOME/Build/testmemory/Valgrind_TAO_DEBUG.supp'
        echo '                 --num-callers=40" '
        echo 'and insert \$CDMW_CHECKTEST before your test executable'
        echo 'Remember to remove it after testcheck session.'
        echo '+------------------------------------------------------------+'
	
	eval $*
	
    else
        echo +------------------------------------------------------------+
        echo valgrind is running on: $1
        echo results can be found in: $1.`date +%y-%m-%d_%Hh%M`.log
        echo +------------------------------------------------------------+
        VALGRIND_VERSION=`valgrind --version`
        if [ "`expr "$VALGRIND_VERSION" : 'valgrind-\(.*\)'`" != "3.3.0" ]
        then
            LOG_FILE_OPTION=--log-file-exactly
        else
            LOG_FILE_OPTION=--log-file
        fi
        
        # In order to also check child process, add "- -trace-children=yes"
        # option below. But as this option slow down child process
        # start-up, it could provoke tests failure.
        # Timescale may have to be increased in such case.
    
        eval valgrind --tool=memcheck $LOG_FILE_OPTION=`pwd`/$1.`date +%y-%m-%d_%Hh%M`.log --show-reachable=yes --leak-check=yes --gen-suppressions=all --suppressions=$CDMW_HOME/Build/testmemory/Valgrind_ignored_warnings.supp --suppressions=$CDMW_HOME/Build/testmemory/Valgrind_TAO_DEBUG.supp --num-callers=40 -v $*
	
    fi
fi
        
