#! /bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

########################################################################
# Environment variables
########################################################################
if [ -z "$CDMW_HOME" ];then
    echo "Error linkgcovfiles.sh : CDMW_HOME is not intialised" 
    exit 1
fi

########################################################################




if [ "$1" = "clean" ]
then
    for i in `find $CDMW_HOME -type f -name '*.gc??'`
    do
        rm -f $i
    done

    for i in `find $CDMW_HOME -type f -name '*.gc??.rn'`
    do
        mv $i ${i:0:`expr ${#i} - 3`}
    done
    
else


    for i in `find $CDMW_HOME -type f -name '*.gc??'`
    do
        mv $i $i.rn
    done
    
    
    for i in `find $CDMW_HOME -type f -name '*.gc??.rn'`
    do
        j=${i:0:`expr ${#i} - 3`}
        namepart1=`expr "$j" : '\(.*\)\.obj.*'`
        namepart2=`expr "$j" : '.*\.obj/\(.*\)'`
        if [ ! -n "$namepart1" ]
        then
            namepart1=`expr "$j" : '\(.*\)\.shobj.*'`
            namepart2=`expr "$j" : '.*\.shobj/\(.*\)'`
        fi
        if [ -f "$namepart1`basename $namepart2`" ]
        then
            rm -f $namepart1`basename $namepart2`
        fi
        ln $i $namepart1`basename $namepart2`
    done
fi
