/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_CCM_CIF_RECEPTACLEDESCRIPTION_IMPL_HPP
#define INCL_CCM_CIF_RECEPTACLEDESCRIPTION_IMPL_HPP


#include <Foundation/idllib/Components.skel.hpp>
#include <CCMContainer/ccmcif/PortDescription_impl.hpp>


namespace {


} // End anonymous space


namespace Cdmw {

namespace CCM {

namespace CIF {

//
// IDL:omg.org/Components/ReceptacleDescription:1.0
//
class ReceptacleDescription_impl : virtual public OBV_Components::ReceptacleDescription,
                                   virtual public PortDescription_impl
{
    ReceptacleDescription_impl(const ReceptacleDescription_impl&);
    void operator=(const ReceptacleDescription_impl&);

public:

    ReceptacleDescription_impl();
    ~ReceptacleDescription_impl();

    virtual CORBA::ValueBase* _copy_value();
};

class ReceptacleDescriptionFactory : virtual public CORBA::ValueFactoryBase
{
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    ReceptacleDescriptionFactory();
    virtual ~ReceptacleDescriptionFactory();
};


} // End namespace CIF

} // End namespace CCM

} // End namespce Cdmw

#endif // INCL_CCM_CIF_RECEPTACLEDESCRIPTION_IMPL_HPP

