/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef ABSTRACTAPPLICATIONELEMENTCONTEXTFACTORY_HPP_
#define ABSTRACTAPPLICATIONELEMENTCONTEXTFACTORY_HPP_

#include <string>
#include <Foundation/orbsupport/CORBA.hpp>
#include "CCMContainer/idllib/CdmwCcmContainer.stub.hpp"

namespace Cdmw
{
namespace CCM
{
namespace Container
{

class AbstractApplicationElementContextFactory
{

public:
    virtual ~AbstractApplicationElementContextFactory()
    {
    }

    virtual CdmwCcmContainer::ApplicationElementContext* create_element_context(
            const std::string& id, CORBA::Object_ptr ref,
            const Components::ConfigValues& configValues) = 0;

    virtual CdmwCcmContainer::ApplicationElementContext* find_element_context_by_id(
            const std::string& id) const = 0;

    virtual void remove_element_context(const std::string& id) = 0;

    virtual void clear() = 0;
};

}
}
}
#endif /* ABSTRACTAPPLICATIONELEMENTCONTEXTFACTORY_HPP_ */
