/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_CCM_COPI_COPICOOKIE_IMPL_HPP_
#define CDMW_CCM_COPI_COPICOOKIE_IMPL_HPP_

#include <sstream>

#include "CCMContainer/idllib/CdmwCcmContainer.stub.hpp"
#include "CCMContainer/ccmcommon/Cookie_impl.hpp"
#include <CCMContainer/ccmcommon/CCMUtils.hpp>

namespace Cdmw
{
namespace CCM
{
namespace COPI
{

class COPICookie_impl: public virtual Cdmw::CCM::Common::Cookie_impl
{
    friend class CookieKey_impl;
    friend class COPIRegistration_impl;

public:
    
    // ctor
    COPICookie_impl(::Components::ContainerPortableInterceptor::ContainerInterceptor_ptr copi);
    
    bool equals(COPICookie_impl * cookie); 


public:
    unsigned long m_id;

private:
    int dummy;
  
    short priority;
    std::string port;
    std::string operation;
};

}}}
#endif /* CDMW_CCM_COPI_COPICOOKIE_IMPL_HPP_ */

