/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_CCM_COPI_COPIMAINORBINITIALIZER_HPP
#define CDMW_CCM_COPI_COPIMAINORBINITIALIZER_HPP

// Cdmw Files
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <Foundation/orbsupport/PortableInterceptor.hpp>


namespace {


} // End anonymous space


namespace Cdmw
{
namespace CCM
{
namespace COPI
{

/**
*Purpose:
*<p>    This class creates ClientRequestInterceptorIterator_impl and ServerRequestInterceptorIterator_impl
*
*/

class COPIMainORBInitializer: virtual public PortableInterceptor::ORBInitializer
{
public:

    /**
     * Purpose:
     * <p> Constructor
     *
     */ 
    COPIMainORBInitializer();

    /**
     * Purpose:
     * <p> Destructor
     * 
     */ 
    ~COPIMainORBInitializer();

    /**
     * Purpose:
     * <p> This operation is called during ORB initialization.
     * 
     */ 
    virtual void
    pre_init(PortableInterceptor::ORBInitInfo_ptr info) 
       throw (CORBA::SystemException);

    
    /**
     * Purpose:
     * <p> This operation is called during ORB initialization.
     *
     * Note: the interceptors are registered in post_init()
     *       if their constructors require
     *       ORBInitInfo::resolve_initial_reference(), which XXX
     *       cannot be called in pre_init().
     *
     */
    virtual void
    post_init(PortableInterceptor::ORBInitInfo_ptr info) 
       throw (CORBA::SystemException);

private:
    COPIMainORBInitializer&  operator = (const COPIMainORBInitializer& other);
    COPIMainORBInitializer(const COPIMainORBInitializer& other);    

};

} // End of namespace COPI
} // End of namespace CCM
} // End of namespace Cdmw

#endif  // CDMW_CCM_COPI_COPIMAINORBINITIALIZER_HPP

