/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_CCM_COPI_COPIUTILS_IMPL_HPP
#define CDMW_CCM_COPI_COPIUTILS_IMPL_HPP


#include <Foundation/idllib/Components.skel.hpp>
#include <Foundation/common/Exception.hpp>
#include <Foundation/ossupport/OS.hpp>


/** TODO: When this class was ported 99% of the Java class was commented out the following
    Comment was left:

    // 2009/04/29 FLE Remove this line and uncomment next one when PCR-2154 is fixed.

    -> need to review this PORTOB
*/




namespace {


} // End anonymous space


namespace Cdmw
{
namespace CCM
{
namespace COPI
{

class COPIUtils_impl {

 
public:
    static
    ::Components::ContainerPortableInterceptor::COPIServiceContext *
    Service_to_copi_context
    (
     const ::IOP::ServiceContext & svc_ctx
     )
        throw(::IOP::Codec::FormatMismatch, ::Cdmw::BadParameterException);

    static 
    ::IOP::ServiceContext * Copi_to_service_context
    (
     ::Components::ContainerPortableInterceptor::COPIServiceContext * copi_ctx
     ) 
        throw(::IOP::Codec::InvalidTypeForEncoding);

    static  
    ::IOP::Codec_ptr Get_codec();
       
    static 
    void Set_codec(::IOP::Codec_ptr codec); 
    
    static 
    int Get_ARG_MODE(const ::CORBA::ParameterMode *& mode);

    static
    std::string Timestamp_to_string
    (
     const Cdmw::OsSupport::OS::Timeval & tv, 
     const char * format
     );

private:
    static ::IOP::Codec_ptr M_codec;
    static const std::string M_ENCODING;
    static const std::string M_item_sep;
    static const std::string M_item_seq_sep;
    static const std::string M_copi_ctx_sep;
    

};


} // End of namespace COPI
} // End of namespace CCM
} // End of namespace Cdmw

#endif // CDMW_CCM_COPI_COPIUTILS_IMPL_HPP

