/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_CCM_COPI_CONTAINEREXTENDEDCOPISREQUESTINFODATA_IMPL_HPP
#define CDMW_CCM_COPI_CONTAINEREXTENDEDCOPISREQUESTINFODATA_IMPL_HPP


#include <Foundation/idllib/Components.skel.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>


namespace {


} // End anonymous space


namespace Cdmw {

namespace CCM {

namespace COPI {

template <typename T>
class ContainerExtendedCopisRequestInfoData_impl
{
public:
        
    // ctor
    ContainerExtendedCopisRequestInfoData_impl 
    (
     const char * operation
     );

    ContainerExtendedCopisRequestInfoData_impl
    (
     ::Dynamic::ParameterList * arguments,
     ::CORBA::Any & result,
     T target,
     ::CORBA::Any & the_exception,
     const char * operation
     );

    // dtor
    virtual ~ContainerExtendedCopisRequestInfoData_impl (void);
  
    virtual
    ::Dynamic::ParameterList * arguments ()
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void arguments (
                    const ::Dynamic::ParameterList & arguments
                    )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    char * operation ()
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    ::CORBA::Any * result ()
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void result (
                 const ::CORBA::Any & result
                 )
        throw (
               ::CORBA::SystemException
               );
       
    virtual
    ::CORBA::Any * the_exception ()
        throw (
               ::CORBA::SystemException
               );

    virtual
    T target();
    
    virtual
    void target(T target);
    
    virtual
    void the_exception (
                        const ::CORBA::Any & the_exception
                        )
        throw (
               ::CORBA::SystemException
               );



    ::CORBA::SystemException *
    get_system_exception_ptr();
    
    void set_system_exception_ptr
    (
     ::CORBA::SystemException * se
     ); 

    void
    throw_system_exception();


private:
    ContainerExtendedCopisRequestInfoData_impl(const ContainerExtendedCopisRequestInfoData_impl&);
    ContainerExtendedCopisRequestInfoData_impl& operator=(const ContainerExtendedCopisRequestInfoData_impl&);

    ::Dynamic::ParameterList_var m_arguments;

    ::CORBA::String_var m_operation;

    ::CORBA::Any m_result;
    
    T m_target;

    ::CORBA::Any m_the_exception;

    // alloc'd using _tao_duplicate()
    ::CORBA::SystemException * m_system_exception_ptr;
};

} // End namespace Cdmw

} // End namespace CCM

} // End namespce COPI

#endif // CDMW_CCM_COPI_CONTAINEREXTENDEDCOPISREQUESTINFODATA_IMPL_HPP
