/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_CCM_COPI_CONTAINERREQUESTINFO_IMPL_HPP
#define CDMW_CCM_COPI_CONTAINERREQUESTINFO_IMPL_HPP


#include <Foundation/idllib/Components.skel.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>


namespace {


} // End anonymous space


namespace Cdmw {

namespace CCM {

namespace COPI {


class  ContainerRequestInfo_impl
  : public virtual Components::ContainerPortableInterceptor::ContainerRequestInfo,
    public virtual OrbSupport::RefCountLocalObject {
public:
        
    // ctor
    ContainerRequestInfo_impl 
    (
     const char * name,
     CORBA::OctetSeq * origin_id,
     CORBA::OctetSeq * target_id
     );

    // dtor
    virtual ~ContainerRequestInfo_impl (void);
  
    virtual
    ::CORBA::OctetSeq * origin_id ()
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    ::CORBA::OctetSeq * target_id ()
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    char * name ()
        throw (
               ::CORBA::SystemException
               );

   /**
    * Non standard setters of the origin_id and target_id
    */
    void set_origin_id(::CORBA::OctetSeq * id);

    void set_target_id(::CORBA::OctetSeq * id);


private:

    CORBA::String_var m_name;
    CORBA::OctetSeq_var m_origin_id;
    CORBA::OctetSeq_var m_target_id;

    ContainerRequestInfo_impl(const ContainerRequestInfo_impl&);
    ContainerRequestInfo_impl& operator=(const ContainerRequestInfo_impl&);


};

} // End namespace Cdmw

} // End namespace CCM

} // End namespce COPI

#endif // CDMW_CCM_COPI_CONTAINERREQUESTINFO_IMPL_HPP
