/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_CCM_COPI_CONTAINERSERVANTREQUEST_IMPL_HPP
#define CDMW_CCM_COPI_CONTAINERSERVANTREQUEST_IMPL_HPP

#include <string>


#include <Foundation/logging/CdmwLogging.stub.hpp>
#include <Foundation/logging/Logger.hpp>
#include <Foundation/orbsupport/PortableInterceptor.hpp>
#include <CCMContainer/ccmcif/Context.hpp>

#include <CCMContainer/idllib/CdmwCcmCopi.stub.hpp>
#include <CCMContainer/ccmcopi/ContainerRequest_impl.hpp>
#include <CCMContainer/ccmcopi/ContainerServantRequestInfo_impl.hpp>
#include <CCMContainer/ccmcopi/ServantContainerInterceptorIterator_impl.hpp>
#include <CCMContainer/ccmcopi/ContainerExtendedCopisRequest_impl.hpp>

namespace {


} // End anonymous space


namespace Cdmw {

namespace CCM {

namespace COPI {


/**
 * represents an outcoming request
 */
class ContainerServantRequest_impl : 
        public virtual ContainerExtendedCopisRequest_impl<ContainerServantRequestInfo_impl>
{

public:


    ContainerServantRequest_impl
    (
     ::Cdmw::CCM::CIF::Context * ctx
    );

    virtual
    ~ContainerServantRequest_impl
    ();

    
    void pre_invoke();

    void post_invoke();

    
protected:
    void pre_invoke_basic_copi();
       
    void pre_invoke_extended_copi();

    void post_invoke_basic_copi();
    
    void post_invoke_extended_copi ();



private:
    ContainerServantRequest_impl(const ContainerServantRequest_impl &);
    ContainerServantRequest_impl & operator=(const ContainerServantRequest_impl &);


    ServantContainerInterceptorIterator_impl * m_servant_copi_iterator;

};


} // End namespace Cdmw

} // End namespace CCM

} // End namespce COPI

#endif // CDMW_CCM_COPI_CONTAINERSERVANTREQUEST_IMPL_HPP



