/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_CCM_COPI_CONTAINERSTUBREQUESTINFO_IMPL_HPP
#define CDMW_CCM_COPI_CONTAINERSTUBREQUESTINFO_IMPL_HPP


#include <Foundation/idllib/Components.skel.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <CCMContainer/ccmcopi/ContainerExtendedCopisRequestInfoData_impl.hpp>
#include <CCMContainer/ccmcopi/ContainerRequestInfo_impl.hpp>

namespace {


} // End anonymous space


namespace Cdmw {

namespace CCM {

namespace COPI {

class  ContainerStubRequestInfo_impl
  : public virtual Components::ContainerPortableInterceptor::ContainerStubRequestInfo,
    public virtual ContainerRequestInfo_impl,
    public virtual OrbSupport::RefCountLocalObject
{
public:
    // Constructor 
    ContainerStubRequestInfo_impl 
    (
     const char * name,
     ::CORBA::OctetSeq * origin_id,
     ::CORBA::OctetSeq * target_id,
     const char * operation
     );
  
    // Destructor 
    virtual 
    ~ContainerStubRequestInfo_impl (void);
      
    virtual
    ::Dynamic::ParameterList * arguments ()
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void arguments (
                    const ::Dynamic::ParameterList & arguments
                    )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    char * operation ()
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    ::CORBA::Any * result ()
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void result (
                 const ::CORBA::Any & result
                 )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    ::CORBA::Object_ptr target ()
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void target (
                 ::CORBA::Object_ptr target
                 )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    ::CORBA::Any * the_exception ()
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void the_exception (
                        const ::CORBA::Any & the_exception
                        )
        throw (
               ::CORBA::SystemException
               );

    ::CORBA::SystemException *
    get_system_exception_ptr();
    
    void set_system_exception_ptr
    (
     ::CORBA::SystemException * se
     ); 

    void
    throw_system_exception();
  
private:
    ContainerStubRequestInfo_impl(const ContainerStubRequestInfo_impl&);
    ContainerStubRequestInfo_impl& operator=(const ContainerStubRequestInfo_impl&);

    ContainerExtendedCopisRequestInfoData_impl < ::CORBA::Object_ptr > m_data;
};


} // End namespace Cdmw

} // End namespace CCM

} // End namespce COPI

#endif // CDMW_CCM_COPI_CONTAINERSTUBREQUESTINFO_IMPL_HPP
