/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_CCM_COPI_PUSHCONTAINERSTUBREQUEST_IMPL_HPP
#define CDMW_CCM_COPI_PUSHCONTAINERSTUBREQUEST_IMPL_HPP

#include <string>


#include <Foundation/logging/CdmwLogging.stub.hpp>
#include <Foundation/logging/Logger.hpp>
#include <Foundation/orbsupport/PortableInterceptor.hpp>
#include <CCMContainer/ccmcif/Context.hpp>

#include <CCMContainer/idllib/CdmwCcmCopi.stub.hpp>
#include <CCMContainer/ccmcopi/ContainerRequest_impl.hpp>
#include <CCMContainer/ccmcopi/ContainerStubRequestInfo_impl.hpp>
#include <CCMContainer/ccmcopi/StubContainerInterceptorIterator_impl.hpp>
#include <CCMContainer/ccmcopi/ContainerStubRequest_impl.hpp>

namespace {


} // End anonymous space


namespace Cdmw {

namespace CCM {

namespace COPI {



/**
 * represents an outcoming request
 */
class PushContainerStubRequest_impl : 
        public virtual ContainerStubRequest_impl {
    
public:    
    
    PushContainerStubRequest_impl
    (
     const char * source_name,
     const char * component_id, 
     ::CosEventComm::PushConsumer_ptr proxy_consumer,
     ::Cdmw::CCM::CIF::Context * ctx
     );


    virtual
    ~PushContainerStubRequest_impl
    ();

    char * operation();

    void push(::CORBA::Any event);

    void add_exception_disconnected(CosEventComm::Disconnected & d);

    void throw_exception() throw (::CORBA::SystemException);

            
private:
    PushContainerStubRequest_impl(const PushContainerStubRequest_impl &);
    PushContainerStubRequest_impl & operator=(const PushContainerStubRequest_impl &);


    ::CORBA::String_var m_source_event_port_name;
    ::CosEventComm::PushConsumer_var m_proxy_consumer;
};



} // End namespace Cdmw

} // End namespace CCM

} // End namespce COPI

#endif // CDMW_CCM_COPI_PUSHCONTAINERSTUBREQUEST_IMPL_HPP
