/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include "ApplicationElementContext_impl.hpp"
#include <string.h>

namespace Cdmw
{
namespace CCM
{
namespace Container
{

ApplicationElementContext_impl::ApplicationElementContext_impl()
{
}

ApplicationElementContext_impl::ApplicationElementContext_impl(const Components::ConfigValues& configuration,
        const std::string& id, CORBA::Object_ptr ref) :
    m_configuration(configuration), m_ref(ref)
{
    m_id = strdup(id.c_str());
}


ApplicationElementContext_impl::~ApplicationElementContext_impl()
{
    free(m_id);
}

Components::ConfigValues* ApplicationElementContext_impl::configuration() throw (::CORBA::SystemException)
{
    return &m_configuration;

}

char* ApplicationElementContext_impl::id() throw (::CORBA::SystemException)
{
    return m_id;
}

CORBA::Object_ptr ApplicationElementContext_impl::ref() throw (::CORBA::SystemException)
{
    return m_ref;
}

void ApplicationElementContext_impl::setConfiguration(const Components::ConfigValues& configuration)
{
    m_configuration = configuration;
}

void ApplicationElementContext_impl::setId(const std::string& id)
{
    free(m_id);
    m_id = strdup(id.c_str());
}

void ApplicationElementContext_impl::setRef(CORBA::Object_ptr ref)
{
    m_ref = ref;
}

}
}
}
