/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef APPLICATIONELEMENTCONTEXT_IMPL_HPP_
#define APPLICATIONELEMENTCONTEXT_IMPL_HPP_

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include "CCMContainer/idllib/CdmwCcmContainer.stub.hpp"

namespace Cdmw
{
namespace CCM
{
namespace Container
{

class ApplicationElementContext_impl: public Cdmw::OrbSupport::RefCountLocalObject, public virtual  CdmwCcmContainer::ApplicationElementContext
{
public:
    /**
     * Ctor
     */
    ApplicationElementContext_impl();

    /**
     * Ctor
     *
     * @param configuration
     * @param id
     * @param ref
     */
    ApplicationElementContext_impl(
            const Components::ConfigValues& configuration,
            const std::string& id, CORBA::Object_ptr ref);

    /**
     * Dtor
     */
    virtual ~ApplicationElementContext_impl();

public:
    virtual Components::ConfigValues* configuration() throw (::CORBA::SystemException);

    virtual char* id() throw (::CORBA::SystemException);

    virtual CORBA::Object_ptr ref() throw (::CORBA::SystemException);

    //public is used here because the "package" visibility that protected offer in java is required
public:
    void setConfiguration(const Components::ConfigValues& configuration);

    void setId(const std::string& id);

    void setRef(CORBA::Object_ptr ref);

private:
    Components::ConfigValues m_configuration;
    char* m_id;
    CORBA::Object_ptr m_ref;
};

}
}
}

#endif /* APPLICATIONELEMENTCONTEXT_IMPL_HPP_ */
