/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef COMPONENTSERVERELEMENTCONTEXT_IMPL_HPP_
#define COMPONENTSERVERELEMENTCONTEXT_IMPL_HPP_

#include "Foundation/orbsupport/CORBA.hpp"
#include "CCMContainer/idllib/CdmwCcmContainer.stub.hpp"
#include "ApplicationElementContext_impl.hpp"


namespace Cdmw
{
namespace CCM
{
namespace Container
{

class ComponentServerElementContext_impl: public virtual CdmwCcmContainer::ComponentServerContext,
                                   public ApplicationElementContext_impl
{
public:
    ComponentServerElementContext_impl(const Components::ConfigValues& configuration, const std::string& id,
            CORBA::Object_ptr ref) :
        ApplicationElementContext_impl(configuration, id, ref)
    {
    }

    virtual ~ComponentServerElementContext_impl()
    {}

    Components::NameList* get_installed_services() throw (::CORBA::SystemException );

    CORBA::Object_ptr ref() throw (CORBA::SystemException);
private:
};

}// End namespace Container
}// End namespace CCM
}// End namespace Cdmw


#endif /* COMPONENTSERVERELEMENTCONTEXT_IMPL_HPP_ */
