/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <CCMContainer/ccmcontainer/ConfigValue_impl.hpp>

namespace Cdmw
{

namespace CCM
{
namespace Container
{

    
ConfigValue_impl::ConfigValue_impl()
{
    CORBA::Any any;
    any <<= CORBA::Short(0);
    name((const char*)"");
    value(any);
}
    
    
ConfigValue_impl::ConfigValue_impl(const char*       the_name,
                                   const CORBA::Any& the_value)
    : OBV_Components::ConfigValue()
{
    CORBA::Any any = the_value;
    name( the_name );
    value( any );
}

CORBA::ValueBase*
ConfigValue_impl::_copy_value()
{
    return new ConfigValue_impl(name(),value());
}

ConfigValue_impl::~ConfigValue_impl()
    throw ()
{
}

CORBA::ValueBase * 
ConfigValueFactory::create_for_unmarshal ()
{
    return new ConfigValue_impl();
}


}; // End namespace Container
}; // End namespace CCM
}; // End namespace Cdmw


