/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef HOMEELEMENTCONTEXT_IMPL_HPP_
#define HOMEELEMENTCONTEXT_IMPL_HPP_

#include <string>
#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/idllib/Components.stub.hpp"
#include "CCMContainer/idllib/CdmwCcmContainer.stub.hpp"
#include "ApplicationElementContext_impl.hpp"

namespace Cdmw
{
namespace CCM
{
namespace Container
{

/**
 *
 */
class HomeElementContext_impl: public ApplicationElementContext_impl, public virtual CdmwCcmContainer::ContainerElementContext
{
public:
    HomeElementContext_impl(const Components::ConfigValues& configuration, const std::string& id, CORBA::Object_ptr ref) :
        ApplicationElementContext_impl(configuration, id, ref)
    {
    }
};

} // end namespace Container
} // end namespace CCM
} // end namespace Cdmw

#endif /* HOMEELEMENTCONTEXT_IMPL_HPP_ */
