/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */



#include "CCMContainer/ccmcopi/COPICookie_impl.hpp"


namespace Cdmw
{
namespace CCM
{
namespace COPI
{

    // ctor
COPICookie_impl::COPICookie_impl(::Components::ContainerPortableInterceptor::ContainerInterceptor_ptr copi):
    Cdmw::CCM::Common::Cookie_impl()
{
    // the address of copi serves as id
    m_id = (unsigned long) copi;
    std::stringstream ostr;

    ostr << m_id;
    CORBA::OctetSeq_var cookie_value = Cdmw::CCM::Common::string_to_OctetSeq(
                                                                             ostr.str().c_str());
    cookieValue(cookie_value.in());

    this->priority = copi->priority();
    if (copi->registration_info() != 0)
        {
            this->port = copi->registration_info()->port;
            this->operation = copi->registration_info()->operation;
        }
    else
        {
            this->port = "";
            this->operation = "";
        }
}

bool COPICookie_impl::equals(COPICookie_impl * cookie) {
    if(m_id == cookie->m_id) {
        return true;
    }

    return false;
}




}}}


