/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

// standard files

// Cdmw Files

// Local Files
#include <CCMContainer/ccmcopi/ContainerRequest_impl.hpp>
#include <CCMContainer/ccmcopi/COPIServiceInit.hpp>


namespace Cdmw
{
namespace CCM
{
namespace COPI
{

// ctor
ContainerRequest_impl::ContainerRequest_impl()
{};


// dtor
ContainerRequest_impl::~ContainerRequest_impl()
{};


bool ContainerRequest_impl::is_read_write() 
{
    return COPIServiceInit::Is_COPI_requests_read_write();
}


void ContainerRequest_impl::add_exception_tc(::CORBA::TypeCode_ptr tc) 
{
    m_exceptions_type_codes.push_back(::CORBA::TypeCode::_duplicate(tc));
}


const ::CORBA::Any * ContainerRequest_impl::get_arg 
(
 const ::Dynamic::ParameterList & arguments,
 unsigned int index
 ) 
{        
    if(index > arguments.length()) {
        return 0; //TODO : throw an exception (NOTE: this is from Java MOSIC)
    }

    return new ::CORBA::Any(arguments[index].argument);
}


} // End of namespace COPI
} // End of namespace CCM
} // End of namespace Cdmw

