/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

// standard files


// Cdmw Files
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/ossupport/OS.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
#include <CCMContainer/ccmcommon/CCMLoggers.hpp>

// Local Files
#include <ccmcopi/ContainerServerRequestInfo_impl.hpp>

namespace 
{
    
} // end of anonymous namespace


namespace Cdmw
{
namespace CCM
{
namespace COPI
{

// Implementation skeleton constructor
ContainerServerRequestInfo_impl::ContainerServerRequestInfo_impl
(
 const char * name, 
 CORBA::OctetSeq * origin_id,
 CORBA::OctetSeq * target_id, 
 ::PortableInterceptor::ServerRequestInfo_ptr info
 ) : ContainerRequestInfo_impl(name, origin_id, target_id),
     m_server_request_info(::PortableInterceptor::ServerRequestInfo::_duplicate(info))
{}


// Implementation skeleton destructor
ContainerServerRequestInfo_impl::~ContainerServerRequestInfo_impl (void)
{
    // empty
}

::PortableInterceptor::ServerRequestInfo_ptr
ContainerServerRequestInfo_impl::request_info ()
    throw (
           ::CORBA::SystemException
           )
{
    CDMW_LOG_FUNCTION(CCMLoggers::Get_ccmcommon_logger(), "");
    return m_server_request_info;
}

} // End of namespace COPI
} // End of namespace CCM
} // End of namespace Cdmw
