/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
#include <CCMContainer/ccmcommon/CCMLoggers.hpp>
#include <CCMContainer/ccmcopi/PushContainerServantRequest_impl.hpp>



namespace {


} // End anonymous space


namespace Cdmw {

namespace CCM {

namespace COPI {

    
PushContainerServantRequest_impl::PushContainerServantRequest_impl
(
 const char * sink_name,
 const char * component_id, 
 ::CORBA::Object_ptr target_object,
 ::Cdmw::CCM::CIF::Context * ctx
 ) : Cdmw::CCM::COPI::ContainerExtendedCopisRequest_impl<Cdmw::CCM::COPI::ContainerServantRequestInfo_impl>(ctx),
     ContainerServantRequest_impl(ctx), 
     m_sink_event_port_name(::CORBA::string_dup(sink_name))
{
    CDMW_LOG_FUNCTION(CCMLoggers::Get_ccmcommon_logger(), "");   
    this->initialise(sink_name, component_id, target_object);
}


PushContainerServantRequest_impl::~PushContainerServantRequest_impl() {
    CDMW_LOG_FUNCTION(CCMLoggers::Get_ccmcommon_logger(), "");
    // empty
}

char * PushContainerServantRequest_impl::operation() {
    CDMW_LOG_FUNCTION(CCMLoggers::Get_ccmcommon_logger(), "");
    return ::CORBA::string_dup("push");
}


void PushContainerServantRequest_impl::throw_exception() {
    CDMW_LOG_FUNCTION(CCMLoggers::Get_ccmcommon_logger(), "");

    ::CORBA::Any_var ex_any = m_request_info->the_exception();
    if(::CORBA::tk_null == ex_any->type()->kind()) {
        return;
    }            
    CDMW_ERROR(CCMLoggers::Get_ccmcommon_logger(), "Failed to send event with " << 
               m_sink_event_port_name << " port");

    ::CORBA::SystemException * e = this->the_systemException();
    if(0 != e) {
        CDMW_LOG_FUNCTION_EXCEPTION(*e);
        e->_raise();
    }            
}
          
} // End namespace Cdmw

} // End namespace CCM

} // End namespce COPI


