/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccm.ccmcopi;

import org.omg.Components.ContainerPortableInterceptor.ContainerInterceptor;

import cdmw.ccm.common.CookieImpl;



/**
 *
 */
public class COPICookieImpl extends CookieImpl {
    
    short priority;
    String port ;
    String operation;
    
    
    public COPICookieImpl (ContainerInterceptor copi){
        this.cookieValue = Integer.toString(copi.hashCode()).getBytes();
        this.priority = copi.priority();
        if(copi.registration_info() != null) {
            this.port = copi.registration_info().port;
            this.operation = copi.registration_info().operation;
        }
        else {
            this.port ="";
            this.operation ="";
        } 
    }
    /**
     * override the base compareTo to apply an order following the priority
     * The order is inverse to the natural order of integers.
     * The highest priority comes first 
     */
    public int compareTo(Object o) {
        COPICookieImpl ck = (COPICookieImpl)o;
        //same priority does not mean equality !
        if(this.priority == ck.priority) return super.compareTo(o);
            else return (-1 * new Integer(priority).compareTo(new Integer(ck.priority))); 
    }
    
    
}
