/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccm.ccmcopi;

import org.omg.CORBA.Any;
import org.omg.CORBA.Object;
import org.omg.Components.ContainerPortableInterceptor.ContainerStubRequestInfo;
import org.omg.Dynamic.Parameter;

/**
 *
 */
public class ContainerStubRequestInfoImpl extends ContainerRequestInfoImpl
        implements ContainerStubRequestInfo {

    private Parameter[] arguments;
    
    private String operation;
    
    private Any result;
    
    private Object target;
    
    private Any the_exception;
    
    

    public ContainerStubRequestInfoImpl(String name, byte[] origin_id,
            byte[] target_id, String operation) {
        super(name, origin_id, target_id);
        this.operation = operation;
    }
    
    public ContainerStubRequestInfoImpl(String name, byte[] origin_id,
            byte[] target_id, Parameter[] arguments, String operation,
            Any result, Object target, Any the_exception) {
        super(name, origin_id, target_id);
        this.arguments = arguments;
        this.operation = operation;
        this.result = result;
        this.target = target;
        this.the_exception = the_exception;
    }


    public Parameter[] arguments() {
        return this.arguments;
    }

 
    public void arguments(Parameter[] param) {
        this.arguments=param;
    }

 
    public String operation() {
        return this.operation;
    }


    public Any result() {
        return this.result;
    }


    public void result(Any res) {
        this.result=res;

    }

 
    public Object target() {
        return this.target;
    }

 
    public void target(Object target) {
        this.target=target;

    }

 
    public Any the_exception() {
        return this.the_exception;
    }


    public void the_exception(Any ex) {
        this.the_exception = ex;
    }

}
