/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccm.ccmcopi;


import static cdmw.logging.FunctionLogger.CDMW_LOG_FUNCTION;
import static cdmw.logging.FunctionLogger.CDMW_LOG_FUNCTION_EXCEPTION;
import static cdmw.logging.FunctionLogger.CDMW_LOG_FUNCTION_RETURN;
import static cdmw.logging.Logger.CDMW_ERROR;

import org.omg.CORBA.Object;

import cdmw.ccm.cif.Context;

/**
 *
 */
public class PushContainerServantRequest extends ContainerServantRequest {

    private String sinkEventPortName;
    
    public PushContainerServantRequest(String sink_name, String component_id,
            Object target_object, Context ctx) {
        super(sink_name, component_id, target_object, ctx);
        CDMW_LOG_FUNCTION(logger, "");
        sinkEventPortName = sink_name;
        CDMW_LOG_FUNCTION_RETURN(logger);
    }

    public String operation() {
        return "push";
    }
    
    public void throw_exception() throws org.omg.CORBA.SystemException {
        CDMW_LOG_FUNCTION(logger, "");
        if (this.the_exception() == null)
            return;
        CDMW_ERROR(logger, "Failed to deliver event to the "
                + this.sinkEventPortName + " port");
        org.omg.CORBA.SystemException e = this.the_systemException();
        CDMW_LOG_FUNCTION_EXCEPTION(logger, e);
        throw e;

    }

}
