/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccm.container;

import org.omg.CORBA.Object;
import org.omg.Components.CCMException;
import org.omg.Components.ConfigValue;
import org.omg.Components.Deployment.ComponentServer;
import org.omg.Components.Deployment.ComponentServerHelper;

import cdmw.ccm.common.CCMId;
import cdmw.ccm.common.CCMLoggers;
import cdmw.ccm.componentserver.ComponentServerImpl;
import cdmw.orbsupport.ExceptionMinorCodes;

import com.thalesgroup.CdmwCcmContainer.ComponentServerContext;
import static cdmw.logging.Logger.*;
import static cdmw.logging.FunctionLogger.*;

/**
 *
 */
public class ComponentServerElementContextImpl extends
        ApplicationElementContextImpl implements ComponentServerContext {


    public ComponentServerElementContextImpl (ConfigValue[] configuration,
            String id, Object ref){
        super(configuration, id, ref);
    }
    
    public String[] get_installed_services() {
        return ServiceRegistry.getInstance().list();
    }
    
    public Object ref(){
        ComponentServer csRef =null;
        try {
            Object obj = ServiceRegistry.getInstance().
                lookup(CCMId.componentServerRefServiceProvider);
            csRef = ComponentServerHelper.narrow(obj);
        }
        catch (CCMException e) {
            CDMW_ERROR(CCMLoggers.GetCcmcontainerLogger(), "Failed to retrieve the ComponentServer reference");
        }
        finally{
            if(csRef == null) {
                org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
                        ExceptionMinorCodes.INTERNAL, 
                        org.omg.CORBA.CompletionStatus.COMPLETED_YES);
                throw ex;
            }
        }
        
        return csRef;
    }

}
