/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccm.qosenablers.requestfollowup;

import org.omg.Components.CCMException;
import org.omg.Components.EnterpriseComponent;
import org.omg.Components.HomeExecutorBase;

import cdmw.commonsvcs.requestfollowup.NDCLogger;
import cdmw.ccm.qosenablers.common.QOSEnablerHomeBase;

import static cdmw.logging.FunctionLogger.*;
import static cdmw.logging.Logger.*;

/**
 * This class implements the QOSEnablerHomeBase class
 */
public class ExtendedNDCExecutorHomeImpl 
    extends QOSEnablerHomeBase
{
    public EnterpriseComponent create() throws CCMException {
        // CDMW_LOG_FUNCTION(NDCLogger.getInstance().getLogger(),"");
        System.out.println("ExtendedNDCExecutorHomeImpl.create called");
        return new ExtendedNDCExecutorImpl();
    }
    
    public static HomeExecutorBase createHomeImpl() {
        // CDMW_LOG_FUNCTION(NDCLogger.getInstance().getLogger(),"");
        System.out.println("ExtendedNDCExecutorHomeImpl.createHomeImpl called");
        return new ExtendedNDCExecutorHomeImpl();
    }
}
