/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "testccmcif/Event_impl.hpp"

// Enty points

extern "C" {
    
    CORBA::ValueFactoryBase* createEventFactory () {
        return new BasicDemo::EventFactory();
    }
};



// Constructor
BasicDemo::Event_impl::Event_impl ()
{
}

// Copy Constructor
BasicDemo::Event_impl::Event_impl (const Event_impl& right)
    {
        text(right.text());
    }

    // Destructor
    BasicDemo::Event_impl::~Event_impl ()
    {
    }

    CORBA::ValueBase* 
    BasicDemo::Event_impl::_copy_value()
    {
        BasicDemo::Event_impl* result = new Event_impl();
        result->text(text());
        
        return result;
    }

    /******************************/
    /*         Factory            */
    /******************************/


    BasicDemo::EventFactory::EventFactory()
    {
    }
    
    BasicDemo::EventFactory::~EventFactory()
    {
    }

    CORBA::ValueBase * 
    BasicDemo::EventFactory::create_for_unmarshal ()
    {
        return new BasicDemo::Event_impl();
    }

