/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_TEST_FT_CCM_CIF_TESTTHREAD_HPP 
#define INCL_TEST_FT_CCM_CIF_TESTTHREAD_HPP 

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/osthreads/ThreadHandle.hpp>
#include <Foundation/idllib/Components.stub.hpp>
#include <FaultTolerance/idllib/FT.stub.hpp>

namespace TestFtCcmCif
{


class TestThread : public Cdmw::OsSupport::Thread 
{
public:
    TestThread(CORBA::ORB_ptr orb, CosNaming::NamingContext_ptr nc)
        throw (CORBA::SystemException);

    virtual ~TestThread()
        throw ();
        
protected:
    void run() 
        throw();
    
private:
    
    TestThread();
    TestThread(const TestThread&);
    TestThread& operator = (const TestThread&);
    
    CORBA::ORB_var m_orb;
    CosNaming::NamingContext_var  m_nc;

};


}; // End namespace 

#endif // INCL_TEST_FT_CCM_CIF_TESTTHREAD_HPP 

