/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <Foundation/osthreads/Condition.hpp>
#include <Foundation/osthreads/MutexGuard.hpp>
#include <Foundation/ossupport/OS.hpp>
#include <Foundation/orbsupport/OrbSupport.hpp>
#include <Foundation/idllib/Components.skel.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>

#include <Foundation/idllib/Components.skel.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>

#ifndef CDMW_CCM_COPI_CHANGEMSGONSERVANTRECVREQ_COPI_IMPL
#define CDMW_CCM_COPI_CHANGEMSGONSERVANTRECVREQ_COPI_IMPL

namespace {


} // End anonymous space


namespace Cdmw {

namespace CCM {

namespace COPI {


class  ChangeMsgOnServantRecvReqCOPI_impl
  : public virtual Components::ContainerPortableInterceptor::ServantContainerInterceptor,
    public virtual TAO_Local_RefCounted_Object
{

public:
    // Constructor 
    ChangeMsgOnServantRecvReqCOPI_impl
    (
     const std::string & name,
     OsSupport::Condition * cond,
     OsSupport::Mutex * lock
     );

  
    // Destructor 
    virtual ~ChangeMsgOnServantRecvReqCOPI_impl (void);
  
    virtual
    void servant_receive_request (
                                  ::Components::ContainerPortableInterceptor::ContainerServantRequestInfo_ptr info,
                                  ::CORBA::Boolean_out proceed_call
                                  )
        throw (
               ::CORBA::SystemException,
               ::PortableInterceptor::ForwardRequest
               );
  
    virtual
    void servant_send_reply (
                             ::Components::ContainerPortableInterceptor::ContainerServantRequestInfo_ptr info,
                             ::CORBA::Boolean_out proceed_call
                             )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void servant_send_exception (
                                 ::Components::ContainerPortableInterceptor::ContainerServantRequestInfo_ptr info,
                                 ::CORBA::Boolean_out proceed_call
                                 )
        throw (
               ::CORBA::SystemException,
               ::PortableInterceptor::ForwardRequest
               );
  
    virtual
    void servant_send_other (
                             ::Components::ContainerPortableInterceptor::ContainerServantRequestInfo_ptr info
                             )
        throw (
               ::CORBA::SystemException,
               ::PortableInterceptor::ForwardRequest
               );
  
    virtual
    char * name (
      
    )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    ::CORBA::UShort priority (
      
    )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    ::Components::ContainerPortableInterceptor::IntegrationPoint * registration_info (
      
    )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void destroy (
      
    )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void set_slot_id (
                      ::PortableInterceptor::SlotId slot_id
                      )
        throw (
               ::CORBA::SystemException
               );

private:
    ChangeMsgOnServantRecvReqCOPI_impl& operator=(const ChangeMsgOnServantRecvReqCOPI_impl & other);
    ChangeMsgOnServantRecvReqCOPI_impl(const ChangeMsgOnServantRecvReqCOPI_impl & other);

    std::string get_header();     
    std::string m_copi_name;

    OsSupport::Condition * m_cond;
    OsSupport::Mutex * m_lock;

public:
    bool m_failed; 

};

} // End namespace CIF

} // End namespace CCM

} // End namespce COPI

#endif // CDMW_CCM_COPI_CHANGEMSGONSERVANTRECVREQ_COPI_IMPL
