/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef ECHOSERVANT_REQUEST_IMPL_HPP
#define ECHOSERVANT_REQUEST_IMPL_HPP

#include <map>
#include <CCMContainer/ccmcopi/ContainerServantRequest_impl.hpp>


namespace {


} // End anonymous space


namespace Cdmw {
    
namespace CCM {

namespace CIF {

namespace CdmwTestComponents {




class EchoServantRequest_impl : public virtual ::Cdmw::CCM::COPI::ContainerServantRequest_impl {

public:

    // MOSIC Java ctor has ctx as arg this is not used though
    EchoServantRequest_impl 
    (
     const char *  receptacle_name, 
     const char *  component_id,
     ::CORBA::Object_ptr facet_object,
     ::Cdmw::CCM::CIF::Context * ctx  
     );

    ~EchoServantRequest_impl();

    char * operation();

    void add_in_args_msg(const char * msg);
    
    char * get_in_args_msg();

    void 
    throw_exception();


private:
    ::std::map< ::std::string, int > m_arguments_indices;
    
    int m_index;
    
};

} // End namespace CIF

} // End namespace CCM

} // End namespce COPI

}


#endif /* ECHOSERVANT_REQUEST_IMPL_HPP  */
