/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include <Foundation/idllib/Components.skel.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>


#ifndef CDMW_CCM_COPI_EMPTYCOPIS_IMPL_HPP
#define CDMW_CCM_COPI_EMPTYCOPIS_IMPL_HPP

namespace {


} // End anonymous space


namespace Cdmw {

namespace CCM {

namespace COPI {

class  DummyClientContainerInterceptor_impl
  : public virtual Components::ContainerPortableInterceptor::ClientContainerInterceptor,
    public virtual TAO_Local_RefCounted_Object
{
public:
  // Constructor 

   DummyClientContainerInterceptor_impl(std::string name);
   DummyClientContainerInterceptor_impl(std::string name, short p, std::string port, std::string operation);
  
  // Destructor 
  virtual ~DummyClientContainerInterceptor_impl (void);
  
  virtual
  void send_request (
      ::Components::ContainerPortableInterceptor::ContainerClientRequestInfo_ptr info
    )
    throw (
      ::CORBA::SystemException,
      ::PortableInterceptor::ForwardRequest
    );
  
  virtual
  void send_poll (
      ::Components::ContainerPortableInterceptor::ContainerClientRequestInfo_ptr info
    )
    throw (
      ::CORBA::SystemException
    );
  
  virtual
  void receive_reply (
      ::Components::ContainerPortableInterceptor::ContainerClientRequestInfo_ptr info
    )
    throw (
      ::CORBA::SystemException
    );
  
  virtual
  void receive_exception (
      ::Components::ContainerPortableInterceptor::ContainerClientRequestInfo_ptr info
    )
    throw (
      ::CORBA::SystemException,
      ::PortableInterceptor::ForwardRequest
    );
  
  virtual
  void receive_other (
      ::Components::ContainerPortableInterceptor::ContainerClientRequestInfo_ptr info
    )
    throw (
      ::CORBA::SystemException,
      ::PortableInterceptor::ForwardRequest
    );
  
  virtual
  char * name (
      
    )
    throw (
      ::CORBA::SystemException
    );
  
  virtual
  ::CORBA::UShort priority (
      
    )
    throw (
      ::CORBA::SystemException
    );
  
  virtual
  ::Components::ContainerPortableInterceptor::IntegrationPoint * registration_info (
      
    )
    throw (
      ::CORBA::SystemException
    );
  
  virtual
  void destroy (
      
    )
    throw (
      ::CORBA::SystemException
    );
  
  virtual
  void set_slot_id (
      ::PortableInterceptor::SlotId slot_id
    )
    throw (
      ::CORBA::SystemException
    );

private:
    std::string m_COPIname;
    short m_priority;
    std::string  m_port;
    std::string  m_operation;
};


} // End namespace CIF

} // End namespace CCM

} // End namespce COPI

#endif // CDMW_CCM_COPI_EMPTYCOPIS_IMPL_HPP

