/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */



///// FILE TO BE GENERATED


#ifndef __INCL_CCMCIF_FACETHELLO_HPP__
#define __INCL_CCMCIF_FACETHELLO_HPP__

#include "Cdmw_TestComponents_cif.skel.hpp"
#include "generated/testccmcopi/Hello_impl.hpp"    

   
#include <Foundation/orbsupport/RefCountServantBase.hpp>
#include <Foundation/logging/CdmwLogging.stub.hpp>
#include <CCMContainer/ccmcif/LifeCycleObjectBase.hpp>
#include <CCMContainer/ccmcopi/ContainerStubRequest_impl.hpp>
   

   
namespace Cdmw {

namespace CCM {

namespace CIF {


   // Forward declaration
   class CCMObject_impl;

   
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF


namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwHelloModule {


class FacetHello_impl : 
        virtual public ::Cdmw::CCM::CIF::CdmwHelloModule::Hello_impl,
        virtual public LifeCycleObjectBase,
        virtual public OrbSupport::RefCountServantBase
{
public:
    FacetHello_impl
    (
     Components::ExecutorLocator_ptr exec_locator, 
     const std::string& name,
     Context * ctx,
     CORBA::Object_ptr           comp_ref,
     PortableServer::Servant     component,
     CdmwLogging::Logger_ptr     logger,
     const std::string& comp_id
     );

    ~FacetHello_impl() throw();
                 
         
    virtual void
    echo
    (                 
     const char * msg
     )
        throw (                              
               CORBA::SystemException
               );
             

private:
    FacetHello_impl(const FacetHello_impl&);
    void operator=(const FacetHello_impl&);

    Components::ExecutorLocator_var m_exec_loc;
    
    // m_facet_name private in superclass
    const std::string m_facet_name;

    void before_throw
    (
     Cdmw::CCM::COPI::ContainerStubRequest_impl * request,
     ::CORBA::Object_ptr obj
     );

    ::Cdmw::CCM::CIF::Context * m_context;    
    
    const ::std::string  m_component_identity;    
    CdmwLogging::Logger_var m_logger;

};

   
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestComponents

#endif // __INCL_CCMCIF_FACETHELLO_HPP__
