/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */



#include "HelloExecuter_impl.hpp"
#include <iostream>


namespace HelloModule {


    // Constructor
    HelloExecuter_impl::HelloExecuter_impl (void) : m_received_value(0),  m_throw_on_echo(false)
    {
    }
    

    // Destructor
    HelloExecuter_impl::~HelloExecuter_impl (void)
    {
        // empty
    }

  
    void HelloExecuter_impl::echo (
                                   const char * msg
                                   )
        throw (
               ::CORBA::SystemException
               ) {

        std::cout << "m_throw_on_echo" << m_throw_on_echo  << std::endl;
        if(m_throw_on_echo) {
            std::cout << "throwing ::CORBA::BAD_OPERATION" << std::endl;

            throw ::CORBA::BAD_OPERATION();
        }

        std::cout << "HelloExecuter_impl::echo() received [" << msg << "]" << std::endl;
        if(m_received_value) {
            free(m_received_value);
        }

        m_received_value = strdup(msg);
    }





} // end of namespace CdmwTestComponents

