/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */



#ifndef INCL_CCM_COPI_HELLOEXECUTER_HPP
#define INCL_CCM_COPI_HELLOEXECUTER_HPP

#include "hello_cif.skel.hpp"

namespace HelloModule {



class  HelloExecuter_impl
    : public virtual HelloModule::CCM_Hello
//    public virtual TAO_Local_RefCounted_Object
{
public:
    // Constructor
    HelloExecuter_impl (void);

    // Destructor
    virtual ~HelloExecuter_impl (void);

  virtual
  void echo (
      const char * msg
      )
      throw (
                       ::CORBA::SystemException
                       );

    // non idl ops

    virtual const char * get_received_value() {
        return m_received_value;
                          
    }

    virtual const void throw_on_echo(bool b) {
        m_throw_on_echo = b;
    }

private:
    char * m_received_value;
    bool m_throw_on_echo;

};


}

#endif // INCL_CCM_COPI_HELLOEXECUTER_HPP

