/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "MyCCMObject_impl.hpp"

namespace Cdmw {

namespace CCM {

namespace COPI {


// Implementation skeleton constructor
    MyCCMObject_impl::MyCCMObject_impl 
        (
         const std::string& comp_oid,
         Cdmw::CCM::CIF::Context *          ctx,
         const std::string& rep_id,
         CORBA::Object_ptr  comp_ref,
         CdmwLifeCycle::ObjectRegistration_ptr object_registration,
         CdmwLogging::LoggerFactory_ptr logger_factory,
         CosEventComm::PushConsumer_ptr consumer
        ) :
            Cdmw::CCM::CIF::CCMObject_impl(comp_oid, ctx, rep_id, comp_ref, object_registration, logger_factory),
            m_consumer(CosEventComm::PushConsumer::_duplicate(consumer))
{
}

// Implementation skeleton destructor
MyCCMObject_impl::~MyCCMObject_impl (void)
{
}


CosEventComm::PushConsumer_ptr
MyCCMObject_impl::get_proxy_consumer(const std::string& source_name)
    throw (CORBA::SystemException)
{
    return CosEventComm::PushConsumer::_duplicate(m_consumer.in());
}


};
};
};
