/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_CCM_COPI_MY_CCMOBJECT_HPP
#define CDMW_CCM_COPI_MY_CCMOBJECT_HPP

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/idllib/CdmwDeployment.skel.hpp>
#include <Foundation/orbsupport/RefCountServantBase.hpp>
#include <CCMContainer/ccmcif/CCMObject_impl.hpp>


namespace Cdmw {

namespace CCM {

namespace COPI {





class  MyCCMObject_impl
    : public virtual Cdmw::CCM::CIF::CCMObject_impl
{
public:
    // Constructor 
    MyCCMObject_impl 
    (
     const std::string& comp_oid,
     Cdmw::CCM::CIF::Context*  ctx,
     const std::string& rep_id,
     CORBA::Object_ptr  comp_ref,
     CdmwLifeCycle::ObjectRegistration_ptr object_registration,
     CdmwLogging::LoggerFactory_ptr logger_factory,
     CosEventComm::PushConsumer_ptr consumer
     );

    
  
    // Destructor 
    virtual ~MyCCMObject_impl (void);

    virtual void ccm_activate() throw (Components::CCMException, CORBA::SystemException) {};

    virtual void ccm_passivate() throw (Components::CCMException, CORBA::SystemException) {};

    virtual void ccm_remove() throw (Components::CCMException, CORBA::SystemException) {};

    virtual void advise_executor_of_remove_component() throw (CORBA::SystemException) {};    

    virtual PortableServer::ServantBase* get_facet_servant(const std::string&) throw (CORBA::SystemException) {return 0;};

    virtual
    CosEventComm::PushConsumer_ptr
    get_proxy_consumer(const std::string& source_name)
        throw (CORBA::SystemException);

    CosEventComm::PushConsumer_var m_consumer;
};

}; // End namespace ComponentServer
}; // End namespace CCM
}; // End namespace Cdmw

#endif // CDMW_CCM_COPI_MY_CCMOBJECT_HPP

