/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef CDMW_CCM_COMPONENT_MY_COMPONENT_INSTALLATION_HPP
#define CDMW_CCM_COMPONENT_MY_COMPONENT_INSTALLATION_HPP

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/idllib/CdmwDeployment.skel.hpp>
#include <Foundation/orbsupport/RefCountServantBase.hpp>

namespace Cdmw {

namespace CCM {

namespace COPI {

class  MyComponentInstallation_impl
    : public virtual POA_CdmwDeployment::ComponentInstallation,
      public Cdmw::OrbSupport::RefCountServantBase
{
public:
    // Constructor
    MyComponentInstallation_impl (::PortableServer::POA_ptr poa);

    // Destructor
    virtual ~MyComponentInstallation_impl (void);

    ::PortableServer::POA_ptr _default_POA();

    virtual
    char * get_valuetypefactory_location (
                                          const char * implUUID,
                                          const char * repid
                                          )
        throw (
               ::CORBA::SystemException,
               ::Components::Deployment::UnknownImplId,
               ::CdmwDeployment::UnknownValuetype,
               ::Components::Deployment::InstallationFailure
               );

    virtual
    void install (
                  const char * implUUID,
                  const char * component_loc
                  )
        throw (
               ::CORBA::SystemException,
               ::Components::Deployment::InvalidLocation,
               ::Components::Deployment::InstallationFailure
               );

    virtual
    void replace (
                  const char * implUUID,
                  const char * component_loc
                  )
        throw (
               ::CORBA::SystemException,
               ::Components::Deployment::InvalidLocation,
               ::Components::Deployment::InstallationFailure
               );

    virtual
    void remove (
                 const char * implUUID
                 )
        throw (
               ::CORBA::SystemException,
               ::Components::Deployment::UnknownImplId,
               ::Components::RemoveFailure
               );

    virtual
    char * get_implementation (
                               const char * implUUID
                               )
        throw (
               ::CORBA::SystemException,
               ::Components::Deployment::UnknownImplId,
               ::Components::Deployment::InstallationFailure
               );

private:
    ::PortableServer::POA_var m_poa;

};

}; // End namespace ComponentServer
}; // End namespace CCM
}; // End namespace Cdmw

#endif // CDMW_CCM_COMPONENT_MY_COMPONENT_INSTALLATION_HPP
