/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include "MyExecuterLocator_impl.hpp"
#include "HelloExecuter_impl.hpp"


namespace Cdmw {

namespace CCM {

namespace COPI {



// Implementation skeleton constructor
    MyExecuterLocator_impl::MyExecuterLocator_impl (void) : m_executer_hello(0), m_executer_client(0)
{
}

// Implementation skeleton destructor
MyExecuterLocator_impl::~MyExecuterLocator_impl (void)
{
    // empty
}

::CORBA::Object_ptr MyExecuterLocator_impl::obtain_executor (
    const char * name
    )
    throw (
                     ::CORBA::SystemException,
                     ::Components::CCMException
                     )
{
    if(0 == strcmp(name , "ServerInfoConsumer_sink_name")) {
        if(m_executer_client) {
            return m_executer_client;
        } else {
            m_executer_client = new ::MyCCM_ClientExecuter_impl();
            return this->m_executer_client;
        }
    }

    if(m_executer_hello) {
        return m_executer_hello;
    } else {
        m_executer_hello =
            new HelloModule::HelloExecuter_impl();
    }

    return m_executer_hello;
}

void MyExecuterLocator_impl::release_executor (
                                                     ::CORBA::Object_ptr exc
                                                     )
    throw (
                     ::CORBA::SystemException,
                     ::Components::CCMException
                     )
{
    if(m_executer_client) {
        m_executer_client->_remove_ref();
    }
    m_executer_client = 0;
}

void MyExecuterLocator_impl::configuration_complete (

  )
    throw (
                     ::CORBA::SystemException,
                     ::Components::InvalidConfiguration
                     )
{
    // empty
}


}
}
}
