/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_CCM_COPI_MYEXECUTERLOCATOR_HPP
#define INCL_CCM_COPI_MYEXECUTERLOCATOR_HPP

#include <Foundation/common/Assert.hpp>
#include <CCMContainer/idllib/CdmwCcmContainer.stub.hpp>
#include <Foundation/common/NotFoundException.hpp>
#include <CCMContainer/ccmcontainer/ConfigValue_impl.hpp>
#include <Foundation/common/AlreadyExistException.hpp>
#include <CCMContainer/idllib/CdmwCcmCif.stub.hpp>
#include "MyCCM_ClientExecuter_impl.hpp"
#include <map>

#include "HelloExecuter_impl.hpp"



namespace Cdmw {

namespace CCM {

namespace COPI {

class  MyExecuterLocator_impl
    : public virtual Components::ExecutorLocator,
    public virtual TAO_Local_RefCounted_Object
{
public:
    // Constructor
    MyExecuterLocator_impl (void);

    // Destructor
    virtual ~MyExecuterLocator_impl (void);

    virtual
    ::CORBA::Object_ptr obtain_executor (
                                         const char * name
                                         )
        throw (
               ::CORBA::SystemException,
               ::Components::CCMException
               );

    virtual
    void release_executor (
                           ::CORBA::Object_ptr exc
                           )
        throw (
               ::CORBA::SystemException,
               ::Components::CCMException
               );

    virtual
    void configuration_complete (

    )
        throw (
               ::CORBA::SystemException,
               ::Components::InvalidConfiguration
               );


    HelloModule::HelloExecuter_impl * get_executer() {
        return m_executer_hello;
    }

private:
     HelloModule::HelloExecuter_impl * m_executer_hello;
     ::MyCCM_ClientExecuter_impl * m_executer_client;
    
};

}
}
}

#endif // INCL_CCM_COPI_MYEXECUTERLOCATOR_HPP

