/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */



///// FILE TO BE GENERATED


#ifndef __INCL_CCMCIF_RECEPTACLE_HELLO_HPP__
#define __INCL_CCMCIF_RECEPTACLE_HELLO_HPP__

#include "Cdmw_TestComponents_cif.skel.hpp"
#include "generated/testccmcopi/Hello_impl.hpp"    

   
#include <Foundation/orbsupport/RefCountServantBase.hpp>
#include <Foundation/logging/CdmwLogging.stub.hpp>
#include <CCMContainer/ccmcif/LifeCycleObjectBase.hpp>

#include "generated/testccmcopi/hello_cif.stub.hpp"
   

namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwHelloModule {


class ReceptacleHello_impl : 
        virtual public ::HelloModule::CCM_Hello
        //virtual public OrbSupport::RefCountServantBase
{
public:

    ReceptacleHello_impl
    (
     const ::std::string & receptacle_name,
     const ::std::string & component_id,
     ::CORBA::Object_ptr facet_object,
     ::Cdmw::CCM::CIF::Context * context,
     CdmwLogging::Logger_ptr     logger
     );
    
    ~ReceptacleHello_impl() throw();
                        
    virtual void
    echo
    (                 
     const char * msg
     )
        throw (                              
               CORBA::SystemException
               );
             

private:
    ReceptacleHello_impl(const ReceptacleHello_impl&);
    void operator=(const ReceptacleHello_impl&);

    const std::string m_receptacle_name;    
    const std::string m_component_identity;
    ::CORBA::Object_var m_facet_object;
    ::Cdmw::CCM::CIF::Context * m_context;   
    ::CdmwLogging::Logger_ptr m_logger;
};

   
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestComponents

#endif // __INCL_CCMCIF_RECEPTACLE_HELLO_HPP__
