/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_CDMW_CCM_COPI_TESTCOPI_EVENT_COPI_IMPL_HPP
#define INCL_CDMW_CCM_COPI_TESTCOPI_EVENT_COPI_IMPL_HPP

#include "ace/UUID.h"

#include "Foundation/testutils/CORBATestManager.hpp"

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/CosNaming.stub.hpp"
#include "Cdmw_TestComponents_cif.skel.hpp"


namespace Cdmw {

namespace CCM {

namespace COPI {

class ServerInfo_impl : 
        virtual public OBV_TestComponents::ServerInfo,
        virtual public CORBA::DefaultValueRefCountBase
{
public:
    ServerInfo_impl() {};

    ServerInfo_impl(const ServerInfo_impl & right) 
    {
        data(right.data());
    }

    ~ServerInfo_impl() {};

    
    virtual CORBA::ValueBase * _copy_value() {
        ServerInfo_impl * result = new ServerInfo_impl();
        result->data(data());

        return result;
    }

};


/**
*Purpose:
*<p>    [class description]
*
*Features:
*<p> [Thread safety, exception safety, performance]
*    [if no pertinent write none ]
*
*@see  [if necessary] 
*@link [if necessary] 
*
*/
class TestCopi_Event_impl : public CppUnit::TestFixture
{
   public:

      /**
       * Purpose:
       * <p> [Constructor description if necessary]
       * 
       *@param
       *@exception
       */ 
      TestCopi_Event_impl()
         throw();

      /**
       * Purpose:
       * <p>  [Copy constructor description if necessary]
       * 
       *@param
       *@exception
       */ 
      TestCopi_Event_impl(const TestCopi_Event_impl& rfu)
         throw();


      /**
       * Purpose:
       * <p> [ Destructor description if necessary]
       * 
       */ 
      virtual 
      ~TestCopi_Event_impl()
         throw();


      /**
       * Purpose:
       * <p> [ Assignement operator description if necessary]
       * 
       *@param
       *@return
       *@exception
       */ 
      TestCopi_Event_impl&
      operator=(const TestCopi_Event_impl& rfu)
         throw();


      /**
       * Purpose:
       * <p>
       * 
       *@param
       *@return
       *@exception
       */ 


      /**
       *[Attribute description]
       */ 


   protected:
      void test0 ();

   private:

CPPUNIT_TEST_SUITE( TestCopi_Event_impl );
CPPUNIT_TEST( test0 );
CPPUNIT_TEST_SUITE_END();

}; // End class TestCopi_Event_impl 

} // End namespace COPI
} // End namespace CCM
} // End namespace Cdmw


#endif // INCL_CDMW_CCM_COPI_TESTCOPI_EVENT_COPI_IMPL_HPP
