
/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/* =========================================================================== * 
 * This code has been generated by CDMW Code Generator 1.0
 * on Thu Jul 23 18:02:12 CEST 2009
 * DO NOT EDIT !!!
 * =========================================================================== */


   

   
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/Codec.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <CCMContainer/ccmcommon/CCMLoggers.hpp>
   
   #include "CCM_Client_SessionContext_impl.hpp"

   
  
namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwTestComponents {

CCM_Client_SessionContext_impl::CCM_Client_SessionContext_impl

         (Components::CCMContext_ptr ctx,
          ::Cdmw::CCM::CIF::CCMObject_impl* component,
          CdmwLogging::LoggerFactory_ptr logger_factory)
      throw (CORBA::SystemException)
         : SessionContext_impl(ctx, logger_factory),
           m_component(component)
   {
       // create logger with domain for ccmcif
       m_logger = logger_factory->get_logger(CCMLoggers::CCMGENERATED_LOG_DOMAIN);
       
       CDMW_LOG_FUNCTION(m_logger.in(), "");
   }

   
CCM_Client_SessionContext_impl::~CCM_Client_SessionContext_impl()

   {
   }

   

   
TestComponents::FacetTest_ptr
CCM_Client_SessionContext_impl::get_connection_to_server()

      throw(CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      Components::ConnectionDescriptions_var comp_desc;

      try
      {
         comp_desc = 
            m_component->get_connections("to_server");
      }
      catch (const Components::InvalidName& e)
      {
          CDMW_ERROR(m_logger.in(), "Cannot find to_server receptacle");
          CORBA::INTERNAL ex(OrbSupport::INTERNAL, CORBA::COMPLETED_NO);
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const CORBA::SystemException& e )
      {
         CDMW_ERROR(m_logger.in(), "Exception finding to_server receptacle");
         CDMW_LOG_FUNCTION_EXCEPTION(e);
         throw;
      }

      TestComponents::FacetTest_var recep;
      if (comp_desc->length() == 1)
      {
         CORBA::Object_var obj = CORBA::Object::_duplicate(comp_desc->operator[](0)->objref());

         recep = TestComponents::FacetTest::_narrow(obj.in());
      }
      else
      {
         recep = TestComponents::FacetTest::_nil();
      }

      return recep._retn();
   }

HelloModule::Hello_ptr
CCM_Client_SessionContext_impl::get_connection_to_echo()

      throw(CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      Components::ConnectionDescriptions_var comp_desc;

      try
      {
         comp_desc = 
            m_component->get_connections("to_echo");
      }
      catch (const Components::InvalidName& e)
      {
          CDMW_ERROR(m_logger.in(), "Cannot find to_echo receptacle");
          CORBA::INTERNAL ex(OrbSupport::INTERNAL, CORBA::COMPLETED_NO);
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const CORBA::SystemException& e )
      {
         CDMW_ERROR(m_logger.in(), "Exception finding to_echo receptacle");
         CDMW_LOG_FUNCTION_EXCEPTION(e);
         throw;
      }

      HelloModule::Hello_var recep;
      if (comp_desc->length() == 1)
      {
         CORBA::Object_var obj = CORBA::Object::_duplicate(comp_desc->operator[](0)->objref());

         recep = HelloModule::Hello::_narrow(obj.in());
      }
      else
      {
         recep = HelloModule::Hello::_nil();
      }

      return recep._retn();
   }

} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestComponents
