
/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/* =========================================================================== * 
 * This code has been generated by CDMW Code Generator 1.0
 * on Tue Jul 28 15:36:49 CEST 2009
 * DO NOT EDIT !!!
 * =========================================================================== */


   

   
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/Codec.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <CCMContainer/ccmcommon/CCMLoggers.hpp>
#include <CCMContainer/ccmcopi/PushContainerStubRequest_impl.hpp>
#include <CCMContainer/ccmcopi/COPIServiceInit.hpp>
   
   #include "CCM_Server_SessionContext_impl.hpp"

   
  DEFINE_VALUETYPE_DATA_TRAITS(TestComponents::Activated)
DEFINE_VALUETYPE_DATA_TRAITS(TestComponents::ServerInfo)

namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwTestComponents {

CCM_Server_SessionContext_impl::CCM_Server_SessionContext_impl

         (Components::CCMContext_ptr ctx,

          ::Cdmw::CCM::CIF::CCMObject_impl* component,

          CdmwLogging::LoggerFactory_ptr logger_factory)
      throw (CORBA::SystemException)
         : SessionContext_impl(ctx, logger_factory),
           m_component(component)
   {
       // create logger with domain for ccmcif
       m_logger = logger_factory->get_logger(CCMLoggers::CCMGENERATED_LOG_DOMAIN);
       
       CDMW_LOG_FUNCTION(m_logger.in(), "");
   }

   
CCM_Server_SessionContext_impl::~CCM_Server_SessionContext_impl()

   {
   }

   

   
void
CCM_Server_SessionContext_impl::push_i_am_activated(TestComponents::Activated* event)
throw(CORBA::SystemException)

   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      // insert event into an any
      /* PCR-0049
      CORBA::Any data;
      data <<= event;
      */
      Cdmw::OrbSupport::Codec<TestComponents::Activated> codec;
      CORBA::OctetSeq_var encoded_data = codec.encode(event);
      CORBA::Any data;
      data <<= encoded_data;

      // find proxy to push event
      CosEventComm::PushConsumer_var proxy_consumer =
         m_component->get_proxy_consumer("i_am_activated");

      if (CORBA::is_nil(proxy_consumer.in()))
      {
          CDMW_ERROR(m_logger.in(), "ProxyConsumer for i_am_activated port is nil");
          CORBA::INTERNAL ex(OrbSupport::INTERNAL, CORBA::COMPLETED_NO);
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }

      try
      {
          proxy_consumer->push(data);
      }
      catch (const CosEventComm::Disconnected &)
      {
          CDMW_ERROR(m_logger.in(), "Cannot send event with i_am_activated port since it's not connected");
          CORBA::INTERNAL ex(OrbSupport::INTERNAL, CORBA::COMPLETED_NO);
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
   }

void
CCM_Server_SessionContext_impl::push_info(TestComponents::ServerInfo* event)
throw(CORBA::SystemException)

   {
       CORBA::Any data;
       CDMW_LOG_FUNCTION(m_logger.in(), "");

            
       if(Cdmw::CCM::COPI::COPIServiceInit::Is_initialized() &&
          Cdmw::CCM::COPI::COPIServiceInit::Is_COPI_requests_read_write()
          ) {
           // need to enable COPIs to access type information,
           // COPIs are not aware of a) which codec to use b) to which object to cast
           data <<= event;
       }
       else        
           {
               Cdmw::OrbSupport::Codec<TestComponents::ServerInfo> codec;
               CORBA::OctetSeq_var encoded_data = codec.encode(event);
               data <<= encoded_data;
           }

       // find proxy to push event
       CosEventComm::PushConsumer_var proxy_consumer =
           m_component->get_proxy_consumer("info");

       if (CORBA::is_nil(proxy_consumer.in()))
           {
               CDMW_ERROR(m_logger.in(), "ProxyConsumer for info port is nil");
               CORBA::INTERNAL ex(OrbSupport::INTERNAL, CORBA::COMPLETED_NO);
               CDMW_LOG_FUNCTION_EXCEPTION(ex);
               throw ex;
           }

       if(Cdmw::CCM::COPI::COPIServiceInit::Is_initialized() &&
          Cdmw::CCM::COPI::COPIServiceInit::Is_COPI_requests_read_write()) {
           Cdmw::CCM::COPI::PushContainerStubRequest_impl request 
               (
                "info",
                m_component->get_component_identity().c_str(),
                proxy_consumer.in(),
                m_component->get_context()
                );

           request.push(data);
          
       } else {
           try
               {
                   proxy_consumer->push(data);
               }
           catch (const CosEventComm::Disconnected &)
               {
                   CDMW_ERROR(m_logger.in(), "Cannot send event with info port since it's not connected");
                   CORBA::INTERNAL ex(OrbSupport::INTERNAL, CORBA::COMPLETED_NO);
                   CDMW_LOG_FUNCTION_EXCEPTION(ex);
                   throw ex;
               }
       }

   }

} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestComponents
