
/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/* =========================================================================== * 
 * This code has been generated by CDMW Code Generator 1.0
 * on Tue Jul 28 15:36:49 CEST 2009
 * DO NOT EDIT !!!
 * =========================================================================== */


   
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/orbsupport/Codec.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
#include <CCMContainer/ccmcopi/COPIServiceInit.hpp>
   
   #include "ServerInfoConsumer_impl.hpp"

   DEFINE_VALUETYPE_DATA_TRAITS(TestComponents::ServerInfo)

   
namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwTestComponents {
ServerInfoConsumer_impl::ServerInfoConsumer_impl
(
 Components::ExecutorLocator_ptr exec_locator,
 const std::string& name,
 const std::string& component_identity,
 Context*                    ctx,
 PortableServer::Servant     component,
 CdmwLogging::Logger_ptr     logger
 )
      : LifeCycleObjectBase(ctx),
        m_executor_locator(Components::ExecutorLocator::_duplicate(exec_locator)),
        m_sink_name(name),
        m_component_identity(component_identity),
        m_component(component),
        m_logger(CdmwLogging::Logger::_duplicate(logger)),
        m_ctx(ctx)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "name="<<name);
      // incrementation refcount of component in order to avoid destruction
      // of the component before the destruction of the facet
      m_component->_add_ref();
   }

   ServerInfoConsumer_impl::~ServerInfoConsumer_impl() throw()
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "m_sink_name="<<m_sink_name);
      // no remove_ref on component while it's done in var destructor
   }


   void
   ServerInfoConsumer_impl::push_ServerInfo(TestComponents::ServerInfo* the_serverinfo)
      throw (CORBA::SystemException)
   {
        CDMW_LOG_FUNCTION(m_logger.in(), "");
        CDMW_DEBUG(m_logger.in(), "Consumer " << m_sink_name
                   << " receives an event");
        try {

            CORBA::Object_var obj = m_executor_locator->obtain_executor(
                                                                        m_sink_name.c_str());

            if (CORBA::is_nil(obj.in())) {
                CDMW_ERROR(m_logger.in(), "Executor for consumer " << m_sink_name
                           << " is nil");
                CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST,
                                           CORBA::COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(ex);
                throw ex;
            }

           ::TestComponents::CCM_Client_var consumer_exec = 
                TestComponents::CCM_Client::_narrow(obj.in());

            if (!CORBA::is_nil(consumer_exec.in())) {

                if (Cdmw::CCM::COPI::COPIServiceInit::Is_initialized()) {

                    Cdmw::CCM::COPI::PushContainerServantRequest_impl * request =
                        new Cdmw::CCM::COPI::PushContainerServantRequest_impl(
                                                                              m_sink_name.c_str(), m_component_identity.c_str(), consumer_exec, m_ctx);

                    if (request->is_read_write()) {
                        // request is a read / write request

                        ::CORBA::Any any;
                        any <<= the_serverinfo;

                        ::CORBA::Any in_arg;
                        in_arg <<= any;
 
                        request->add_in_args(in_arg);
                    }

                    request->pre_invoke();

                    // The operation parameters
                    const ::CORBA::Any * event_any = 0;
                    TestComponents::ServerInfo * intercepted_event = the_serverinfo;

                    if (request->is_read_write()) {
                        try {
                            ::CORBA::Any_var a = request->get_arg(0);

                            a.in() >>= event_any;
                            if (0 == event_any || false == ((*event_any) >>= intercepted_event)) {
                                // TODO log event, set mior ...
                                CDMW_ERROR(m_logger.in(),"A Stub COPI has corrupted the args");
                                ::CORBA::BAD_OPERATION bad_op;
                                request->add_system_exception(bad_op);
                            }

                        } catch (::CORBA::SystemException & se) {
                            request->add_system_exception(se);
                        }
                    }

                    ::CORBA::Any_var ex_any = request->the_exception();

                    if (!(true == request->m_proceed_call && ::CORBA::tk_null
                          == ex_any->type()->kind())) {
                        consumer_exec->push_server_info(intercepted_event);
                    }

                    request->post_invoke();
                    request->throw_exception();
                    delete request;
                    request = 0;

                } else {
                    // COPI Service not initialised
                    consumer_exec->push_server_info(the_serverinfo);
                }

            } else {
                CDMW_ERROR(m_logger.in(), "Executor for consumer " << m_sink_name
                           << " has wrong type");
                CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST,
                                           CORBA::COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(ex);
                throw ex;
            }

            m_executor_locator->release_executor(obj.in());

        } catch (const Components::CCMException& e) {
            CDMW_ERROR(m_logger.in(), "CCMException received: " << e);
            CORBA::INTERNAL
                ex(OrbSupport::INTERNALCCMCIFError, CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
   }

   void
   ServerInfoConsumer_impl::push_event(Components::EventBase * evt)
      throw (Components::BadEventType, CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      TestComponents::ServerInfo_var info_evt
         = TestComponents::ServerInfo::_downcast(evt);
      CORBA::add_ref(info_evt.in());

      if (!info_evt.in())
      {
         CDMW_WARN(m_logger.in(),
             "EventBase with unexpected type received");
         Components::BadEventType ex;
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
      else
      {
         this->push_ServerInfo(info_evt.in());
      }
   }

   void
   ServerInfoConsumer_impl::push(const CORBA::Any& data)
      throw (CosEventComm::Disconnected,
             CORBA::SystemException)
   {
       CDMW_LOG_FUNCTION(m_logger.in(), "");
       TestComponents::ServerInfo * event = 0;
       /* PCR-0049
          data >>= event;
       */

       bool was_decoded = false;
      
       if(Cdmw::CCM::COPI::COPIServiceInit::Is_initialized() &&
          Cdmw::CCM::COPI::COPIServiceInit::Is_COPI_requests_read_write()
          ) {
           // need to enable COPIs to access type information,
           // COPIs are not aware of a) which codec to use b) to which object to cast
           data >>= event;
           if(0 == event) {
               CDMW_DEBUG(m_logger.in(), "event extraction failed, retrying with codec");
           }
       } else if(0 == event) {
         
           const CORBA::OctetSeq* p_encoded_data;
           data >>= p_encoded_data;
           CORBA::OctetSeq encoded_data(*p_encoded_data);

           Cdmw::OrbSupport::Codec<TestComponents::ServerInfo> codec;
           codec.decode(encoded_data, event);
           was_decoded = true;

       }
      

       try
           {
               this->push_ServerInfo(event);               
               if(was_decoded) {
                   // close leak
                   TestComponents::ServerInfo_var c = event;
               } 
           }
       catch (const CORBA::SystemException& e)
           {
               CDMW_LOG_FUNCTION_EXCEPTION(e);
               throw;
           }
   }

   void
   ServerInfoConsumer_impl::disconnect_push_consumer()
      throw (CORBA::SystemException)
   {
       CDMW_LOG_FUNCTION(m_logger.in(), "");
   }

   
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestComponents
