/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef LIFECYCLEINTERCEPTORHOMETEST_HPP_
#define LIFECYCLEINTERCEPTORHOMETEST_HPP_

#include <string>
#include <CCMContainer/idllib/CdmwCcmContainer.stub.hpp>
#include <Foundation/idllib/Components.stub.hpp>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <Foundation/testutils/CORBATestManager.hpp>

namespace Cdmw
{
namespace CCM
{
namespace COPI
{

class LifeCycleInterceptorHomeTest;
typedef LifeCycleInterceptorHomeTest* LifeCycleInterceptorHomeTest_ptr;

/**
 *
 */
class LifeCycleInterceptorHomeTest: public CdmwCcmContainer::HomeLifeCycleInterceptor,
                                public Cdmw::OrbSupport::RefCountLocalObject
{
public:

    explicit LifeCycleInterceptorHomeTest(std::string name);

    LifeCycleInterceptorHomeTest(std::string name, CORBA::UShort priority);

protected:
    virtual ~LifeCycleInterceptorHomeTest();

public:
    void after_home_create(const char* homeId, CORBA::Object_ptr homeRef) throw (CORBA::SystemException);
    void after_home_remove(const char* homeId)  throw (CORBA::SystemException);
    void before_home_create(const char* homeId, Components::ConfigValues& values, const char* entryPoint)  throw (CORBA::SystemException);
    void before_home_remove(const char* homeId)  throw (CORBA::SystemException);


    void destroy() throw (::CORBA::SystemException);
    char* name() throw (::CORBA::SystemException);
    CORBA::UShort priority() throw (::CORBA::SystemException);

    Components::ContainerPortableInterceptor::IntegrationPoint* registration_info()
            throw (::CORBA::SystemException);

    void set_slot_id(::PortableInterceptor::SlotId slot_id) throw (::CORBA::SystemException);

private:
    std::string m_name;
    CORBA::UShort m_priority;
//    CORBA::Object_ptr m_orb;

};

} //namespace Cdmw
} //namespace CCM
} //namespace COPI

#endif /* LIFECYCLEINTERCEPTORHOMETEST_HPP_ */
