
/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/* =========================================================================== * 
 * This code has been generated by CDMW Code Generator 1.0
 * on Wed Jul 15 09:57:26 CEST 2009
 * DO NOT EDIT !!!
 * =========================================================================== */

#ifndef __INCL_CCMCIF_SESSIONCLIENTHOME_IMPL_HPP__
#define __INCL_CCMCIF_SESSIONCLIENTHOME_IMPL_HPP__

      #include "Cdmw_Basic_cif.skel.hpp"
    


#include <CCMContainer/ccmcif/CCMHome_impl.hpp>
#include <CCMContainer/ccmcif/HomeConfiguration_impl.hpp>
#include <CCMContainer/ccmcontainer/HomeAllocator.hpp>
   
namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwBasicDemo {


   class SessionClientHome_impl : virtual public POA_Cdmw_BasicDemo::ClientHome,
                                                       public CCMHome_impl,
      
                                                       virtual public HomeConfiguration_impl
   {
      friend class Container::HomeAllocator<SessionClientHome_impl>;

      public:
         // Destructor
         ~SessionClientHome_impl() throw();

         /**
          * Home attributes
          */

         

         /**
          * Explicit interface
          */

         

         /**
          * Implicit interface
          */

         virtual BasicDemo::Client_ptr
         create()
            throw(Components::CreateFailure,
                  CORBA::SystemException);

         // Keyless home operation

         virtual Components::CCMObject_ptr
         create_component()
            throw(Components::CreateFailure,
                  CORBA::SystemException);

         // CDMW Keyless home operation
         Components::CCMObject_ptr
         create_component_with_config_values(const Components::ConfigValues& config)
            throw(Components::CreateFailure,
                  CORBA::SystemException);


         
            /**
             * Purpose:
             * <p>This method acts as a hand shaking between the Servant Provider
             * and the generated Factory implementation. It indicates whether
             * a Servant provided by this Servant Provider may incarnate multiple
             * objects (with ObjectIds provided by this Servant Provider)
             *
             * @return <B>true</B> if a servant may incarnate multiple objects,
             * <B>false</B> otherwise.
             */
            virtual bool may_incarnate_multiple_objects() const throw()
            {
               return false;
            }

       //ADDED LCFIntecpet BEGIN
       virtual void remove_component(Components::CCMObject_ptr comp)
           throw(Components::RemoveFailure,
                 CORBA::SystemException);
       //ADDED LCFIntecpet END


            virtual void remove()
                throw(CosLifeCycle::NotRemovable,
                      CORBA::SystemException);
         

      protected:
         // Constructor
         SessionClientHome_impl(Components::HomeExecutorBase_ptr home_exec,
                                const Cdmw::LifeCycle::ObjectDeactivator& deactivator,
                                CdmwLifeCycle::ObjectRegistration_ptr      object_registration,
                                const Components::ConfigValues& config)
            throw(CORBA::SystemException);

         
            /**
             * This returns an array containing repository IDs of all objects
             * supported by the current ServantProvider.
             * <B>NOTA:</B> Repository IDs should be statically allocated; thus derived classes
             * should not delete return pointer(s).
             */
            virtual const char ** get_ids() const throw();
         

         
            /**
             * This returns the number of repository Ids supported by the current ServantProvider.
             * <B>NOTA:</B> This should correspond to the number of null terminated strings
             * returned by get_ids() operation.
             */
            virtual CORBA::Long get_number_of_ids() const throw();
         

         
            /**
             * Purpose:
             * <p>
             *   This creates new component servant.
             *   This shall be implemented by the well typed home servant.
             *
             * @param ctx      The component context
             * @param executor The component executor
             *
             * @return The new component servant.
             * @exception Components::CreateFailure if a problem occured when creating executor.
             * @exception Any CORBA Exception
             *
             */
            virtual PortableServer::Servant
            create_component_servant(const std::string&  comp_oid,
                                     Context*            ctx,
                                     ComponentInfo&      comp_info)
               throw(Components::CreateFailure,
                     CORBA::SystemException);
         

         
   
      private:
         SessionClientHome_impl(const SessionClientHome_impl&);
         void operator=(const SessionClientHome_impl&);

         // Home executor
         BasicDemo::CCM_ClientHome_var m_home_executor;
   };


   
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwBasicDemo


   namespace Cdmw
   {
   namespace CCM
   {
   namespace Container
   {
      template <>
      PortableServer::Servant
      HomeAllocator<CIF::CdmwBasicDemo::SessionClientHome_impl>::allocate
                  (Components::HomeExecutorBase_ptr            home_executor,
                   const Cdmw::LifeCycle::ObjectDeactivator & deactivator,
                   CdmwLifeCycle::ObjectRegistration_ptr      object_registration,
                   const Components::ConfigValues& config)
         throw(CORBA::SystemException,
               std::bad_alloc);
   }; // end of namespace Container

   }; // end of namespace CCM

   }; // end of namespace Cdmw

   


#endif // __INCL_CCMCIF_SESSIONCLIENTHOME_IMPL_HPP__
