/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef _QOSENABLERTESTCLIENTSERVICECOMPONENTHOME_IMPL_HPP_
#define _QOSENABLERTESTCLIENTSERVICECOMPONENTHOME_IMPL_HPP_

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/RefCountLocalObject.hpp"
#include "testqosenabler/TestComponents_cif.skel.hpp"

namespace TestComponents
{


class ClientComponentHome_impl : virtual public ::TestComponents::CCM_ClientHome,
                            virtual public Cdmw::OrbSupport::RefCountLocalObject
{
    ClientComponentHome_impl(const ClientComponentHome_impl&);
    void operator=(const ClientComponentHome_impl&);

public:

    ClientComponentHome_impl();
    ~ClientComponentHome_impl();


    virtual Components::EnterpriseComponent_ptr create()
        throw(Components::CCMException,
              CORBA::SystemException);
};

}; // End of namespace TestService


#endif // _QOSENABLERTESTCLIENTSERVICECOMPONENTHOME_IMPL_HPP_

