/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef _EVENTMODIFIERCOPITESTSTUBCOPI_IMPL_HPP
#define _EVENTMODIFIERCOPITESTSTUBCOPI_IMPL_HPP

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/CosNaming.stub.hpp>
#include <Foundation/testutils/CORBATestManager.hpp>
#include <Foundation/idllib/CdmwDeployment.skel.hpp>
#include <Foundation/idllib/Components.skel.hpp>
#include <CCMContainer/ccmcontainer/ConfigValue_impl.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include "COPITester_impl.hpp"
#include "ParamModifierCOPITest.hpp"
#include "testqosenabler/TestService_cif.skel.hpp"
#include "testqosenabler/TestComponents_cif.skel.hpp"



namespace Cdmw
{
namespace CCM
{
namespace CIF
{

extern int test_case_id;

/**
*Purpose:
*<p>    [class description]
*
*Features:
*<p> [Thread safety, exception safety, performance]
*    [if no pertinent write none ]
*
*@see  [if necessary] 
*@link [if necessary] 
*
*/
class EventModifierCOPITestStubCOPI_impl : 
        public virtual Components::ContainerPortableInterceptor::StubContainerInterceptor,
        public virtual TAO_Local_RefCounted_Object
{

public:
    // called by TestFixtureFactory.h
    EventModifierCOPITestStubCOPI_impl
    (
     );

    EventModifierCOPITestStubCOPI_impl
    (
     const ::std::string name
     ) 
        throw(CORBA::SystemException);


    /**
     * Purpose:
     * <p>  [Copy constructor description if necessary]
     * 
     *@param
     *@exception
     */ 
    EventModifierCOPITestStubCOPI_impl(const EventModifierCOPITestStubCOPI_impl& rhs)
        throw();


    /**
     * Purpose:
     * <p> [ Destructor description if necessary]
     * 
     */ 
    virtual 
    ~EventModifierCOPITestStubCOPI_impl()
        throw();


    /**
     * Purpose:
     * <p> [ Assignement operator description if necessary]
     * 
     *@param
     *@return
     *@exception
     */ 
    EventModifierCOPITestStubCOPI_impl&
    operator=(const EventModifierCOPITestStubCOPI_impl& rhs)
        throw();
    
    /**
     *[Attribute description]
     */ 

    // STUB COPI

        virtual
    void stub_send_request (
                            ::Components::ContainerPortableInterceptor::ContainerStubRequestInfo_ptr info,
                            ::CORBA::Boolean_out proceed_call
                            )
        throw (
               ::CORBA::SystemException,
               ::PortableInterceptor::ForwardRequest
               );
  
    virtual
    void stub_receive_reply (
                             ::Components::ContainerPortableInterceptor::ContainerStubRequestInfo_ptr info,
                             ::CORBA::Boolean_out proceed_call
                             )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void stub_receive_exception (
                                 ::Components::ContainerPortableInterceptor::ContainerStubRequestInfo_ptr info,
                                 ::CORBA::Boolean_out proceed_call
                                 )
        throw (
               ::CORBA::SystemException,
               ::PortableInterceptor::ForwardRequest
               );
  
    virtual
    void stub_receive_other (
                             ::Components::ContainerPortableInterceptor::ContainerStubRequestInfo_ptr info
                             )
        throw (
               ::CORBA::SystemException,
               ::PortableInterceptor::ForwardRequest
               );

  
    virtual
    char * name (
      
    )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    ::CORBA::UShort priority (
      
    )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    ::Components::ContainerPortableInterceptor::IntegrationPoint * registration_info (
      
    )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void destroy (
      
    )
        throw (
               ::CORBA::SystemException
               );
    
    virtual
    void set_slot_id (
                      ::PortableInterceptor::SlotId slot_id
                      )
        throw (
               ::CORBA::SystemException
               );
    

protected:    

    
private:
    
    void do_modify_event_data
    (
     ::Components::ContainerPortableInterceptor::ContainerStubRequestInfo_ptr info,
     ::CORBA::ULong new_value
     );

    ::CORBA::ULong get_event_data
    (
     ::Components::ContainerPortableInterceptor::ContainerStubRequestInfo_ptr info
     );

   
    std::string get_header();     
    const std::string m_copi_name;
    int m_slot_id;  

    ::TestService::Logger_var m_logger;
    
}; // End class EventModifierCOPITestStubCOPI_impl

}; // End namespace CIF
}; // End namespace CCM
}; // End namespace Cdmw
#endif // _EVENTMODIFIERCOPITESTSTUBCOPI_IMPL_HPP

