/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef _EVENTMODIFIERCOPITEST_IMPL_HPP
#define _EVENTMODIFIERCOPITEST_IMPL_HPP

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/CosNaming.stub.hpp>
#include <Foundation/testutils/CORBATestManager.hpp>
#include <Foundation/idllib/CdmwDeployment.skel.hpp>
#include <Foundation/idllib/Components.skel.hpp>
#include <CCMContainer/ccmcontainer/ConfigValue_impl.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include "COPITester_impl.hpp"
#include "ParamModifierCOPITest.hpp"
#include "testqosenabler/TestService_cif.skel.hpp"
#include "testqosenabler/TestComponents_cif.skel.hpp"




namespace Cdmw
{
namespace CCM
{
namespace CIF
{

int test_case_id;

/**
*Purpose:
*<p>    [class description]
*
*Features:
*<p> [Thread safety, exception safety, performance]
*    [if no pertinent write none ]
*
*@see  [if necessary] 
*@link [if necessary] 
*
*/
class EventModifierCOPITest_impl : 
        public CppUnit::TestFixture
{

public:
    // called by TestFixtureFactory.h
    EventModifierCOPITest_impl
    (
     );

    EventModifierCOPITest_impl
    (
     const ::std::string name
     ) 
        throw(CORBA::SystemException);


    /**
     * Purpose:
     * <p>  [Copy constructor description if necessary]
     * 
     *@param
     *@exception
     */ 
    EventModifierCOPITest_impl(const EventModifierCOPITest_impl& rhs)
        throw();


    /**
     * Purpose:
     * <p> [ Destructor description if necessary]
     * 
     */ 
    virtual 
    ~EventModifierCOPITest_impl()
        throw();


    /**
     * Purpose:
     * <p> [ Assignement operator description if necessary]
     * 
     *@param
     *@return
     *@exception
     */ 
    EventModifierCOPITest_impl&
    operator=(const EventModifierCOPITest_impl& rhs)
        throw();
        

protected:    
    virtual void do_tests();

    
private:
    bool check_received_event(::CORBA::ULong data);
    void test_modify_event(::CORBA::ULong data);

    ::TestComponents::CCM_Server_Context_var m_server_context;
    ::TestService::Logger_var m_logger;
    

    CPPUNIT_TEST_SUITE( EventModifierCOPITest_impl );
    CPPUNIT_TEST( do_tests );
    CPPUNIT_TEST_SUITE_END();
}; // End class EventModifierCOPITest_impl

}; // End namespace CIF
}; // End namespace CCM
}; // End namespace Cdmw
#endif // _EVENTMODIFIERCOPITEST_IMPL_HPP

