/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef __LOGGERSERVICECOMPONENT_IMPL_HPP_
#define __LOGGERSERVICECOMPONENT_IMPL_HPP_

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/RefCountLocalObject.hpp"
#include "testqosenabler/UserTestService.skel.hpp"
#include "testqosenabler/Cdmw_TestService_cif.skel.hpp"
#include "COPITester_impl.hpp"

namespace TestService
{

//
//
class LoggerServiceComponent_impl : virtual public ::UserTestService::User_TestService,

                        virtual public Cdmw::OrbSupport::RefCountLocalObject
{
    LoggerServiceComponent_impl(const LoggerServiceComponent_impl&);
    void operator=(const LoggerServiceComponent_impl&);

     CORBA::String_var                   m_name;
     CORBA::String_var                   m_text;
     Cdmw_TestService::CCM_LoggerService_ExtensionContext_var m_context;
     bool                                m_test_result;

     
public:

    LoggerServiceComponent_impl();
    ~LoggerServiceComponent_impl();

    void set_extension_context(Components::ExtensionContext_ptr ctx)
                 throw(CORBA::SystemException);


    void ccm_remove()
      throw(CORBA::SystemException);

    

    TestService::CCM_Logger * get_logger()
        throw(CORBA::SystemException);


    void LOG_MESSAGE(const char* msg) 
        throw(CORBA::SystemException);

private:

    static ::Cdmw::CCM::COPI::COPITester_impl * M_copi_tester;

};

}; // End of namespace TestService


#endif // __LOGGERSERVICECOMPONENT_IMPL_HPP_

