/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#ifndef _PARAMMODIFIERCOPITEST_IMPL_HPP
#define _PARAMMODIFIERCOPITEST_IMPL_HPP

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/CosNaming.stub.hpp>
#include <Foundation/testutils/CORBATestManager.hpp>
#include <Foundation/idllib/CdmwDeployment.skel.hpp>
#include <Foundation/idllib/Components.skel.hpp>
#include <CCMContainer/ccmcontainer/ConfigValue_impl.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>

namespace Cdmw
{
namespace CCM
{
namespace CIF
{


/**
 *
 */
class ParamModifierCOPITest 
{
#define MODIFY_IN_PARAM 0
#define MODIFY_OUT_RET 1
#define THROW_EXCEPTION 2
#define MODIFY_EXCEPTION 3
#define DO_NOT_PROCEED_CALL 4

  
public:  
    ParamModifierCOPITest()
    {};
        
    virtual void modify_in_param
    (
     ::Components::ContainerPortableInterceptor::ContainerRequestInfo_ptr info,  
     ::CORBA::Boolean & proceed_call
     ) = 0; 
    virtual void test_modify_in_param() = 0;
    
    virtual void modify_out_return_param
    (
     ::Components::ContainerPortableInterceptor::ContainerRequestInfo_ptr info, 
     ::CORBA::Boolean & proceed_call
     ) = 0; 
    virtual void test_modify_out_return_param() = 0;
    
    virtual void throw_exception
    (
     ::Components::ContainerPortableInterceptor::ContainerRequestInfo_ptr info, 
     ::CORBA::Boolean & proceed_call
     ) = 0;
    virtual void test_throw_exception() = 0;
    
    virtual void modify_exception
    (
     ::Components::ContainerPortableInterceptor::ContainerRequestInfo_ptr info, 
     ::CORBA::Boolean & proceed_call      
     ) = 0;
    virtual void test_modify_exception() = 0;
    
    virtual void do_not_proceed_call
    (
     ::Components::ContainerPortableInterceptor::ContainerRequestInfo_ptr info, 
     ::CORBA::Boolean & proceed_call      
     ) = 0;
    virtual void test_do_not_proceed_call() = 0;

protected:

}; // End class ParamModifierCOPITest_impl


}; // End namespace CIF
}; // End namespace CCM
}; // End namespace Cdmw
#endif // _PARAMMODIFIERCOPITEST_IMPL_HPP

