/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef _PARAMMODIFIERSERVANTCOPITEST_IMPL_HPP
#define _PARAMMODIFIERSERVANTCOPITEST_IMPL_HPP

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/CosNaming.stub.hpp>
#include <Foundation/testutils/CORBATestManager.hpp>
#include <Foundation/idllib/CdmwDeployment.skel.hpp>
#include <Foundation/idllib/Components.skel.hpp>
#include <CCMContainer/ccmcontainer/ConfigValue_impl.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include "COPITester_impl.hpp"
#include "ParamModifierCOPITest.hpp"
#include "testqosenabler/TestService_cif.skel.hpp"
#include "testqosenabler/TestComponents_cif.skel.hpp"



namespace Cdmw
{
namespace CCM
{
namespace CIF
{

/**
*Purpose:
*<p>    [class description]
*
*Features:
*<p> [Thread safety, exception safety, performance]
*    [if no pertinent write none ]
*
*@see  [if necessary] 
*@link [if necessary] 
*
*/
class ParamModifierServantCOPITest_impl : 
        public virtual Components::ContainerPortableInterceptor::ServantContainerInterceptor,
        public virtual ParamModifierCOPITest, 
        public virtual TAO_Local_RefCounted_Object,
        public CppUnit::TestFixture
{

public:
    // called by TestFixtureFactory.h
    ParamModifierServantCOPITest_impl
    (
     );

    ParamModifierServantCOPITest_impl
    (
     const ::std::string name
     ) 
        throw(CORBA::SystemException);


    /**
     * Purpose:
     * <p> [Constructor description if necessary]
     * 
     *@param
     *@exception
     */ 


    ParamModifierServantCOPITest_impl
    (
     const ::std::string name,
     ::Cdmw::CCM::COPI::COPITester_impl * tester
    )
        throw(CORBA::SystemException);



    ParamModifierServantCOPITest_impl
    (
     const ::std::string name,
     TestService::COPITester_ptr tester
     )
        throw(CORBA::SystemException);


    /**
     * Purpose:
     * <p>  [Copy constructor description if necessary]
     * 
     *@param
     *@exception
     */ 
    ParamModifierServantCOPITest_impl(const ParamModifierServantCOPITest_impl& rhs)
        throw();


    /**
     * Purpose:
     * <p> [ Destructor description if necessary]
     * 
     */ 
    virtual 
    ~ParamModifierServantCOPITest_impl()
        throw();


    /**
     * Purpose:
     * <p> [ Assignement operator description if necessary]
     * 
     *@param
     *@return
     *@exception
     */ 
    ParamModifierServantCOPITest_impl&
    operator=(const ParamModifierServantCOPITest_impl& rhs)
        throw();
    
    /**
     *[Attribute description]
     */ 

    
    virtual
    void servant_receive_request (
                                  ::Components::ContainerPortableInterceptor::ContainerServantRequestInfo_ptr info,
                                  ::CORBA::Boolean_out proceed_call
                                  )
        throw (
               ::CORBA::SystemException,
               ::PortableInterceptor::ForwardRequest
               );
    
    virtual
    void servant_send_reply (
                             ::Components::ContainerPortableInterceptor::ContainerServantRequestInfo_ptr info,
                             ::CORBA::Boolean_out proceed_call
                             )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void servant_send_exception (
                                 ::Components::ContainerPortableInterceptor::ContainerServantRequestInfo_ptr info,
                                 ::CORBA::Boolean_out proceed_call
                                 )
        throw (
               ::CORBA::SystemException,
               ::PortableInterceptor::ForwardRequest
               );
  
    virtual
    void servant_send_other (
                             ::Components::ContainerPortableInterceptor::ContainerServantRequestInfo_ptr info
                             )
        throw (
               ::CORBA::SystemException,
               ::PortableInterceptor::ForwardRequest
               );
  
    virtual
    char * name (
      
    )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    ::CORBA::UShort priority (
      
    )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    ::Components::ContainerPortableInterceptor::IntegrationPoint * registration_info (
      
    )
        throw (
               ::CORBA::SystemException
               );
  
    virtual
    void destroy (
      
    )
        throw (
               ::CORBA::SystemException
               );
    
    virtual
    void set_slot_id (
                      ::PortableInterceptor::SlotId slot_id
                      )
        throw (
               ::CORBA::SystemException
               );
    

    virtual void modify_in_param
    (
     ::Components::ContainerPortableInterceptor::ContainerRequestInfo_ptr info,  
     ::CORBA::Boolean & proceed_call
     ); 
    virtual void test_modify_in_param();
    
    virtual void modify_out_return_param
    (
     ::Components::ContainerPortableInterceptor::ContainerRequestInfo_ptr info, 
     ::CORBA::Boolean & proceed_call
     ); 
    virtual void test_modify_out_return_param();
    
    virtual void throw_exception
    (
     ::Components::ContainerPortableInterceptor::ContainerRequestInfo_ptr info, 
     ::CORBA::Boolean & proceed_call
     );
    virtual void test_throw_exception();
    
    virtual void modify_exception
    (
     ::Components::ContainerPortableInterceptor::ContainerRequestInfo_ptr info, 
     ::CORBA::Boolean & proceed_call      
     );
    virtual void test_modify_exception();
    
    virtual void do_not_proceed_call
    (
     ::Components::ContainerPortableInterceptor::ContainerRequestInfo_ptr info, 
     ::CORBA::Boolean & proceed_call      
     );
    virtual void test_do_not_proceed_call();

protected:    
    virtual void do_tests();
    
private:
    static int M_test_case_id;
    static ::CORBA::ORB_var M_orb;
   
    std::string get_header();     
    const std::string m_copi_name;
    ::Cdmw::CCM::COPI::COPITester_impl * m_tester;
    int m_slot_id;  

    ::TestService::Logger_var m_logger;
    ::TestComponents::FacetTest_var m_facet;

    
    CPPUNIT_TEST_SUITE( ParamModifierServantCOPITest_impl );
    CPPUNIT_TEST( do_tests );
    CPPUNIT_TEST_SUITE_END();

}; // End class ParamModifierServantCOPITest_impl

}; // End namespace CIF
}; // End namespace CCM
}; // End namespace Cdmw
#endif // _PARAMMODIFIERSERVANTCOPITEST_IMPL_HPP

