/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef ___QOSENABLERTEST_SERVER_COMPONENT_IMPL_HPP__
#define ___QOSENABLERTEST_SERVER_COMPONENT_IMPL_HPP__

#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/RefCountLocalObject.hpp"
#include "generated/ComponentServer/testqosenabler/UserTestComponents.skel.hpp"

namespace TestComponents
{

//
// IDL:thalesgroup.com/TestComponents/CCM_Client:1.0
//
class ServerComponent_impl : virtual public ::UserTestComponents::User_CCM_Server,
                        virtual public Cdmw::OrbSupport::RefCountLocalObject
{
    ServerComponent_impl(const ServerComponent_impl&);
    void operator=(const ServerComponent_impl&);

     CORBA::String_var                   m_name;
     CORBA::String_var                   m_text;
    ::TestComponents::CCM_Server_Context_var m_session_context;
    bool                                 m_test_result;

     
public:

    ServerComponent_impl();
    ~ServerComponent_impl();

    void set_session_context(Components::SessionContext_ptr ctx)
                 throw(CORBA::SystemException);
    void ccm_activate()
                 throw(CORBA::SystemException);
    void ccm_passivate()
                 throw(CORBA::SystemException);
    void ccm_remove()
                 throw(CORBA::SystemException);

    virtual TestComponents::CCM_FacetTest * get_for_clients()
        throw(CORBA::SystemException);

    
    virtual HelloModule::CCM_Hello * get_echo()
        throw(CORBA::SystemException);

    virtual void raiseException(CORBA::Boolean, const char*)
        throw (CORBA::SystemException, TestComponents::ExceptionTest);


    virtual CORBA::Long makeOperation(TestComponents::ArithOperator, CORBA::Long, CORBA::Long, CORBA::Long&)
        throw (CORBA::SystemException, TestComponents::ExceptionTest);

    virtual void echo(const char*)
        throw (CORBA::SystemException);

};

}; // End of namespace TestComponents


#endif // ___QOSENABLERTEST_SERVER_COMPONENT_IMPL_HPP__

