/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "ServerInfoFactory_impl.hpp"

// Enty points

extern "C" {
    
    CORBA::ValueFactoryBase* create_server_info_factory () {
        return new TestComponents::ServerInfoFactory_impl();
    }
};



// Constructor
TestComponents::ServerInfo_impl::ServerInfo_impl ()
{
}

// Copy Constructor
TestComponents::ServerInfo_impl::ServerInfo_impl (const ServerInfo_impl& right)
{
    data(right.data());
}

// Destructor
TestComponents::ServerInfo_impl::~ServerInfo_impl ()
{
}

CORBA::ValueBase*
TestComponents::ServerInfo_impl::_copy_value()
{
    TestComponents::ServerInfo_impl* result = new ServerInfo_impl();
    result->data(data());

    return result;
}

/******************************/
/*         Factory            */
/******************************/


TestComponents::ServerInfoFactory_impl::ServerInfoFactory_impl()
{
}

TestComponents::ServerInfoFactory_impl::~ServerInfoFactory_impl()
{
}

CORBA::ValueBase *
TestComponents::ServerInfoFactory_impl::create_for_unmarshal ()
{
    return new TestComponents::ServerInfo_impl();
}


