/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */



#include "EchoStubRequest_impl.hpp"


namespace {


} // End anonymous space



namespace Cdmw {
    
namespace CCM {

namespace CIF {

namespace CdmwTestComponents {



EchoStubRequest_impl::EchoStubRequest_impl 
(
 const char *  receptacle_name, 
 const char *  component_id,
 ::CORBA::Object_ptr facet_object,
 ::Cdmw::CCM::CIF::Context * ctx  
 ) :
    ::Cdmw::CCM::COPI::ContainerExtendedCopisRequest_impl<Cdmw::CCM::COPI::ContainerStubRequestInfo_impl>(ctx),
    ContainerStubRequest_impl(ctx), m_index(-1)
{
    initialise(receptacle_name, component_id, facet_object);
}

EchoStubRequest_impl::~EchoStubRequest_impl() 
{
    // empty
}

char * EchoStubRequest_impl::operation() {
    return ::CORBA::string_dup("echo");
}

void EchoStubRequest_impl::add_in_args_msg(const char * msg) {
    ::CORBA::Any any;
    any <<= msg;
    this->add_in_args(any);
    m_arguments_indices.insert(::std::make_pair("msg", ++m_index));
}
    
char * EchoStubRequest_impl::get_in_args_msg() 
{
    ::std::map< ::std::string, int >::iterator it =
          m_arguments_indices.find("msg");

    const char * str = 0;

    if(it != m_arguments_indices.end()) {
        ::CORBA::Any_var any =
              get_arg(it->second);            

        if(!(any.in() >>= str)) {
            CDMW_ASSERT(0);
        };
                                   
    } else {            
        CDMW_ASSERT(0);
    }

    return ::CORBA::string_dup(str);
}

void 
EchoStubRequest_impl::throw_exception()
{    
    m_request_info->throw_system_exception();

    /* CODEGEN: generate code for user exceptions */    

    /* Example: */
    
    /*
    ::CORBA::Any_var ex_any = this->the_exception();

    if (::MyUserModude::MyException::tk_of_my_ex != ex_any->type()->kind()) {
        ::MyUserModude::MyException * ex = 0;
        ex <<= m_the_exception;
        CDMW_LOG_FUNCTION_EXCEPTION(ex);
        throw ex;
    } else if(... next user exception)
        ...
    }
    */

}


} // End namespace CIF

} // End namespace CCM

} // End namespce COPI

}

