/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/* =========================================================================== * 
 * This code has been generated by CDMW Code Generator 1.0
 * on Wed Oct 28 17:00:56 CET 2009
 * DO NOT EDIT !!!
 * =========================================================================== */


   
#include <sstream>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
#include <CCMContainer/ccmcommon/CCMLoggers.hpp>
#include <CCMContainer/ccmcif/CCMUtils.hpp>
#include <Foundation/idllib/CdmwDeployment.stub.hpp>



         #include "ExtensionLoggerServiceHome_impl.hpp"
         #include "ExtensionLoggerService_impl.hpp"
      

namespace {
      
      const char* HOME_REP_ID = "IDL:acme.com/Cdmw_TestService/LoggerServiceHome:1.0";
      
      const char* COMP_REP_ID = "IDL:acme.com/TestService/LoggerService:1.0";
      

};  // End of anonymous namespace

   
namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwTestService {


   // Constructor 
   ExtensionLoggerServiceHome_impl::ExtensionLoggerServiceHome_impl
         (Components::HomeExecutorBase_ptr home_exec, 
          const Cdmw::LifeCycle::ObjectDeactivator& deactivator,
          CdmwLifeCycle::ObjectRegistration_ptr      object_registration,
          const Components::ConfigValues& config)
      throw(CORBA::SystemException)
   
         : CCMHome_impl(HOME_REP_ID, COMP_REP_ID, deactivator, object_registration, config)
      
   {
      CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
      try {
         m_home_executor = TestService::CCM_LoggerServiceHome::_narrow(home_exec);

         if (CORBA::is_nil(m_home_executor.in()))
         {
            CDMW_ERROR(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
                "Executor for LoggerServiceHome is not a TestService::CCM_LoggerServiceHome");
            CORBA::BAD_PARAM ex(OrbSupport::BAD_PARAMInvalidHomeExecutor, 
                                CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }
      }
      catch (const CORBA::Exception & e)
      {
         // This is to avoid Assertion failure in debug mode as internal ref count
         // equals 1 (CORBA C++ mapping oblige!)
         _set_ref_count(0);
         CDMW_LOG_FUNCTION_EXCEPTION(e);
         throw;
      }
   }

   // Destructor
   ExtensionLoggerServiceHome_impl::~ExtensionLoggerServiceHome_impl() throw()
   {
       CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
   }

   /**
    * Home attributes
    */

   

   /**
    * Explicit interface
    */

   

   //
   // Implicit interface
   //

   TestService::LoggerService_ptr
ExtensionLoggerServiceHome_impl::create()
      throw(Components::CreateFailure,
            CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
      check_is_removed(m_oid.in());

      // Create an empty config
      Components::ConfigValues config(0L);
      config.length(0L);


      Components::CCMObject_var cmp = create_component_with_config_values(config);
      TestService::LoggerService_var result = TestService::LoggerService::_narrow(cmp.in());
      return result._retn();
   }

   //
   // IDL:omg.org/Components/KeylessCCMHome/create_component:1.0
   //
   Components::CCMObject_ptr
   ExtensionLoggerServiceHome_impl::create_component()
      throw(Components::CreateFailure,
            CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
      check_is_removed(m_oid.in());

      // Create an empty config
      Components::ConfigValues config(0L);
      config.length(0L);

      Components::CCMObject_var cmp = create_component_with_config_values(config);
      TestService::LoggerService_var result = TestService::LoggerService::_narrow(cmp.in());
      return result._retn();
   }

   //
   // IDL:omg.org/CdmwCcmCif/KeylessCCMHome/create_component_with_config_values:1.0
   //
   Components::CCMObject_ptr
   ExtensionLoggerServiceHome_impl::create_component_with_config_values(const Components::ConfigValues& config)
     throw(Components::CreateFailure,
            CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
          "config.length="<<config.length());
      check_is_removed(m_oid.in());

      CORBA::Object_var obj = create_component_ref(config);
      TestService::LoggerService_var result = TestService::LoggerService::_narrow(obj.in());

      if (CORBA::is_nil(result.in()))
      {
         CDMW_ERROR(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
            "Created reference is not a LoggerService!");
         CORBA::INTERNAL ex(OrbSupport::INTERNALLifeCycleFrameworkError, CORBA::COMPLETED_NO);
         throw ex;
      }

 
      if (!CORBA::is_nil(m_configurator.in()))
      {
          try
          {
              // a configurator exist!
              m_configurator->configure(result.in());
          }
          catch (const Components::WrongComponentType& )
          {
            CDMW_ERROR(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
                "Cannot configure created component: wrong component type.");
            Components::CreateFailure ex(CdmwDeployment::WRONG_COMPONENT_KIND);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
          }
      }
    
      return result._retn();
   }

 

   //
   // IDL:omg.org/CosLifeCycle/LifeCycleObject/remove:1.0
   //
   void
   ExtensionLoggerServiceHome_impl::remove()
      throw(CosLifeCycle::NotRemovable,
            CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
      check_is_removed(m_oid.in());

      
      CCMHome_impl::remove();
         
      m_home_executor = TestService::CCM_LoggerServiceHome::_nil();
   }

   //
   // ServantProvider abstract operation implementation
   //

   
   /**
    * This returns an array containing repository IDs of all objects
    * supported by the current ServantProvider.
    * <B>NOTA:</B> Repository IDs should be statically allocated; thus derived classes
    * should not delete return pointer(s).
    */
   
   const char ** 
   ExtensionLoggerServiceHome_impl::get_ids() const
      throw()
   {
      CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
      static const char* ids[] = {
         "IDL:omg.org/Components/Events:1.0",
         "IDL:omg.org/Components/Receptacles:1.0",
         "IDL:omg.org/Components/Navigation:1.0",
         "IDL:omg.org/Components/CCMObject:1.0",
         "IDL:acme.com/TestService/LoggerService:1.0",

         0
      };

      return ids;
   }

   
   /**
    * This returns the number of repository Ids supported by the current ServantProvider.
    * <B>NOTA:</B> This should correspond to the number of null terminated strings
    * returned by get_ids() operation.
    */
   
   CORBA::Long 
   ExtensionLoggerServiceHome_impl::get_number_of_ids() const
      throw()
   {
      CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
      
   
      static const CORBA::Long nb = 5;

      CDMW_LOG_FUNCTION_RETURN(nb);
      return nb;
   }

   //
   // CdmwCCMHome abstract operation implementation
   //

   
   /**
    * Purpose:
    * <p>
    *   This creates new component servant.
    *   This shall be implemented by the well typed home servant.
    *
    * @param ctx      The component context
    * @param executor The component executor. It can null if component has been
    *                 created with a standard factory operation.
    * 
    * @return The new component servant.
    */
   
   PortableServer::Servant 
   ExtensionLoggerServiceHome_impl::create_component_servant
         (const std::string&                comp_oid,
          Context*            ctx,
          ComponentInfo&   comp_info)
      throw(Components::CreateFailure,
            CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
          "comp_oid="<<comp_oid);
      check_is_removed(m_oid.in());

      try
      {
      
         // get COMPONENT_NAME from ConfigValues
         const char* component_name = 0;
         try {
             Components::ConfigValues_var config_values = 
                 ctx->get_config_values(comp_oid);
             for( CORBA::ULong i = 0; i < config_values->length(); i++ ) {
                 if( ! strcmp (::CdmwDeployment::COMPONENT_NAME, config_values[i]->name())) 
                 {
                     // extract COMPONENT_NAME
                     config_values[i]->value() >>= component_name;
                 }
             }
             
         } catch (const Cdmw::Common::NotFoundException& e) {
             // No config values for this component.
         }
         
         // create LoggerFactory with component name
         std::ostringstream component_log_name;
         if (component_name != 0) {
             component_log_name << component_name;
         } else {
             static int counter=0;
             component_log_name << "LoggerService"
                                << "#" << ++counter;
         }
         CdmwLogging::LoggerFactory_var logger_factory =
             Cdmw::CCM::CIF::CCMUtils::Create_LoggerFactory(component_log_name.str().c_str());

             
         // Check if an executor has been created at ref creation
         // that is a factory operation has been used to create ref.
         Components::EnterpriseComponent_var comp_exec = comp_info.comp_exec;
         bool is_created_by_factory_operation = false;

         if (CORBA::is_nil(comp_exec.in()))
         {
             CDMW_INFO(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(),
                "Create component executor " << component_log_name.str()); 
             
            // Create executor
            comp_exec = m_home_executor->create();
            
            if (CORBA::is_nil(comp_exec.in()))
            {
               CDMW_ERROR(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
                   "Component executor is nil!");
               Components::CreateFailure ex(CdmwDeployment::INVALID_COMPONENT_EXECUTOR);
               CDMW_LOG_FUNCTION_EXCEPTION(ex);
               throw ex;
            }
         }
         else
         {
            is_created_by_factory_operation = true;
         }

         CDMW_INFO(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(),
            "Create component servant " << component_log_name.str()); 
             
   
         return new ExtensionLoggerService_impl(
            comp_oid, 
            ctx, 
            comp_info.comp_ref.in(), 
            comp_exec.in(),
            m_object_registration.in(),
            logger_factory.in(),
            is_created_by_factory_operation);
      
      }
      catch (const Components::CCMException& e)
      {
         CDMW_ERROR(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
             "CCMException occured during component executor creation: " << e);
         Components::CreateFailure ex(CdmwDeployment::CREATE_FAILURE);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
      catch (const CORBA::SystemException& e)
      {
         CDMW_ERROR(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
             "SystemException occured during component executor creation: " << e);
         CDMW_LOG_FUNCTION_EXCEPTION(e);
         throw;
      }
   }

   
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestService


   
   
   namespace Cdmw
   {
   namespace CCM
   {
   namespace Container
   {
   
      template <>
      PortableServer::Servant
      HomeAllocator<CIF::CdmwTestService::ExtensionLoggerServiceHome_impl>::allocate
                  (Components::HomeExecutorBase_ptr            home_executor,
                   const Cdmw::LifeCycle::ObjectDeactivator & deactivator,
                   CdmwLifeCycle::ObjectRegistration_ptr      object_registration,
                   const Components::ConfigValues& config)
         throw(CORBA::SystemException,
               std::bad_alloc)
      {
         CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
         return new CIF::CdmwTestService::ExtensionLoggerServiceHome_impl(home_executor, deactivator, object_registration, config);
      }   
   
   }; // end of namespace Container

   }; // end of namespace CCM

   }; // end of namespace Cdmw

