
/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/* =========================================================================== * 
 * This code has been generated by CDMW Code Generator 1.0
 * on Fri Nov 13 14:09:24 CET 2009
 * DO NOT EDIT !!!
 * =========================================================================== */

   
   
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
   

   #include "FacetFacetTest_impl.hpp"
   #include "RaiseExceptionServantRequest_impl.hpp"
   #include "MakeOperationServantRequest_impl.hpp"

   
namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwTestComponents {
FacetFacetTest_impl::FacetFacetTest_impl(Components::ExecutorLocator_ptr exec_locator, 
                        const std::string& name,
                        Context*                  ctx,
                        CORBA::Object_ptr         comp_ref,
                        PortableServer::Servant   component,
                        CdmwLogging::Logger_ptr   logger,
                        const std::string& comp_id)
    : LifeCycleObjectBase(ctx), FacetTest_impl(exec_locator, name, ctx, comp_ref, component, logger),
        m_context(ctx),
        m_component_identity(comp_id)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "name="<<name);
      // TODO: in Java MOSIC there is no comp_ref argument
   }

   FacetFacetTest_impl::~FacetFacetTest_impl() throw()
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "m_facet_name="<<m_facet_name);
      // no remove_ref on component while it's done in var destructor
   }
     
void
FacetFacetTest_impl::raiseException
(
 CORBA::Boolean raise,
 const char* reason
 )
    throw (
         TestComponents::ExceptionTest,            
         CORBA::SystemException
         )
{
    CDMW_LOG_FUNCTION(m_logger.in(), "");
    try
        {
            CORBA::Object_var obj = m_executor_locator->obtain_executor(m_facet_name.c_str());

            if (CORBA::is_nil(obj.in()))
                {
                    CDMW_ERROR(m_logger.in(), 
                               "Executor for facet " <<m_facet_name<< " is nil");
                    CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                               CORBA::COMPLETED_NO);
                    CDMW_LOG_FUNCTION_EXCEPTION(ex);
                    throw ex;
                }

            TestComponents::CCM_FacetTest_var facet_exec = TestComponents::CCM_FacetTest::_narrow(obj.in());


    
            if (CORBA::is_nil(facet_exec.in()))
                {
                    CDMW_ERROR(m_logger.in(), 
                               "Executor for facet " <<m_facet_name<< " has wrong type");
                    CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                               CORBA::COMPLETED_NO);
                    CDMW_LOG_FUNCTION_EXCEPTION(ex);
                    throw ex;
                }



            ::std::string feature_name =
                  ::std::string(this->m_facet_name);
            
            ::CORBA::Object_var target = 
                  ::CORBA::Object::_duplicate(this->m_executor_locator);
           
            /**
             * The thrown exception if any
             */

            RaiseExceptionServantRequest_impl request
                (
                 feature_name.c_str(),
                 m_component_identity.c_str(), 
                 target, 
                 m_context
                 );

            if (request.is_read_write()) {
                request.add_in_args_raise(raise);
                request.add_in_args_reason(reason);
                request.add_exception_ExceptionTest_tc();
            }
            request.pre_invoke();

       
            /**
             * The operation parameters
             */
            ::CORBA::Boolean _raise = raise;

            /**
             * The operation parameters
             */
            const char * _reason = reason;

            if (request.is_read_write()) {
                _raise = request.get_in_args_raise();
                _reason = request.get_in_args_reason();
            }
        
            try {


                ::CORBA::Any_var the_exception
                      = request.the_exception();

                if(true == request.m_proceed_call && 
                   ::CORBA::tk_null == the_exception->type()->kind()) {

                    facet_exec->raiseException
                        (
                         _raise, 
                         _reason
                         );               
                }

            }
            catch(::CORBA::SystemException & se){
                CDMW_LOG_FUNCTION_EXCEPTION(se);
                request.add_system_exception(se);
            }
            catch(::TestComponents::ExceptionTest & e) {
                CDMW_LOG_FUNCTION_EXCEPTION(e);
                request.add_exception_ExceptionTest(e);                
            }


            request.post_invoke();
  
            m_executor_locator->release_executor(facet_exec.in());

                    
            if (request.is_read_write()) {

                ::CORBA::Any_var the_exception
                      = request.the_exception();
           
                if(::CORBA::tk_null != the_exception->type()->kind()) {
                    ::CORBA::Any_var ex = request.the_exception();
                    
                    if(ex->type()->equal(::TestComponents::_tc_ExceptionTest)) {
                        ::TestComponents::ExceptionTest * user_exception = 0;
                        if(!(ex.in() >>= user_exception)) {
                            CDMW_ASSERT(0);
                        }

                        throw *user_exception;
                    } else {
                        throw request.the_systemException();
                    } 

                }
                       
            } else {
                request.throw_exception();
            }            
        }
    catch (const Components::CCMException& e )
        {
            CDMW_ERROR(m_logger.in(), 
                       "CCMException received: "<< e);
            CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                               CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
}
   
CORBA::Long
FacetFacetTest_impl::makeOperation

(
 
 TestComponents::ArithOperator oper,
 CORBA::Long operand1,
 CORBA::Long operand2,
 CORBA::Long_out remainder
         )
    throw (
           
           TestComponents::ExceptionTest,           
           CORBA::SystemException
           )
{
    CDMW_LOG_FUNCTION(m_logger.in(), "");
    try
        {
            CORBA::Object_var obj = m_executor_locator->obtain_executor(m_facet_name.c_str());
            
            if (CORBA::is_nil(obj.in()))
                {
                    CDMW_ERROR(m_logger.in(), 
                               "Executor for facet " <<m_facet_name<< " is nil");
                    CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                               CORBA::COMPLETED_NO);
                    CDMW_LOG_FUNCTION_EXCEPTION(ex);
                    throw ex;
                }

            TestComponents::CCM_FacetTest_var facet_exec = TestComponents::CCM_FacetTest::_narrow(obj.in());
    
            if (CORBA::is_nil(facet_exec.in()))
                {
                    CDMW_ERROR(m_logger.in(), 
                               "Executor for facet " <<m_facet_name<< " has wrong type");
                    CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                               CORBA::COMPLETED_NO);
                    CDMW_LOG_FUNCTION_EXCEPTION(ex);
                    throw ex;
                }
    

            ::std::string feature_name =
                  this->m_facet_name;
            
            ::CORBA::Object_var target =
                  ::CORBA::Object::_duplicate(this->m_executor_locator);
       
            /**
             * The return value
             */
            ::CORBA::Long __result =0; 
            MakeOperationServantRequest_impl request
                (
                 feature_name.c_str(),
                 m_component_identity.c_str(),
                 target,
                 m_context
                 );
            
            if (request.is_read_write()) {
                request.add_in_args_oper(oper);
                request.add_in_args_operand1(operand1);
                request.add_in_args_operand2(operand2);
                request.add_out_args_remainder(remainder);
                request.add_exception_ExceptionTest_tc();

                request.add_result_value(__result);
       

            }
            request.pre_invoke();

       
            /**
             * The operation parameters
             */
            ::TestComponents::ArithOperator _oper =oper;

            /**
             * The operation parameters
             */
            ::CORBA::Long _operand1 =operand1;

            /**
             * The operation parameters
             */
            ::CORBA::Long _operand2 =operand2;

            /**
             * The operation parameters
             */
            ::CORBA::Long & _remainder =remainder;

            if (request.is_read_write()) {
                _oper = request.get_in_args_oper();
                _operand1 = request.get_in_args_operand1();
                _operand2 = request.get_in_args_operand2();

            }
        
            try{           
                ::CORBA::Any_var the_exception =
                      request.the_exception();
                if(true == request.m_proceed_call &&
                   ::CORBA::tk_null == the_exception->type()->kind()) {

                    __result =
                        facet_exec->makeOperation
                        (
                         _oper,
                         _operand1,
                         _operand2,
                         _remainder
                         );


                    if (request.is_read_write()) {
                        request.add_out_args_remainder(remainder);

                        request.add_result_value(__result);
                    }
            
                }
            }
            catch(::CORBA::SystemException & se){
                request.add_system_exception(se);
            }
            catch(::TestComponents::ExceptionTest & e) {
                request.add_exception_ExceptionTest(e);
            }

            request.post_invoke();
                  
            m_executor_locator->release_executor(facet_exec.in());

            if (request.is_read_write()) {
           
                ::CORBA::Any_var the_exception =
                      request.the_exception();
                
                if(::CORBA::tk_null != the_exception->type()->kind()) {           
                    if(the_exception->type()->equal(::TestComponents::_tc_ExceptionTest)) {
                        ::TestComponents::ExceptionTest * user_exception = 0;
                        if(!(the_exception.in() >>= user_exception)) {
                            CDMW_ASSERT(0);                            
                        }
                        throw *user_exception;
                    } else {            
                        throw request.the_systemException();
                    }
                }
                       
        
                __result = request.result_value();
                remainder = request.get_out_args_remainder();

            
            } else {
                request.throw_exception();
            }


            return __result;
                              
        }
    catch (const Components::CCMException& e )
        {
            CDMW_ERROR(m_logger.in(), 
                       "CCMException received: "<< e);
            CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                               CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
}
   
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestComponents
