
/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/* =========================================================================== * 
 * This code has been generated by CDMW Code Generator 1.0
 * on Fri Nov 13 14:09:24 CET 2009
 * DO NOT EDIT !!!
 * =========================================================================== */

   
   
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
   
   #include "FacetHello_impl.hpp"
   #include "EchoServantRequest_impl.hpp"


   
namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwTestComponents {
FacetHello_impl::FacetHello_impl(Components::ExecutorLocator_ptr exec_locator, 
                        const std::string& name,
                        Context*                  ctx,
                        CORBA::Object_ptr         comp_ref,
                        PortableServer::Servant   component,
                        CdmwLogging::Logger_ptr   logger,
                        const std::string& comp_id)
    : LifeCycleObjectBase(ctx), Hello_impl(exec_locator, name, ctx, comp_ref, component, logger),
        m_context(ctx),
        m_component_identity(comp_id)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "name="<<name);
      // TODO: in Java MOSIC there is no comp_ref argument
   }

   FacetHello_impl::~FacetHello_impl() throw()
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "m_facet_name="<<m_facet_name);
      // no remove_ref on component while it's done in var destructor
   }


    void FacetHello_impl::echo 
    (         
     const char* msg
     )
        throw (                                  
               CORBA::SystemException
               )
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "");
        try
            {
                CORBA::Object_var obj = m_executor_locator->obtain_executor(m_facet_name.c_str());
            
                if (CORBA::is_nil(obj.in()))
                    {
                        CDMW_ERROR(m_logger.in(), 
                                   "Executor for facet " <<m_facet_name<< " is nil");
                        CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                                   CORBA::COMPLETED_NO);
                        CDMW_LOG_FUNCTION_EXCEPTION(ex);
                        throw ex;
                    }

                HelloModule::CCM_Hello_var facet_exec = HelloModule::CCM_Hello::_narrow(obj.in());
    
                if (CORBA::is_nil(facet_exec.in()))
                    {
                        CDMW_ERROR(m_logger.in(), 
                                   "Executor for facet " <<m_facet_name<< " has wrong type");
                        CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                                   CORBA::COMPLETED_NO);
                        CDMW_LOG_FUNCTION_EXCEPTION(ex);
                        throw ex;
                    }
    

                ::std::string feature_name =
                      this->m_facet_name;
            
                ::CORBA::Object_var target =
                      ::CORBA::Object::_duplicate(this->m_executor_locator);
       
                /**
                 * The return value
                 */

                EchoServantRequest_impl request
                    (
                     feature_name.c_str(),
                     m_component_identity.c_str(),
                     target,
                     m_context
                     );
            
                if (request.is_read_write()) {
                    request.add_in_args_msg(msg);       
                }
                request.pre_invoke();

       
                /**
                 * The operation parameters
                 */
                const char * _msg =msg;


                if (request.is_read_write()) {
                    _msg = request.get_in_args_msg();
                }
        
                try {           
                    ::CORBA::Any_var the_exception =
                          request.the_exception();
                    if(true == request.m_proceed_call &&
                       ::CORBA::tk_null == the_exception->type()->kind()) {
                            facet_exec->echo 
                            (
                             _msg
                             );                          
                    }
                }
                catch(::CORBA::SystemException & se){
                    request.add_system_exception(se);
                }
            
                request.post_invoke();
                  
                m_executor_locator->release_executor(facet_exec.in());

                if (request.is_read_write()) {
           
                    ::CORBA::Any_var the_exception =
                          request.the_exception();
                
                    if(::CORBA::tk_null != the_exception->type()->kind()) {           
                        throw request.the_systemException();
                    }
                                          
                } else {
                    request.throw_exception();
                }
                              
            }
        catch (const Components::CCMException& e )
            {
                CDMW_ERROR(m_logger.in(), 
                           "CCMException received: "<< e);
                CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                                   CORBA::COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(ex);
                throw ex;
            }
    }
   
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestComponents
