
/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/* =========================================================================== * 
 * This code has been generated by CDMW Code Generator 1.0
 * on Fri Nov 13 14:09:24 CET 2009
 * DO NOT EDIT !!!
 * =========================================================================== */

   
   
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
   

   #include "FacetTest_impl.hpp"

   
namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwTestComponents {
FacetTest_impl::FacetTest_impl(Components::ExecutorLocator_ptr exec_locator, 
                        const std::string& name,
                        Context*                  ctx,
                        CORBA::Object_ptr         comp_ref,
                        PortableServer::Servant   component,
                        CdmwLogging::Logger_ptr   logger)
      : LifeCycleObjectBase(ctx),
        m_executor_locator(Components::ExecutorLocator::_duplicate(exec_locator)),
        m_facet_name(name),
        m_comp_ref(CORBA::Object::_duplicate(comp_ref)),
        m_component(component),
        m_logger(CdmwLogging::Logger::_duplicate(logger))
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "name="<<name);
      // incrementation refcount of component in order to avoid destruction
      // of the component before the destruction of the facet
      m_component->_add_ref();
   }

   FacetTest_impl::~FacetTest_impl() throw()
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "m_facet_name="<<m_facet_name);
      // no remove_ref on component while it's done in var destructor
   }

   CORBA::Object_ptr
   FacetTest_impl::_get_component()
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      return CORBA::Object::_duplicate(m_comp_ref.in());
   }

    
     
     
     
void
FacetTest_impl::raiseException

         (
            
            CORBA::Boolean raise,
const char* reason
         )
      throw (
         
         TestComponents::ExceptionTest,
            
         CORBA::SystemException
      )
      {
           CDMW_LOG_FUNCTION(m_logger.in(), "");
           try
            {
             CORBA::Object_var obj = m_executor_locator->obtain_executor(m_facet_name.c_str());

            if (CORBA::is_nil(obj.in()))
            {
               CDMW_ERROR(m_logger.in(), 
                   "Executor for facet " <<m_facet_name<< " is nil");
               CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                          CORBA::COMPLETED_NO);
               CDMW_LOG_FUNCTION_EXCEPTION(ex);
               throw ex;
            }

            TestComponents::CCM_FacetTest_var facet_exec = TestComponents::CCM_FacetTest::_narrow(obj.in());
    
            if (CORBA::is_nil(facet_exec.in()))
            {
               CDMW_ERROR(m_logger.in(), 
                   "Executor for facet " <<m_facet_name<< " has wrong type");
               CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                          CORBA::COMPLETED_NO);
               CDMW_LOG_FUNCTION_EXCEPTION(ex);
               throw ex;
            }
    
            
            facet_exec->raiseException
               (
                  raise, reason
               );

            m_executor_locator->release_executor(facet_exec.in());

            
         }
            catch (const Components::CCMException& e )
            {
               CDMW_ERROR(m_logger.in(), 
                   "CCMException received: "<< e);
               CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                                  CORBA::COMPLETED_NO);
               CDMW_LOG_FUNCTION_EXCEPTION(ex);
               throw ex;
            }
       }
   
CORBA::Long
FacetTest_impl::makeOperation

         (
            
            TestComponents::ArithOperator oper,
CORBA::Long operand1,
CORBA::Long operand2,
CORBA::Long_out remainder
         )
      throw (
         
         TestComponents::ExceptionTest,
            
         CORBA::SystemException
      )
      {
           CDMW_LOG_FUNCTION(m_logger.in(), "");
           try
            {
             CORBA::Object_var obj = m_executor_locator->obtain_executor(m_facet_name.c_str());

            if (CORBA::is_nil(obj.in()))
            {
               CDMW_ERROR(m_logger.in(), 
                   "Executor for facet " <<m_facet_name<< " is nil");
               CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                          CORBA::COMPLETED_NO);
               CDMW_LOG_FUNCTION_EXCEPTION(ex);
               throw ex;
            }

            TestComponents::CCM_FacetTest_var facet_exec = TestComponents::CCM_FacetTest::_narrow(obj.in());
    
            if (CORBA::is_nil(facet_exec.in()))
            {
               CDMW_ERROR(m_logger.in(), 
                   "Executor for facet " <<m_facet_name<< " has wrong type");
               CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                          CORBA::COMPLETED_NO);
               CDMW_LOG_FUNCTION_EXCEPTION(ex);
               throw ex;
            }
    
            CORBA::Long result =
            facet_exec->makeOperation
               (
                  oper, operand1, operand2, remainder
               );

            m_executor_locator->release_executor(facet_exec.in());

            
                     return result;
                  
         }
            catch (const Components::CCMException& e )
            {
               CDMW_ERROR(m_logger.in(), 
                   "CCMException received: "<< e);
               CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                                  CORBA::COMPLETED_NO);
               CDMW_LOG_FUNCTION_EXCEPTION(ex);
               throw ex;
            }
       }
   
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestComponents
