
/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/* =========================================================================== * 
 * This code has been generated by CDMW Code Generator 1.0
 * on Fri Nov 06 14:46:22 CET 2009
 * DO NOT EDIT !!!
 * =========================================================================== */

   
   
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
#include <CCMContainer/ccmcommon/CCMUtils.hpp>
#include <CCMContainer/ccmcif/CCMUtils.hpp>
#include <CCMContainer/ccmcommon/CCMLoggers.hpp>
#include <CCMContainer/ccmcopi/COPIServiceInit.hpp>
   
   #include "SessionClient_impl.hpp"
   
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <SystemMngt/platforminterface/PlatformInterface.hpp>
#include <Foundation/idllib/CdmwDeployment.stub.hpp>
   


#include "ActivatedConsumer_impl.hpp"
#include "ServerInfoConsumer_impl.hpp"

   
#include <CCMContainer/idllib/CdmwCcmCif.skel.hpp>
   
   #include "CCM_Client_SessionContext_impl.hpp"

#include "ReceptacleHello_impl.hpp"
#include "ReceptacleFacetTest_impl.hpp" 

   namespace {
        
      
      const char* COMP_REP_ID = "IDL:acme.com/TestComponents/Client:1.0";
      
      const char* COMP_NAME   = "Client";

      
      
const char* RECEP_TO_SERVER_NAME = "to_server";
   
const char* RECEP_TO_SERVER_REP_ID = "IDL:acme.com/TestComponents/FacetTest:1.0";

const char* RECEP_TO_ECHO_NAME = "to_echo";
   
const char* RECEP_TO_ECHO_REP_ID = "IDL:acme.com/HelloModule/Hello:1.0";

const char* CONSUMER_SERVER_IS_ACTIVATED_NAME = "server_is_activated";
   
const char* CONSUMER_SERVER_IS_ACTIVATED_REP_ID = "IDL:thalesgroup.com/Cdmw_TestComponents/ActivatedConsumer:1.0";

const char* CONSUMER_SERVER_INFO_NAME = "server_info";
   
const char* CONSUMER_SERVER_INFO_REP_ID = "IDL:thalesgroup.com/Cdmw_TestComponents/ServerInfoConsumer:1.0";

      
      /*
       * If a home, when creating a component, returns an EnterpriseComponent, we map it 
       * in an ExecutorLocator for code optimisation purpose. Thus the code is the same
       * for monolithic executor and segmented executor.
       */
      class ClientExecutorLocator : public CdmwCcmCif::SessionExecutorLocator,
                                    public Cdmw::OrbSupport::RefCountLocalObject
      {
      public:
          ClientExecutorLocator
          (
           const ::std::string & component_id,
           ::Cdmw::CCM::CIF::Context * context,
           TestComponents::CCM_Client_ptr executor,                                
           CdmwLogging::Logger_ptr logger
           )
              : is_a_session_component(false),
                m_comp_executor(TestComponents::CCM_Client::_duplicate(executor)),
                m_logger(CdmwLogging::Logger::_duplicate(logger))
          {
              CDMW_LOG_FUNCTION(m_logger.in(), "");
              try 
                  {
                      Components::SessionComponent_var session_comp
                          = Components::SessionComponent::_narrow(m_comp_executor.in());
            
                      if (!CORBA::is_nil(session_comp.in()))
                          {
                              is_a_session_component = true;
                          }
                  }
              catch (...)
                  {
                  }

              m_server_info_consumer_executer =
                  new CCM_ServerInfoConsumer_impl
                  (                   
                   component_id,
                   context,
                   executor,
                   logger
                   );                         
          };

          ~ClientExecutorLocator() 
          {
              CDMW_LOG_FUNCTION(m_logger.in(), "");
              delete m_server_info_consumer_executer;
              m_server_info_consumer_executer = 0;
          };

          /*
           * the cif will invoke its obtain_executor operation prior to each invocation to
           * retrieve the implementation for a port. The port name, given in the name
           * parameter, is the same as used in the components interface description 
           * in IDL, or the components name for the main executor. The obtain_executor
           * operation returns a local object reference of the expected type. The 
           * CCMException exception may be raised in case of a system error that 
           * prohibits locating the requested executor.
           */
          //
          // IDL:omg.org/Components/ExecutorLocator/obtain_executor:1.0
          //
          virtual CORBA::Object_ptr obtain_executor(const char* name)
              throw(Components::CCMException,
                    CORBA::SystemException)
          {
              CDMW_LOG_FUNCTION(m_logger.in(), "name="<<name);
              std::string exec_name(name);
              CORBA::Object_var result;

              if (exec_name == "Client")
                  {
                      result = TestComponents::CCM_Client::_duplicate(m_comp_executor.in());
                  }
                  
   
              else if (exec_name == CONSUMER_SERVER_IS_ACTIVATED_NAME)
                  {
                      // NOTE: code generator should generate the same
                      // as it is done for ServerInfo
                      ::CORBA::NO_IMPLEMENT no;
                      CDMW_LOG_FUNCTION_EXCEPTION(no);
                      throw no;
                  }
   
   
              else if (exec_name == CONSUMER_SERVER_INFO_NAME)
                  {
                      result = ::TestComponents::CCM_ServerInfoConsumer::_duplicate(m_server_info_consumer_executer);
                  }

              else 
                  {
                      CDMW_ERROR(m_logger.in(), 
                                 "'"<<name<<"' is unkown: cannot obtain executor for it");
                      CORBA::BAD_PARAM ex(Cdmw::OrbSupport::BAD_PARAMInvalidExecutorName, CORBA::COMPLETED_NO);
                      CDMW_LOG_FUNCTION_EXCEPTION(ex);
                      throw ex;
                  }

              return result._retn();
          };

          /* 
           * The release_executor operation is called by the cif once the current
           * invocation on an executor that was obtained through the obtain_executor 
           * operation has finished. The locator can thus release any resources that
           * were acquired as part of the obtain_executor operation.
           */
          //
          // IDL:omg.org/Components/ExecutorLocator/release_executor:1.0
          //
          virtual void release_executor(CORBA::Object_ptr exc)
              throw(Components::CCMException,
                    CORBA::SystemException)
          {
              CDMW_LOG_FUNCTION(m_logger.in(), "");
          };

          /* 
           * The configuration_complete operation is called to propagate the
           * configuration_complete operation on the CCMObject interface to the
           * component implementation.
           */
          //
          // IDL:omg.org/Components/ExecutorLocator/configuration_complete:1.0
          //
          virtual void configuration_complete()
              throw(Components::InvalidConfiguration,
                    CORBA::SystemException)
          {
              CDMW_LOG_FUNCTION(m_logger.in(), "");
              // No equivalent operation for monolithic executor
          };

          //
          // IDL:omg.org/Components/SessionComponent/set_session_context:1.0
          //
          virtual void set_session_context(Components::SessionContext_ptr ctx)
              throw(Components::CCMException,
                    CORBA::SystemException)
          {
              CDMW_LOG_FUNCTION(m_logger.in(), "");
              // check if component implements the SessionComponent local interface
              if (is_a_session_component)
                  {
                      CDMW_INFO(m_logger.in(), "Call set_session_context()");
                      Components::SessionComponent_var session_comp 
                          = Components::SessionComponent::_narrow(m_comp_executor.in());
                      session_comp->set_session_context(ctx);
                  }
          };

          /* 
           * The ccm_activate operation is called by the container to notify a 
           * session component that it has been made active. The component instance
           * should perform any initialization required prior to operation invocation.
           * The component may raise the CCMException with the SYSTEM_ERROR minor code
           * to indicate a failure caused by a system level error.
           */
          //
          // IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
          //
          virtual void ccm_activate()
              throw(Components::CCMException,
                    CORBA::SystemException)
          {
              CDMW_LOG_FUNCTION(m_logger.in(), "");
              // check if component implements the SessionComponent local interface
              if (is_a_session_component)
                  {
                      CDMW_INFO(m_logger.in(), "Call ccm_activate()");
                      Components::SessionComponent_var session_comp 
                          = Components::SessionComponent::_narrow(m_comp_executor.in());
                      session_comp->ccm_activate();
                  }
          };

          /* 
           * The ccm_passivate operation is called by the container to notify a session
           * component that it has been made inactive. The component instance should
           * release any resources it acquired at activation time.The component may 
           * raise the CCMException with the SYSTEM_ERROR minor code to indicate a 
           * failure caused by a system level error.
           */
          //
          // IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
          //
          virtual void ccm_passivate()
              throw(Components::CCMException,
                    CORBA::SystemException)
          {
              CDMW_LOG_FUNCTION(m_logger.in(), "");
              // check if component implements the SessionComponent local interface
              if (is_a_session_component)
                  {
                      CDMW_INFO(m_logger.in(), "Call ccm_passivate()");
                      Components::SessionComponent_var session_comp 
                          = Components::SessionComponent::_narrow(m_comp_executor.in());
                      session_comp->ccm_passivate();
                  }
          };

          /* 
           * The ccm_remove operation is called by the container when the servant is
           * about to be destroyed. It informs the component that it is about to be
           * destroyed.The component may raise the CCMException with the SYSTEM_ERROR
           * minor code to indicate a failure caused by a system level error.
           */
          //
          // IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
          //
          virtual void ccm_remove()
              throw(Components::CCMException,
                    CORBA::SystemException)
          {
              CDMW_LOG_FUNCTION(m_logger.in(), "");
              // check if component implements the SessionComponent local interface
              if (is_a_session_component)
                  {
                      CDMW_INFO(m_logger.in(), "Call ccm_remove()");
                      Components::SessionComponent_var session_comp 
                          = Components::SessionComponent::_narrow(m_comp_executor.in());
                      session_comp->ccm_remove();
                  }
          };


      private:
          ClientExecutorLocator(const ClientExecutorLocator&);
          void operator=(const ClientExecutorLocator&);

          class CCM_ServerInfoConsumer_impl : 
              virtual public ::CORBA::LocalObject,
              virtual public ::TestComponents::CCM_ServerInfoConsumer
          {
          public:
              CCM_ServerInfoConsumer_impl
              (
               const ::std::string & component_id,
               ::Cdmw::CCM::CIF::Context * context,
               ::TestComponents::CCM_Client_ptr comp_executor,
               CdmwLogging::Logger_ptr logger
               ) :
                  m_component_id(component_id),
                  m_context(context),
                  m_comp_executor(::TestComponents::CCM_Client::_duplicate(comp_executor)),
                  m_logger(::CdmwLogging::Logger::_duplicate(logger))
              {                  
                  CDMW_LOG_FUNCTION(m_logger.in(), "");
              }
       
              ~CCM_ServerInfoConsumer_impl() throw() 
              {
                  CDMW_LOG_FUNCTION(m_logger.in(), "");
              }

              virtual void 
              push(TestComponents::ServerInfo * event)
                  throw (CORBA::SystemException)  
              {
                  CDMW_LOG_FUNCTION(m_logger.in(), "");
                  push_server_info(event);
              }
         
              virtual void
              push_server_info(TestComponents::ServerInfo * event)
                  throw (CORBA::SystemException) 
              {
                  CDMW_LOG_FUNCTION(m_logger.in(), "");
        
                  if(true == Cdmw::CCM::COPI::COPIServiceInit::Is_initialized()) {
            
                      Cdmw::CCM::COPI::PushContainerServantRequest_impl request
                          (
                           "server_info", 
                           m_component_id.c_str(),
                           m_comp_executor, 
                           m_context
                           );

                      if(!request.is_read_write()) {
                          m_comp_executor->push_server_info(event);
                          return;
                      }

                      // request is a read / write request
                      ::CORBA::Any in_arg;
                      in_arg <<= event;

                      request.add_in_args(in_arg);
                      request.pre_invoke();

                      // The operation parameters
                      ::TestComponents::ServerInfo * _event = 0;
                      ::CORBA::Any_var event_any;

                      try {
                          event_any = request.get_arg(0);
                      } catch(::CORBA::SystemException & se) {
                          request.add_system_exception(se);
                          request.throw_exception();
                      } catch(...) {
                          CDMW_ERROR(m_logger.in(),"A Stub COPI has corrupted the args");
                          ::CORBA::BAD_OPERATION bad_op;
                          request.add_system_exception(bad_op);
                          request.throw_exception();
                      }

                      if(::CORBA::tk_null == event_any->type()->kind()) {
                          CDMW_ERROR(m_logger.in(),"A Stub COPI has corrupted the args");
                          ::CORBA::BAD_OPERATION bad_op;
                          request.add_system_exception(bad_op);
                          request.throw_exception();
                      }

                      if(event_any->type()->equal(::TestComponents::_tc_ServerInfo)) {
                          if(!(event_any.in() >>= _event)) {
                              CDMW_ASSERT(0);
                          }
                      } else {
                          CDMW_ERROR(m_logger.in(),"A Stub COPI has corrupted the args");
                          ::CORBA::BAD_OPERATION bad_op;
                          request.add_system_exception(bad_op);
                          request.throw_exception();
                      }

                      try {
                          ::CORBA::Any_var the_exception =
                                request.the_exception();
                          if((true == request.m_proceed_call && ::CORBA::tk_null == the_exception->type()->kind())) {
                              m_comp_executor->push_server_info(_event);
                          }
                      } catch(::CORBA::SystemException & se) {
                          request.add_system_exception(se);
                      }
                      request.post_invoke();           
                      request.throw_exception();
                  } else {
                      // COPI Service not initialised
                      m_comp_executor->push_server_info(event);
                      return;
                  }

              }

          private:
              CCM_ServerInfoConsumer_impl(const CCM_ServerInfoConsumer_impl&);
              void operator=(const CCM_ServerInfoConsumer_impl&);

              const ::std::string m_component_id;
              ::Cdmw::CCM::CIF::Context * m_context;
              ::TestComponents::CCM_Client_var m_comp_executor;
              CdmwLogging::Logger_var m_logger;
          };


          bool is_a_session_component;  // indicates that the component executor inherits
          // from the SessionComponent local interface.

          TestComponents::CCM_Client_var m_comp_executor; // points on Component monolithic executor.

          CCM_ServerInfoConsumer_impl * m_server_info_consumer_executer;
            
          CdmwLogging::Logger_var m_logger;
      };
   };  // end of anonymous namespace

   
namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwTestComponents {



   // Constructor
   SessionClient_impl::SessionClient_impl(const std::string& comp_oid,
                         Context*                          ctx,
                         CORBA::Object_ptr                 comp_ref,
                         Components::EnterpriseComponent*  executor,
      
                         CdmwLifeCycle::ObjectRegistration_ptr object_registration,
                         CdmwLogging::LoggerFactory_ptr    logger_factory,
                                          bool is_created_by_factory_operation) 
      throw (Components::CCMException,
             CORBA::SystemException)
      
      : CCMObject_impl(comp_oid, ctx, COMP_REP_ID, comp_ref, object_registration, logger_factory),
         
        m_is_created_by_factory_operation(is_created_by_factory_operation)      
   {
      // create logger with domain for ccmcif
      m_logger = logger_factory->get_logger(CCMLoggers::CCMGENERATED_LOG_DOMAIN);
   
      CDMW_LOG_FUNCTION(m_logger.in(), "comp_oid="<<comp_oid);
      
      
      
      // Check if the home returns an executor locator
      m_executor_locator = Components::ExecutorLocator::_narrow(executor);

      if (CORBA::is_nil(m_executor_locator.in()))
      {
         // executor is not an executor locator
         // map monolithic executor to executor locator
         TestComponents::CCM_Client_var comp_exec = TestComponents::CCM_Client::_narrow(executor);
        
         if (CORBA::is_nil(comp_exec.in()))
         {
            // This is to avoid Assertion failure in debug mode as internal ref count
            // equals 1 (CORBA C++ mapping oblige!)
            _set_ref_count(0);

            CDMW_ERROR(m_logger.in(), "Invalid Component Executor");
            CORBA::BAD_PARAM ex(OrbSupport::BAD_PARAMInvalidComponentExecutor,
                                CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }
         m_executor_locator =
             new ClientExecutorLocator
             (
              get_component_identity(),
              get_context(),
              comp_exec.in(),
              m_logger.in()
              );

         m_session_locator = Components::SessionComponent::_narrow(m_executor_locator.in());
        
         if (CORBA::is_nil(m_session_locator.in()))
         {
             CDMW_ERROR(m_logger.in(), 
                "Executor Locator should be a session component!");
             CORBA::INTERNAL ex(OrbSupport::INTERNALInvalidExecutor,
                                CORBA::COMPLETED_NO);
             CDMW_LOG_FUNCTION_EXCEPTION(ex);
             throw ex;
         }
      }
      else
      {
         Components::SessionComponent_var m_session_locator 
            = Components::SessionComponent::_narrow(m_executor_locator.in());
        
         if (CORBA::is_nil(m_session_locator.in()))
         {
             CDMW_ERROR(m_logger.in(), 
                "Executor Locator should be a session component!");
             CORBA::BAD_PARAM ex(OrbSupport::BAD_PARAMInvalidComponentExecutor,
                                CORBA::COMPLETED_NO);
             CDMW_LOG_FUNCTION_EXCEPTION(ex);
             throw ex;
         }
      }

      Components::CCMContext_var ccm_ctx = ctx->get_ccm_context();
      m_context_executor = new CCM_Client_SessionContext_impl(ccm_ctx.in(), this, logger_factory);
      m_session_locator->set_session_context(m_context_executor.in());

      
         try
         {
            

   declare_receptacle(RECEP_TO_SERVER_NAME, RECEP_TO_SERVER_REP_ID);


   declare_receptacle(RECEP_TO_ECHO_NAME, RECEP_TO_ECHO_REP_ID);

         }
         catch (const AlreadyDoneException&)
         {
            // This is to avoid Assertion failure in debug mode as internal ref count
            // equals 1 (CORBA C++ mapping oblige!)
            _set_ref_count(0);

            CDMW_ERROR(m_logger.in(), 
                "Receptacle already declared!");
            // Don't propagate while its probably a code generation error!
         }
         catch (const InternalErrorException&)
         {
            // This is to avoid Assertion failure in debug mode as internal ref count
            // equals 1 (CORBA C++ mapping oblige!)
            _set_ref_count(0);
        
            CDMW_ERROR(m_logger.in(), 
                "Internal exception raised when declaring receptacle!");
            CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }
         catch (const CORBA::SystemException& e)
         {
            // This is to avoid Assertion failure in debug mode as internal ref count
            // equals 1 (CORBA C++ mapping oblige!)
            _set_ref_count(0);
        
            CDMW_ERROR(m_logger.in(), 
                "System exception raised when declaring receptacle: " << e);
            CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }
      
         try
         {
            
  {
   CORBA::Object_var consumer =
      declare_consumer(comp_oid.c_str(), CONSUMER_SERVER_IS_ACTIVATED_NAME, CONSUMER_SERVER_IS_ACTIVATED_REP_ID);
  }

  {
   CORBA::Object_var consumer =
      declare_consumer(comp_oid.c_str(), CONSUMER_SERVER_INFO_NAME, CONSUMER_SERVER_INFO_REP_ID);
  }

         }
         catch (const AlreadyDoneException&)
         {
            // This is to avoid Assertion failure in debug mode as internal ref count
            // equals 1 (CORBA C++ mapping oblige!)
            _set_ref_count(0);

            CDMW_ERROR(m_logger.in(), "Consumer already declared!");
            // Don't propagate while its probably a code generation error!
         }
         catch (const InternalErrorException&)
         {
            // This is to avoid Assertion failure in debug mode as internal ref count
            // equals 1 (CORBA C++ mapping oblige!)
            _set_ref_count(0);
        
            CDMW_ERROR(m_logger.in(), "Internal exception raised when declaring consumer!");
            CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }
         catch (const CORBA::SystemException& e)
         {
            // This is to avoid Assertion failure in debug mode as internal ref count
            // equals 1 (CORBA C++ mapping oblige!)
            _set_ref_count(0);
        
            CDMW_ERROR(m_logger.in(), 
                "System exception raised when declaring consumer: " << e);
            CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }
      

   }

   SessionClient_impl::~SessionClient_impl()
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      
   }


   /**
    * Component attributes
    */
   

   /**
    * Supported interfaces
    */

   
   







   /**
    * Equivalent IDL methods
    */

   // Facets

   

   // Receptacles

   
void
SessionClient_impl::connect_to_server(TestComponents::FacetTest_ptr conxn)

      throw(Components::AlreadyConnected,
            Components::InvalidConnection,
            CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      try
      {
          CCMObject_impl::connect(RECEP_TO_SERVER_NAME, conxn);
      }
      catch (const Components::InvalidName &)
      {
          CDMW_ERROR(m_logger.in(), "Invalid name for receptacle connection!");
          CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                             CORBA::COMPLETED_NO);
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const Components::AlreadyConnected & e)
      {
          CDMW_LOG_FUNCTION_EXCEPTION(e);
          throw;
      }
      catch (const Components::InvalidConnection & e)
      {
          CDMW_LOG_FUNCTION_EXCEPTION(e);
          throw;
      }
      catch (const Components::ExceededConnectionLimit &)
      {
          CDMW_ERROR(m_logger.in(), 
              "Exceeded connection limit reached for receptacle connection!");
          CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                             CORBA::COMPLETED_NO);   
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const CORBA::SystemException & e)
      {
          CDMW_LOG_FUNCTION_EXCEPTION(e);
          throw;
      }
   }

   
TestComponents::FacetTest_ptr
SessionClient_impl::disconnect_to_server()

      throw(Components::NoConnection,
            CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      try
      {
          TestComponents::FacetTest_var result = get_connection_to_server();
          CCMObject_impl::disconnect(RECEP_TO_SERVER_NAME, 0);

          return result._retn();
      }
      catch (const Components::InvalidName &)
      {
          CDMW_ERROR(m_logger.in(), "Invalid name for receptacle disconnection!");
          CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                            CORBA::COMPLETED_NO);   
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const Components::NoConnection & e)
      {
          CDMW_LOG_FUNCTION_EXCEPTION(e);
          throw;
      }
      catch (const Components::InvalidConnection &)
      {
          CDMW_ERROR(m_logger.in(), "Invalid connection for receptacle disconnection!");
          CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                             CORBA::COMPLETED_NO);
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const Components::CookieRequired &)
      {
          CDMW_ERROR(m_logger.in(), "Cookie required for receptacle disconnection!");
          CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                             CORBA::COMPLETED_NO);   
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const CORBA::SystemException & e)
      {
          CDMW_LOG_FUNCTION_EXCEPTION(e);
          throw;
      }
   }

   
TestComponents::FacetTest_ptr
SessionClient_impl::get_connection_to_server()

      throw(CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      Components::ConnectionDescriptions_var comp_desc;

      try
      {
         comp_desc = CCMObject_impl::get_suitable_connections(RECEP_TO_SERVER_NAME);
      }
      catch (const Components::InvalidName& e)
      {
         CDMW_ERROR(m_logger.in(), "Invalid name getting receptacle!");
         CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                            CORBA::COMPLETED_NO);   
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
      catch (const CORBA::SystemException& e )
      {
         CDMW_LOG_FUNCTION_EXCEPTION(e);
         throw;
      }
      
      TestComponents::FacetTest_var result;
      
      if (comp_desc->length() == 1)
      {
         CORBA::Object_var obj = CORBA::Object::_duplicate(comp_desc->operator[](0)->objref());

         result = TestComponents::FacetTest::_narrow(obj.in());
      }
      else
      {
         result = TestComponents::FacetTest::_nil();
      }
 
      return result._retn();
   }

void
SessionClient_impl::connect_to_echo(HelloModule::Hello_ptr conxn)

      throw(Components::AlreadyConnected,
            Components::InvalidConnection,
            CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      try
      {
          CCMObject_impl::connect(RECEP_TO_ECHO_NAME, conxn);
      }
      catch (const Components::InvalidName &)
      {
          CDMW_ERROR(m_logger.in(), "Invalid name for receptacle connection!");
          CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                             CORBA::COMPLETED_NO);
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const Components::AlreadyConnected & e)
      {
          CDMW_LOG_FUNCTION_EXCEPTION(e);
          throw;
      }
      catch (const Components::InvalidConnection & e)
      {
          CDMW_LOG_FUNCTION_EXCEPTION(e);
          throw;
      }
      catch (const Components::ExceededConnectionLimit &)
      {
          CDMW_ERROR(m_logger.in(), 
              "Exceeded connection limit reached for receptacle connection!");
          CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                             CORBA::COMPLETED_NO);   
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const CORBA::SystemException & e)
      {
          CDMW_LOG_FUNCTION_EXCEPTION(e);
          throw;
      }
   }

   
HelloModule::Hello_ptr
SessionClient_impl::disconnect_to_echo()

      throw(Components::NoConnection,
            CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      try
      {
          HelloModule::Hello_var result = get_connection_to_echo();
          CCMObject_impl::disconnect(RECEP_TO_ECHO_NAME, 0);

          return result._retn();
      }
      catch (const Components::InvalidName &)
      {
          CDMW_ERROR(m_logger.in(), "Invalid name for receptacle disconnection!");
          CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                            CORBA::COMPLETED_NO);   
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const Components::NoConnection & e)
      {
          CDMW_LOG_FUNCTION_EXCEPTION(e);
          throw;
      }
      catch (const Components::InvalidConnection &)
      {
          CDMW_ERROR(m_logger.in(), "Invalid connection for receptacle disconnection!");
          CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                             CORBA::COMPLETED_NO);
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const Components::CookieRequired &)
      {
          CDMW_ERROR(m_logger.in(), "Cookie required for receptacle disconnection!");
          CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                             CORBA::COMPLETED_NO);   
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const CORBA::SystemException & e)
      {
          CDMW_LOG_FUNCTION_EXCEPTION(e);
          throw;
      }
   }

   
HelloModule::Hello_ptr
SessionClient_impl::get_connection_to_echo()

      throw(CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      Components::ConnectionDescriptions_var comp_desc;

      try
      {
         comp_desc = CCMObject_impl::get_suitable_connections(RECEP_TO_ECHO_NAME);
      }
      catch (const Components::InvalidName& e)
      {
         CDMW_ERROR(m_logger.in(), "Invalid name getting receptacle!");
         CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                            CORBA::COMPLETED_NO);   
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
      catch (const CORBA::SystemException& e )
      {
         CDMW_LOG_FUNCTION_EXCEPTION(e);
         throw;
      }
      
      HelloModule::Hello_var result;
      
      if (comp_desc->length() == 1)
      {
         CORBA::Object_var obj = CORBA::Object::_duplicate(comp_desc->operator[](0)->objref());

         result = HelloModule::Hello::_narrow(obj.in());
      }
      else
      {
         result = HelloModule::Hello::_nil();
      }
 
      return result._retn();
   }


   // Publishers

   
   
   // Emitters

   
   
   // Consumers
   
   
TestComponents::ActivatedConsumer_ptr
SessionClient_impl::get_consumer_server_is_activated()
      throw(CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      CORBA::Object_var obj;

      try 
      {
         obj = CCMObject_impl::get_consumer(CONSUMER_SERVER_IS_ACTIVATED_NAME);
      }
      catch (const Components::InvalidName & e)
      {
         CDMW_ERROR(m_logger.in(), "Invalid consumer name");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST,
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }

      if (CORBA::is_nil(obj.in()))
      {
         CDMW_ERROR(m_logger.in(), "Consumer is nil");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }

      TestComponents::ActivatedConsumer_var consumer_ref = TestComponents::ActivatedConsumer::_narrow(obj.in());
       
      if (CORBA::is_nil(consumer_ref.in()))
      {
         CDMW_ERROR(m_logger.in(), "Consumer has wrong type");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
       
      return consumer_ref._retn();
   } 

TestComponents::ServerInfoConsumer_ptr
SessionClient_impl::get_consumer_server_info()
      throw(CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      CORBA::Object_var obj;

      try 
      {
         obj = CCMObject_impl::get_consumer(CONSUMER_SERVER_INFO_NAME);
      }
      catch (const Components::InvalidName & e)
      {
         CDMW_ERROR(m_logger.in(), "Invalid consumer name");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST,
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }

      if (CORBA::is_nil(obj.in()))
      {
         CDMW_ERROR(m_logger.in(), "Consumer is nil");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }

      TestComponents::ServerInfoConsumer_var consumer_ref = TestComponents::ServerInfoConsumer::_narrow(obj.in());
       
      if (CORBA::is_nil(consumer_ref.in()))
      {
         CDMW_ERROR(m_logger.in(), "Consumer has wrong type");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
       
      return consumer_ref._retn();
   } 


   void
   SessionClient_impl::configuration_complete()
      throw(Components::InvalidConfiguration,
            CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      if (!is_configured())
      {
         CDMW_DEBUG(m_logger.in(), "Check if configuration is complete");
      
            
         
         CCMObject_impl::configuration_complete();
        
         try
         {
            
            m_executor_locator->configuration_complete();
            
            // change state
            m_state = m_state->configuration_complete(this);
            

         }
         catch (const Components::CCMException& e)
         {
            
            CDMW_ERROR(m_logger.in(), "Components::CCMException raised, reason " << e);
            
            CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError,
                               CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }
      }
   }

   
TestComponents::CCM_Client*
SessionClient_impl::obtain_component_executor()
      throw (CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      try
      {
         CORBA::Object_var obj = m_executor_locator->obtain_executor(COMP_NAME);

         if (CORBA::is_nil(obj.in()))
         {
            CDMW_ERROR(m_logger.in(), "Component executor is nil");
            CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXISTInvalidExecutor,
                                       CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }

         TestComponents::CCM_Client_var comp_exec = TestComponents::CCM_Client::_narrow(obj.in());
    
         if (CORBA::is_nil(comp_exec.in()))
         {
            CDMW_ERROR(m_logger.in(), 
                "Component executor is not a TestComponents::CCM_Client");
            CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXISTInvalidExecutor,
                                       CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }
    
         return comp_exec._retn();
      }
      catch (const Components::CCMException& e)
      {
         CDMW_ERROR(m_logger.in(), 
            "CCMException obtaining component executor: " <<e);
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXISTInvalidExecutor,
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
      catch (const CORBA::BAD_PARAM& e)
      {
         CDMW_ERROR(m_logger.in(), 
            "CORBA::BAD_PARAM obtaining component executor");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXISTInvalidExecutor,
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
   }

   
   /**
    * Purpose:
    * <p>This returns the servant for the facet/consumer specified by facet_name.
    * This operation is implemented by the well typed component servant.
    *
    * @param facet_name The facet name
    *
    * @return the facet servant.
    */
   
   
         PortableServer::Servant
         SessionClient_impl::get_facet_servant(const std::string& facet_name) 
            throw (CORBA::SystemException)
         {
            CDMW_LOG_FUNCTION(m_logger.in(), "facet_name="<<facet_name);
            check_is_removed();

            PortableServer::ServantBase_var facet_servant;
          
            

   if (facet_name == CONSUMER_SERVER_IS_ACTIVATED_NAME)
   {
      facet_servant 
         = new Cdmw::CCM::CIF::CdmwTestComponents::ActivatedConsumer_impl(m_executor_locator.in(), 
                   CONSUMER_SERVER_IS_ACTIVATED_NAME,
                   m_context,
                   this,
                   m_logger.in());
   }
   else


   if (facet_name == CONSUMER_SERVER_INFO_NAME)
   {

       ::std::string component_id = get_component_identity(); 
       facet_servant 
           = new Cdmw::CCM::CIF::CdmwTestComponents::ServerInfoConsumer_impl
           (
            m_executor_locator.in(), 
            CONSUMER_SERVER_INFO_NAME,
            component_id,
            m_context,
            this,
            m_logger.in()
            );
   }
   else

            {
               // No facet/consumer with this name define for this component
               CDMW_ERROR(m_logger.in(), 
                   "No '" << facet_name << 
                   "' facet or consumer defined for this component");
               CORBA::OBJECT_NOT_EXIST ex(Cdmw::OrbSupport::OBJECT_NOT_EXIST,
                                          CORBA::COMPLETED_NO); 
               CDMW_LOG_FUNCTION_EXCEPTION(ex);
               throw ex;
            }
          
            return facet_servant._retn();
         }
      

   
   
    /**
     * Purpose:
     * <p>In case of a session component, this operation will call 
     * it's executor's ccm_activate operation.
     *
     *@exception Components::CCMException Any CCMException thrown by the
     * executor's ccm_activate operation.
     *@exception CORBA::SystemException Any SystemException thrown by the
     * executor's ccm_activate operation.
     */ 
   
    void SessionClient_impl::ccm_activate() 
        throw (Components::CCMException, CORBA::SystemException)
    {
        // this is a session component, call ccm_activate
        m_session_locator->ccm_activate();
    }
   
   
   
    /**
     * Purpose:
     * <p>In case of a session component, this operation will call 
     * it's executor's ccm_passivate operation.
     *
     *@exception Components::CCMException Any CCMException thrown by the
     * executor's ccm_passivate operation.
     *@exception CORBA::SystemException Any SystemException thrown by the
     * executor's ccm_passivate operation.
     */ 
   
    void SessionClient_impl::ccm_passivate() 
        throw (Components::CCMException, CORBA::SystemException)
    {
        // this is a session component, call ccm_passivate
        m_session_locator->ccm_passivate();
    }
   
   
   
    /**
     * Purpose:
     * <p>In case of a session component, this operation will call 
     * it's executor's ccm_remove operation.
     *
     *@exception Components::CCMException Any CCMException thrown by the
     * executor's ccm_remove operation.
     *@exception CORBA::SystemException Any SystemException thrown by the
     * executor's ccm_remove operation.
     */ 
   
    void SessionClient_impl::ccm_remove() 
        throw (Components::CCMException, CORBA::SystemException)
    {
        // this is a session component, call ccm_remove
        m_session_locator->ccm_remove();
    }
    
    ::CORBA::LocalObject_ptr SessionClient_impl::get_receptacle_object
    (
     const char * receptacle_name,
     ::CORBA::Object_ptr facet_object
     ) throw (CORBA::SystemException)
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "receptacle name=" << receptacle_name);
        ::CORBA::LocalObject_var obj = ::CORBA::LocalObject::_nil();

        ::std::string component_id = get_component_identity();
        
                  
        if(0 == strcmp(RECEP_TO_SERVER_NAME, receptacle_name))
            {
                obj =
                    new Cdmw::CCM::CIF::CdmwTestComponents::ReceptacleFacetTest_impl 
                    (
                     receptacle_name,
                     component_id,
                     facet_object,
                     this->m_context,
                     m_logger.in()
                     );
            }    
        else if(0 == strcmp(RECEP_TO_ECHO_NAME, receptacle_name))
            {
                obj = 
                    new Cdmw::CCM::CIF::CdmwTestComponents::ReceptacleHello_impl 
                    (
                     receptacle_name,
                     component_id.c_str(),
                     facet_object, 
                     this->m_context,
                     m_logger.in()
                     );
            }    
    
        else CDMW_ERROR(m_logger.in(), 
                        "No '" <<  receptacle_name << "' receptacle defined for this component");
         

        
        return obj._retn();
    }

   
   
   // Change state to REMOVED; this will call ccm_passivate and ccm_remove on executor
   void 
   SessionClient_impl::advise_executor_of_remove_component()
      throw (CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      try
      {
         m_state = m_state->remove(this);
      }
      catch (const Components::CCMException& e)
      {
         
         CDMW_ERROR(m_logger.in(), "Components::CCMException raised, reason " << e);
         
         CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError,
                            CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
   }

 
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestComponents
