
/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/* =========================================================================== * 
 * This code has been generated by CDMW Code Generator 1.0
 * on Fri Nov 06 14:46:22 CET 2009
 * DO NOT EDIT !!!
 * =========================================================================== */

#ifndef __INCL_CCMCIF_SESSIONCLIENT_IMPL_HPP__
#define __INCL_CCMCIF_SESSIONCLIENT_IMPL_HPP__

        #include "Cdmw_TestComponents_cif.skel.hpp"
        #include "ServerInfoConsumer_impl.hpp"

#include <CCMContainer/ccmcif/CCMObject_impl.hpp>
#include <CCMContainer/ccmcif/DefaultCCMObjectStates.hpp>


namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwTestComponents {

   
   /**
    * Session component
    */

   
   class SessionClient_impl : virtual public POA_TestComponents::Client,
      
                                                                virtual public CCMObject_impl
   
   {
      public:
   
         SessionClient_impl(const std::string& comp_oid,
   
                  Context*                          ctx,
                  CORBA::Object_ptr                 comp_ref,
                  Components::EnterpriseComponent*  executor,
   
                  CdmwLifeCycle::ObjectRegistration_ptr object_registration,
                  CdmwLogging::LoggerFactory_ptr    logger_factory,
                            bool is_created_by_factory_operation)
            throw (Components::CCMException,
                   CORBA::SystemException);

   
         ~SessionClient_impl();
   

         /**
          * Component attributes
          */

         
    // @@ BEGIN template session_component_hpp.Attributes.Operations.Declaration

    // @@ END template session_component_hpp.Attributes.Operations.Declaration

    // @@ BEGIN template session_component_hpp.Attributes.Operations.Declaration

    // @@ END template session_component_hpp.Attributes.Operations.Declaration

    // @@ BEGIN template session_component_hpp.Attributes.Operations.Declaration

    // @@ END template session_component_hpp.Attributes.Operations.Declaration

    // @@ BEGIN template session_component_hpp.Attributes.Operations.Declaration

    // @@ END template session_component_hpp.Attributes.Operations.Declaration


         /**
          * Supported interfaces
          */

         
         



         /**
          * Equivalent IDL methods
          */

         // Facets

         

         // Receptacles

         
    // @@ BEGIN template session_component_hpp.Receptacles.EquivalentIDL.Declaration

virtual void connect_to_server(TestComponents::FacetTest_ptr conxn)
throw(Components::AlreadyConnected, Components::InvalidConnection, CORBA::SystemException);

virtual TestComponents::FacetTest_ptr disconnect_to_server()
throw(Components::NoConnection, CORBA::SystemException);

virtual TestComponents::FacetTest_ptr get_connection_to_server()
throw(CORBA::SystemException);

    // @@ END template session_component_hpp.Receptacles.EquivalentIDL.Declaration

    // @@ BEGIN template session_component_hpp.Receptacles.EquivalentIDL.Declaration

virtual void connect_to_echo(HelloModule::Hello_ptr conxn)
throw(Components::AlreadyConnected, Components::InvalidConnection, CORBA::SystemException);

virtual HelloModule::Hello_ptr disconnect_to_echo()
throw(Components::NoConnection, CORBA::SystemException);

virtual HelloModule::Hello_ptr get_connection_to_echo()
throw(CORBA::SystemException);

    // @@ END template session_component_hpp.Receptacles.EquivalentIDL.Declaration


         // Consumers

      
    // @@ BEGIN template session_component_hpp.Consumers.EquivalentIDL.Declaration

virtual TestComponents::ActivatedConsumer_ptr
get_consumer_server_is_activated()
   throw(CORBA::SystemException);

    // @@ END template session_component_hpp.Consumers.EquivalentIDL.Declaration

    // @@ BEGIN template session_component_hpp.Consumers.EquivalentIDL.Declaration

virtual TestComponents::ServerInfoConsumer_ptr
get_consumer_server_info()
   throw(CORBA::SystemException);

    // @@ END template session_component_hpp.Consumers.EquivalentIDL.Declaration


         // Publishers

         
         
         // Emitters

         

         /**
          * Inherited CCMObject interface implemented by CCMObject_impl
          */

         virtual void
         configuration_complete()
            throw(Components::InvalidConfiguration,
                  CORBA::SystemException);

         /**
          * Inherited Events interface implemented by CCMObject_impl
          */

         
            /**
             * Purpose:
             * <p>This returns the servant for the facet specified by facet_name.
             * This operation is implemented by the well typed component servant.
             *
             * @param facet_name The facet name
             *
             * @return the facet servant.
             */
            virtual PortableServer::Servant
            get_facet_servant(const std::string& facet_name)
               throw (CORBA::SystemException);
               
            /**
             * Purpose:
             * <p>In case of a session component, this operation will call 
             * it's executor's ccm_activate operation.
             *
             *@exception Components::CCMException Any CCMException thrown by the
             * executor's ccm_activate operation.
             *@exception CORBA::SystemException Any SystemException thrown by the
             * executor's ccm_activate operation.
             */ 
            virtual void 
            ccm_activate() 
                throw (Components::CCMException, CORBA::SystemException);
               
            /**
             * Purpose:
             * <p>In case of a session component, this operation will call 
             * it's executor's ccm_passivate operation.
             *
             *@exception Components::CCMException Any CCMException thrown by the
             * executor's ccm_passivate operation.
             *@exception CORBA::SystemException Any SystemException thrown by the
             * executor's ccm_passivate operation.
             */ 
            virtual void 
            ccm_passivate() 
                throw (Components::CCMException, CORBA::SystemException);
               
            /**
             * Purpose:
             * <p>In case of a session component, this operation will call 
             * it's executor's ccm_remove operation.
             *
             *@exception Components::CCMException Any CCMException thrown by the
             * executor's ccm_remove operation.
             *@exception CORBA::SystemException Any SystemException thrown by the
             * executor's ccm_remove operation.
             */ 
            virtual void 
            ccm_remove() 
                throw (Components::CCMException, CORBA::SystemException);



          /**
          * This returns the local object for the receptacle specified by receptacle_name.
          * This operation is implemented by the well typed component servant.
          *
          * @param receptacle_name The Receptacle name
          * @param facet_object The remote facet reference 
          *
          * @return the receptacle local object or null if the component has no receptacles.
          */

          virtual ::CORBA::LocalObject_ptr get_receptacle_object
          (
           const char * receptacle_name,
           ::CORBA::Object_ptr facet_object
           ) throw (CORBA::SystemException);

         

      protected:
         // Return the component executor
         TestComponents::CCM_Client_ptr
         obtain_component_executor()
            throw (CORBA::SystemException);

         // Call ccm_passivate and ccm_remove on executor
         void advise_executor_of_remove_component()
           throw (CORBA::SystemException);

         // return true if configuration complete has already been called
         inline bool is_configured() {
    
            return (m_state == Cdmw::CCM::CIF::CCM_OBJECT_STATE_FULLY_ACTIVATED);
        
         }
 
   
   
      private:
   
         SessionClient_impl(const SessionClient_impl&);
         void operator=(const SessionClient_impl&);


       /*
       class CCM_ServerInfoConsumer_impl 
       ::CORBA::LocalObject,
       ::TestComponents::CCM_ServerInfoConsumer
       {
            
           CCM_ServerInfoConsumer_impl ()
           {
           };
            
            
           void push (::TestComponents::ServerInfo_ptr event)
           {
               CDMW_LOG_FUNCTION(m_logger, "");
                          
               push_server_info(event); 
            
           }
        
        
   
           void push_server_info(::TestComponents::ServerInfo_ptr event) {
               CDMW_LOG_FUNCTION(m_logger.in(), "");
            

               if(true == Cdmw::CCM::COPI::COPIServiceInit::Is_initialized()) {
            
        cdmw.ccm.ccmcopi.PushContainerServantRequest request = new cdmw.ccm.ccmcopi.PushContainerServantRequest("server_info",
                                                                                                                get_component_identity(), compExecutor, get_context());

        if(!request.isReadWrite()) {
            compExecutor.push_server_info(event);
            return;
        }

        // request is a read / write request
        Any in_arg = request.createAny();
        com.acme.TestComponents.ServerInfoHelper.insert(in_arg, event);

        request.add_in_args(in_arg);
        request.preInvoke();

        // The operation parameters
        com.acme.TestComponents.ServerInfo _event = null;
        Any eventAny = null;

        try {
            eventAny = request.get_arg(0);
        } catch(org.omg.CORBA.SystemException se) {
            request.add_SystemException(se);
            request.throw_exception();
        } catch(Exception e) {
            org.omg.CORBA.SystemException se =
                new org.omg.CORBA.BAD_OPERATION("A Stub COPI has corrupted the args", 0, CompletionStatus.COMPLETED_NO);
            request.add_SystemException(se);
            request.throw_exception();
        }

        if(eventAny == null) {
            org.omg.CORBA.SystemException se =
                new org.omg.CORBA.BAD_OPERATION("A Stub COPI has corrupted the args", 0, CompletionStatus.COMPLETED_NO);
            request.add_SystemException(se);
            request.throw_exception();
        }

        if(eventAny.type().equals(com.acme.TestComponents.ServerInfoHelper.type())) {
            _event = com.acme.TestComponents.ServerInfoHelper.extract(eventAny);
        } else {
            org.omg.CORBA.SystemException se =
                new org.omg.CORBA.BAD_OPERATION("A Stub COPI has corrupted the args", 0, CompletionStatus.COMPLETED_NO);
            request.add_SystemException(se);
            request.throw_exception();
        }

        try {
            if((request.proceed_call.value && request.the_exception() == null)) {
                compExecutor.push_server_info(_event);
            }
        } catch(org.omg.CORBA.SystemException se) {
            request.add_SystemException(se);
        }
        request.postInvoke();           
        request.throw_exception();
    } else {
        // COPI Service not initialised
        compExecutor.push_server_info(event);
        return;
    }
}
               
       }   
       */
   
   

         /**
          * Attributes
          */

         /**
          * If a home, in creating a component, returns an ExecutorLocator, the cif
          * will invoke its obtain_executor operation prior to each invocation to
          * retrieve the implementation for a port. If the home returns an
          * EnterpriseComponent, we encapsulate it in an executor locator in order to
          * use same code.
          *
          */

         // Client executor locator used to get component exec and facet exec
         Components::ExecutorLocator_var   m_executor_locator;
         
         // executor locator must be a session component to be advise of its activation, passivation 
         // and removal
         Components::SessionComponent_var  m_session_locator;

         // set to true when component is activated
         bool m_is_activated;


         // Client context executor
         Cdmw_TestComponents::CCM_Client_SessionContext_var  m_context_executor;

         // Indicates if current component has been created via a factory operation
   
         
         CdmwLogging::Logger_var m_logger;   // Logger for logging
    
         bool m_is_created_by_factory_operation;

         
    // @@ BEGIN template session_component_hpp.Attributes.Declaration

    // @@ END template session_component_hpp.Attributes.Declaration

    // @@ BEGIN template session_component_hpp.Attributes.Declaration

    // @@ END template session_component_hpp.Attributes.Declaration

    // @@ BEGIN template session_component_hpp.Attributes.Declaration

    // @@ END template session_component_hpp.Attributes.Declaration

    // @@ BEGIN template session_component_hpp.Attributes.Declaration

    // @@ END template session_component_hpp.Attributes.Declaration

   };

   
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestComponents

#endif // __INCL_CCMCIF_SESSIONCLIENT_IMPL_HPP__
