
/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

/* =========================================================================== * 
 * This code has been generated by CDMW Code Generator 1.0
 * on Fri Nov 06 14:46:22 CET 2009
 * DO NOT EDIT !!!
 * =========================================================================== */

   
   
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
#include <CCMContainer/ccmcommon/CCMUtils.hpp>
#include <CCMContainer/ccmcif/CCMUtils.hpp>
#include <CCMContainer/ccmcommon/CCMLoggers.hpp>
#include <ccmcopi/COPIServiceInit.hpp>
   
   #include "SessionServer_impl.hpp"
   
#include <Foundation/orbsupport/RefCountLocalObject.hpp>
#include <SystemMngt/platforminterface/PlatformInterface.hpp>
#include <Foundation/idllib/CdmwDeployment.stub.hpp>
   


#include "FacetFacetTest_impl.hpp"
#include "Hello_impl.hpp"
#include "FacetHello_impl.hpp"
   
#include <CCMContainer/idllib/CdmwCcmCif.skel.hpp>
   
   #include "CCM_Server_SessionContext_impl.hpp"

   

   namespace {
        
      
      const char* COMP_REP_ID = "IDL:acme.com/TestComponents/Server:1.0";
      
      const char* COMP_NAME   = "Server";

      
      
const char* FACET_FOR_CLIENTS_NAME = "for_clients";
   
const char* FACET_FOR_CLIENTS_REP_ID = "IDL:acme.com/TestComponents/FacetTest:1.0";

const char* FACET_ECHO_NAME = "echo";
   
const char* FACET_ECHO_REP_ID = "IDL:acme.com/HelloModule/Hello:1.0";

const char* PUBLISHER_INFO_NAME = "info";
   
const char* PUBLISHER_INFO_REP_ID = "IDL:acme.com/TestComponents/ServerInfoConsumer:1.0";

const char* EMITTER_I_AM_ACTIVATED_NAME = "i_am_activated";
   
const char* EMITTER_I_AM_ACTIVATED_REP_ID = "IDL:acme.com/TestComponents/ActivatedConsumer:1.0";

      
      /*
       * If a home, when creating a component, returns an EnterpriseComponent, we map it 
       * in an ExecutorLocator for code optimisation purpose. Thus the code is the same
       * for monolithic executor and segmented executor.
       */
      class ServerExecutorLocator : public CdmwCcmCif::SessionExecutorLocator,
                                    public Cdmw::OrbSupport::RefCountLocalObject
      {
         public:
            ServerExecutorLocator(
                  TestComponents::CCM_Server_ptr executor,
                  CdmwLogging::Logger_ptr logger)
               : is_a_session_component(false),
               m_comp_executor(TestComponents::CCM_Server::_duplicate(executor)),
               m_logger(CdmwLogging::Logger::_duplicate(logger))
            {
               CDMW_LOG_FUNCTION(m_logger.in(), "");
               try 
               {
                  Components::SessionComponent_var session_comp
                     = Components::SessionComponent::_narrow(m_comp_executor.in());
            
                  if (!CORBA::is_nil(session_comp.in()))
                  {
                     is_a_session_component = true;
                  }
               }
               catch (...)
               {
               }
            };

            ~ServerExecutorLocator() 
            {
                CDMW_LOG_FUNCTION(m_logger.in(), "");
            };

            /*
             * the cif will invoke its obtain_executor operation prior to each invocation to
             * retrieve the implementation for a port. The port name, given in the name
             * parameter, is the same as used in the components interface description 
             * in IDL, or the components name for the main executor. The obtain_executor
             * operation returns a local object reference of the expected type. The 
             * CCMException exception may be raised in case of a system error that 
             * prohibits locating the requested executor.
             */
            //
            // IDL:omg.org/Components/ExecutorLocator/obtain_executor:1.0
            //
            virtual CORBA::Object_ptr obtain_executor(const char* name)
               throw(Components::CCMException,
                     CORBA::SystemException)
            {
               CDMW_LOG_FUNCTION(m_logger.in(), "name="<<name);
               std::string exec_name(name);
               CORBA::Object_var result;

               if (exec_name == "Server")
               {
                  result = TestComponents::CCM_Server::_duplicate(m_comp_executor.in());
               }
               
   
   else if (exec_name == "for_clients")
   {
      result = m_comp_executor->get_for_clients();
   }

   
   else if (exec_name == "echo")
   {
      result = m_comp_executor->get_echo();
   }

               else 
               {
                  CDMW_ERROR(m_logger.in(), 
                      "'"<<name<<"' is unkown: cannot obtain executor for it");
                  CORBA::BAD_PARAM ex(Cdmw::OrbSupport::BAD_PARAMInvalidExecutorName, CORBA::COMPLETED_NO);
                  CDMW_LOG_FUNCTION_EXCEPTION(ex);
                  throw ex;
               }

               return result._retn();
            };

            /* 
             * The release_executor operation is called by the cif once the current
             * invocation on an executor that was obtained through the obtain_executor 
             * operation has finished. The locator can thus release any resources that
             * were acquired as part of the obtain_executor operation.
             */
            //
            // IDL:omg.org/Components/ExecutorLocator/release_executor:1.0
            //
            virtual void release_executor(CORBA::Object_ptr exc)
               throw(Components::CCMException,
                     CORBA::SystemException)
            {
                CDMW_LOG_FUNCTION(m_logger.in(), "");
            };

            /* 
             * The configuration_complete operation is called to propagate the
             * configuration_complete operation on the CCMObject interface to the
             * component implementation.
             */
            //
            // IDL:omg.org/Components/ExecutorLocator/configuration_complete:1.0
            //
            virtual void configuration_complete()
               throw(Components::InvalidConfiguration,
                     CORBA::SystemException)
            {
               CDMW_LOG_FUNCTION(m_logger.in(), "");
               // No equivalent operation for monolithic executor
            };

            //
            // IDL:omg.org/Components/SessionComponent/set_session_context:1.0
            //
            virtual void set_session_context(Components::SessionContext_ptr ctx)
               throw(Components::CCMException,
                     CORBA::SystemException)
            {
               CDMW_LOG_FUNCTION(m_logger.in(), "");
               // check if component implements the SessionComponent local interface
               if (is_a_session_component)
               {
                  CDMW_INFO(m_logger.in(), "Call set_session_context()");
                  Components::SessionComponent_var session_comp 
                     = Components::SessionComponent::_narrow(m_comp_executor.in());
                  session_comp->set_session_context(ctx);
               }
            };

            /* 
             * The ccm_activate operation is called by the container to notify a 
             * session component that it has been made active. The component instance
             * should perform any initialization required prior to operation invocation.
             * The component may raise the CCMException with the SYSTEM_ERROR minor code
             * to indicate a failure caused by a system level error.
             */
            //
            // IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
            //
            virtual void ccm_activate()
               throw(Components::CCMException,
                     CORBA::SystemException)
            {
               CDMW_LOG_FUNCTION(m_logger.in(), "");
               // check if component implements the SessionComponent local interface
               if (is_a_session_component)
               {
                  CDMW_INFO(m_logger.in(), "Call ccm_activate()");
                  Components::SessionComponent_var session_comp 
                     = Components::SessionComponent::_narrow(m_comp_executor.in());
                  session_comp->ccm_activate();
               }
            };

            /* 
             * The ccm_passivate operation is called by the container to notify a session
             * component that it has been made inactive. The component instance should
             * release any resources it acquired at activation time.The component may 
             * raise the CCMException with the SYSTEM_ERROR minor code to indicate a 
             * failure caused by a system level error.
             */
            //
            // IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
            //
            virtual void ccm_passivate()
               throw(Components::CCMException,
                     CORBA::SystemException)
            {
               CDMW_LOG_FUNCTION(m_logger.in(), "");
               // check if component implements the SessionComponent local interface
               if (is_a_session_component)
               {
                  CDMW_INFO(m_logger.in(), "Call ccm_passivate()");
                  Components::SessionComponent_var session_comp 
                     = Components::SessionComponent::_narrow(m_comp_executor.in());
                  session_comp->ccm_passivate();
               }
            };

            /* 
             * The ccm_remove operation is called by the container when the servant is
             * about to be destroyed. It informs the component that it is about to be
             * destroyed.The component may raise the CCMException with the SYSTEM_ERROR
             * minor code to indicate a failure caused by a system level error.
             */
            //
            // IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
            //
            virtual void ccm_remove()
               throw(Components::CCMException,
                     CORBA::SystemException)
            {
               CDMW_LOG_FUNCTION(m_logger.in(), "");
               // check if component implements the SessionComponent local interface
               if (is_a_session_component)
               {
                  CDMW_INFO(m_logger.in(), "Call ccm_remove()");
                  Components::SessionComponent_var session_comp 
                     = Components::SessionComponent::_narrow(m_comp_executor.in());
                  session_comp->ccm_remove();
               }
            };



         private:
            ServerExecutorLocator(const ServerExecutorLocator&);
            void operator=(const ServerExecutorLocator&);

            bool is_a_session_component;  // indicates that the component executor inherits
                                          // from the SessionComponent local interface.

            TestComponents::CCM_Server_var m_comp_executor; // points on Component monolithic executor.
            
            CdmwLogging::Logger_var m_logger;
      };
   };  // end of anonymous namespace

   
namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwTestComponents {



   // Constructor
   SessionServer_impl::SessionServer_impl(const std::string& comp_oid,
                         Context*                          ctx,
                         CORBA::Object_ptr                 comp_ref,
                         Components::EnterpriseComponent*  executor,
      
                         CdmwLifeCycle::ObjectRegistration_ptr object_registration,
                         CdmwLogging::LoggerFactory_ptr    logger_factory,
                         bool is_created_by_factory_operation)
      throw (Components::CCMException,
             CORBA::SystemException)
      
      : CCMObject_impl(comp_oid, ctx, COMP_REP_ID, comp_ref, object_registration, logger_factory),
         
        m_is_created_by_factory_operation(is_created_by_factory_operation)
      
   {
      // create logger with domain for ccmcif
      m_logger = logger_factory->get_logger(CCMLoggers::CCMGENERATED_LOG_DOMAIN);
   
      CDMW_LOG_FUNCTION(m_logger.in(), "comp_oid="<<comp_oid);
      
      
      
      // Check if the home returns an executor locator
      m_executor_locator = Components::ExecutorLocator::_narrow(executor);

      if (CORBA::is_nil(m_executor_locator.in()))
      {
         // executor is not an executor locator
         // map monolithic executor to executor locator
         TestComponents::CCM_Server_var comp_exec = TestComponents::CCM_Server::_narrow(executor);
        
         if (CORBA::is_nil(comp_exec.in()))
         {
            // This is to avoid Assertion failure in debug mode as internal ref count
            // equals 1 (CORBA C++ mapping oblige!)
            _set_ref_count(0);

            CDMW_ERROR(m_logger.in(), "Invalid Component Executor");
            CORBA::BAD_PARAM ex(OrbSupport::BAD_PARAMInvalidComponentExecutor,
                                CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }
         m_executor_locator = new ServerExecutorLocator(comp_exec.in(), m_logger.in());

         m_session_locator = Components::SessionComponent::_narrow(m_executor_locator.in());
        
         if (CORBA::is_nil(m_session_locator.in()))
         {
             CDMW_ERROR(m_logger.in(), 
                "Executor Locator should be a session component!");
             CORBA::INTERNAL ex(OrbSupport::INTERNALInvalidExecutor,
                                CORBA::COMPLETED_NO);
             CDMW_LOG_FUNCTION_EXCEPTION(ex);
             throw ex;
         }
      }
      else
      {
         Components::SessionComponent_var m_session_locator 
            = Components::SessionComponent::_narrow(m_executor_locator.in());
        
         if (CORBA::is_nil(m_session_locator.in()))
         {
             CDMW_ERROR(m_logger.in(), 
                "Executor Locator should be a session component!");
             CORBA::BAD_PARAM ex(OrbSupport::BAD_PARAMInvalidComponentExecutor,
                                CORBA::COMPLETED_NO);
             CDMW_LOG_FUNCTION_EXCEPTION(ex);
             throw ex;
         }
      }

      Components::CCMContext_var ccm_ctx = ctx->get_ccm_context();
      m_context_executor = new CCM_Server_SessionContext_impl(ccm_ctx.in(), this, logger_factory);
      m_session_locator->set_session_context(m_context_executor.in());

      

   try
   {
      CORBA::Object_var for_clients_facet
         = declare_facet(comp_oid, 
                         FACET_FOR_CLIENTS_NAME, 
                         FACET_FOR_CLIENTS_REP_ID);
                         
      if (CORBA::is_nil(for_clients_facet.in()))
      {
         // This is to avoid Assertion failure in debug mode as internal ref count
         // equals 1 (CORBA C++ mapping oblige!)
         _set_ref_count(0);

         CDMW_ERROR(m_logger.in(), 
            "Internal exception raised when declaring facet for_clients!");
         CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
   }
   catch (const AlreadyDoneException&)
   {
      // This is to avoid Assertion failure in debug mode as internal ref count
      // equals 1 (CORBA C++ mapping oblige!)
      _set_ref_count(0);
     
      CDMW_ERROR(m_logger.in(), "Facet for_clients already declared!");
      // Don't propagate while its probably a code generation error!
   }
   catch (const InternalErrorException&)
   {
      // This is to avoid Assertion failure in debug mode as internal ref count
      // equals 1 (CORBA C++ mapping oblige!)
      _set_ref_count(0);

      CDMW_ERROR(m_logger.in(), 
          "Internal exception raised when declaring facet FacetTest!");
      CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, CORBA::COMPLETED_NO);
      CDMW_LOG_FUNCTION_EXCEPTION(ex);
      throw ex;
   }


   try
   {
      CORBA::Object_var echo_facet
         = declare_facet(comp_oid, 
                         FACET_ECHO_NAME, 
                         FACET_ECHO_REP_ID);
                         
      if (CORBA::is_nil(echo_facet.in()))
      {
         // This is to avoid Assertion failure in debug mode as internal ref count
         // equals 1 (CORBA C++ mapping oblige!)
         _set_ref_count(0);

         CDMW_ERROR(m_logger.in(), 
            "Internal exception raised when declaring facet echo!");
         CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
   }
   catch (const AlreadyDoneException&)
   {
      // This is to avoid Assertion failure in debug mode as internal ref count
      // equals 1 (CORBA C++ mapping oblige!)
      _set_ref_count(0);
     
      CDMW_ERROR(m_logger.in(), "Facet for_clients already declared!");
      // Don't propagate while its probably a code generation error!
   }
   catch (const InternalErrorException&)
   {
      // This is to avoid Assertion failure in debug mode as internal ref count
      // equals 1 (CORBA C++ mapping oblige!)
      _set_ref_count(0);

      CDMW_ERROR(m_logger.in(), 
          "Internal exception raised when declaring facet Hello!");
      CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, CORBA::COMPLETED_NO);
      CDMW_LOG_FUNCTION_EXCEPTION(ex);
      throw ex;
   }

         try
         {
            

   declare_publisher(PUBLISHER_INFO_NAME, PUBLISHER_INFO_REP_ID);


   declare_emitter(EMITTER_I_AM_ACTIVATED_NAME, EMITTER_I_AM_ACTIVATED_REP_ID);

         }
         catch (const AlreadyDoneException&)
         {
            // This is to avoid Assertion failure in debug mode as internal ref count
            // equals 1 (CORBA C++ mapping oblige!)
            _set_ref_count(0);

            CDMW_ERROR(m_logger.in(), "Event source already declared!");
            // Don't propagate while its probably a code generation error!
         }
         catch (const CORBA::SystemException& e)
         {
            // This is to avoid Assertion failure in debug mode as internal ref count
            // equals 1 (CORBA C++ mapping oblige!)
            _set_ref_count(0);
        
            CDMW_ERROR(m_logger.in(), 
                "System exception raised when declaring event source: " << e);
            CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }
      

   }

   SessionServer_impl::~SessionServer_impl()
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      
   }


   /**
    * Component attributes
    */
   

   /**
    * Supported interfaces
    */

   
   







   /**
    * Equivalent IDL methods
    */

   // Facets

   
TestComponents::FacetTest_ptr
SessionServer_impl::provide_for_clients()
throw(CORBA::SystemException)

   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      CORBA::Object_var obj;

      try 
      {
         obj = CCMObject_impl::provide_facet("for_clients");
      }
      catch (const Components::InvalidName &)
      {
         CDMW_ERROR(m_logger.in(), 
             "'for_clients' is not a valid facet name");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST,
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }

      if (CORBA::is_nil(obj.in()))
      {
         CDMW_ERROR(m_logger.in(), 
             "Facet for_clients is nil");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }

      TestComponents::FacetTest_var facet_ref = TestComponents::FacetTest::_narrow(obj.in());
       
      if (CORBA::is_nil(facet_ref.in()))
      {
         CDMW_ERROR(m_logger.in(), 
             "Facet for_clients is not a TestComponents::FacetTest");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
       
      return facet_ref._retn();
   }

   
HelloModule::Hello_ptr
SessionServer_impl::provide_echo()
throw(CORBA::SystemException)

   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      CORBA::Object_var obj;

      try 
      {
         obj = CCMObject_impl::provide_facet("echo");
      }
      catch (const Components::InvalidName &)
      {
         CDMW_ERROR(m_logger.in(), 
             "'echo' is not a valid facet name");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST,
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }

      if (CORBA::is_nil(obj.in()))
      {
         CDMW_ERROR(m_logger.in(), 
             "Facet echo is nil");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }

      HelloModule::Hello_var facet_ref = HelloModule::Hello::_narrow(obj.in());
       
      if (CORBA::is_nil(facet_ref.in()))
      {
         CDMW_ERROR(m_logger.in(), 
             "Facet echo is not a HelloModule::Hello");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
       
      return facet_ref._retn();
   }

   

   // Receptacles

   

   // Publishers

   
Components::Cookie*
SessionServer_impl::subscribe_info(TestComponents::ServerInfoConsumer_ptr consumer)
      throw(Components::ExceededConnectionLimit, CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      Components::Cookie_var result;
      
      try
      {
          result = CCMObject_impl::subscribe(PUBLISHER_INFO_NAME,
                                             consumer);
      }
      catch (const Components::InvalidName &)
      {
          CDMW_ERROR(m_logger.in(), "Invalid name for publisher subscription!");
          CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                             CORBA::COMPLETED_NO);   
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const Components::InvalidConnection &)
      {
          // should never appear!
          CDMW_ERROR(m_logger.in(), "Invalid Connection");
          CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                             CORBA::COMPLETED_NO);
          CDMW_LOG_FUNCTION_EXCEPTION(ex);
          throw ex;
      }
      catch (const Components::ExceededConnectionLimit & e)
      {
          CDMW_LOG_FUNCTION_EXCEPTION(e);
          throw;
      }
      catch (const CORBA::SystemException& e)
      {
          throw;
          CDMW_LOG_FUNCTION_EXCEPTION(e);
      }
      
      return result._retn();
   }

   
TestComponents::ServerInfoConsumer_ptr
SessionServer_impl::unsubscribe_info(Components::Cookie* ck)
      throw(Components::InvalidConnection, CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      if (!ck) {
         CDMW_ERROR(m_logger.in(), "Cookie is null");
         CORBA::BAD_PARAM ex(OrbSupport::BAD_PARAMNilObjectReference, CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
       
      TestComponents::ServerInfoConsumer_var result = TestComponents::ServerInfoConsumer::_nil();
      try
      {
         Components::EventConsumerBase_var consumer 
            = CCMObject_impl::get_consumer(PUBLISHER_INFO_NAME, ck);

         result = TestComponents::ServerInfoConsumer::_narrow(consumer.in());

         CCMObject_impl::unsubscribe(PUBLISHER_INFO_NAME, ck);
      }
      catch (const Components::InvalidName&)
      {
         // internal error should not appear
         CDMW_ERROR(m_logger.in(), "Invalid name for publisher unsubscription!");
         CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                            CORBA::COMPLETED_NO);   
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
      catch (const Components::InvalidConnection& e)
      {
         CDMW_LOG_FUNCTION_EXCEPTION(e);
         throw;
      }
      catch (const CORBA::SystemException& e)
      {
         CDMW_LOG_FUNCTION_EXCEPTION(e);
         throw;
      }

      return result._retn();
   }

   
   // Emitters

   
void
SessionServer_impl::connect_i_am_activated(TestComponents::ActivatedConsumer_ptr consumer)
      throw(Components::AlreadyConnected, CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      try
      {
         CCMObject_impl::connect_consumer(EMITTER_I_AM_ACTIVATED_NAME, consumer);
      }
      catch (const Components::InvalidName&)
      {
         // can not appear!
         CDMW_ERROR(m_logger.in(), "Invalid name for emitter conection!");
         CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                            CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
      catch (const Components::InvalidConnection&)
      {
         // can not appear!
         CDMW_ERROR(m_logger.in(), "Invalid connection for emitter conection!");
         CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                            CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      } 
      catch (const Components::AlreadyConnected& e)
      {
         CDMW_LOG_FUNCTION_EXCEPTION(e);
         throw;
      }
      catch (const CORBA::SystemException& e)
      {
         CDMW_LOG_FUNCTION_EXCEPTION(e);
         throw;
      } 
   }

   
TestComponents::ActivatedConsumer_ptr
SessionServer_impl::disconnect_i_am_activated()
      throw(Components::NoConnection, CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      try
      {
         Components::EventConsumerBase_var consumer = 
            CCMObject_impl::disconnect_consumer(EMITTER_I_AM_ACTIVATED_NAME);

         TestComponents::ActivatedConsumer_var result = 
            TestComponents::ActivatedConsumer::_narrow(consumer.in());

         if (CORBA::is_nil(result.in()))
         {
            // can not appear!
            CDMW_ERROR(m_logger.in(), "Old connection had wrong type");
            CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                               CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }

         return result._retn();
      }
      catch (const Components::InvalidName&)
      {
         // can not appear!
         CDMW_ERROR(m_logger.in(), "Invalid name for emitter disconection!");
         CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                            CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
      catch (const Components::InvalidConnection&)
      {
         // can not appear!
         CDMW_ERROR(m_logger.in(), "Invalid connection for emitter disconection!");
         CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                            CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      } 
      catch (const Components::AlreadyConnected& e)
      {
         CDMW_LOG_FUNCTION_EXCEPTION(e);
         throw;
      }
      catch (const CORBA::SystemException& e)
      {
         CDMW_LOG_FUNCTION_EXCEPTION(e);
         throw;
      } 
   }

   
   // Consumers
   
   

   void
   SessionServer_impl::configuration_complete()
      throw(Components::InvalidConfiguration,
            CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      if (!is_configured())
      {
         CDMW_DEBUG(m_logger.in(), "Check if configuration is complete");
      
            
         
         CCMObject_impl::configuration_complete();
        
         try
         {
            
            m_executor_locator->configuration_complete();
            
            // change state
            m_state = m_state->configuration_complete(this);
            

         }
         catch (const Components::CCMException& e)
         {
            
            CDMW_ERROR(m_logger.in(), "Components::CCMException raised, reason " << e);
            
            CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError,
                               CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }
      }
   }

   
TestComponents::CCM_Server*
SessionServer_impl::obtain_component_executor()
      throw (CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      try
      {
         CORBA::Object_var obj = m_executor_locator->obtain_executor(COMP_NAME);

         if (CORBA::is_nil(obj.in()))
         {
            CDMW_ERROR(m_logger.in(), "Component executor is nil");
            CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXISTInvalidExecutor,
                                       CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }

         TestComponents::CCM_Server_var comp_exec = TestComponents::CCM_Server::_narrow(obj.in());
    
         if (CORBA::is_nil(comp_exec.in()))
         {
            CDMW_ERROR(m_logger.in(), 
                "Component executor is not a TestComponents::CCM_Server");
            CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXISTInvalidExecutor,
                                       CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
         }
    
         return comp_exec._retn();
      }
      catch (const Components::CCMException& e)
      {
         CDMW_ERROR(m_logger.in(), 
            "CCMException obtaining component executor: " <<e);
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXISTInvalidExecutor,
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
      catch (const CORBA::BAD_PARAM& e)
      {
         CDMW_ERROR(m_logger.in(), 
            "CORBA::BAD_PARAM obtaining component executor");
         CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXISTInvalidExecutor,
                                    CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
   }

   
   /**
    * Purpose:
    * <p>This returns the servant for the facet/consumer specified by facet_name.
    * This operation is implemented by the well typed component servant.
    *
    * @param facet_name The facet name
    *
    * @return the facet servant.
    */
   
   
    PortableServer::Servant
    SessionServer_impl::get_facet_servant(const std::string& facet_name) 
        throw (CORBA::SystemException)
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "facet_name="<<facet_name);
        check_is_removed();

        PortableServer::ServantBase_var facet_servant;
                      

        if (facet_name == FACET_FOR_CLIENTS_NAME)
            {
                if(true == Cdmw::CCM::COPI::COPIServiceInit::Is_initialized()) {
                    facet_servant 
                        = new FacetFacetTest_impl
                        (
                         m_executor_locator.in(), 
                         FACET_FOR_CLIENTS_NAME,
                         m_context,
                         m_comp_ref.in(),
                         this,
                         m_logger.in(),
                         this->get_component_identity()
                         );
                } else {
                    facet_servant 
                        = new FacetTest_impl
                        (
                         m_executor_locator.in(), 
                         FACET_FOR_CLIENTS_NAME,
                         m_context,
                         m_comp_ref.in(),
                         this,
                         m_logger.in()
                         );
                }

            }
        else if (facet_name == FACET_ECHO_NAME)
            {
                if(true == Cdmw::CCM::COPI::COPIServiceInit::Is_initialized()) {
                    facet_servant 
                        = new FacetHello_impl
                        (
                         m_executor_locator.in(), 
                         FACET_ECHO_NAME,
                         m_context,
                         m_comp_ref.in(),
                         this,
                         m_logger.in(),
                         this->get_component_identity()
                         );                                        
                } else {                
                    facet_servant 
                        = new Hello_impl
                        (
                         m_executor_locator.in(), 
                         FACET_ECHO_NAME,
                         m_context,
                         m_comp_ref.in(),
                         this,
                         m_logger.in()
                         );
                }
            }
        else
            {
                // No facet/consumer with this name define for this component
                CDMW_ERROR(m_logger.in(), 
                           "No '" << facet_name << 
                           "' facet or consumer defined for this component");
                CORBA::OBJECT_NOT_EXIST ex(Cdmw::OrbSupport::OBJECT_NOT_EXIST,
                                           CORBA::COMPLETED_NO); 
                CDMW_LOG_FUNCTION_EXCEPTION(ex);
                throw ex;
            }
          
        return facet_servant._retn();
    }
      

   
   
    /**
     * Purpose:
     * <p>In case of a session component, this operation will call 
     * it's executor's ccm_activate operation.
     *
     *@exception Components::CCMException Any CCMException thrown by the
     * executor's ccm_activate operation.
     *@exception CORBA::SystemException Any SystemException thrown by the
     * executor's ccm_activate operation.
     */ 
   
    void SessionServer_impl::ccm_activate() 
        throw (Components::CCMException, CORBA::SystemException)
    {
        // this is a session component, call ccm_activate
        m_session_locator->ccm_activate();
    }
   
   
   
    /**
     * Purpose:
     * <p>In case of a session component, this operation will call 
     * it's executor's ccm_passivate operation.
     *
     *@exception Components::CCMException Any CCMException thrown by the
     * executor's ccm_passivate operation.
     *@exception CORBA::SystemException Any SystemException thrown by the
     * executor's ccm_passivate operation.
     */ 
   
    void SessionServer_impl::ccm_passivate() 
        throw (Components::CCMException, CORBA::SystemException)
    {
        // this is a session component, call ccm_passivate
        m_session_locator->ccm_passivate();
    }
   
   
   
    /**
     * Purpose:
     * <p>In case of a session component, this operation will call 
     * it's executor's ccm_remove operation.
     *
     *@exception Components::CCMException Any CCMException thrown by the
     * executor's ccm_remove operation.
     *@exception CORBA::SystemException Any SystemException thrown by the
     * executor's ccm_remove operation.
     */ 
   
    void SessionServer_impl::ccm_remove() 
        throw (Components::CCMException, CORBA::SystemException)
    {
        // this is a session component, call ccm_remove
        m_session_locator->ccm_remove();
    }


    ::CORBA::LocalObject_ptr SessionServer_impl::get_receptacle_object
    (
     const char * receptacle_name,
     ::CORBA::Object_ptr facet_object
     ) throw (CORBA::SystemException)
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "receptacle name=" << receptacle_name);
        ::CORBA::LocalObject_ptr obj = ::CORBA::LocalObject::_nil();
        
        CDMW_DEBUG(m_logger.in(),"This component has no receptacles");
        
        return ::CORBA::LocalObject::_duplicate(obj);
    }

   
   
   // Change state to REMOVED; this will call ccm_passivate and ccm_remove on executor
   void 
   SessionServer_impl::advise_executor_of_remove_component()
      throw (CORBA::SystemException)
   {
      CDMW_LOG_FUNCTION(m_logger.in(), "");
      check_is_removed();

      try
      {
         m_state = m_state->remove(this);
      }
      catch (const Components::CCMException& e)
      {
         
         CDMW_ERROR(m_logger.in(), "Components::CCMException raised, reason " << e);
         
         CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError,
                            CORBA::COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(ex);
         throw ex;
      }
   }

 
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestComponents
