/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccm.testccmcopi;

import org.omg.CORBA.BooleanHolder;
import org.omg.Components.ContainerPortableInterceptor.ContainerRequestInfo;

/**
 *
 */
public interface ParamModifierCOPITest {
    final int MODIFY_IN_PARAM = 0;
    final int MODIFY_OUT_RET = 1;
    final int THROW_EXCEPTION = 2;
    final int MODIFY_EXCEPTION = 3;
    final int DO_NOT_PROCEED_CALL = 4;
    
    public void modify_in_param(ContainerRequestInfo info,  BooleanHolder proceed_call);
    public void test_modify_in_param();
    
    public void modify_out_return_param(ContainerRequestInfo info, BooleanHolder proceed_call);
    public void test_modify_out_return_param();
    
    public void throw_exception(ContainerRequestInfo info, BooleanHolder proceed_call);
    public void test_throw_exception();
    
    public void modify_exception(ContainerRequestInfo info, BooleanHolder proceed_call);
    public void test_modify_exception();
    
    public void do_not_proceed_call(ContainerRequestInfo info, BooleanHolder proceed_call);
    public void test_do_not_proceed_call();
    
}
