/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccm.testqosenabler_dds4ccm;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;
import org.omg.Components.CCMObject;

import com.acme.Hello.Donnee_Getter;
import com.acme.Hello.Donnee_MyConnector_DDS_Get;
import com.acme.Hello.Donnee_MyConnector_DDS_RawListen;
import com.acme.Hello.Donnee_MyConnector_DDS_StateListen;
import com.acme.Hello.Donnee_MyConnector_DDS_Update;
import com.acme.Hello.Donnee_MyConnector_DDS_Write;
import com.acme.Hello.Donnee_RawListener;
import com.acme.Hello.Donnee_StateListener;
import com.acme.Hello.Donnee_Reader;
import com.acme.Hello.Donnee_Updater;
import com.acme.Hello.Donnee_Writer;
import com.thalesgroup.CdmwDeployment.ValuetypeFactoryDescription;
import com.thalesgroup.CdmwDeployment.ValuetypeFactoryDescriptionSeqHelper;


import cdmw.ccm.container.ConfigValueImpl;
import cdmw.ccm.container.HomeAllocator;
import cdmw.ccm.container.HomeAllocatorRegistry;
import cdmw.testutils.CORBATestManager;
import cdmw.testutils.TestManager;
import cdmw.testutils.CORBATestManager.InvalidObject;

import org.omg.CCM_DDS.ListenerControl;

/**
 *
 */
public class DeploymentTest {

    private org.omg.CORBA.ORB orb;

//    private org.omg.PortableServer.POA poa;

    @Before
    public void init() throws InvalidObject {
        CORBATestManager testManager = CORBATestManager.instance();

        this.orb = testManager.getORB();
//        this.poa = testManager.getPOA();
    }

    @Test
    public void doTests() {

        //int timescale = TestManager.getTimescale();

        System.out.println("Testing the Deployment process ...");

       /* cdmw.ossupport.ThreadedProcess process = null;
        try {
            System.out
                    .println("Start process component_server without Persistence");
            process = cdmw.ossupport.OS
                    .createJavaProcess("cdmw.ccm.testqosenabler_dds4ccm.MainTest --server"
                            + " --CdmwProcessPort=22200 "
                            + " -DCdmw.CCM.SessionContainer.PersistentRef=no" +
                                    " --CdmwLogLevel=ALL");
            try {
                cdmw.ossupport.OS.sleep(timescale * 2000);
            } catch (java.lang.InterruptedException e) {
                // ignore
            }
        } catch (java.io.IOException e) {
            fail("Error while starting MainTest process: " + e.getMessage());
        }*/


        HomeAllocator allocator = null;

        // Register HomeAllocator
        allocator = new HomeAllocator("Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_WriteHome_impl");
                //"Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_WriteHome_impl");

        HomeAllocatorRegistry.register("Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_WriteHome_impl", allocator);

        assertNotNull(HomeAllocatorRegistry.getAllocator("Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_WriteHome_impl"));

        System.out.println("Write HomeAllocator registered ...");

        allocator = new HomeAllocator(
                "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_GetHome_impl");
        HomeAllocatorRegistry.register(
                "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_GetHome_impl",
                allocator);
        allocator = new HomeAllocator(
                "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_RawListenHome_impl");
        HomeAllocatorRegistry.register(
                "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_RawListenHome_impl",
                allocator);

        allocator = new HomeAllocator(
               "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_UpdateHome_impl");
        HomeAllocatorRegistry.register(
                "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_UpdateHome_impl",
        allocator);

        allocator = new HomeAllocator(
        "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_StateListenHome_impl");
HomeAllocatorRegistry.register(
        "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_StateListenHome_impl",
        allocator);

        allocator = new HomeAllocator("Cdmw.CCM.CIF.CdmwHello.SessionComposantHome_impl");
        HomeAllocatorRegistry.register("Cdmw.CCM.CIF.CdmwHello.SessionComposantHome_impl",
                allocator);


        System.out.println("Testing The Extension Container ...");

        org.omg.Components.Deployment.ComponentServer componentServer = null;
        System.out.println("get the reference of the component_server ...");
        /*try {
            org.omg.CORBA.Object obj = orb
                    .string_to_object("file://componentServer.ior");
            componentServer = org.omg.Components.Deployment.ComponentServerHelper
                    .narrow(obj);

        } catch (org.omg.CORBA.BAD_PARAM e) {
            fail("Error while retrieving component_server reference: "
                    + e.getMessage());
        }*/
        componentServer = (org.omg.Components.Deployment.ComponentServer)CORBATestManager.instance().getLocalProperty("ComponentServer");

        // Create an extension container
        System.out.println("Creating a container instance ...");
        org.omg.Components.ConfigValue[] cfgCompserver = new org.omg.Components.ConfigValue[0];
        org.omg.Components.Deployment.Container theContainer = null;
        try {
            theContainer = componentServer.create_container(cfgCompserver);
        } catch (org.omg.Components.CreateFailure cf) {
            fail(cf.getMessage());
        } catch (org.omg.Components.Deployment.InvalidConfiguration ic) {
            fail(ic.getMessage());
        }

        // Testing theContainer.install_home() ...
        System.out
                .println("******************************************************");
        System.out
                .println("************* DDS Fragments Deployment  **************");
        System.out
                .println("******************************************************");


        try {
            System.out.println("Installing the Writer Home ...");

            String ENTRY_PT = "cdmw.ccm.testqosenabler_dds4ccm.Donnee_MyConnector_DDS_WriteHomeExecutorImpl.createDonnee_MyConnector_DDS_WriteHomeExecutor";
            String UUID_home1 = "WriteHome";

            com.acme.Hello.Donnee_MyConnector_DDS_WriteHome writehome = null;

            // Create a set of ConfigValues.
            org.omg.Components.ConfigValue[] cfg = createConfigValues(
                    com.thalesgroup.CdmwDeployment.ComponentKindValue.EXTENSION,
                    com.thalesgroup.CdmwDeployment.ServantLifetimeValue.COMPONENT_LIFETIME,
                    com.thalesgroup.CdmwDeployment.ThreadingPolicyValue.MULTITHREAD,
                    "IDL:acme.com/Hello/Donnee_MyConnector_DDS_WriteHome:1.0",
                    "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_WriteHome_impl",
                    null);
            System.out.println("Creating " + UUID_home1 + " home...");
            assertNotNull(HomeAllocatorRegistry.getAllocator("Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_WriteHome_impl"));
            org.omg.Components.CCMHome home = theContainer.install_home(UUID_home1, ENTRY_PT, cfg);
            writehome = com.acme.Hello.Donnee_MyConnector_DDS_WriteHomeHelper
                    .narrow(home);
            assertTrue(writehome != null);

            // Creating the QoS Enabler component
            System.out.println("Creating the Writer Component ...");

            org.omg.Components.ConfigValue[] configValues = new org.omg.Components.ConfigValue[1];
            org.omg.CORBA.Any value = orb.create_any();
            value.insert_string("WRITE_COMPONENT_NAME");
            configValues[0] = new cdmw.ccm.container.ConfigValueImpl(
                    com.thalesgroup.CdmwDeployment.COMPONENT_NAME.value, value);
            System.out
                    .println("Creating the QoSEnabler component using create_component_with_config_values()...");
            com.thalesgroup.CdmwCcmCif.KeylessCCMHome cdmwKeylessHome = com.thalesgroup.CdmwCcmCif.KeylessCCMHomeHelper
                    .narrow(home);
            CCMObject cmp = cdmwKeylessHome
                    .create_component_with_config_values(configValues);
            Donnee_MyConnector_DDS_Write writecomp = com.acme.Hello.Donnee_MyConnector_DDS_WriteHelper.narrow(cmp);
            assertTrue(writecomp != null);




            System.out.println("Installing the Getter Home ...");
            ENTRY_PT = "cdmw.ccm.testqosenabler_dds4ccm.Donnee_MyConnector_DDS_GetHomeExecutorImpl.createDonnee_MyConnector_DDS_GetHomeExecutor";
            UUID_home1 = "GetHome";

            com.acme.Hello.Donnee_MyConnector_DDS_GetHome gethome = null;

            cfg = createConfigValues(
                    com.thalesgroup.CdmwDeployment.ComponentKindValue.EXTENSION,
                    com.thalesgroup.CdmwDeployment.ServantLifetimeValue.COMPONENT_LIFETIME,
                    com.thalesgroup.CdmwDeployment.ThreadingPolicyValue.MULTITHREAD,
                    "IDL:acme.com/Hello/Donnee_MyConnector_DDS_GetHome:1.0",
                    "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_GetHome_impl",
                    null);
            System.out.println("Creating " + UUID_home1 + " home...");
            home = theContainer.install_home(
                    UUID_home1, ENTRY_PT, cfg);
            gethome = com.acme.Hello.Donnee_MyConnector_DDS_GetHomeHelper
                    .narrow(home);
            assertTrue(gethome != null);



            System.out.println("Installing the Getter Component ...");

            configValues = new org.omg.Components.ConfigValue[1];
            value = orb.create_any();
            value.insert_string("GET_COMPONENT_NAME");
            configValues[0] = new cdmw.ccm.container.ConfigValueImpl(
                    com.thalesgroup.CdmwDeployment.COMPONENT_NAME.value, value);
            System.out
                    .println("Creating the QoSEnabler component using create_component_with_config_values()...");
            cdmwKeylessHome = com.thalesgroup.CdmwCcmCif.KeylessCCMHomeHelper
                    .narrow(home);
            cmp = cdmwKeylessHome
                    .create_component_with_config_values(configValues);
            Donnee_MyConnector_DDS_Get getcomp = com.acme.Hello.Donnee_MyConnector_DDS_GetHelper.narrow(cmp);
            assertTrue(getcomp != null);




            System.out.println("Installing the RawListen Home ...");
            ENTRY_PT = "cdmw.ccm.testqosenabler_dds4ccm.Donnee_MyConnector_DDS_RawListenHomeExecutorImpl.createDonnee_MyConnector_DDS_RawListenHomeExecutor";
            UUID_home1 = "RawListenHome";

            com.acme.Hello.Donnee_MyConnector_DDS_RawListenHome rawhome = null;

            cfg = createConfigValues(
                    com.thalesgroup.CdmwDeployment.ComponentKindValue.EXTENSION,
                    com.thalesgroup.CdmwDeployment.ServantLifetimeValue.COMPONENT_LIFETIME,
                    com.thalesgroup.CdmwDeployment.ThreadingPolicyValue.MULTITHREAD,
                    "IDL:acme.com/Hello/Donnee_MyConnector_DDS_RawListenHome:1.0",
                    "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_RawListenHome_impl",
                    null);
            System.out.println("Creating " + UUID_home1 + " home...");
            home = theContainer.install_home(
                    UUID_home1, ENTRY_PT, cfg);
            rawhome = com.acme.Hello.Donnee_MyConnector_DDS_RawListenHomeHelper
                    .narrow(home);
            assertTrue(rawhome != null);

            System.out.println("Installing the RawListen Component ...");
            configValues = new org.omg.Components.ConfigValue[1];
            value = orb.create_any();
            value.insert_string("RAWLISTEN_COMPONENT_NAME");
            configValues[0] = new cdmw.ccm.container.ConfigValueImpl(
                    com.thalesgroup.CdmwDeployment.COMPONENT_NAME.value, value);
            System.out
                    .println("Creating the QoSEnabler component using create_component_with_config_values()...");
            cdmwKeylessHome = com.thalesgroup.CdmwCcmCif.KeylessCCMHomeHelper
                    .narrow(home);
            cmp = cdmwKeylessHome
                    .create_component_with_config_values(configValues);
            Donnee_MyConnector_DDS_RawListen rawcomp = com.acme.Hello.Donnee_MyConnector_DDS_RawListenHelper.narrow(cmp);
            assertTrue(rawcomp != null);







            System.out.println("Installing the Update Home ...");
            ENTRY_PT = "cdmw.ccm.testqosenabler_dds4ccm.Donnee_MyConnector_DDS_UpdateHomeExecutorImpl.createDonnee_MyConnector_DDS_UpdateHomeExecutor";
            UUID_home1 = "UpdateHome";

            com.acme.Hello.Donnee_MyConnector_DDS_UpdateHome uphome = null;

            cfg = createConfigValues(
                    com.thalesgroup.CdmwDeployment.ComponentKindValue.EXTENSION,
                    com.thalesgroup.CdmwDeployment.ServantLifetimeValue.COMPONENT_LIFETIME,
                    com.thalesgroup.CdmwDeployment.ThreadingPolicyValue.MULTITHREAD,
                    "IDL:acme.com/Hello/Donnee_MyConnector_DDS_UpdateHome:1.0",
                    "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_UpdateHome_impl",
                    null);
            System.out.println("Creating " + UUID_home1 + " home...");
            home = theContainer.install_home(
                    UUID_home1, ENTRY_PT, cfg);
            uphome = com.acme.Hello.Donnee_MyConnector_DDS_UpdateHomeHelper
                    .narrow(home);
            assertTrue(uphome != null);

            System.out.println("Installing the Update Component ...");
            configValues = new org.omg.Components.ConfigValue[1];
            value = orb.create_any();
            value.insert_string("UPDATE_COMPONENT_NAME");
            configValues[0] = new cdmw.ccm.container.ConfigValueImpl(
                    com.thalesgroup.CdmwDeployment.COMPONENT_NAME.value, value);
            System.out
                    .println("Creating the QoSEnabler component using create_component_with_config_values()...");
            cdmwKeylessHome = com.thalesgroup.CdmwCcmCif.KeylessCCMHomeHelper
                    .narrow(home);
            cmp = cdmwKeylessHome
                    .create_component_with_config_values(configValues);
            Donnee_MyConnector_DDS_Update upcomp = com.acme.Hello.Donnee_MyConnector_DDS_UpdateHelper.narrow(cmp);
            assertTrue(upcomp != null);







            System.out.println("Installing the StateListen Home ...");
            ENTRY_PT = "cdmw.ccm.testqosenabler_dds4ccm.Donnee_MyConnector_DDS_StateListenHomeExecutorImpl.createDonnee_MyConnector_DDS_StateListenHomeExecutor";
            UUID_home1 = "StateListenHome";

            com.acme.Hello.Donnee_MyConnector_DDS_StateListenHome statehome = null;

            cfg = createConfigValues(
                    com.thalesgroup.CdmwDeployment.ComponentKindValue.EXTENSION,
                    com.thalesgroup.CdmwDeployment.ServantLifetimeValue.COMPONENT_LIFETIME,
                    com.thalesgroup.CdmwDeployment.ThreadingPolicyValue.MULTITHREAD,
                    "IDL:acme.com/Hello/Donnee_MyConnector_DDS_StateListenHome:1.0",
                    "Cdmw.CCM.CIF.CdmwHello.ExtensionDonnee_MyConnector_DDS_StateListenHome_impl",
                    null);
            System.out.println("Creating " + UUID_home1 + " home...");
            home = theContainer.install_home(
                    UUID_home1, ENTRY_PT, cfg);
            statehome = com.acme.Hello.Donnee_MyConnector_DDS_StateListenHomeHelper
                    .narrow(home);
            assertTrue(statehome != null);

            System.out.println("Installing the StateListen Component ...");
            configValues = new org.omg.Components.ConfigValue[1];
            value = orb.create_any();
            value.insert_string("STATELISTEN_COMPONENT_NAME");
            configValues[0] = new cdmw.ccm.container.ConfigValueImpl(
                    com.thalesgroup.CdmwDeployment.COMPONENT_NAME.value, value);
            System.out
                    .println("Creating the QoSEnabler component using create_component_with_config_values()...");
            cdmwKeylessHome = com.thalesgroup.CdmwCcmCif.KeylessCCMHomeHelper
                    .narrow(home);
            cmp = cdmwKeylessHome
                    .create_component_with_config_values(configValues);
            Donnee_MyConnector_DDS_StateListen statecomp = com.acme.Hello.Donnee_MyConnector_DDS_StateListenHelper.narrow(cmp);
            assertTrue(statecomp != null);











            System.out.println("Complete the configuration of the fragments component");


        System.out
                .println("******************************************************");
        System.out
                .println("************* Application Deployment  ****************");
        System.out
                .println("******************************************************");
        // Creating the
        System.out.println("Installing the Hello component Home ...");
        ENTRY_PT = "cdmw.ccm.testqosenabler_dds4ccm.ComposantHomeExecutorImpl.createComposantHomeExecutor";
        UUID_home1 = "ComposantHome";
        com.acme.Hello.ComposantHome composanthome = null;

/*        ValuetypeFactoryDescription[] valueTypeFactorySeq = new ValuetypeFactoryDescription[2];
        ValuetypeFactoryDescription desc = new ValuetypeFactoryDescription(
                "IDL:acme.com/Hello/Activated:1.0",
                "cdmw.ccm.testccmcopi.ActivatedEventFactoryImpl.createActivatedFactory");
        valueTypeFactorySeq[0] = desc;
        desc = new ValuetypeFactoryDescription(
                "IDL:acme.com/TestComponents/ServerInfo:1.0",
                "cdmw.ccm.testccmcopi.ServerInfoFactoryImpl.createServerInfoFactory");
        valueTypeFactorySeq[1] = desc; */

            // Create a set of ConfigValues.
            cfg = createConfigValues(
                    com.thalesgroup.CdmwDeployment.ComponentKindValue.SESSION,
                    com.thalesgroup.CdmwDeployment.ServantLifetimeValue.COMPONENT_LIFETIME,
                    com.thalesgroup.CdmwDeployment.ThreadingPolicyValue.MULTITHREAD,
                    "IDL:acme.com/Hello/ComposantHome:1.0",
                    "Cdmw.CCM.CIF.CdmwHello.SessionComposantHome_impl",
                    null);//valueTypeFactorySeq);
            System.out.println("Creating " + UUID_home1 + " home...");

            home = theContainer.install_home(
                    UUID_home1, ENTRY_PT, cfg);
            composanthome = com.acme.Hello.ComposantHomeHelper.narrow(home);
            assertTrue(composanthome != null);


            System.out.println("Creation a Hello Component instance ...");

            configValues = new org.omg.Components.ConfigValue[1];
            value = orb.create_any();
            value.insert_string("COMPOSANT_COMPONENT_NAME");
            configValues[0] = new cdmw.ccm.container.ConfigValueImpl(
                    com.thalesgroup.CdmwDeployment.COMPONENT_NAME.value, value);
            cdmwKeylessHome = com.thalesgroup.CdmwCcmCif.KeylessCCMHomeHelper
                    .narrow(composanthome);
            CCMObject comp = cdmwKeylessHome
                    .create_component_with_config_values(configValues);

            com.acme.Hello.Composant composantComp = com.acme.Hello.ComposantHelper
                    .narrow(comp);

            System.out.println("Configuring the DDS Fragments ...");
            String[] keys = new String[0];
            String domain_id = "",
                     topic_name = "TOPIC_TEST",
                     qosProfile = "file://"+ System.getenv("CDMW_HOME")+
            "/CCMContainer/tests/java/testqosenabler_dds4ccmdata/DDS_QoS_KEEP_ALL_HISTORY.xml",
                    defaultProfile = null;

            writecomp.domain_id(domain_id);
            getcomp.domain_id(domain_id);
            rawcomp.domain_id(domain_id);
            upcomp.domain_id(domain_id);
            statecomp.domain_id(domain_id);

            writecomp.key_fields(keys);
            getcomp.key_fields(keys);
            rawcomp.key_fields(keys);
            upcomp.key_fields(keys);
            statecomp.key_fields(keys);

            writecomp.topic_name(topic_name);
            getcomp.topic_name(topic_name);
            rawcomp.topic_name(topic_name);
            upcomp.topic_name(topic_name);
            statecomp.topic_name(topic_name);

            writecomp.qos_profile(defaultProfile);
            getcomp.qos_profile(qosProfile);
            rawcomp.qos_profile(qosProfile);
            assertEquals("Unexpected Qos Profile for the RawListen fragment",
                    qosProfile, rawcomp.qos_profile());
            upcomp.qos_profile(defaultProfile);
            statecomp.qos_profile(defaultProfile);



            System.out.println("Connecting facets...");

            Donnee_Writer p_Write_data = writecomp.provide_p_Write_data();
            Donnee_Getter p_Get_data = getcomp.provide_p_Get_data();
            Donnee_Reader p_RawListen_data = rawcomp.provide_p_RawListen_data();
            ListenerControl p_RawListen_control = rawcomp.provide_p_RawListen_control();
            Donnee_RawListener p_Composant_listener = composantComp.provide_p_Composant_listener();
            Donnee_Updater p_Update_data = upcomp.provide_p_Update_data();
            Donnee_StateListener p_StateListener_listener = composantComp.provide_p_StateListen_listener();
            ListenerControl p_StateListen_control = statecomp.provide_p_StateListen_control();
            Donnee_Reader p_StateListen_data = statecomp.provide_p_StateListen_data();


            rawcomp.connect_p_RawListen_listener(p_Composant_listener);
            statecomp.connect_p_StateListen_listener(p_StateListener_listener);
            composantComp.connect_p_Get_data(p_Get_data);
            composantComp.connect_p_Composant_control(p_RawListen_control);
            composantComp.connect_p_Write_data(p_Write_data);
            composantComp.connect_p_Composant_data(p_RawListen_data);


            System.out.println("configuration_complete ...");
            writecomp.configuration_complete();
            getcomp.configuration_complete();
            rawcomp.configuration_complete();
            composantComp.configuration_complete();
            upcomp.configuration_complete();
            statecomp.configuration_complete();

            CORBATestManager testManager = (CORBATestManager)TestManager.instance();


            testManager.setLocalProperty(
                    "cdmw.ccm.testqosenabler_dds4ccm.writecomp", writecomp);

            testManager.setLocalProperty(
                    "cdmw.ccm.testqosenabler_dds4ccm.getcomp", getcomp);

            testManager.setLocalProperty(
                    "cdmw.ccm.testqosenabler_dds4ccm.rawcomp", rawcomp);

            testManager.setLocalProperty(
                    "cdmw.ccm.testqosenabler_dds4ccm.upcomp", upcomp);

            testManager.setLocalProperty(
                    "cdmw.ccm.testqosenabler_dds4ccm.statecomp", statecomp);

            testManager.setLocalProperty(
                    "cdmw.ccm.testqosenabler_dds4ccm.composantComp", composantComp);





            testManager.setLocalProperty(
                "cdmw.ccm.testqosenabler_dds4ccm.p_Write_data", p_Write_data);

            testManager.setLocalProperty(
                    "cdmw.ccm.testqosenabler_dds4ccm.p_RawListen_data", p_RawListen_data);

            testManager.setLocalProperty(
                    "cdmw.ccm.testqosenabler_dds4ccm.p_Get_data", p_Get_data);

            testManager.setLocalProperty(
                    "cdmw.ccm.testqosenabler_dds4ccm.p_RawListen_control", p_RawListen_control);

            testManager.setLocalProperty(
                    "cdmw.ccm.testqosenabler_dds4ccm.p_Update_data", p_Update_data);

            testManager.setLocalProperty(
                    "cdmw.ccm.testqosenabler_dds4ccm.p_StateListen_control", p_StateListen_control);

            testManager.setLocalProperty(
                    "cdmw.ccm.testqosenabler_dds4ccm.p_StateListen_data", p_StateListen_data);

System.out.println("********** End of DeploymentTest");

        } catch (Exception ex) {
            ex.printStackTrace();
            fail("ex = " + ex.toString());
        }

    }

    private org.omg.Components.ConfigValue[] createConfigValues(
            com.thalesgroup.CdmwDeployment.ComponentKindValue componentKind,
            com.thalesgroup.CdmwDeployment.ServantLifetimeValue servantLifetime,
            com.thalesgroup.CdmwDeployment.ThreadingPolicyValue threadingPolicy,
            String repid, String classname, ValuetypeFactoryDescription[] seq) {

        int nbValues = (seq != null ? 6 : 5);
        org.omg.Components.ConfigValue[] cfg = new org.omg.Components.ConfigValue[nbValues];
        org.omg.CORBA.Any value = null;

        // COMPONENT_KIND
        value = orb.create_any();
        com.thalesgroup.CdmwDeployment.ComponentKindValueHelper.insert(value,
                componentKind);
        cfg[0] = new ConfigValueImpl(
                com.thalesgroup.CdmwDeployment.COMPONENT_KIND.value, value);

        // HOME_REPOSITORY_ID
        value = orb.create_any();
        value.insert_string(repid);
        cfg[1] = new ConfigValueImpl(
                com.thalesgroup.CdmwDeployment.HOME_REPOSITORY_ID.value, value);

        // HOME_SERVANT_CLASSNAME
        value = orb.create_any();
        value.insert_string(classname);
        cfg[2] = new ConfigValueImpl(
                com.thalesgroup.CdmwDeployment.HOME_SERVANT_CLASSNAME.value,
                value);

        // SERVANT_LIFETIME
        value = orb.create_any();
        com.thalesgroup.CdmwDeployment.ServantLifetimeValueHelper.insert(value,
                servantLifetime);
        cfg[3] = new ConfigValueImpl(
                com.thalesgroup.CdmwDeployment.SERVANT_LIFETIME.value, value);

        // THREADING_POLICY
        value = orb.create_any();
        com.thalesgroup.CdmwDeployment.ThreadingPolicyValueHelper.insert(value,
                threadingPolicy);
        cfg[4] = new ConfigValueImpl(
                com.thalesgroup.CdmwDeployment.THREADING_POLICY.value, value);

        // VALUETYPE_FACTORY_DEPENDENCIES
        if (nbValues == 6) {
            value = orb.create_any();
            ValuetypeFactoryDescriptionSeqHelper.insert(value, seq);
            cfg[5] = new ConfigValueImpl(
                    com.thalesgroup.CdmwDeployment.VALUETYPE_FACTORY_DEPENDENCIES.value,
                    value);
        }

        return cfg;

    }

}
