package cdmw.ccm.testqosenabler_dds4ccm;

import java.util.Hashtable;

import org.omg.CCM_DDS.CCM_ListenerControl;
import org.omg.CCM_DDS.InstanceStatus;
import org.omg.CCM_DDS.ReadInfo;

import DDS.DataReader;
import DDS.RETCODE_NO_DATA;
import DDS.RETCODE_OK;
import DDS.SampleInfoSeqHolder;

import com.acme.Hello.CCM_Donnee_Reader;
import com.acme.Hello.Donnee;
import com.acme.Hello.DonneeDataReader;
import com.acme.Hello.DonneeDataReaderHelper;
import com.acme.Hello.DonneeSeqHolder;
import com.acme.Hello.Donnee_StateListener;


import static cdmw.ccm.qosenablers.dds.DataUtil.*;
import cdmw.ccm.qosenablers.dds.DDS_ReaderImpl;
import cdmw.ccm.qosenablers.dds.DataReaderListenerImpl;

public class DonneeStateListenerImpl extends DataReaderListenerImpl {

    private Donnee_StateListener listenerReceptacle;
    private final int INSTANCE_ALIVE = 1;
    private final int INSTANCE_DELETED = 0;
    private Hashtable<Integer,Integer> aliveTargets = new Hashtable<Integer,Integer>();

    public DonneeStateListenerImpl(Donnee_StateListener stateListen_listener,
            CCM_ListenerControl StateListen_control,
            CCM_Donnee_Reader StateListen_data) {
        super((DDS_ReaderImpl)StateListen_data, StateListen_control);
        this.listenerReceptacle = stateListen_listener;
    }

    /**
     * USELESS
     * @param dr
     */
    public void on_data_available0(DataReader dr) {

        if(!listenEnabler.enabled() || this.listenerReceptacle == null) return;

        DonneeDataReader donneeReader = DonneeDataReaderHelper.narrow(dr);

        DonneeSeqHolder data = new DonneeSeqHolder();
        SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
        //     int status = donneeReader.read_w_condition(data, infoSeq, 1, getReadCondition());
        int status = donneeReader.read(data, infoSeq, DDS.LENGTH_UNLIMITED.value, DDS.NOT_READ_SAMPLE_STATE.value,
                DDS.NEW_VIEW_STATE.value
                | DDS.NOT_NEW_VIEW_STATE.value,
                DDS.ALIVE_INSTANCE_STATE.value
                | DDS.NOT_ALIVE_INSTANCE_STATE.value);


        if (status == RETCODE_OK.value) {
            System.out.println("RETCODE_OK");

            if(data.value.length == 1) {

                ReadInfo[] info = new ReadInfo[]{new ReadInfo()};
                fillReadInfo(infoSeq.value[0], info[0], 0);

                if (infoSeq.value[0].valid_data) {

                    Donnee an_instance = data.value[0];
                    org.omg.DDS.Time_t tmp = new org.omg.DDS.Time_t(infoSeq.value[0].source_timestamp.sec, infoSeq.value[0].source_timestamp.nanosec);

                    if(info[0].instance_status == InstanceStatus.INSTANCE_CREATED) {
                        aliveTargets.put(an_instance.ID, INSTANCE_ALIVE);
                        this.listenerReceptacle.on_creation(an_instance, tmp);
                    }

                    if(info[0].instance_status == InstanceStatus.INSTANCE_UPDATED) {
                        aliveTargets.put(an_instance.ID, INSTANCE_ALIVE);
                        this.listenerReceptacle.on_update(an_instance, tmp);
                    }

                    if(info[0].instance_status == InstanceStatus.INSTANCE_DELETED) {
                        aliveTargets.put(an_instance.ID, INSTANCE_DELETED);
                        this.listenerReceptacle.on_deletion(an_instance, tmp);
                    }

                }

            } else {

                ReadInfo[] info = new ReadInfo[data.value.length];

                for (int i = 0; i < infoSeq.value.length; i++) {

                    if (infoSeq.value[i].sample_rank == 0) {

                        if (infoSeq.value[i].valid_data) {

                            info[i] = new ReadInfo();
                            fillReadInfo(infoSeq.value[i], info[i], infoSeq.value[i].sample_rank);

                            Donnee an_instance = data.value[i];
                            org.omg.DDS.Time_t tmp = new org.omg.DDS.Time_t(infoSeq.value[i].source_timestamp.sec, infoSeq.value[i].source_timestamp.nanosec);

                            if(info[i].instance_status == InstanceStatus.INSTANCE_CREATED) {
                                aliveTargets.put(an_instance.ID, INSTANCE_ALIVE);
                                this.listenerReceptacle.on_creation(an_instance, tmp);
                            }

                            if(info[i].instance_status == InstanceStatus.INSTANCE_UPDATED) {
                                aliveTargets.put(an_instance.ID, INSTANCE_ALIVE);
                                this.listenerReceptacle.on_update(an_instance, tmp);
                            }

                            if(info[i].instance_status == InstanceStatus.INSTANCE_DELETED) {
                                aliveTargets.put(an_instance.ID, INSTANCE_DELETED);
                                this.listenerReceptacle.on_deletion(an_instance, tmp);
                            }

                        }


                    } else {
                        i = i - 1 + infoSeq.value[i].sample_rank;
                    }
                }


            }

        }


        if(status == RETCODE_NO_DATA.value) {
System.out.println("RETCODE_NO_DATA");
            status = donneeReader.read(data, infoSeq, DDS.LENGTH_UNLIMITED.value, DDS.ANY_SAMPLE_STATE.value,
                    DDS.NEW_VIEW_STATE.value
                    | DDS.NOT_NEW_VIEW_STATE.value,
                    DDS.NOT_ALIVE_DISPOSED_INSTANCE_STATE.value);


            for (int i = 0; i < infoSeq.value.length; i++) {
                if (infoSeq.value[i].sample_rank == 0) {
                    if(aliveTargets.get(data.value[i].ID) != null) {
                        if( aliveTargets.get(data.value[i].ID) == this.INSTANCE_ALIVE ) {
                            org.omg.DDS.Time_t tmp = new org.omg.DDS.Time_t(infoSeq.value[i].source_timestamp.sec, infoSeq.value[i].source_timestamp.nanosec);
                            this.listenerReceptacle.on_deletion(data.value[i], tmp);
                            aliveTargets.put(data.value[i].ID, INSTANCE_DELETED);
                        }
                    }
                } else {
                    i = i - 1 + infoSeq.value[i].sample_rank;
                }
            }

        }

    }


    public synchronized void on_data_available(DataReader dr) {

        if (!listenEnabler.enabled() || this.listenerReceptacle == null)
            return;

        DonneeDataReader donneeReader = DonneeDataReaderHelper.narrow(dr);

        /**
         * reading alive instances
         */

        DonneeSeqHolder data = new DonneeSeqHolder();
        SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
        /* filter not actived */
        // int status = donneeReader.read_w_condition(data, infoSeq, 1,
        // getReadCondition());
        int status = donneeReader.read(data, infoSeq,
                DDS.LENGTH_UNLIMITED.value, DDS.NOT_READ_SAMPLE_STATE.value,
                DDS.NEW_VIEW_STATE.value | DDS.NOT_NEW_VIEW_STATE.value,
                DDS.ALIVE_INSTANCE_STATE.value);

        if (status == RETCODE_OK.value) {
            ReadInfo[] info = new ReadInfo[data.value.length];
            for (int i = 0; i < infoSeq.value.length; i++) {

                if (infoSeq.value[i].sample_rank == 0) {
                    info[i] = new ReadInfo();
                    fillReadInfo(infoSeq.value[i], info[i],
                            infoSeq.value[i].sample_rank);

                    Donnee an_instance = data.value[i];
                    org.omg.DDS.Time_t tmp = new org.omg.DDS.Time_t(
                            infoSeq.value[i].source_timestamp.sec,
                            infoSeq.value[i].source_timestamp.nanosec);

                    if (info[i].instance_status == InstanceStatus.INSTANCE_CREATED) {
                        this.listenerReceptacle.on_creation(an_instance, tmp);
                    }

                    if (info[i].instance_status == InstanceStatus.INSTANCE_UPDATED) {
                        this.listenerReceptacle.on_update(an_instance, tmp);
                    }

                }
            }

        }
        donneeReader.return_loan(data, infoSeq);

        /**
         * reading DISPOSED instances
         */
        data = new DonneeSeqHolder();
        infoSeq = new SampleInfoSeqHolder();

        status = donneeReader.take(data, infoSeq, DDS.LENGTH_UNLIMITED.value,
                DDS.ANY_SAMPLE_STATE.value,
                DDS.NEW_VIEW_STATE.value | DDS.NOT_NEW_VIEW_STATE.value,
                DDS.NOT_ALIVE_DISPOSED_INSTANCE_STATE.value);

        if (status == RETCODE_OK.value) {
            for (int i = 0; i < infoSeq.value.length; i++) {

                if (infoSeq.value[i].sample_rank == 0) {
                    org.omg.DDS.Time_t tmp = new org.omg.DDS.Time_t(
                            infoSeq.value[i].source_timestamp.sec,
                            infoSeq.value[i].source_timestamp.nanosec);
                    this.listenerReceptacle.on_deletion(data.value[i], tmp);
                }
            }
        }

        donneeReader.return_loan(data, infoSeq);
    }


}
