package cdmw.ccm.testqosenabler_dds4ccm;



import org.omg.Components.CCMException;
import org.omg.Components.CCMExceptionReason;
import org.omg.Components.SessionContext;

import com.acme.Hello.CCM_Donnee_Getter;
import com.acme.Hello.CCM_Donnee_MyConnector_DDS_Get;
import com.acme.Hello.DonneeDataReader;
import com.acme.Hello.DonneeDataReaderHelper;
import com.acme.Hello.DonneeTypeSupport;

import cdmw.ccm.qosenablers.dds.DDS_TopicBaseFragmentImpl;
import cdmw.ccm.qosenablers.dds.ErrorHandler;

import DDS.*;

public class Donnee_MyConnector_DDS_GetExecutorImpl extends
    DDS_TopicBaseFragmentImpl implements CCM_Donnee_MyConnector_DDS_Get,
    org.omg.Components.SessionComponent
    {
    DonneeDataReader donneeReader;
    DonneeTypeSupport dataTS;

    CCM_Donnee_Getter p_Get_data;

    // ------------- attributs ----------------

    public CCM_Donnee_Getter get_p_Get_data() {
        return p_Get_data;
    }

    public Donnee_MyConnector_DDS_GetExecutorImpl() {
        super();
        dataTS = new DonneeTypeSupport();
    }

    public void ccm_activate() throws CCMException{
        System.out
                .println("Donnee_MyConnector_DDS_GetExecutorImpl.ccm_activate called ...");
        try {
            super.setupDDSInfrastructure(false,true);


            donneeReader = DonneeDataReaderHelper.narrow(super.reader);
            ErrorHandler.checkHandle(donneeReader,
                    "DDS.DonneeDataReaderHelper.narrow");

            this.p_Get_data = new Donnee_GetterFacetImpl(donneeReader);

        } catch (Exception e) {
            System.out.println("Unexpected exception raised!\n" + e.getMessage());
            logger.throwing("", "ccm_activate", e);
            throw new CCMException("Failed to setup the DDS infrastructure of fragment" +
                    "Donnee_MyConnector_DDS_Get"+ e.getMessage(), CCMExceptionReason.SERVICE_INSTALLATION_ERROR);

        }
    }

    public void ccm_remove() throws CCMException{
        try {
            super.teardownDDSInfrastructure(false,true);

        } catch (Exception e) {
            e.printStackTrace();
            logger.throwing(this.getClass().getName(), "ccm_remove", e);
            throw new CCMException("Failed to teardown the DDS infrastructure of fragment" +
                        "Donnee_MyConnector_DDS_Get", CCMExceptionReason.REMOVE_ERROR);
        }
    }

    public void ccm_passivate() throws CCMException{

    }

    public void set_session_context(SessionContext arg0) throws CCMException{
    }

    @Override
    protected TypeSupport getDataTypeSupport() {
        return dataTS;
    }

}
