package cdmw.ccm.testqosenabler_dds4ccm;

import org.omg.CCM_DDS.CCM_ListenerControl;
import org.omg.CORBA.Object;
import org.omg.Components.CCMException;
import org.omg.Components.CCMExceptionReason;
import org.omg.Components.SessionContext;

import com.acme.Hello.CCM_Donnee_MyConnector_DDS_RawListen;
import com.acme.Hello.CCM_Donnee_MyConnector_DDS_RawListen_Context;
import com.acme.Hello.CCM_Donnee_MyConnector_DDS_RawListen_ContextHelper;
import com.acme.Hello.CCM_Donnee_Reader;
import com.acme.Hello.DonneeDataReader;
import com.acme.Hello.DonneeDataReaderHelper;
import com.acme.Hello.DonneeTypeSupport;
import com.acme.Hello.Donnee_RawListener;

import cdmw.ccm.qosenablers.dds.DDS_TopicBaseFragmentImpl;
import cdmw.ccm.qosenablers.dds.ErrorHandler;
import cdmw.ccm.qosenablers.dds.ListenerControlImpl;

import DDS.*;

public class Donnee_MyConnector_DDS_RawListenExecutorImpl extends
       DDS_TopicBaseFragmentImpl implements
        CCM_Donnee_MyConnector_DDS_RawListen, org.omg.Components.SessionComponent {

    /* Type-specific DDS entities */
    DonneeTypeSupport dataTS;
    DonneeDataReader donneeDR;

    // --------------- attributs --------------

    private CCM_Donnee_MyConnector_DDS_RawListen_Context sessionContext;

    private CCM_Donnee_Reader donneeReaderPort;
    protected CCM_ListenerControl listenerControl;

    public Donnee_MyConnector_DDS_RawListenExecutorImpl() {
        //this("", null, "DefaultTOPIC", null);
        super();
       init();
    }

    public Donnee_MyConnector_DDS_RawListenExecutorImpl(String domain_id,
            String qos_profile, String topic_name, String[] key_fields) {
        super(domain_id, qos_profile, topic_name, key_fields);
        init();
    }

    private void init(){
        this.listenerControl = new ListenerControlImpl();
        dataTS = new DonneeTypeSupport();
    }

    public CCM_Donnee_Reader get_p_RawListen_data() {
        return this.donneeReaderPort;
    }

    public CCM_ListenerControl get_p_RawListen_control() {
        return this.listenerControl;
    }

    public void ccm_activate() throws CCMException{
        try {
            super.setupDDSInfrastructure(false,true);
            // getting the typed datareader
            donneeDR = DonneeDataReaderHelper.narrow(reader);
            ErrorHandler.checkHandle(donneeDR,
                    "DDS.DonneeDataReaderHelper.narrow");

            //To create the facet executor
            this.donneeReaderPort = new Donnee_ReaderFacetImpl(donneeDR);

            // To get the component listener
            Donnee_RawListener donneeListenerPort = this.sessionContext.get_connection_p_RawListen_listener();

            if(donneeListenerPort == null) logger.fine("Failed to get the component RawListen facet !");


            // To set the DDS listener
            DonneeDataReaderListenerImpl listener = new DonneeDataReaderListenerImpl(
                    donneeListenerPort, listenerControl, donneeReaderPort);
            int status = donneeDR.set_listener(listener,
                    DDS.DATA_AVAILABLE_STATUS.value);
            ErrorHandler.checkStatus(status, "set_listener");

        } catch (Exception e) {
            System.out.println("Unexpected exception raised!\n" + e.getMessage());
            logger.throwing("", "ccm_activate", e);
            throw new CCMException("Failed to setup the DDS infrastructure of fragment" +
                    "Donnee_MyConnector_DDS_RawListen: "+ e.getMessage(), CCMExceptionReason.SERVICE_INSTALLATION_ERROR);

        }

    }

    public void ccm_remove() throws CCMException{
        try{
            // To detach the listener
            donneeDR.set_listener(null, DDS.ANY_STATUS.value);
            super.teardownDDSInfrastructure(false,true);
        } catch (Exception e) {
            e.printStackTrace();
            logger.throwing(this.getClass().getName(), "ccm_remove", e);
            throw new CCMException("Failed to teardown the DDS infrastructure of fragment" +
                    "Donnee_MyConnector_DDS_RawListen " + e.getMessage(), CCMExceptionReason.REMOVE_ERROR);
        }
    }

    public void ccm_passivate() throws CCMException{

    }

    public void set_session_context(SessionContext arg0) throws CCMException{
        sessionContext = CCM_Donnee_MyConnector_DDS_RawListen_ContextHelper
                .narrow((Object) arg0);
    }

    protected TypeSupport getDataTypeSupport() {
        return dataTS;
    }

}
