package cdmw.ccm.testqosenabler_dds4ccm;

import org.omg.CCM_DDS.CCM_ListenerControl;
import org.omg.CORBA.Object;
import org.omg.Components.CCMException;
import org.omg.Components.CCMExceptionReason;
import org.omg.Components.SessionContext;

import DDS.TypeSupport;
import cdmw.ccm.qosenablers.dds.DDS_TopicBaseFragmentImpl;
import cdmw.ccm.qosenablers.dds.ErrorHandler;
import cdmw.ccm.qosenablers.dds.ListenerControlImpl;

import com.acme.Hello.CCM_Donnee_MyConnector_DDS_StateListen;
import com.acme.Hello.CCM_Donnee_MyConnector_DDS_StateListen_Context;
import com.acme.Hello.CCM_Donnee_MyConnector_DDS_StateListen_ContextHelper;
import com.acme.Hello.CCM_Donnee_Reader;
import com.acme.Hello.DonneeDataReader;
import com.acme.Hello.DonneeDataReaderHelper;
import com.acme.Hello.DonneeTypeSupport;

public class Donnee_MyConnector_DDS_StateListenExecutorImpl extends
DDS_TopicBaseFragmentImpl implements
CCM_Donnee_MyConnector_DDS_StateListen, org.omg.Components.SessionComponent {

    DonneeTypeSupport dataTS;
    private ListenerControlImpl listenerControl;
    private CCM_Donnee_Reader donneeReaderPort;
    private CCM_Donnee_MyConnector_DDS_StateListen_Context sessionContext;
    DonneeDataReader donneeDR;

    public Donnee_MyConnector_DDS_StateListenExecutorImpl() {
        //this("", null, "DefaultTOPIC", null);
        super();
        this.listenerControl = new ListenerControlImpl();
        dataTS = new DonneeTypeSupport();
    }

    public Donnee_MyConnector_DDS_StateListenExecutorImpl(String domain_id,
            String qos_profile, String topic_name, String[] key_fields) {
        super(domain_id, qos_profile, topic_name, key_fields);
        this.listenerControl = new ListenerControlImpl();
        dataTS = new DonneeTypeSupport();
    }

    protected TypeSupport getDataTypeSupport() {
        return dataTS;
    }

    public CCM_ListenerControl get_p_StateListen_control() {
        return this.listenerControl;
    }

    public CCM_Donnee_Reader get_p_StateListen_data() {
        return this.donneeReaderPort;
    }

    public void ccm_activate() throws CCMException {
        try {
            super.setupDDSInfrastructure(false,true);
            // getting the typed datareader
            donneeDR = DonneeDataReaderHelper.narrow(reader);
            ErrorHandler.checkHandle(donneeDR,
                    "DDS.DonneeDataReaderHelper.narrow");

            //To create the facet executor
            this.donneeReaderPort = new Donnee_ReaderFacetImpl(donneeDR);

            // To get the component listener
            com.acme.Hello.Donnee_StateListener donneeListenerPort = this.sessionContext.get_connection_p_StateListen_listener();

            if(donneeListenerPort == null) logger.fine("Failed to get the component StateListen facet !");


            // To set the DDS listener
            DonneeStateListenerImpl listener = new DonneeStateListenerImpl(
                    donneeListenerPort, listenerControl, donneeReaderPort);
            int status = donneeDR.set_listener(listener,
                    DDS.DATA_AVAILABLE_STATUS.value);
            ErrorHandler.checkStatus(status, "set_listener");

        }  catch (Exception e) {
            System.out.println("Unexpected exception raised!\n" + e.getMessage());
            logger.throwing("", "ccm_activate", e);
            throw new CCMException("Failed to setup the DDS infrastructure of fragment" +
                    "Donnee_MyConnector_DDS_StateListen"+ e.getMessage(), CCMExceptionReason.SERVICE_INSTALLATION_ERROR);

        }
    }

    public void ccm_passivate() throws CCMException {
        // TODO Auto-generated method stub

    }

    public void ccm_remove() throws CCMException{
        try{
            // To detach the listener
            donneeDR.set_listener(null, DDS.ANY_STATUS.value);
            super.teardownDDSInfrastructure(false,true);

        } catch (Exception e) {
            e.printStackTrace();
            logger.throwing(this.getClass().getName(), "ccm_remove", e);
            throw new CCMException("Failed to teardown the DDS infrastructure of fragment" +
                    "Donnee_MyConnector_DDS_StateListen", CCMExceptionReason.REMOVE_ERROR);
        }
}

    public void set_session_context(SessionContext arg0) throws CCMException {
        sessionContext = CCM_Donnee_MyConnector_DDS_StateListen_ContextHelper
        .narrow((Object) arg0);

    }

}
