package cdmw.ccm.testqosenabler_dds4ccm;

import org.omg.CORBA.Object;
import org.omg.Components.CCMException;
import org.omg.Components.CCMExceptionReason;
import org.omg.Components.SessionContext;

import DDS.TypeSupport;
import cdmw.ccm.qosenablers.dds.DDS_TopicBaseFragmentImpl;
import cdmw.ccm.qosenablers.dds.ErrorHandler;

import com.acme.Hello.CCM_Donnee_MyConnector_DDS_Update;
import com.acme.Hello.CCM_Donnee_MyConnector_DDS_Update_Context;
import com.acme.Hello.CCM_Donnee_MyConnector_DDS_Update_ContextHelper;
import com.acme.Hello.CCM_Donnee_Updater;
import com.acme.Hello.DonneeDataReader;
import com.acme.Hello.DonneeDataReaderHelper;
import com.acme.Hello.DonneeDataWriter;
import com.acme.Hello.DonneeDataWriterHelper;
import com.acme.Hello.DonneeTypeSupport;


public class Donnee_MyConnector_DDS_UpdateExecutorImpl extends
DDS_TopicBaseFragmentImpl implements
CCM_Donnee_MyConnector_DDS_Update, org.omg.Components.SessionComponent {


    DonneeTypeSupport dataTS;
    private CCM_Donnee_MyConnector_DDS_Update_Context sessionContext;
    private CCM_Donnee_Updater p_Update_data ;


    public Donnee_MyConnector_DDS_UpdateExecutorImpl() {
        super();
        init();
    }

    public Donnee_MyConnector_DDS_UpdateExecutorImpl(String domain_id,
            String qos_profile, String topic_name, String[] key_fields) {
        super(domain_id, qos_profile, topic_name, key_fields);
        init();
    }

    private void init(){
        dataTS = new DonneeTypeSupport();
    }


    protected TypeSupport getDataTypeSupport() {
        return dataTS;
    }


    public CCM_Donnee_Updater get_p_Update_data() {
        return this.p_Update_data;
    }

    public void ccm_activate() throws CCMException {
        System.out.println("Donnee_MyConnector_DDS_WriteExecutorImpl.ccm_activate called ...");
        try {
            super.setupDDSInfrastructure(true, true);

            DonneeDataReader donneeDR = DonneeDataReaderHelper.narrow(reader);
            ErrorHandler.checkHandle(donneeDR,
                    "DDS.DonneeDataReaderHelper.narrow");

            /* Narrow the abstract parent into its typed representative. */
            DonneeDataWriter talker = DonneeDataWriterHelper.narrow(writer);
            ErrorHandler.checkHandle(talker,
                    "!!!!Donnee.DonneeDataWriterHelper.narrow");

            this.p_Update_data = new Donnee_UpdaterFacetImpl(talker, donneeDR);

        } catch (Exception e) {
            e.printStackTrace();
            logger.throwing(this.getClass().getName(), "ccm_activate", e);
            throw new CCMException("Failed to setup the DDS infrastructure of fragment" +
                    "Donnee_MyConnector_DDS_Update"+ e.getMessage(), CCMExceptionReason.SERVICE_INSTALLATION_ERROR);
        }
    }

    public void ccm_remove() throws CCMException{

        try {
            super.teardownDDSInfrastructure(true,true);

        } catch (Exception e) {
            e.printStackTrace();
            logger.throwing(this.getClass().getName(), "ccm_remove", e);
            throw new CCMException("Failed to teardown the DDS infrastructure of fragment" +
                    "Donnee_MyConnector_DDS_Update", CCMExceptionReason.REMOVE_ERROR);
        }

    }


    public void ccm_passivate() throws CCMException {
        // TODO Auto-generated method stub

    }

    public void set_session_context(SessionContext arg0) throws CCMException {
        sessionContext = CCM_Donnee_MyConnector_DDS_Update_ContextHelper
        .narrow((Object) arg0);
    }


}
