package cdmw.ccm.testqosenabler_dds4ccm;

import org.omg.CCM_DDS.DDSEntityKind;
import org.omg.CCM_DDS.InternalError;
import org.omg.CCM_DDS.NoSuchDDSEntity;
import org.omg.Components.CCMException;
import org.omg.Components.CCMExceptionReason;
import org.omg.Components.SessionContext;

import cdmw.ccm.qosenablers.dds.DDS_TopicBaseFragmentImpl;
import cdmw.ccm.qosenablers.dds.ErrorHandler;

import com.acme.Hello.CCM_Donnee_Writer;
import com.acme.Hello.CCM_Donnee_MyConnector_DDS_Write;
import com.acme.Hello.Donnee;
import com.acme.Hello.DonneeDataWriter;
import com.acme.Hello.DonneeDataWriterHelper;
import com.acme.Hello.DonneeTypeSupport;

import DDS.*;

public class Donnee_MyConnector_DDS_WriteExecutorImpl extends
        DDS_TopicBaseFragmentImpl implements
        CCM_Donnee_Writer, CCM_Donnee_MyConnector_DDS_Write, org.omg.Components.SessionComponent {


    /* Type-specific DDS entities */
    DonneeTypeSupport dataTS;
    DonneeDataWriter talker;


    public Donnee_MyConnector_DDS_WriteExecutorImpl(){
        dataTS = new DonneeTypeSupport();
    }

    public CCM_Donnee_Writer get_p_Write_data() {
        return (CCM_Donnee_Writer)this;
    }

    public void ccm_activate() throws CCMException{
        System.out.println("Donnee_MyConnector_DDS_WriteExecutorImpl.ccm_activate called ...");
        try {
            super.setupDDSInfrastructure(true,false);

            /* Narrow the abstract parent into its typed representative. */
            talker = DonneeDataWriterHelper.narrow(this.writer);
            ErrorHandler.checkHandle(talker,
                    "Donnee.DonneeDataWriterHelper.narrow");

        } catch (Exception e) {
            System.out.println("Unexpected exception raised!\n" + e.getMessage());
            logger.throwing("", "ccm_activate", e);
            throw new CCMException("Failed to setup the DDS infrastructure of fragment" +
                    "Donnee_MyConnector_DDS_Write"+ e.getMessage(), CCMExceptionReason.SERVICE_INSTALLATION_ERROR);

        }

    }

    public void ccm_remove() throws CCMException{

        try {
            super.teardownDDSInfrastructure(true,false);
        } catch (Exception e) {
            e.printStackTrace();
            logger.throwing(this.getClass().getName(), "ccm_remove", e);
            throw new CCMException("Failed to teardown the DDS infrastructure of fragment" +
                    "Donnee_MyConnector_DDS_Write", CCMExceptionReason.REMOVE_ERROR);
        }

    }

    public void ccm_passivate() throws CCMException{

    }

    public void set_session_context(SessionContext arg0) throws CCMException{
    }

    @Override
    protected TypeSupport getDataTypeSupport() {
        return dataTS;
    }


    /**
     * The Writer facet implementation
     *
    /**/

    /**
     *
     * @param an_instance
     * @throws InternalError
     */
    public void write(Donnee an_instance) throws InternalError {
        long userHandle = talker.register_instance(an_instance);
        int status = talker.write(an_instance, userHandle);
        if (status != RETCODE_OK.value && status != RETCODE_NO_DATA.value) {
            InternalError e = new InternalError();
            e.error_code = status;
            throw e;
        }
    }

    public org.omg.CORBA.Object getDDSEntity(DDSEntityKind kind) throws NoSuchDDSEntity{
        return null;
    }

}