package cdmw.ccm.testqosenabler_dds4ccm;

import static org.junit.Assert.fail;

import org.junit.Test;
import org.omg.CCM_DDS.InternalError;
import org.omg.CCM_DDS.ReadInfoSeqHolder;

import cdmw.testutils.CORBATestManager;
import cdmw.testutils.TestManager;

public class RawListenTest {

    private static boolean testFail = false;

    @Test
    public void doTests() {

        System.out
        .println("******************************************************");
        System.out
        .println("************** DDS_RawListen Fragment ****************");
        System.out
        .println("******************************************************");

        CORBATestManager testManager = (CORBATestManager)TestManager.instance();

        com.acme.Hello.Donnee_Writer writer
        = (com.acme.Hello.Donnee_Writer)testManager.getLocalProperty(
        "cdmw.ccm.testqosenabler_dds4ccm.p_Write_data");


        org.omg.CCM_DDS.ListenerControl listenerControl
        = (org.omg.CCM_DDS.ListenerControl)testManager.getLocalProperty(
        "cdmw.ccm.testqosenabler_dds4ccm.p_RawListen_control");

        com.acme.Hello.Donnee_Reader reader
        = (com.acme.Hello.Donnee_Reader)testManager.getLocalProperty(
        "cdmw.ccm.testqosenabler_dds4ccm.p_RawListen_data");

        com.acme.Hello.DonneeSeqHolder instances = new com.acme.Hello.DonneeSeqHolder();
        ReadInfoSeqHolder infos = new ReadInfoSeqHolder();        

        try {
            reader.read_all_history(instances, infos);
        } catch (InternalError e) {
            e.printStackTrace();
        }

        com.acme.Hello.Donnee an_instance;

        System.out.println("Listener activation");
        listenerControl.enabled(true);

        for(int i=0; i<5; i++) {

            an_instance = new com.acme.Hello.Donnee(i, "testU" +i);

            try {
                writer.write(an_instance);
            } catch (InternalError e) {
                e.printStackTrace();
                fail("Writer Error ! Error code = " + e.error_code);
            }

            try {
                Thread.sleep(200);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

            if(testFail) {
                fail("Error on listener");
            }

        }

        System.out.println("Listener desactivation");
        listenerControl.enabled(false);

        System.out.println("RawListener OK");

    }

    public static void testFail() {
        testFail = false;
    }

}
