package cdmw.ccm.testqosenabler_dds4ccm;

import static org.junit.Assert.fail;

import org.junit.Test;
import org.omg.CCM_DDS.AlreadyCreated;
import org.omg.CCM_DDS.InternalError;
import org.omg.CCM_DDS.NonExistent;
import org.omg.CCM_DDS.ReadInfoSeqHolder;

import com.acme.Hello.Donnee;

import cdmw.testutils.CORBATestManager;
import cdmw.testutils.TestManager;

public class StateListenTest {

       private static boolean testFail = false;

        @Test
        public void doTests() {

            System.out
            .println("******************************************************");
            System.out
            .println("************** DDS_StateListen Fragment **************");
            System.out
            .println("******************************************************");

            CORBATestManager testManager = (CORBATestManager)TestManager.instance();

            org.omg.CCM_DDS.ListenerControl listenerControl
            = (org.omg.CCM_DDS.ListenerControl)testManager.getLocalProperty(
            "cdmw.ccm.testqosenabler_dds4ccm.p_StateListen_control");

            com.acme.Hello.Donnee_Updater updater
            = (com.acme.Hello.Donnee_Updater)testManager.getLocalProperty(
            "cdmw.ccm.testqosenabler_dds4ccm.p_Update_data");

            com.acme.Hello.Donnee_Reader reader
            = (com.acme.Hello.Donnee_Reader)testManager.getLocalProperty(
            "cdmw.ccm.testqosenabler_dds4ccm.p_StateListen_data");

            com.acme.Hello.DonneeSeqHolder instances = new com.acme.Hello.DonneeSeqHolder();
            ReadInfoSeqHolder infos = new ReadInfoSeqHolder();

            try {
                reader.read_all_history(instances, infos);
            } catch (InternalError e) {
                e.printStackTrace();
            }

//            for(int i =0; i < instances.value.length; i++) {
//                System.out.println("ID = " + instances.value[i].ID + " | msg = " + instances.value[i].msg);
//            }

            try {
                Thread.sleep(200);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

            com.acme.Hello.Donnee[] an_instance = new com.acme.Hello.Donnee[5];
            for(int i=6; i<=10; i++)
                an_instance[i-6] = new Donnee(i,"testU6"+i);

            System.out.println("Listener activation");
            listenerControl.enabled(true);

            try {
                Thread.sleep(200);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

            try {
                for(int i=0; i<5; i++)
                updater.create(an_instance[i]);
            } catch (AlreadyCreated e) {
                e.printStackTrace();
            } catch (InternalError e) {
                e.printStackTrace();
            }

            try {
                Thread.sleep(200);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

            if(testFail) {
                fail("Error on listener");
            }

            for(int i=0; i<5; i++)
                an_instance[i].msg = "test6Update";

            try {
                for(int i=0; i<5; i++)
                updater.update(an_instance[i]);
            } catch (NonExistent e) {
                e.printStackTrace();
            } catch (InternalError e) {
                e.printStackTrace();
            }

            try {
                Thread.sleep(200);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

            if(testFail) {
                fail("Error on listener");
            }

            try {
                for(int i=0; i<5; i++)
                    updater.delete(an_instance[i]);
            } catch (NonExistent e) {
                e.printStackTrace();
            } catch (InternalError e) {
                e.printStackTrace();
            }

            try {
                Thread.sleep(200);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }


            System.out.println("Listener desactivation");
            listenerControl.enabled(false);

            System.out.println("StateListener OK");

        }

        public static void testFail() {
            testFail = false;
        }


}
