package cdmw.ccm.testqosenabler_dds4ccm;

import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import org.junit.Assert;
import org.junit.Test;
import org.omg.CCM_DDS.AlreadyCreated;
import org.omg.CCM_DDS.InternalError;
import org.omg.CCM_DDS.NonExistent;
import org.omg.CCM_DDS.ReadInfoSeqHolder;

import cdmw.testutils.CORBATestManager;
import cdmw.testutils.TestManager;

public class UpdateTest {


    @Test
    public void doTests() {

        System.out
        .println("******************************************************");
        System.out
        .println("**************** DDS_Update Fragment *****************");
        System.out
        .println("******************************************************");


        CORBATestManager testManager = (CORBATestManager)TestManager.instance();

        Assert.assertTrue(testManager != null);
        
    
        com.acme.Hello.Donnee_Updater updater = (com.acme.Hello.Donnee_Updater)testManager.getLocalProperty(
        "cdmw.ccm.testqosenabler_dds4ccm.p_Update_data");
        
        com.acme.Hello.Donnee_Getter getter
        = (com.acme.Hello.Donnee_Getter)testManager.getLocalProperty(
            "cdmw.ccm.testqosenabler_dds4ccm.p_Get_data");

        Assert.assertNotNull(updater);
        Assert.assertNotNull(getter);
  
        
        com.acme.Hello.DonneeSeqHolder instances = new com.acme.Hello.DonneeSeqHolder();
        ReadInfoSeqHolder infos = new ReadInfoSeqHolder(); 
        
        boolean testException = false;
        
        com.acme.Hello.Donnee an_instance = new com.acme.Hello.Donnee();
        an_instance.ID = 5;
        an_instance.msg = "testU5";
        
        try {
            getter.get_all_history(instances, infos);
        } catch (InternalError e) {
            e.printStackTrace();
        }

 
        try {
            updater.create(an_instance);
        } catch (AlreadyCreated e) {
            fail("Updater Error ! Already created");
            e.printStackTrace();
        } catch (InternalError e) {
            fail("Updater Error ! Error code = " + e.error_code);
            e.printStackTrace();
        }
        
        try {
            updater.create(an_instance);
        } catch (AlreadyCreated e) {
            testException = true;
            System.out.println("Exception AlreadyCreated");
        } catch (InternalError e) {
            fail("Updater Error ! Error code = " + e.error_code);
            e.printStackTrace();
        }
        
        if(testException == false) {
            fail("Error on AlreadyCreated exception");
        }
        testException = false;
        
        
        try {
            getter.get_all_history(instances, infos);
        } catch (InternalError e) {
            e.printStackTrace();
        }
                
        assertTrue("Error on get_all_history", instances.value.length == 1);
        assertTrue("Error on get_all_history", (instances.value[0].ID == 5) && instances.value[0].msg.equals("testU5"));
        
        System.out.println("Instance created");

        an_instance.msg = "testU5Update";
        try {
            updater.update(an_instance);
        } catch (NonExistent e) {
            fail("Updater Error ! Non Existent");
            e.printStackTrace();
        } catch (InternalError e) {
            fail("Updater Error ! Error code = " + e.error_code);
            e.printStackTrace();
        }
        
        try {
            getter.get_all_history(instances, infos);
        } catch (InternalError e) {
            e.printStackTrace();
        }
        
            
        assertTrue("Error on get_all_history", (instances.value[0].ID == 5) && instances.value[0].msg.equals("testU5Update"));

        System.out.println("Instance updated");
        

        try {
            updater.delete(an_instance);
        } catch (NonExistent e) {
            fail("Updater Error ! Non Existent");
            e.printStackTrace();
        } catch (InternalError e) {
            fail("Updater Error ! Error code = " + e.error_code);
            e.printStackTrace();
        }
        
        boolean status = true;
        try {
            status = getter.get_all_history(instances, infos);
        } catch (InternalError e) {
            e.printStackTrace();
        }
                
        assertTrue("Error on get_all_history", status == false);

        System.out.println("Instance deleted");
        
        try {
            updater.delete(an_instance);
        } catch (NonExistent e) {
            testException = true;
            System.out.println("Exception NonExistent");
        } catch (InternalError e) {
            fail("Updater Error ! Error code = " + e.error_code);
            e.printStackTrace();
        }
        
        if(testException == false) {
            fail("Error on NonExistent exception");
        }
        testException = false;
        
        
        try {
            updater.update(an_instance);
        } catch (NonExistent e) {
            testException = true;
            System.out.println("Exception NonExistent");
        } catch (InternalError e) {
            fail("Updater Error ! Error code = " + e.error_code);
            e.printStackTrace();
        }
        
        if(testException == false) {
            fail("Error on NonExistent exception");
        }   
        
        
        System.out.println("Updater OK");


    }


}
