eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
    & eval 'exec perl -S $0 $argv:q'
    if 0;

use lib "$ENV{ACE_ROOT}/bin";
use lib "$ENV{CDMW_HOME}/Build/testautomation";
use File::Basename;
use Cwd;
use PerlACE::Run_Test;
use TestUtils;

# This is a Perl script that tests CCMContainer/testccmcifdata

$test_exec = "cdmw.ccm.testccmcif.MainTest";
$test_id = "U-CMC-1001";
$test_args = "Cdmw.CCM.TypeChecking=on";
@processes_to_kill = ("output_redirection.sh", "Naming_Service", "cdmw_simulated_repository");
@files_to_move = ("SimRepository.IOR", "SimProcessCallback.IOR", "SimPlatformManagement.log");
@needed_files = ($ENV{CDMW_HOME}."/bin/cdmw_simulated_repository");

$expected_status=0;
$max_wait_time=180 ;
$nbtestable ="3";

PerlACE::add_lib_path($ENV{TAO_ROOT}."/orbsvcs/Naming_Service");

$ENV{CLASSPATH}=$ENV{CLASSPATH}.":$ENV{CDMW_HOME}/CCMContainer/tests/lib/java/testccmcif/main.jar".
                                ":$ENV{CDMW_HOME}/CCMContainer/tests/lib/java/testccmcif/BasicDemo.jar".
                                ":$ENV{CDMW_HOME}/lib/java/libcdmwlifecycle.jar".
                                ":$ENV{CDMW_HOME}/lib/java/libcdmwrepository.jar".
                                ":$ENV{CDMW_HOME}/lib/java/libcdmwccmcontainer.jar".
                                ":$ENV{CDMW_HOME}/lib/java/libcdmwfoundation.jar".
                                ":$ENV{CDMW_HOME}/lib/java/libcdmwevent.jar".
                                ":$ENV{CDMW_HOME}/lib/java/libcdmwsystemmngt.jar" ;

#creating folders and removing old test results
TestUtils::prepareDirectoryStructureForUnitTest($test_id);

#creating soft links for needed files
$runtest_path = "runtest/".$test_id."/";
foreach $from_file (@needed_files)
{
    $to_file = basename $from_file;
    symlink $from_file, $runtest_path.$to_file;
}

chdir $runtest_path;
 
# replace environment variables in linked files
$replace_cmd = "$ENV{CDMW_HOME}/Build/scripts/replace_environment.sh";
$replace_dir = ".";
if (PerlACE::is_vxworks_test()) 
         {$test = new PerlACE::ProcessVX ($replace_cmd, $replace_dir); }
else     {$test = new PerlACE::Process   ($replace_cmd, $replace_dir); }
$status = $test->SpawnWaitKill(10);


$status = 0;

#create test process
$xbootcp="-Xbootclasspath/p:$ENV{CLASSPATH}";
$redirect = "$ENV{CDMW_HOME}/Build/testautomation/output_redirection.sh";
$cmnd = "java $xbootcp $test_exec $test_args 2>&1 | tee results/output.txt" ;
if (PerlACE::is_vxworks_test()) 
         {$test = new PerlACE::ProcessVX ($redirect, $cmnd); }
else     {$test = new PerlACE::Process   ($redirect, $cmnd); }
#run process and wait for test finishes
$status = $test->SpawnWaitKill($max_wait_time);

#move temprorary and log files to results dir
foreach $file (@files_to_move)
{
    TestUtils::moveFileToResults($file);
}

#open file to write result of test
open (RES, '>>results/result.txt');

#check returned value of test
if ($status != $expected_status )
{
    print RES "ERROR: test returned $status\n";
    $status = 1;
}
else
{
    $status = 0;
}

#check existence of output.txt
if (!-e "results/output.txt")
{
    print RES "ERROR: output.txt file does not exist\n";
    $status = 1;
}

#check results in test output
if ($status == 0)
{
    if (TestUtils::checkForMessage("results/output.txt", "TESTABLE_OK") != $nbtestable )
    {
        print RES "ERROR: Incorrect count of TESTABLE_OK in log of test\n";
        $status = 1;
    }
}

#check for errors in test output
if ($status == 0)
{
    if (TestUtils::checkForErrorMessages("results/output.txt") > 0)
    {
        print RES "ERROR: There is an error in log of test\n";
	$status = 1;
    }
}

if ($status == 0)
{
    print RES "Test OK\n";    
}
else
{
    print RES "Test FAILED\n";    
}
close(RES);

#kill processes
foreach $process (@processes_to_kill)
{
    system("killall -q $process");
}

exit $status;
