eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
    & eval 'exec perl -S $0 $argv:q'
    if 0;

use lib "$ENV{ACE_ROOT}/bin";
use lib "$ENV{CDMW_HOME}/Build/testautomation";
use File::Basename;
use Cwd;
use PerlACE::Run_Test;
use TestUtils;

# This is a Perl script that tests CCMContainer/testloggingqosenabler

$test_exec = "cdmw.ccm.testloggingqosenabler.MainCCMTest";
$test_id = "U-CMC-1200";
$test_args = "-DCdmw.CCM.TypeChecking=on";

@processes_to_kill = ("output_redirection.sh", "cdmw_simulated_repository", "cdmw_event_channel_manager", 
                      "cdmw_event_admin", "Naming_Service");
@files_to_move = ("componentServer.ior", "SimRepository.IOR", "SimProcessCallback.IOR", "SimPlatformManagement.log");
@needed_files = ($ENV{CDMW_HOME}."/share/EventChannelManager_Desc.dtd", 
                 $ENV{CDMW_HOME}."/share/EventChannelManager.xml",
                 $ENV{CDMW_HOME}."/share/EventChannel_Desc.dtd",
                 cwd()."/EventChannelConf1.xml",
                 $ENV{CDMW_HOME}."/bin/cdmw_simulated_repository",
                 $ENV{CDMW_HOME}."/bin/cdmw_event_channel_manager",
                 $ENV{CDMW_HOME}."/bin/cdmw_event_admin");

$expected_status=0;
$max_wait_time=180 ;
$nbtestable=1 ;

# we do expect these regular expressions to match against the output, note: a certain number of occurences 
# expected as well
@targetOc = (
             "LoggingQoSEnablerTestApplication/LoggingQoSEnablerTestProcess#CLIENT_COMPONENT_NAME1\\] MyPrivateLoggerOffFactory0",
             "LoggingQoSEnablerTestApplication/LoggingQoSEnablerTestProcess#CLIENT_COMPONENT_NAME2\\] MyPrivateLoggerOffFactory1"
            );
$expectedOc = 2;



PerlACE::add_lib_path($ENV{TAO_ROOT}."/orbsvcs/Naming_Service");
$ENV{CLASSPATH}=$ENV{CLASSPATH}.":$ENV{CDMW_HOME}/CCMContainer/tests/lib/java/testloggingqosenabler/testloggingqosenabler.jar".
                                ":$ENV{CDMW_HOME}/lib/java/libcdmwccmcontainer.jar".
                                ":$ENV{CDMW_HOME}/lib/java/libcdmwevent.jar".
                                ":$ENV{CDMW_HOME}/lib/java/libcdmwlifecycle.jar".
                                ":$ENV{CDMW_HOME}/lib/java/libcdmwfoundation.jar" ;

#creating folders and removing old test results
TestUtils::prepareDirectoryStructureForUnitTest($test_id);

#creating soft links for needed files
$runtest_path = "runtest/".$test_id."/";
foreach $from_file (@needed_files)
{
    $to_file = basename $from_file;
    symlink $from_file, $runtest_path.$to_file;
}

chdir $runtest_path;


 
# replace environment variables in linked files
$replace_cmd = "$ENV{CDMW_HOME}/Build/scripts/replace_environment.sh";
$replace_dir = ".";
if (PerlACE::is_vxworks_test()) 
         {$test = new PerlACE::ProcessVX ($replace_cmd, $replace_dir); }
else     {$test = new PerlACE::Process   ($replace_cmd, $replace_dir); }
$status = $test->SpawnWaitKill(10);


$status = 0;

#create test process
$xbootcp="-Xbootclasspath/p:$ENV{CLASSPATH}";
# $debugargs="-Xdebug -Xrunjdwp:transport=dt_socket,address=1044,server=y,suspend=n"
$redirect = "$ENV{CDMW_HOME}/Build/testautomation/output_redirection.sh";
$cmnd = "java $debugargs $xbootcp $test_exec $test_args 2>&1 | tee results/output.txt" ;
if (PerlACE::is_vxworks_test()) 
         {$test = new PerlACE::ProcessVX ($redirect, $cmnd); }
else     {$test = new PerlACE::Process   ($redirect, $cmnd); }
#run process and wait for test finishes
$status = $test->SpawnWaitKill($max_wait_time);

#move temprorary and log files to results dir
foreach $file (@files_to_move)
{
    TestUtils::moveFileToResults($file);
}

#open file to write result of test
open (RES, '>>results/result.txt');

#check returned value of test
if ($status != $expected_status )
{
    print RES "ERROR: test returned $status\n";
    $status = 1;
}
else
{
    $status = 0;
}

#check existence of output.txt
if (!-e "results/output.txt")
{
    print RES "ERROR: output.txt file does not exist\n";
    $status = 1;
}

#check results in test output
if ($status == 0)
{
    if (TestUtils::checkForMessage("results/output.txt", "TESTABLE_OK") != $nbtestable )
    {
        print RES "ERROR: Incorrect count of TESTABLE_OK in log of test\n";
        $status = 1;
    }

    # TestUtils::checkForMessage proved to be useless here 
    open FILE, "<results/output.txt" or $status = 1;

    $ocC = 0;

    if($status == 0)
    {
        $ocC = 0;
        while (my $line = <FILE>)
        {
            foreach $q (@targetOc)
            {
                if($line =~ m/$q/)
                {
                    $ocC++;
                }
            }
        }
        close(FILE);

        if ($ocC != $expectedOc)
        {
            print RES "ERROR: Not expected output. Some regular expressions didn't match or the number of matches was not right. Consider \@targetOc\n";
            $status = 1;
        }
    }
}

#check for errors in test output
if ($status == 0)
{
    if (TestUtils::checkForErrorMessages("results/output.txt") > 0)
    {
        print RES "ERROR: There is an error in log of test\n";
	$status = 1;
    }
}

if ($status == 0)
{
    print RES "Test OK\n";    
}
else
{
    print RES "Test FAILED\n";    
}
close(RES);

#kill processes
foreach $process (@processes_to_kill)
{
    system("killall -q $process");
}

exit $status;
