/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX Sistemi Integrati. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2007. 
 * Copyright (C) THALES 2008-2010. All rights reserved.
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */


package cdmw.cdmwinit.testrequestfollowupinit;

import org.junit.Test;
import cdmw.testutils.CORBATestManager;
import org.omg.CORBA.*;

import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import cdmw.common.BadParameterException;

import cdmw.cdmwinit.CdmwInitConfiguration;

public class InitConfigurationTest {

    @Test
    public void doTests() {        

        try {
            CORBATestManager testManager = CORBATestManager.instance();
            ORB orb = testManager.getORB();
            try {
                String[] args = new String[1];
                
                System.out.println("Init PlatformInterface");
          
                cdmw.cdmwinit.CdmwInterface.cdmwInit(orb, args, null, 
                    "cdmw.generated.TestRequestFollowupInit"); 
                assertTrue(true);
            }
            catch(java.lang.Exception e)
            {
                e.printStackTrace();
                fail();
            }
            
            if (orb != null) {
                System.out.println("Cleanup PlatformInterface");
                cdmw.cdmwinit.CdmwInterface.cdmwCleanup(orb, 
                    "cdmw.generated.TestRequestFollowupInit");                                                 
            }

             
         }
        catch(Exception e) {
            e.printStackTrace();
            fail(e.getMessage());
        }

    }

}

