# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================
eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
    & eval 'exec perl -S $0 $argv:q'
    if 0;

use lib "$ENV{ACE_ROOT}/bin";
use lib "$ENV{CDMW_HOME}/Build/testautomation";
use File::Basename;
use Cwd;
use PerlACE::Run_Test;
use TestUtils;


# in CSCProperties.xml, this test is not executed with JacORB (-check-not-JacORB)
print "This test is not executed if JacORB is used\n";
exit 0;

# following is what should be the script if ever the test should run in the future


# This is a Perl script that tests Event/testeventadmindata

$test_exec = "MainTest";
$test_id = "U-EVT-1006";
@needed_files = ($ENV{CDMW_HOME}."/Event/eventadmin/test/testeventadmin/java/EventChannelConf.xml",
                 $ENV{CDMW_HOME}."/Event/eventadmin/test/testeventadmin/java/start_event_admin_test.sh", 
                 $ENV{CDMW_HOME}."/Event/eventadmin/test/testeventadmin/java/EventChannel_Desc.dtd",
                 $ENV{CDMW_HOME}."/Event/eventadmin/test/testeventadmin/java/Server_Desc.dtd",
                 $ENV{CDMW_HOME}."/Event/eventadmin/test/testeventadmin/java/start_event_admin_test.xml",
                 $ENV{CDMW_HOME}."/Event/eventadmin/test/testeventadmin/java/ec_manip.cmd", 
                 $ENV{CDMW_HOME}."/Event/eventadmin/test/testeventadmin/java/ob.conf",
                 $ENV{CDMW_HOME}."/Event/eventadmin/test/testeventadmin/java/Server.xml",
                 $ENV{CDMW_HOME}."/Event/eventadmin/test/testeventadmin/java/typed_ec_manip.cmd",
                 $ENV{CDMW_HOME}."/Event/eventadmin/test/testeventadmin/Echo.idl",
                 $ENV{CDMW_HOME}."/Repository/simrepository/cdmw_simulated_repository");
@processes_to_kill = ("output_redirection.sh");
@files_to_move = ();
$expected_status=0;
$max_wait_time=180 ;
$nbtestable=1 ;

$ENV{CLASSPATH}=$ENV{CLASSPATH}.":$ENV{CDMW_HOME}/Event/tests/java-build/classes/:$ENV{CDMW_HOME}/Event/java-build/classes/" ;

#creating folders and removing old test results
TestUtils::prepareDirectoryStructureForUnitTest($test_id);

#creating soft links for needed files
$runtest_path = "runtest/".$test_id."/";
foreach $from_file (@needed_files)
{
    $to_file = basename $from_file;
    symlink $from_file, $runtest_path.$to_file;
}

chdir $runtest_path;
 
# replace environment variables in linked files
$replace_cmd = "$ENV{CDMW_HOME}/Build/scripts/replace_environment.sh";
$replace_dir = ".";
if (PerlACE::is_vxworks_test()) 
         {$test = new PerlACE::ProcessVX ($replace_cmd, $replace_dir); }
else     {$test = new PerlACE::Process   ($replace_cmd, $replace_dir); }
$status = $test->SpawnWaitKill(10);


$status = 0;

#create test process
$redirect = "$ENV{CDMW_HOME}/Build/testautomation/output_redirection.sh";
$cmnd = "java $test_exec $test_args 2>&1 | tee results/output.txt" ;
if (PerlACE::is_vxworks_test()) 
         {$test = new PerlACE::ProcessVX ($redirect, $cmnd); }
else     {$test = new PerlACE::Process   ($redirect, $cmnd); }
#run process and wait for test finishes
$status = $test->SpawnWaitKill($max_wait_time);

#move temprorary and log files to results dir
foreach $file (@files_to_move)
{
    TestUtils::moveFileToResults($file);
}

#open file to write result of test
open (RES, '>>results/result.txt');

#check returned value of test
if ($status != $expected_status )
{
    print RES "ERROR: test returned $status\n";
    $status = 1;
}
else
{
    $status = 0;
}

#check existence of output.txt
if (!-e "results/output.txt")
{
    print RES "ERROR: output.txt file does not exist\n";
    $status = 1;
}

#check results in test output
if ($status == 0)
{
    if (TestUtils::checkForMessage("results/output.txt", "TESTABLE_OK") != $nbtestable )
    {
        print RES "ERROR: Incorrect count of TESTABLE_OK in log of test\n";
        $status = 1;
    }
}

#check for errors in test output
if ($status == 0)
{
    if (TestUtils::checkForErrorMessages("results/output.txt") > 0)
    {
        print RES "ERROR: There is an error in log of test\n";
	$status = 1;
    }
}

if ($status == 0)
{
    print RES "Test OK\n";    
}
else
{
    print RES "Test FAILED\n";    
}
close(RES);

#kill processes
foreach $process (@processes_to_kill)
{
    system("killall -q $process");
}

exit $status;
