/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "testftlocationmanager/TestFTActivationHandler_impl.hpp"

#include <iostream>

namespace Cdmw {
namespace FT {

    TestFTActivationHandler_impl::TestFTActivationHandler_impl()
        : m_activation (false)
        {}
    TestFTActivationHandler_impl::~TestFTActivationHandler_impl()
        {}
    
    //
    // IDL:thalesgroup.com/CdmwFT/Location/ActivationHandler/activate:1.0
    //
    void TestFTActivationHandler_impl::activate()
        throw(CORBA::SystemException)
    {
        std::cout<<"TestFTActivationHandler_impl::activate()"<<std::endl;
        m_activation = true;
        
    }
    

    //
    // IDL:thalesgroup.com/CdmwFT/Location/ActivationHandler/deactivate:1.0
    //
    void TestFTActivationHandler_impl::deactivate()
        throw(CORBA::SystemException)
    {
        std::cout<<"TestFTActivationHandler_impl::deactivate()"<<std::endl;
        m_activation = false;
        
    }


} // End of namespace FT
} // End of namespace Cdmw

