eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
    & eval 'exec perl -S $0 $argv:q'
    if 0;

# This is a Perl script that tests FaultTolerance/ftmanager

use lib "$ENV{ACE_ROOT}/bin";
use lib "$ENV{CDMW_HOME}/Build/testautomation";
use File::Basename;
use Cwd;
use PerlACE::Run_Test;
use TestUtils;

#setting common variables
$nbtestable = 1;
$max_wait_time = 180;
$test_exec = "cdmw_test_ft_manager";
$test_id = "U-FLT-0012";
$runtest_path = "runtest/".$test_id."/";
$XML_results = $test_exec."_test_results.xml";
@needed_files = (cwd()."/BadCdmwFaultToleranceManager.dtd", cwd()."/CdmwFaultToleranceManager_test2_conf.xml", cwd()."/CdmwFaultToleranceManager_test3_conf.xml", cwd()."/CdmwFaultToleranceManager_test4_conf.xml", cwd()."/BadCdmwFaultToleranceManager4.dtd", cwd()."/CdmwFaultToleranceManager_test5_conf.xml", cwd()."/BadCdmwFaultToleranceManager5.dtd", cwd()."/CdmwFaultToleranceManager_test_conf.xml", cwd()."/start_ft_manager.sh", $ENV{CDMW_HOME}."/share/CdmwFaultToleranceManager.dtd", $ENV{CDMW_HOME}."/share/CdmwFaultToleranceManager_conf.xml", );
@files_to_move = ($XML_results);
@processes_to_kill = ($test_exec, "cdmw_ft_manager", "start_ft_manager.sh", "output_redirection.sh");

#creating folders and removing old test results
TestUtils::prepareDirectoryStructureForUnitTest($test_id);

#creating soft links for needed files
symlink cwd()."/".$test_exec, $runtest_path.$test_exec;
foreach $from_file (@needed_files)
{
    $to_file = basename $from_file;
    symlink $from_file, $runtest_path.$to_file;
}

PerlACE::add_lib_path(cwd()."/".$runtest_path);
chdir $runtest_path;
 
# replace environment variables in linked files
$replace_cmd = "$ENV{CDMW_HOME}/Build/scripts/replace_environment.sh";
$replace_dir = ".";
if (PerlACE::is_vxworks_test()) 
         {$test = new PerlACE::ProcessVX ($replace_cmd, $replace_dir); }
else     {$test = new PerlACE::Process   ($replace_cmd, $replace_dir); }
$status = $test->SpawnWaitKill(10);


$status = 0;
#create and run test process
$redirect = "$ENV{CDMW_HOME}/Build/testautomation/output_redirection.sh";
$cmnd = "$test_exec $test_args 2>&1| tee results/output.txt" ;
if (PerlACE::is_vxworks_test()) 
         {$test = new PerlACE::ProcessVX ($redirect, $cmnd); }
else     {$test = new PerlACE::Process   ($redirect, $cmnd); }
$status = $test->SpawnWaitKill($max_wait_time);

#move temprorary and log files to results dir
foreach $file (@files_to_move)
{
    TestUtils::moveFileToResults($file);
}

#open file to write result of test
open (RES, '>>results/result.txt');

#check returned value of test
if ($status != 0)
{
    print RES "ERROR: test returned $status\n";
    $status = 1;
}
else
{
    $status = 0;
}

#check results in XML file
if ($status == 0)
{    
    $checkXML_result = TestUtils::checkXML("results/".$XML_results);
    if ($checkXML_result ne "")
    {
        print RES $checkXML_result;
        $status = 1;
    }
}

#check existence of output.txt
if (!-e "results/output.txt")
{
    print RES "ERROR: output.txt file does not exist\n";
    $status = 1;
}

#check results in test output
if ($status == 0)
{
    if (TestUtils::checkForMessage("results/output.txt", "TESTABLE_OK") != $nbtestable)
    {
        print RES "ERROR: Incorrect count of TESTABLE_OK in log of test\n";
        $status = 1;
    }
}

#check for errors in test output
if ($status == 0)
{
    if (TestUtils::checkForErrorMessages("results/output.txt") > 0)
    {
        print RES "ERROR: There is an error in log of test\n";
	$status = 1;
    }
}

#print test global result
if ($status == 0)
{
    print RES "Test OK\n";    
}
else
{
    print RES "Test FAILED\n";    
}
close(RES);

#kill processes
foreach $process (@processes_to_kill)
{
    system("killall -q -s KILL $process");
}

exit $status;
