/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

#include <iostream>

#include <testsimultaneousaddmember/OrbThread.hpp>


namespace Cdmw
{

namespace Test
{

        
OrbThread::OrbThread(CORBA::ORB_ptr orb, std::string host_name)
   : m_orb(CORBA::ORB::_duplicate(orb)),
     m_host_name(host_name)
{    
}


OrbThread::~OrbThread() 
throw() 
{
} 


void
OrbThread::shutdown() 
{
    m_orb->shutdown(true);
}

void
OrbThread::run() 
    throw() 
{
    std::cout << m_host_name << " test_server: running..."<<std::endl;
    m_orb->run();   
}

    

} // end of namespace Test

} // end of namespace Cdmw


