/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


// Standard Files 
#include <string>

// Cdmw Files
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>

#include <testtimeoutrequest/TestHello.stub.hpp>
#include <Foundation/idllib/FTPullMonitorable.skel.hpp>

namespace Cdmw 
{

namespace FT 
{

class TestUtils
{
public:
    static  int   M_current_primary_index;
    static const int   NB_LOCATION = 4;
    static const char* M_locations[NB_LOCATION];
    static const char* M_hello_files[NB_LOCATION];
    static const char* M_comput_files[NB_LOCATION];
;

    static  CdmwFT::Test::HelloInterface_ptr
    get_hello_ref_from_file(CORBA::ORB_ptr orb, std::string file_name)
        throw (CORBA::SystemException);
    
    static  ::FT::PullMonitorable_ptr
    get_pm_ref_from_file(CORBA::ORB_ptr orb, std::string host_name)
        throw (CORBA::SystemException);

    static  CdmwFT::Test::ComputInterface_ptr
    get_comput_ref_from_file(CORBA::ORB_ptr orb, std::string file_name)
        throw (CORBA::SystemException);

private:
    TestUtils();
};

} // end namespace FT

} // end namespace Cdmw

