/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.ft.watchdog.test.testtimeoutrequest;

import org.junit.Assert;
import org.junit.Test;
import org.omg.CORBA.ORB;
import org.omg.CORBA.SystemException;

import cdmw.testutils.CORBATestManager;
import cdmw.testutils.CORBATestManager.InvalidObject;

import com.thalesgroup.CdmwFT.Test.*;

public class HelloTest {

    private final static String COMPUT_OBJECT_STR = "comput_object";

    private ORB orb;

    private HelloInterface helloObj;

    private ComputInterface computObj;

    public HelloTest() {
        CORBATestManager corbaTestMngr = CORBATestManager.instance();

        org.omg.CORBA.Object obj = null;
        try {
            this.orb = corbaTestMngr.getORB();

            obj = corbaTestMngr.getObject(COMPUT_OBJECT_STR);
        }
        catch (InvalidObject ex) {
            ex.printStackTrace();
        }

        this.computObj = ComputInterfaceHelper.narrow(obj);
    }

    @Test
    public void doTests() {
        for (int i = 0; i < 4; i++ ) {
            try {
                System.out.println("Calling hello on HelloInterface in Thread...");

                this.helloObj = TestUtils.getHelloRefFromFile(this.orb,
                    TestUtils.helloFiles[0]);
                this.helloObj.hello(this.computObj);
                System.out.println("hello on HelloInterface in Thread OK...");
                Assert.assertTrue(true);
            }
            catch (SystemException ex) {
                System.out.println("CORBA System Exception raised " + ex.getMessage());
                Assert.assertTrue(false);
            }
        }

        System.out.println("********************************************");
        System.out.println("            HelloTest stop");
        System.out.println("********************************************");

    }
}
