#!/bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2000-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

case ${CDMW_JAVA_ORB} in
    ORBacusJAVA)
    __ORB_CLASSPATH__=@config.ORBacusJAVA.classpath@
    ;;
        JacORB)
        for i in `ls ${JACORB_HOME}/lib/*.jar`; do
           __ORB_CLASSPATH__=$__ORB_CLASSPATH__:$i
        done
        ;;

    *)
    echo " invalid ORB constraint...";
    exit 1;
    ;;
esac

__TOOLS_CLASSPATH__=$__ORB_CLASSPATH__

# add Junit jars
for jar in `find ${JUNIT_HOME} -name "*.jar"`
do
    __TOOLS_CLASSPATH__=$__TOOLS_CLASSPATH__:$jar
done


__CLASSPATH__=""

# add jars
for jar in `find ${CDMW_HOME} -name "*.jar"`
do
    __CLASSPATH__=$__CLASSPATH__$jar:
done

__CLASSPATH__=$__CLASSPATH__$__TOOLS_CLASSPATH__

# set library path for java native libraries
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:${CDMW_HOME}/lib/c++
LIBPATH=$LIBPATH:${CDMW_HOME}/lib/c++

#if we use the onlyqualificationtest or onlyvalidationtest options we should set additional paths
__CDMW_CLASSPATH__=""
if [ $CDMW_ROOT ]
then
    # add CARDAMOM jars
    for cjar in `find $CDMW_ROOT -name "*.jar"`
    do
        __CDMW_CLASSPATH__=$cjar:$__CDMW_CLASSPATH__
    done
    __CLASSPATH__=$__CLASSPATH__:$__CDMW_CLASSPATH__
    
    #paths to CARDAMOM install
    LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$CDMW_ROOT/lib/c++
    LIBPATH=$LIBPATH:$CDMW_ROOT/lib/c++    
fi

if test ! -x `which $TERM`
then
    TERM=xterm
fi


exec $TERM -title `basename ${0}` -ls -sb -sl 500 -e ${SHELL_FORWARD} java -Xbootclasspath/p:$__CLASSPATH__ cdmw.valid.testtimeoutrequest.MainTestTimeoutRequestClient $*

