/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#ifndef INCL_TEST_BACKUP_INSERTION_HPP
#define INCL_TEST_BACKUP_INSERTION_HPP

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/testutils/CORBATestManager.hpp>
#include <Foundation/osthreads/Mutex.hpp>
#include <Foundation/osthreads/Condition.hpp>
#include <Foundation/ossupport/OS.hpp>


namespace Cdmw {
namespace FT {

class TestBackupInsertion : public CppUnit::TestFixture
{
public:
    // constructor
    TestBackupInsertion();

    // destructor
    virtual ~TestBackupInsertion();

protected:
    // do_tests
    virtual void do_tests();

private:
    CORBA::ORB_var m_orb;
    PortableServer::POA_var m_rootPOA;
    std::string m_process_name;
    std::string m_host1;
    std::string m_host2;
    std::string m_host3;

CPPUNIT_TEST_SUITE( TestBackupInsertion );
CPPUNIT_TEST( do_tests );
CPPUNIT_TEST_SUITE_END();

};
}; // namespace FT
}; // namespace Cdmw

#endif // INCL_TEST_BACKUP_INSERTION_HPP

