/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


#include "testftservers/TesterFactory_impl.hpp"

namespace Cdmw {
namespace Test {

TesterFactory_impl::TesterFactory_impl(std::string name)
    :m_name(name)
{

}


CORBA::Boolean TesterFactory_impl::supports(const char* repository_id)
    throw(CORBA::SystemException)
{

    bool res = false;

    if (!strcmp(repository_id, "IDL:Cdmw/Test/Tester:1.0"))
        res = true;
    
    return res;

}


CdmwLifeCycle::RepositoryIdSeq* TesterFactory_impl::get_supported_objects()
    throw(CORBA::SystemException)
{

    CORBA::RepositoryId_var repId = CORBA::string_dup("IDL:Cdmw/Test/Tester:1.0");
    
    CdmwLifeCycle::RepositoryIdSeq_var repIdSeq = new CdmwLifeCycle::RepositoryIdSeq();
    repIdSeq->length(1);
    repIdSeq->operator[](0) = repId;
    
    return repIdSeq._retn();

}

char* TesterFactory_impl::name ()
    throw(CORBA::SystemException)
{
    return CORBA::string_dup(m_name.c_str());
}
    

}; // namespace test

}; // namespace Cdmw

