/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2009-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package com.acme.Hello;


import org.omg.CCM_DDS.InternalError;
import org.omg.CCM_DDS.ListenerControl;
import org.omg.CCM_DDS.ReadInfoSeqHolder;

import com.acme.Hello.Donnee;
import com.acme.Hello.DonneeSeqHolder;
import com.acme.Hello.Donnee_Getter;
import com.acme.Hello.Donnee_Reader;
import com.acme.Hello.Donnee_Writer;


public class Demo implements Runnable {
    
    private Donnee_Writer writer;
    private Donnee_Getter getter;
    private ListenerControl listenerControl;
    private Donnee_Reader reader;
    
    public Demo(Donnee_Writer write_data, Donnee_Getter get_data,
            Donnee_Reader composant_data, ListenerControl composant_control) {
        this.writer = write_data;
        this.getter = get_data;
        this.reader = composant_data;
        this.listenerControl = composant_control;
    }


    public void run() {
        
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        
        System.out.println("\n\n<====== Demo started ======>");
        
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }        
        
        System.out.println("\nSend message \"Hello\" with ID=1");
        
        Donnee an_instance = new Donnee();
        an_instance.ID = 1;
        an_instance.msg = "Hello";
        
        try {
            writer.write(an_instance);            
        } catch (InternalError e) {
            e.printStackTrace();
        }
        
        
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        
        
        System.out.println("Send message \"World !\" with ID=2");
        
        an_instance.ID = 2;
        an_instance.msg = "World !";
        
        try {
            writer.write(an_instance);
        } catch (InternalError e) {
            e.printStackTrace();
        }
        
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }        
        
        
        
        System.out.println("\nTry to get all samples");
        
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        
        DonneeSeqHolder instances = new DonneeSeqHolder();
        ReadInfoSeqHolder infos = new ReadInfoSeqHolder();
        
        try {
            getter.get_all(instances, infos);
        } catch (InternalError e) {
            e.printStackTrace();
        }
        
        for(int i =0; i < instances.value.length; i++) {
            System.out.println("ID = " + instances.value[i].ID + " & msg = " + instances.value[i].msg);
        }
        
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        
        System.out.println("\n! Listener activation !");
        
        listenerControl.enabled(true);
        
        
        System.out.println("\nWrite 5 messages\n");

        try {
            Thread.sleep(2000);
            reader.read_all_history(instances, infos);
        } catch (Exception e) {
            e.printStackTrace();
        }
        
        for(int i =0; i < 5; i++) {
            
            try {
                an_instance.ID = i;
                an_instance.msg = "Message " + i ;
                System.out.println("Send message \"" + an_instance.msg +  "\" with ID=" + an_instance.ID);
            
                writer.write(an_instance);
                Thread.sleep(2000);
            } catch (Exception e) {
                e.printStackTrace();
            }
            
        }
        
        System.out.println("\n! Listener desactivation !\n");
        
        listenerControl.enabled(false);
        
        System.out.println("<====== Demo ended ======>");
        
        
    }

}
