/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2009-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package com.acme.Hello;


import org.omg.CCM_DDS.CCM_ListenerControl;
import org.omg.CCM_DDS.QueryFilter;
import org.omg.CCM_DDS.ReadInfo;

import cdmw.ccm.qosenablers.dds.DDS_ReaderImpl;
import cdmw.ccm.qosenablers.dds.DataReaderListenerImpl;
import static cdmw.ccm.qosenablers.dds.DataUtil.*;

import com.acme.Hello.CCM_Donnee_Reader;
import com.acme.Hello.Donnee;
import com.acme.Hello.DonneeDataReader;
import com.acme.Hello.DonneeDataReaderHelper;
import com.acme.Hello.DonneeSeqHolder;
import com.acme.Hello.Donnee_RawListener;

import DDS.DataReader;
import DDS.DataReaderListener;
import DDS.LivelinessChangedStatus;
import DDS.QueryCondition;
import DDS.RETCODE_OK;
import DDS.RequestedDeadlineMissedStatus;
import DDS.RequestedIncompatibleQosStatus;
import DDS.SampleInfo;
import DDS.SampleInfoSeqHolder;
import DDS.SampleLostStatus;
import DDS.SampleRejectedStatus;
import DDS.SubscriptionMatchedStatus;

public class DonneeDataReaderListenerImpl extends DataReaderListenerImpl {

    private Donnee_RawListener listenerReceptacle;
/*    private CCM_ListenerControl listenerControl;
    private CCM_Donnee_Reader readerFacet;*/

    public DonneeDataReaderListenerImpl(Donnee_RawListener rawListen_listener,
            CCM_ListenerControl rawListen_control,
            CCM_Donnee_Reader rawListen_data) {
        super((DDS_ReaderImpl)rawListen_data, rawListen_control);
        this.listenerReceptacle = rawListen_listener;
    }

    public void on_data_available(DataReader dr) {

        if(!listenEnabler.enabled() || this.listenerReceptacle == null) return;

        DonneeDataReader donneeReader = DonneeDataReaderHelper.narrow(dr);

        DonneeSeqHolder data = new DonneeSeqHolder();
        SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();

//        int status = donneeReader.read_w_condition(data, infoSeq, 1, getReadCondition());
        int status = donneeReader.read(data, infoSeq, 1, DDS.NOT_READ_SAMPLE_STATE.value,
                DDS.NEW_VIEW_STATE.value
                | DDS.NOT_NEW_VIEW_STATE.value,
        DDS.ALIVE_INSTANCE_STATE.value
                | DDS.NOT_ALIVE_INSTANCE_STATE.value);

        if (status == RETCODE_OK.value) {
            if (data.value.length != 1) {
                System.out.println("Size mismatch : " + data.value.length);
            }

            ReadInfo[] info = new ReadInfo[]{new ReadInfo()};
            fillReadInfo(infoSeq.value[0], info[0], 0);

            if (infoSeq.value[0].valid_data) {
                Donnee an_instance = data.value[0];
                this.listenerReceptacle.on_data(an_instance, info[0]);
            }

        }

/*        int status;
        DonneeDataReader reader = DonneeDataReaderHelper.narrow(dr);

        if (this.listenerControl.enabled()) {

            DonneeSeqHolder tmp = new DonneeSeqHolder();
            SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();

            QueryFilter filter = this.readerFacet.filter();

            if (filter != null) {

                QueryCondition queryCond = reader
                        .create_querycondition(DDS.NOT_READ_SAMPLE_STATE.value,
                                DDS.NEW_VIEW_STATE.value
                                        | DDS.NOT_NEW_VIEW_STATE.value,
                                DDS.ALIVE_INSTANCE_STATE.value
                                        | DDS.NOT_ALIVE_INSTANCE_STATE.value,
                                filter.query, filter.query_parameters);
                if (queryCond == null) {
                    System.out.println("Error on create_querycondition");
                    System.exit(-1);
                }

                status = reader.read_w_condition(tmp, infoSeq, 1,
                        this.queryCond);

            } else {
                status = reader
                        .read(tmp, infoSeq, 1, DDS.NOT_READ_SAMPLE_STATE.value,
                                DDS.NEW_VIEW_STATE.value
                                        | DDS.NOT_NEW_VIEW_STATE.value,
                                DDS.ALIVE_INSTANCE_STATE.value
                                        | DDS.NOT_ALIVE_INSTANCE_STATE.value);
            }

            if (status == RETCODE_OK.value) {

                if (tmp.value.length != 1) {
                    System.out.println("Size mismatch : " + tmp.value.length);
                }

                ReadInfo info = new ReadInfo();
                fillReadInfo(infoSeq.value[0], info);

                if (infoSeq.value[0].valid_data) {
                    Donnee an_instance = tmp.value[0];
                    this.listenerReceptacle.on_data(an_instance, info);
                }

            }

        }*/

    }


}
