/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2009-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package com.acme.Hello;

import org.omg.CCM_DDS.InternalError;
import org.omg.CCM_DDS.NonExistent;
import org.omg.CCM_DDS.ReadInfoHolder;
import org.omg.CCM_DDS.ReadInfoSeqHolder;
import org.omg.Components.CCMException;
import org.omg.Components.SessionContext;

import cdmw.ccm.qosenablers.dds.DDS_TopicBaseFragmentImpl;
import cdmw.ccm.qosenablers.dds.DataSeqHolder;
import cdmw.ccm.qosenablers.dds.ErrorHandler;

import DDS.*;

public class Donnee_MyConnector_DDS_GetExecutorImpl extends
    DDS_TopicBaseFragmentImpl implements CCM_Donnee_MyConnector_DDS_Get,
    org.omg.Components.SessionComponent
    {
    DonneeDataReader donneeReader;
    DonneeTypeSupport dataTS;

    CCM_Donnee_Getter p_Get_data;

    // ------------- attributs ----------------

    public CCM_Donnee_Getter get_p_Get_data() {
        return p_Get_data;
    }

    public Donnee_MyConnector_DDS_GetExecutorImpl() {
        super();
        dataTS = new DonneeTypeSupport();
        ErrorHandler.checkHandle(dataTS, "new DonneeTypeSupport");
        super.topic_name("DEMO_TOPIC");
    }

    public void ccm_activate() throws CCMException{
        System.out
                .println("Donnee_MyConnector_DDS_GetExecutorImpl.ccm_activate called ...");
        try {
            super.setupDDSInfrastructure(false,true);

            donneeReader = DonneeDataReaderHelper.narrow(super.reader);
            ErrorHandler.checkHandle(donneeReader,
                    "DDS.DonneeDataReaderHelper.narrow");
            this.p_Get_data = new Donnee_GetterFacetImpl(donneeReader);

        } catch (Exception e) {
            System.out.println("Unexpected exception raised!\n" + e.toString());
        }
    }

    public void ccm_remove() throws CCMException{
        super.teardownDDSInfrastructure(false,true);
    }

    public void ccm_passivate() throws CCMException{

    }

    public void set_session_context(SessionContext arg0) throws CCMException{
    }

    @Override
    protected TypeSupport getDataTypeSupport() {
        return dataTS;
    }

}
