/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2009-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package com.acme.Hello;

import java.util.ArrayList;
import java.util.List;

import org.omg.CCM_DDS.InternalError;
import org.omg.CCM_DDS.NonExistent;
import org.omg.CCM_DDS.QueryFilter;
import org.omg.CCM_DDS.ReadInfo;
import org.omg.CCM_DDS.ReadInfoHolder;
import org.omg.CCM_DDS.ReadInfoSeqHolder;

import DDS.DataReader;
import DDS.Duration_t;
import DDS.LENGTH_UNLIMITED;
import DDS.RETCODE_OK;
import DDS.ReadCondition;
import DDS.SampleInfo;
import DDS.SampleInfoSeqHolder;
import cdmw.ccm.qosenablers.dds.DDS_ReaderImpl;
import cdmw.ccm.qosenablers.dds.DataSeqHolder;
import static cdmw.ccm.qosenablers.dds.DataUtil.*;

import com.acme.Hello.Donnee;
import com.acme.Hello.DonneeDataReader;
import com.acme.Hello.DonneeHolder;
import com.acme.Hello.DonneeSeqHolder;

public class Donnee_ReaderFacetImpl extends DDS_ReaderImpl implements
        CCM_Donnee_Reader {

    DonneeDataReader reader;

    public Donnee_ReaderFacetImpl(DonneeDataReader reader) {
        super(reader);
        this.reader = reader;
    }

    /**
     * returns for each living instance, its last sample ordered by instance
     * first and then by sample
     *
     * @param instances
     * @param infos
     * @throws InternalError
     */
    public void read_all(DonneeSeqHolder instances, ReadInfoSeqHolder infos)
            throws InternalError {

        try {

            initData(new DataSeqHolder<Donnee, DonneeSeqHolder>(Donnee[].class,
                    instances), infos, null);

            SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
            int status = reader.read_w_condition(instances, infoSeq,
                    LENGTH_UNLIMITED.value, this.userQuery);

            readAll(new DataSeqHolder<Donnee, DonneeSeqHolder>(Donnee[].class,
                    instances), infos, infoSeq.value, status);

        } catch (Exception e) {
            throw new InternalError("Operation Failed: " + e.getMessage(),
                    DDS.RETCODE_ERROR.value, 0);
        }



        /*
         * SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
         *
         * int status = reader.read_w_condition(instances, infoSeq,
         * LENGTH_UNLIMITED.value, this.userQuery);
         *
         * readAll(new );
         *
         * if (status != RETCODE_OK.value) { InternalError e = new
         * InternalError(); e.error_code = status; e.index = 0; throw e; }
         *
         * List<SampleInfo> listLastSampleInfo = new ArrayList<SampleInfo>();
         * List<Donnee> listLastSample = new ArrayList<Donnee>();
         *
         * for (int i = 0; i < infoSeq.value.length; i++) { if
         * (infoSeq.value[i].sample_rank == 0) {
         * listLastSampleInfo.add(infoSeq.value[i]);
         * listLastSample.add(instances.value[i]); } else { i = i - 1 +
         * infoSeq.value[i].sample_rank; } }
         *
         * instances.value = new Donnee[listLastSample.size()]; infos.value =
         * new ReadInfo[listLastSample.size()];
         *
         * for (int i = 0; i < listLastSampleInfo.size(); i++) { infos.value[i]
         * = new ReadInfo(); fillReadInfo(listLastSampleInfo.get(i),
         * infos.value[i]); if (listLastSampleInfo.get(i).valid_data) {
         * instances.value[i] = listLastSample.get(i); } }
         */
    }

    /**
     * read_all_history returns all the samples of all instances ordered by
     * instance first and then by sample
     *
     * @param instances
     * @param infos
     * @throws InternalError
     */
    public void read_all_history(DonneeSeqHolder instances,
            ReadInfoSeqHolder infos) throws InternalError {


        try {
            initData(new DataSeqHolder<Donnee, DonneeSeqHolder>(Donnee[].class,
                    instances), infos, null);

            SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
            int status = reader.read_w_condition(instances, infoSeq,
                    LENGTH_UNLIMITED.value, this.userQuery);

            readAllHistory(new DataSeqHolder<Donnee, DonneeSeqHolder>(
                    Donnee[].class, instances), infos, infoSeq.value, status);

        } catch (Exception e) {
            throw new InternalError("Operation Failed: " + e.getMessage(),
                    DDS.RETCODE_ERROR.value, 0);
        }

        /*
         * SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
         *
         * int status = reader.read_w_condition(instances, infoSeq,
         * LENGTH_UNLIMITED.value, this.userQuery);
         *
         * if (status != RETCODE_OK.value) { System.out.println("Error code : "
         * + status); InternalError e = new InternalError(); e.error_code =
         * status; e.index = 0; throw e; }
         *
         * infos.value = new ReadInfo[infoSeq.value.length];
         *
         * for (int i = 0; i < infos.value.length; i++) { infos.value[i] = new
         * ReadInfo(); fillReadInfo(infoSeq.value[i], infos.value[i]);
         * System.out.println("infos.value[" + i + "].timestamp = " +
         * infos.value[i].timestamp); }
         */

    }

    /**
     * returns the last sample of the given instance NOTA: userQuery is ignored
     * because read_instance_with_condition is not implemented by Splice ...
     */
    public void read_one(DonneeHolder an_instance, ReadInfoHolder info)
            throws NonExistent, InternalError {

        try {

            long handle = reader.lookup_instance(an_instance.value);
            if (handle == DDS.HANDLE_NIL.value) {
                throw new NonExistent();
            }
            SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
            DonneeSeqHolder instances = new DonneeSeqHolder();
            int status = reader.read_instance(instances, infoSeq,
                    LENGTH_UNLIMITED.value, handle,
                    DDS.NOT_READ_SAMPLE_STATE.value
                            | DDS.NOT_READ_SAMPLE_STATE.value,
                    DDS.NEW_VIEW_STATE.value | DDS.NOT_NEW_VIEW_STATE.value,
                    DDS.ALIVE_INSTANCE_STATE.value);

            if (infoSeq.value[infoSeq.value.length - 1].valid_data) {
                an_instance.value = instances.value[infoSeq.value.length - 1];
            }

            readOne(info, infoSeq.value, status);

        } catch (Exception e) {
            throw new InternalError("Operation Failed: " + e.getMessage(),
                    DDS.RETCODE_ERROR.value, 0);
        }

        /*
         * SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
         *
         * long handle = reader.lookup_instance(an_instance.value);
         *
         * if (handle == DDS.HANDLE_NIL.value) { throw new NonExistent(); }
         *
         * DonneeSeqHolder tmp = new DonneeSeqHolder(); int status =
         * reader.read_instance(tmp, infoSeq, LENGTH_UNLIMITED.value, handle,
         * DDS.READ_SAMPLE_STATE.value | DDS.NOT_READ_SAMPLE_STATE.value,
         * DDS.NEW_VIEW_STATE.value | DDS.NOT_NEW_VIEW_STATE.value,
         * DDS.ALIVE_INSTANCE_STATE.value);
         *
         * if (status != RETCODE_OK.value) { InternalError e = new
         * InternalError(); e.error_code = status; e.index = 0; throw e; }
         *
         * int length = infoSeq.value.length;
         *
         * info.value = new ReadInfo(); fillReadInfo(infoSeq.value[length - 1],
         * info.value);
         *
         * if (infoSeq.value[length - 1].valid_data) { an_instance.value =
         * tmp.value[length - 1]; }
         */
    }

    /**
     * returns all the samples for the given instance NOTA: userQuery ignored
     */
    public void read_one_history(Donnee an_instance, DonneeSeqHolder instances,
            ReadInfoSeqHolder infos) throws NonExistent, InternalError {

        try {

            long handle = reader.lookup_instance(an_instance);

            if (handle == DDS.HANDLE_NIL.value) {
                throw new NonExistent();
            }
            SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
            int status = reader.read_instance(instances, infoSeq,
                    LENGTH_UNLIMITED.value, handle, DDS.READ_SAMPLE_STATE.value
                            | DDS.NOT_READ_SAMPLE_STATE.value,
                    DDS.NEW_VIEW_STATE.value | DDS.NOT_NEW_VIEW_STATE.value,
                    DDS.ALIVE_INSTANCE_STATE.value);

            readOneHistory(infos, infoSeq.value, status);

        } catch (Exception e) {
            throw new InternalError("Operation Failed: " + e.getMessage(),
                    DDS.RETCODE_ERROR.value, 0);
        }

        /*
         * SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
         *
         * long handle = reader.lookup_instance(an_instance);
         *
         * if (handle == DDS.HANDLE_NIL.value) { throw new NonExistent(); }
         *
         * int status = reader.read_instance(instances, infoSeq,
         * LENGTH_UNLIMITED.value, handle, DDS.READ_SAMPLE_STATE.value |
         * DDS.NOT_READ_SAMPLE_STATE.value, DDS.NEW_VIEW_STATE.value |
         * DDS.NOT_NEW_VIEW_STATE.value, DDS.ALIVE_INSTANCE_STATE.value);
         *
         * if (status != RETCODE_OK.value) { InternalError e = new
         * InternalError(); e.error_code = status; e.index = 0; throw e; }
         *
         * infos.value = new ReadInfo[infoSeq.value.length];
         *
         * for (int i = 0; i < infos.value.length; i++) { infos.value[i] = new
         * ReadInfo(); fillReadInfo(infoSeq.value[i], infos.value[i]); }
         */

    }

}
