/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX SISTEMI INTEGRATI. It is derivative work based on PERCO
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2010. All rights reserved.
 *
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.qosenablers4ccm;

import com.thalesgroup.CdmwRecording.*;
import java.io.*;

public class RecorderImpl extends RecorderPOA {
    // implements RecorderOperations {

    String fileName = "recordingserver_data";

    File file = new File(fileName);
    FileWriter fw;

    public RecorderImpl() {
        if (file.exists()) {
            file.delete();
        }
        try {
            fw = new FileWriter(fileName);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void record(com.thalesgroup.CdmwRecording.GroupHeader header,
            byte[] data) {

        System.out.println("RecorderImpl.record called ...");

        try {
            fw.write("buffer:\n");
            fw.write("hostname:");
            fw.write(header.hostname + "\n");
            fw.write("num_pairs:");
            fw.write(header.num_pairs + '\n');
            fw.write("length:");
            fw.write(data.length + " \n");

            fw.flush();

        } catch (java.io.IOException ex) {
            System.err.println("IOException raised...");
            System.exit(1);
        }
    }

}
