/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2009-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package com.prismtech.mosic.radar.ddsfragments.DDS_StateListen_TargetDistance;

import static cdmw.ccm.qosenablers.dds.DataUtil.fillReadInfo;

import java.util.Hashtable;

import org.omg.CCM_DDS.CCM_ListenerControl;
import org.omg.CCM_DDS.InstanceStatus;
import org.omg.CCM_DDS.ReadInfo;

import com.prismtech.mosic.radar.CCM_TargetDistance_Reader;
import com.prismtech.mosic.radar.TargetDistance;
import com.prismtech.mosic.radar.TargetDistanceDataReader;
import com.prismtech.mosic.radar.TargetDistanceDataReaderHelper;
import com.prismtech.mosic.radar.TargetDistanceSeqHolder;
import com.prismtech.mosic.radar.TargetDistance_StateListener;

import DDS.DataReader;
import DDS.RETCODE_NO_DATA;
import DDS.RETCODE_OK;
import DDS.SampleInfoSeqHolder;
import cdmw.ccm.qosenablers.dds.DDS4CCMLoggers;
import cdmw.ccm.qosenablers.dds.DDS_ReaderImpl;
import cdmw.ccm.qosenablers.dds.DataReaderListenerImpl;
import cdmw.ccm.qosenablers.dds.ErrorHandler;

public class TargetDistanceDataReaderListenerImpl extends
        DataReaderListenerImpl {

    private java.util.logging.Logger logger = DDS4CCMLoggers
            .getDDS_StateListenLogger();

    private TargetDistance_StateListener listenerReceptacle;
    private final int INSTANCE_ALIVE = 1;
    private final int INSTANCE_DELETED = 0;
    private Hashtable<String, Integer> aliveTargets = new Hashtable<String, Integer>();

    public TargetDistanceDataReaderListenerImpl(
            TargetDistance_StateListener stateListen_listener,
            CCM_ListenerControl StateListen_control,
            CCM_TargetDistance_Reader StateListen_data) {
        super((DDS_ReaderImpl) StateListen_data, StateListen_control);
        this.listenerReceptacle = stateListen_listener;
    }

    public synchronized void on_data_available0(DataReader dr) {

        if (!listenEnabler.enabled() || this.listenerReceptacle == null)
            return;

        TargetDistanceDataReader targetDistanceReader = TargetDistanceDataReaderHelper
                .narrow(dr);

        TargetDistanceSeqHolder data = new TargetDistanceSeqHolder();
        SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
        /* filter not actived */
        // int status = targetDistanceReader.read_w_condition(data, infoSeq, 1,
        // getReadCondition());
        int status = targetDistanceReader.read(data, infoSeq,
                DDS.LENGTH_UNLIMITED.value, DDS.NOT_READ_SAMPLE_STATE.value,
                DDS.NEW_VIEW_STATE.value | DDS.NOT_NEW_VIEW_STATE.value,
                DDS.ALIVE_INSTANCE_STATE.value
                        | DDS.NOT_ALIVE_INSTANCE_STATE.value);

        /*
         * if (status == RETCODE_OK.value) {
         * logger.info("&&&&&&&&&(1) : status = RETCODE_OK");
         *
         * if(data.value.length == 1) {
         * logger.info("&&&&&&&&&&&(2) : data length == 1");
         *
         * ReadInfo[] info = new ReadInfo[]{new ReadInfo()};
         * fillReadInfo(infoSeq.value[0], info[0], 0);
         *
         * if (infoSeq.value[0].valid_data) {
         * logger.info("&&&&&&&&&&&&(3) : valid data of: " +
         * data.value[0].trackId);
         * logger.info("&&&&&&&&&&&&&(3) : instance status: " +
         * info[0].instance_status.value());
         *
         * TargetDistance an_instance = data.value[0]; org.omg.DDS.Time_t tmp =
         * new org.omg.DDS.Time_t(infoSeq.value[0].source_timestamp.sec,
         * infoSeq.value[0].source_timestamp.nanosec);
         *
         * if(info[0].instance_status == InstanceStatus.INSTANCE_CREATED) {
         * historic.put(an_instance.trackId, INSTANCE_ALIVE);
         * this.listenerReceptacle.on_creation(an_instance, tmp); }
         *
         * if(info[0].instance_status == InstanceStatus.INSTANCE_UPDATED) {
         * historic.put(an_instance.trackId, INSTANCE_ALIVE);
         * this.listenerReceptacle.on_update(an_instance, tmp); }
         *
         * if(info[0].instance_status == InstanceStatus.INSTANCE_DELETED) {
         * historic.put(an_instance.trackId, INSTANCE_DELETED);
         * this.listenerReceptacle.on_deletion(an_instance, tmp); }
         *
         * }
         *
         * } else { logger.info("&&&&&&&&&&&&&(4) : data length " +
         * data.value.length);
         *
         * ReadInfo[] info = new ReadInfo[data.value.length];
         *
         * for (int i = 0; i < infoSeq.value.length; i++) {
         *
         * logger.info("&&&&&&&&&&&&&(4) : instance status of "+
         * data.value[i].trackId);
         *
         * if (infoSeq.value[i].sample_rank == 0) {
         *
         * if (infoSeq.value[i].valid_data) {
         *
         * info[i] = new ReadInfo(); fillReadInfo(infoSeq.value[i], info[i],
         * infoSeq.value[i].sample_rank);
         *
         * TargetDistance an_instance = data.value[i]; org.omg.DDS.Time_t tmp =
         * new org.omg.DDS.Time_t(infoSeq.value[i].source_timestamp.sec,
         * infoSeq.value[i].source_timestamp.nanosec);
         *
         * logger.info("&&&&&&&&&&&&&(4) : instance status of " +
         * an_instance.trackId +" is "+ info[i].instance_status.value());
         *
         * if(info[i].instance_status == InstanceStatus.INSTANCE_CREATED) {
         * historic.put(an_instance.trackId, INSTANCE_ALIVE);
         * this.listenerReceptacle.on_creation(an_instance, tmp); }
         *
         * if(info[i].instance_status == InstanceStatus.INSTANCE_UPDATED) {
         * historic.put(an_instance.trackId, INSTANCE_ALIVE);
         * this.listenerReceptacle.on_update(an_instance, tmp); }
         *
         * if(info[i].instance_status == InstanceStatus.INSTANCE_DELETED) {
         * historic.put(an_instance.trackId, INSTANCE_DELETED);
         * this.listenerReceptacle.on_deletion(an_instance, tmp); }
         *
         * }
         *
         *
         * } else { i = i - 1 + infoSeq.value[i].sample_rank; } }
         *
         *
         * }
         *
         * }
         */

        if (status == RETCODE_OK.value) {
            logger.info("&&&&&&&&&(1) : status = RETCODE_OK");

            ReadInfo[] info = new ReadInfo[data.value.length];

            for (int i = 0; i < infoSeq.value.length; i++) {

                logger.info("&&&&&&&&&&&&&(2) : instance "
                        + data.value[i].trackId);

                if (infoSeq.value[i].sample_rank == 0) {
                    info[i] = new ReadInfo();
                    fillReadInfo(infoSeq.value[i], info[i],
                            infoSeq.value[i].sample_rank);

                    TargetDistance an_instance = data.value[i];
                    org.omg.DDS.Time_t tmp = new org.omg.DDS.Time_t(
                            infoSeq.value[i].source_timestamp.sec,
                            infoSeq.value[i].source_timestamp.nanosec);

                    if (infoSeq.value[i].valid_data) {

                        logger.info("&&&&&&&&&&&&&(3) : instance status of "
                                + an_instance.trackId + " is "
                                + info[i].instance_status.value());

                        if (info[i].instance_status == InstanceStatus.INSTANCE_CREATED) {
                            aliveTargets.put(an_instance.trackId,
                                    INSTANCE_ALIVE);
                            this.listenerReceptacle.on_creation(an_instance,
                                    tmp);
                        }

                        if (info[i].instance_status == InstanceStatus.INSTANCE_UPDATED) {
                            aliveTargets.put(an_instance.trackId,
                                    INSTANCE_ALIVE);
                            this.listenerReceptacle.on_update(an_instance, tmp);
                        }

                        if (info[i].instance_status == InstanceStatus.INSTANCE_DELETED) {
                            // historic.put(an_instance.trackId,
                            // INSTANCE_DELETED);
                            logger.info("INSTANCE DELETED in RETCODE_OK : "
                                    + an_instance.trackId);
                            if (aliveTargets.containsKey(an_instance.trackId))
                                aliveTargets.remove(an_instance.trackId);
                            this.listenerReceptacle.on_deletion(an_instance,
                                    tmp);
                        }

                    }

                } /*
                   * else { i = i - 1 + infoSeq.value[i].sample_rank; }
                   */
            }

        }

        targetDistanceReader.return_loan(data, infoSeq);

        // if(status == RETCODE_NO_DATA.value) {
        // logger.info("&&&&&&&&&&&&&(5) : status == RETCODE_NO_DATA");

        data = new TargetDistanceSeqHolder();
        infoSeq = new SampleInfoSeqHolder();

        status = targetDistanceReader.read(data, infoSeq,
                DDS.LENGTH_UNLIMITED.value, DDS.ANY_SAMPLE_STATE.value,
                DDS.NEW_VIEW_STATE.value | DDS.NOT_NEW_VIEW_STATE.value,
                DDS.NOT_ALIVE_DISPOSED_INSTANCE_STATE.value);

        logger.info("STATUS (ANY) = " + ErrorHandler.getErrorName(status));

        for (int i = 0; i < infoSeq.value.length; i++) {
            logger.info("&&&&&&&&&&&&&(5) : instance " + data.value[i].trackId);

            if (infoSeq.value[i].sample_rank == 0) {
                if (aliveTargets.get(data.value[i].trackId) != null
                        && aliveTargets.get(data.value[i].trackId) == this.INSTANCE_ALIVE) {

                    // if( historic.get(data.value[i].trackId) ==
                    // this.INSTANCE_ALIVE ) {
                    logger.info("&&&&&&&&&&&&&(5) : on_deletion called on "
                            + data.value[i].trackId);

                    org.omg.DDS.Time_t tmp = new org.omg.DDS.Time_t(
                            infoSeq.value[i].source_timestamp.sec,
                            infoSeq.value[i].source_timestamp.nanosec);
                    this.listenerReceptacle.on_deletion(data.value[i], tmp);
                    aliveTargets.put(data.value[i].trackId, INSTANCE_DELETED);
                    // }
                }
            } /*
               * else { i = i - 1 + infoSeq.value[i].sample_rank; }
               */
        }

        // }

        targetDistanceReader.return_loan(data, infoSeq);

    }

    public synchronized void on_data_available(DataReader dr) {

        if (!listenEnabler.enabled() || this.listenerReceptacle == null)
            return;

        TargetDistanceDataReader targetDistanceReader = TargetDistanceDataReaderHelper
                .narrow(dr);

        /**
         * reading alive instances
         */

        TargetDistanceSeqHolder data = new TargetDistanceSeqHolder();
        SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
        /* filter not actived */
        // int status = targetDistanceReader.read_w_condition(data, infoSeq, 1,
        // getReadCondition());
        int status = targetDistanceReader.read(data, infoSeq,
                DDS.LENGTH_UNLIMITED.value, DDS.NOT_READ_SAMPLE_STATE.value,
                DDS.NEW_VIEW_STATE.value | DDS.NOT_NEW_VIEW_STATE.value,
                DDS.ALIVE_INSTANCE_STATE.value);

        if (status == RETCODE_OK.value) {

            ReadInfo[] info = new ReadInfo[data.value.length];

            for (int i = 0; i < infoSeq.value.length; i++) {

                if (infoSeq.value[i].sample_rank == 0) {
                    info[i] = new ReadInfo();
                    fillReadInfo(infoSeq.value[i], info[i],
                            infoSeq.value[i].sample_rank);

                    TargetDistance an_instance = data.value[i];
                    org.omg.DDS.Time_t tmp = new org.omg.DDS.Time_t(
                            infoSeq.value[i].source_timestamp.sec,
                            infoSeq.value[i].source_timestamp.nanosec);

                    if (info[i].instance_status == InstanceStatus.INSTANCE_CREATED) {
                        this.listenerReceptacle.on_creation(an_instance, tmp);
                    }

                    if (info[i].instance_status == InstanceStatus.INSTANCE_UPDATED) {
                        this.listenerReceptacle.on_update(an_instance, tmp);
                    }

                }
            }

        }
        targetDistanceReader.return_loan(data, infoSeq);

        /**
         * reading NOT ALIVE instances
         */
        data = new TargetDistanceSeqHolder();
        infoSeq = new SampleInfoSeqHolder();

        status = targetDistanceReader.take(data, infoSeq,
                DDS.LENGTH_UNLIMITED.value, DDS.ANY_SAMPLE_STATE.value,
                DDS.NEW_VIEW_STATE.value | DDS.NOT_NEW_VIEW_STATE.value,
                DDS.NOT_ALIVE_DISPOSED_INSTANCE_STATE.value);

        if (status == RETCODE_OK.value) {
            for (int i = 0; i < infoSeq.value.length; i++) {

                if (infoSeq.value[i].sample_rank == 0) {
                    org.omg.DDS.Time_t tmp = new org.omg.DDS.Time_t(
                            infoSeq.value[i].source_timestamp.sec,
                            infoSeq.value[i].source_timestamp.nanosec);
                    this.listenerReceptacle.on_deletion(data.value[i], tmp);

                }
            }
        }
        targetDistanceReader.return_loan(data, infoSeq);

    }

}
