/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2009-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
/**
 *@file ClockDef.inl
 *@brief
 *
 *@author Raffaele Mele <rmele@progesi.it>
 */

#ifndef CTOOLS_CLOCKDEF_INL
#define CTOOLS_CLOCKDEF_INL

namespace ctools { namespace localclock {
    
typedef unsigned long long TimeT;

#ifdef  WIN32
  //  To construct the current gregorian time from Windows time we need to add the
  //  difference of days between 15th October 1582  and 1th Jan 1601 .
  #define FIX_ULL(a) a
  const TimeT base_time_ = (TimeT)FIX_ULL(0x146BF33E42C000);
#else
  //  To construct the current gregorian time from UNIX time we need to add the
  //  difference of days between 15th October 1582 and 1st Jan 1970.
  //  This difference is 141427 days (0x2D8539C80 secs, 0x1B21DD213814000 100*nsec).
  #define FIX_ULL(a) a ## ULL
  const TimeT base_time_ = (TimeT)FIX_ULL(0x1B21DD213814000);
#endif // WIN32
    
} /* localclock */ } /* ctools */

#endif // CTOOLS_CLOCKDEF_INL
