#!/bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================
# 
ID_=[28/09/2007]

if [ -z $1 ]
then
  echo "Usage: $0 [output file]"
  echo $ID_
  exit 1
fi

OUTFILE="$1"
NTPQ_EXE="/usr/sbin/ntpq"

if [ ! -x $NTPQ_EXE ]
then
  echo "$0:"
  echo "ERROR: Unable to find or execute $NTPQ_EXE"
  exit 1
fi

OFFSET=`$NTPQ_EXE -p | tr -s [:blank:] | grep -e "^\*" | sed 's/^[ ]*//' | cut -d' ' -f 9 | tail -1`

if [ -z $OFFSET ]
then
  echo "$0:"
  echo "ERROR: Unable to check NTP synchronization."
  exit 1
fi

echo "=============================================================================="
$NTPQ_EXE -p
echo "=============================================================================="
echo "Host synch diff from server: $OFFSET ms"

if [ -f $OUTFILE ]
then
    echo "Overwriting file $OUTFILE..."
else
    echo "Creating file $OUTFILE..."
fi

echo $OFFSET > $OUTFILE
exit 0
