#!/bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================
# 
ID_=[10/09/2007]

if [ "$#" != "3" ]
then
  echo "Usage: $0 [process name/number] [# iterations] [output file name]"
  echo $ID_
  exit 1
fi
# number of iterations
NITER="$2"
# Output file name
FNAME="$3"
# Process PID
PROCESS_ID=`ps aux | grep "$1" | grep -vw grep | grep -vw use_cpu | head -1 | tr -s [:blank:] | sed 's/^[ ]*//' |  cut -d' ' -f2`
echo "PRCESS NAME***: " $1
echo "PROCESS ID***: " $PROCESS_ID
if [ "$PROCESS_ID" == "" ]
then
  echo "ERROR: process $1 not found!"
  exit 1
fi

COMMAND=`top -p $PROCESS_ID -b -d 0.01 -n $NITER | grep -w $PROCESS_ID | tr -s [:blank:] | sed 's/^[ ]*//' | cut -d' ' -f 9`
if [ "$COMMAND" == "" ]
then
  echo "ERROR: unable to read cpu size for process $1."
  exit 1
fi
if [ -f "$3" ]
then
    echo "Overwriting file $3..."
else
    echo "Creating file $3..."
fi

echo $COMMAND > $FNAME
exit 0

