/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2009-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#ifndef FAKEFTGROUP_IMPL_HPP_
#define FAKEFTGROUP_IMPL_HPP_

#include <iostream>
#include "testperiodicnotifier/FakeEntity.hpp"

#include <SystemMngt/idllib/CdmwPlatformMngtFTGroup.stub.hpp>

namespace Cdmw
{
namespace PlatformMngt
{


// This class replaces FTGroup_impl for test purposes

class FakeFTGroup : public CdmwPlatformMngt::FTGroup 
{
public:

    FakeFTGroup();

    void get_attribute(const char * attr_name, CORBA::Any_out ret_attr , CdmwPlatformMngt::Owner flag)  
    throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound);

    CdmwPlatformMngt::Entity_ptr get_entity (const char* entity_name)
    throw( CdmwPlatformMngt::EntityNotFound,
            CORBA::SystemException );
                   


private:

    CORBA::UShort m_attr_value; 
    FakeEntity * m_entity;
            
};

};
};



#endif /*FAKEFTGroup_impl_HPP_*/
