/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2009-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#ifndef FAKEPROCESS_IMPL_HPP_
#define FAKEPROCESS_IMPL_HPP_

#include <iostream>
#include "testperiodicnotifier/FakeEntity.hpp"
#include "testperiodicnotifier/FakeComponent.hpp"

#include <SystemMngt/idllib/CdmwPlatformMngtProcess.stub.hpp>


namespace Cdmw
{
namespace PlatformMngt
{


// This class replaces Process_impl for test purposes

class FakeProcess : public CdmwPlatformMngt::Process
{
public:

    FakeProcess();

    virtual CdmwPlatformMngt::CcmComponent_ptr get_component(const char* component_name)
    throw(CdmwPlatformMngt::ComponentNotFound,
        CdmwPlatformMngt::NotComponentServer,
        CORBA::SystemException);

    void get_attribute(const char * attr_name, CORBA::Any_out ret_attr , CdmwPlatformMngt::Owner flag)  
    throw (CORBA::SystemException, CdmwPlatformMngt::AttributeNotFound);

    CdmwPlatformMngt::Entity_ptr get_entity (const char* entity_name)
    throw( CdmwPlatformMngt::EntityNotFound,
            CORBA::SystemException );

private:

        CORBA::UShort m_attr_value; 
        FakeEntity * m_entity;
        FakeComponent * m_comp;
            
};

};
};



#endif /*FAKEProcess_impl_HPP_*/
