# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================
eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
    & eval 'exec perl -S $0 $argv:q'
    if 0;

use lib "$ENV{ACE_ROOT}/bin";
use lib "$ENV{CDMW_HOME}/Build/testautomation";
use File::Basename;
use Cwd;
use PerlACE::Run_Test;
use TestUtils;

# This is a Perl script that tests SystemMngt/testentitynavigability
                
$test_id = "U-SMG-0023";
$test_exec = "start_test_entity_nav.sh";
@needed_files = (cwd()."/SystemDefinition.xml",
                 cwd()."/cdmw_test_entity_nav",
                 cwd()."/../../platformftsystem/testFTSupervision/CdmwFTSystemMngtGroupCreator_conf.xml",
                 cwd()."/../../platformftsystem/testFTSupervision/CdmwFaultToleranceManager_conf.xml",
                 cwd()."/../../platforminterface/testmanagedprocess/cdmw_test_managed_process",
                 $ENV{CDMW_HOME}."/bin/cdmw_platform_daemon.sh",      
                 $ENV{CDMW_HOME}."/share/CdmwSystemMngtDatastoreConfig.xml", 
                 $ENV{CDMW_HOME}."/share/CdmwSystemMngtDatastore_Desc.dtd",
                 $ENV{CDMW_HOME}."/share/CdmwPlatformMngtDaemon_conf.xml",
                 $ENV{CDMW_HOME}."/share/CdmwPlatformMngtSystem.dtd",
                 $ENV{CDMW_HOME}."/share/CdmwPlatformMngtDaemon.dtd",
                 $ENV{CDMW_HOME}."/share/CdmwFaultToleranceManager.dtd",
                 $ENV{CDMW_HOME}."/bin/cdmw_platform_supervision",
                 $ENV{CDMW_HOME}."/bin/cdmw_platform_admin",               
                 $ENV{CDMW_HOME}."/bin/cdmw_ft_manager");
$XML_results = "cdmw_test_entity_nav_test_results.xml";
@processes_to_kill = ($test_exec, "cdmw_platform_supervision", "cdmw_platform_admin",
                      "cdmw_platform_daemon.sh",  "cdmw_test_entity_nav", "cdmw_platform_daemon",  
                      "-signal 9 cdmw_ft_manager","cdmw_test_managed_process",                  
                      "output_redirection.sh");
@files_to_move = ($XML_results, "CdmwDaemon.log" , "CdmwDaemon.ior", 
                  "SystemDefinition.xml", "CdmwFTSystemMngtGroupCreator_conf.xml");
$max_wait_time=180 ;
$nbtestable=1 ;
$expected_status=0;

#creating folders and removing old test results
TestUtils::prepareDirectoryStructureForUnitTest($test_id);

#creating soft links for needed files
$runtest_path = "runtest/".$test_id."/";
symlink cwd()."/".$test_exec, $runtest_path.$test_exec;
foreach $from_file (@needed_files)
{
    $to_file = basename $from_file;
    symlink $from_file, $runtest_path.$to_file;
}

PerlACE::add_lib_path(cwd()."/".$runtest_path);
chdir $runtest_path;
 
# replace environment variables in linked files
$replace_cmd = "$ENV{CDMW_HOME}/Build/scripts/replace_environment.sh";
$replace_dir = ".";
if (PerlACE::is_vxworks_test()) 
         {$test = new PerlACE::ProcessVX ($replace_cmd, $replace_dir); }
else     {$test = new PerlACE::Process   ($replace_cmd, $replace_dir); }
$status = $test->SpawnWaitKill(10);


$status = 0;
system("chmod +x *.sh");

#create test process
$redirect = "$ENV{CDMW_HOME}/Build/testautomation/output_redirection.sh";
$cmnd = "$test_exec $test_args 2>&1 | tee results/output.txt" ;
if (PerlACE::is_vxworks_test()) 
         {$test = new PerlACE::ProcessVX ($redirect, $cmnd); }
else     {$test = new PerlACE::Process   ($redirect, $cmnd); }
#run process and wait for test finishes
$status = $test->SpawnWaitKill($max_wait_time);
sleep(3);

#move temprorary and log files to results dir
foreach $file (@files_to_move)
{
    TestUtils::moveFileToResults($file);
}

#open file to write result of test
open (RES, '>>results/result.txt');

#check returned value of test
if ($status != $expected_status )
{
    print RES "ERROR: test returned $status\n";
    $status = 1;
}
else
{
    $status = 0;
}

#check results in XML file
if ($status == 0)
{    
    $checkXML_result = TestUtils::checkXML("results/".$XML_results);
    if ($checkXML_result ne "")
    {
        print RES $checkXML_result;
        $status = 1;
    }
}

#check existence of output.txt
if (!-e "results/output.txt")
{
    print RES "ERROR: output.txt file does not exist\n";
    $status = 1;
}

#check results in test output
if ($status == 0)
{
    if (TestUtils::checkForMessage("results/output.txt", "TESTABLE_OK") != $nbtestable )
    {
        print RES "ERROR: Incorrect count of TESTABLE_OK in log of test\n";
        $status = 1;
    }
}

#check for errors in test output
if ($status == 0)
{
    if (TestUtils::checkForErrorMessages("results/output.txt") > 0)
    {
        print RES "ERROR: There is an error in log of test\n";
	$status = 1;
    }
}

if ($status == 0)
{
    print RES "Test OK\n";    
}
else
{
    print RES "Test FAILED\n";    
}
close(RES);

#kill processes
foreach $process (@processes_to_kill)
{
    system("killall -q $process");
}

exit $status;
