/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2009-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
#include "testhoststatemachine/FakeHost_impl.hpp"

namespace Cdmw
{
namespace PlatformMngt
{

Host_impl::Host_impl()
    : m_hot_reboot_called(false), 
    m_start_processes_called(false),
    m_stop_processes_called(false),
    m_notify_status_change_called(false),
    m_set_restart_attempt_called(false)
{ 
}

void Host_impl::hot_reboot()
{ 
    std::cerr << "Host_impl::hot_reboot() called" << std::endl;
    m_hot_reboot_called = true;
}

void Host_impl::start_processes()
{ 
    std::cerr << "Host_impl::start_processes() called" << std::endl;
    m_start_processes_called = true;
}

void Host_impl::stop_processes()
{ 
    std::cerr << "Host_impl::stop_processes() called" << std::endl;
    m_stop_processes_called = true;
}

void Host_impl::notify_status_change()
{ 
    std::cerr << "Host_impl::notify_status_change() called" << std::endl;
    m_notify_status_change_called = true;
}

void Host_impl::set_restart_attempt(long current_restart_attempt)
{
    std::cerr << "Host_impl::set_restart_attempt() called" << std::endl;
    m_set_restart_attempt_called = true;
}

bool Host_impl::hot_reboot_called()
{
    bool ret = m_hot_reboot_called;
    m_hot_reboot_called = false;
    return ret;
}

bool Host_impl::start_processes_called()
{
    bool ret = m_start_processes_called;
    m_start_processes_called = false;
    return ret;
    
}

bool Host_impl::stop_processes_called()
{
    bool ret = m_stop_processes_called;
    m_stop_processes_called = false;
    return ret;
    
}

bool Host_impl::notify_status_change_called()
{
    bool ret = m_notify_status_change_called;
    m_notify_status_change_called = false;
    return ret;
    
}

bool Host_impl::set_restart_attempt_called()
{
    bool ret = m_set_restart_attempt_called;
    m_set_restart_attempt_called = false;
    return ret;
}


}
}









