#!/bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

#!/bin/sh

my_script=`basename $0`

## Usage
usage() {
    msg="usage: $my_script"
    echo "$msg"
    echo "options:"
    echo "    1 The number of the user-defined property."
    echo "       Used to define and delete the user-defined properties at run-time "
    echo "    2 The value (in ms) of period."
    echo "       Used to register the periodic observer"
    echo "    3 The value (in ms) to kill the primary supervision."
    echo "        Used to verify the change of supervision mastership."
    exit 1
}

if  [ "$1" == "usage" ]; then usage
fi

#This test is associated to V-SMG-047-1.xml

test_periodic_attribute_management --userdef_num=6 --period=2000 --kill_sup=0