#!/bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================


my_script=`basename $0`
val='10'

## Usage
usage() {
    msg="usage: $my_script"
    echo "$msg"
    echo "options:"
    echo "    -d The value (in ms) of the standard deviation from the average."
    echo "       Used to bound the error"
    exit 1
}

if  [ "$1" == "" ]; then
  echo "The deviation default value is 10 ms "
fi

if  [ "$1" == "usage" ]; then usage
fi

if [ "$1" == '-d' ] ;then
    if [ "$2" != "" ];then
        val=$2
    else usage;
    fi
fi

test_timeout_applications --deviation=$val --applications APPL1=500,APPL2,APPL3 APPL2=3000,APPL4 APPL3=1000,APPL4 APPL4=0,0
