#!/bin/sh
# =====================================================================
# This file is part of MOSIC (R). MOSIC is a System@tic project.
# 
# MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
# developed by THALES and SELEX SISTEMI INTEGRATI.
# CARDAMOM is derivative work based on PERCO.
# Copyright (C) THALES 2009-2010. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
# License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

#!/bin/sh

my_script=`basename $0`
val='200'

## Usage
usage() {
    msg="usage: $my_script"
    echo "$msg"
    echo "options:"
    echo "    -d The value (in ms) of the standard deviation from the average."
    echo "       Used to bound the error"
    exit 1
}

if  [ "$1" == "" ]; then
  echo "The daviation default value is 200 ms "
fi

if  [ "$1" == "usage" ]; then usage
fi

if [ "$1" == '-d' ] ;then
    if [ "$2" != "" ];then
        val=$2
    else usage;
    fi
fi

#The parameters P1 P2...P5 indicates the value of initialisation timeout (ms) associated to the respective process
#These value "must" be equal to the values reported in V-SMG-051-1.xml

test_unmanaged_init_timeout --deviation=$val P1=0 P2=1000 P3=0 P4=2000 P5=1000