/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccm.ccmcopi;

import org.omg.CORBA.LocalObject;
import org.omg.Components.ContainerPortableInterceptor.ContainerRequestInfo;

/**
 *
 */
public class ContainerRequestInfoImpl extends LocalObject implements
        ContainerRequestInfo {
    
    private String name;
    private byte[] origin_id;
    private byte[] target_id;
    
    
 
    public ContainerRequestInfoImpl(String name, byte[] origin_id,
            byte[] target_id) {
        this.name = name;
        this.origin_id = origin_id;
        this.target_id = target_id;
    }


    public String name() {
        return this.name;
    }


    public byte[] origin_id() {
        return this.origin_id;
    }

 
    public byte[] target_id() {
        return this.target_id;
    }
    
/**
 * Non standard setters of the origin_id and target_id
 */
    public void setOrigin_id(byte[] id) {
        this.origin_id = id;
    }

    public void setTarget_id(byte[] id) {
        this.target_id = id;
    }

}
