/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccm.container;

import org.omg.CORBA.LocalObject;
import org.omg.CORBA.Object;
import org.omg.Components.CCMException;
import org.omg.Components.ConfigValue;

import com.thalesgroup.CdmwCcmContainer.ApplicationElementContext;
import com.thalesgroup.CdmwCcmContainer.ApplicationElementContextService;
import com.thalesgroup.CdmwCcmContainer.ComponentElementContext;
import com.thalesgroup.CdmwCcmContainer.HomeElementContext;

/**
 *
 */
public class ApplicationElementContextImpl extends LocalObject implements
        ApplicationElementContext{

 
    private ConfigValue[] configuration;
    private String id ;
    private org.omg.CORBA.Object ref;
    

    public ApplicationElementContextImpl(ConfigValue[] configuration,
            String id, Object ref) {
        this.configuration = configuration;
        this.id = id;
        this.ref = ref;
    }
    
    public ApplicationElementContextImpl(){
        
    }
    
    public ConfigValue[] configuration() {
        return this.configuration;
    }

    public String id() {
        return this.id;
    }

    public Object ref() {
        return this.ref;
    }

    protected void setConfiguration(ConfigValue[] configuration) {
        this.configuration = configuration;
    }

    protected void setId(String id) {
        this.id = id;
    }

    protected void setRef(org.omg.CORBA.Object ref) {
        this.ref = ref;
    }
    
    


}
