/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package cdmw.ccm.qosenablers.dds;

import org.omg.CORBA.NO_IMPLEMENT;
import org.omg.DDS.ContentFilteredTopic;
import org.omg.DDS.DomainParticipantListener;
import org.omg.DDS.DomainParticipantQos;
import org.omg.DDS.DomainParticipantQosHolder;
import org.omg.DDS.Duration_t;
import org.omg.DDS.MultiTopic;
import org.omg.DDS.Publisher;
import org.omg.DDS.PublisherListener;
import org.omg.DDS.PublisherQos;
import org.omg.DDS.PublisherQosHolder;
import org.omg.DDS.StatusCondition;
import org.omg.DDS.Subscriber;
import org.omg.DDS.SubscriberListener;
import org.omg.DDS.SubscriberQos;
import org.omg.DDS.SubscriberQosHolder;
import org.omg.DDS.Topic;
import org.omg.DDS.TopicDescription;
import org.omg.DDS.TopicListener;
import org.omg.DDS.TopicQos;
import org.omg.DDS.TopicQosHolder;
import org.omg.CCM_DDS.InternalError;

import DDS.ANY_STATUS;
import DDS.DomainParticipantFactory;
import DDS.PARTICIPANT_QOS_DEFAULT;

/**
 *
 */
public class DomainParticipantImpl extends org.omg.CORBA.LocalObject implements
        org.omg.DDS.DomainParticipant {

    DDS.DomainParticipant participant;

    DomainParticipantFactory dpf;

    protected DomainParticipantImpl(String domainId,
            DDS.DomainParticipantQos qos) throws InternalError {
        System.out.println("Creating the DomainParticipant ...");
        dpf = DomainParticipantFactory.get_instance();
        ErrorHandler.checkHandle(dpf,
                "DDS.DomainParticipantFactory.get_instance");

        if (qos == null) {
            participant = dpf.create_participant(domainId,
                    PARTICIPANT_QOS_DEFAULT.value, null, ANY_STATUS.value);
        } else
            participant = dpf.create_participant(domainId, qos, null,
                    ANY_STATUS.value);

        ErrorHandler.checkHandle(participant,
                "DDS.DomainParticipantFactory.create_participant");
    }

    public void remove() throws org.omg.CCM_DDS.InternalError{
        int status = dpf.delete_participant(participant);
        ErrorHandler.checkStatus(status, "deleting the DomainParticipant");
    }

    public int assert_liveliness() {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public ContentFilteredTopic create_contentfilteredtopic(String arg0,
            Topic arg1, String arg2, String[] arg3) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public MultiTopic create_multitopic(String arg0, String arg1, String arg2,
            String[] arg3) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public Publisher create_publisher(PublisherQos qos,
            PublisherListener listener, int mask) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public Subscriber create_subscriber(SubscriberQos arg0,
            SubscriberListener arg1, int arg2) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public Topic create_topic(String arg0, String arg1, TopicQos arg2,
            TopicListener arg3, int arg4) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int delete_contained_entities() {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int delete_contentfilteredtopic(ContentFilteredTopic arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int delete_multitopic(MultiTopic arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int delete_publisher(Publisher arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int delete_subscriber(Subscriber arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int delete_topic(Topic arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public Topic find_topic(String arg0, Duration_t arg1) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public Subscriber get_builtin_subscriber() {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int get_default_publisher_qos(PublisherQosHolder h) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int get_default_subscriber_qos(SubscriberQosHolder arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int get_default_topic_qos(TopicQosHolder arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public String get_domain_id() {
        return this.participant.get_domain_id();
    }

    public DomainParticipantListener get_listener() {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int get_qos(DomainParticipantQosHolder arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int ignore_participant(long handle) {
        return this.participant.ignore_participant(handle);
    }

    public int ignore_publication(long handle) {
        return this.participant.ignore_publication(handle);
    }

    public int ignore_subscription(long handle) {
        return this.participant.ignore_subscription(handle);
    }

    public int ignore_topic(long handle) {
        return this.participant.ignore_topic(handle);
    }

    public TopicDescription lookup_topicdescription(String arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int set_default_publisher_qos(PublisherQos arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int set_default_subscriber_qos(SubscriberQos arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int set_default_topic_qos(TopicQos arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int set_listener(DomainParticipantListener arg0, int arg1) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int set_qos(DomainParticipantQos arg0) {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

    public int enable() {
        return this.participant.enable();
    }

    public int get_status_changes() {
        return this.participant.get_status_changes();
    }

    public StatusCondition get_statuscondition() {
        throw new NO_IMPLEMENT(
                "There is no CORBA implementation for this method !");
    }

}
