/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */



///// FILE TO BE GENERATED


#ifndef __INCL_CCMCOF_RECEPTACLE_FACETTEST_IMPL_HPP__
#define __INCL_CCMCOF_RECEPTACLE_FACETTEST_IMPL_HPP__

#include "Cdmw_TestComponents_cif.skel.hpp"
#include "Hello_impl.hpp"    

   
#include <Foundation/orbsupport/RefCountServantBase.hpp>
#include <Foundation/logging/CdmwLogging.stub.hpp>
#include <CCMContainer/ccmcif/LifeCycleObjectBase.hpp>

#include "hello_cif.stub.hpp"
   

namespace Cdmw {

namespace CCM {

namespace CIF {

namespace CdmwTestComponents {


class ReceptacleFacetTest_impl : 
        virtual public ::CORBA::LocalObject,
        virtual public ::TestComponents::CCM_FacetTest
        //virtual public OrbSupport::RefCountServantBase
{
public:

    ReceptacleFacetTest_impl
    (
     const ::std::string & receptacle_name,
     const ::std::string & component_id,
     ::CORBA::Object_ptr facet_object,
     ::Cdmw::CCM::CIF::Context * context,
     CdmwLogging::Logger_ptr     logger
     );
    
    ~ReceptacleFacetTest_impl() throw();
                        

    virtual
    void raiseException (
                         ::CORBA::Boolean raise,
                         const char * reason
                         )
        throw (
               ::CORBA::SystemException,
               ::TestComponents::ExceptionTest
               );
  
    virtual
    ::CORBA::Long makeOperation (
                                 ::TestComponents::ArithOperator oper,
                                 ::CORBA::Long operand1,
                                 ::CORBA::Long operand2,
                                 ::CORBA::Long_out remainder
                                 )
        throw (
               ::CORBA::SystemException,
               ::TestComponents::ExceptionTest
               );

             

private:
    ReceptacleFacetTest_impl(const ReceptacleFacetTest_impl&);
    void operator=(const ReceptacleFacetTest_impl&);

    const std::string m_receptacle_name;    
    const std::string m_component_identity;
    ::CORBA::Object_var m_facet_object;
    ::Cdmw::CCM::CIF::Context * m_context;   
    ::CdmwLogging::Logger_ptr m_logger;
};

   
} // end of namespace Cdmw

} // end of namespace CCM

} // end of namespace CIF

} // end of namespace CdmwTestComponents

#endif // __INCL_CCMCOF_RECEPTACLE_FACETTEST_IMPL_HPP__
