package cdmw.ccm.testqosenabler_dds4ccm;


import org.omg.CORBA.LocalObject;
import org.omg.CORBA.Object;

import DDS.ANY_SAMPLE_STATE;
import DDS.ANY_VIEW_STATE;
import DDS.LENGTH_UNLIMITED;
import DDS.SampleInfoSeqHolder;

import org.omg.CCM_DDS.AlreadyCreated;
import org.omg.CCM_DDS.DDSEntityKind;
import org.omg.CCM_DDS.InternalError;
import org.omg.CCM_DDS.NoSuchDDSEntity;
import org.omg.CCM_DDS.NonExistent;


import com.acme.Hello.CCM_Donnee_Updater;
import com.acme.Hello.Donnee;
import com.acme.Hello.DonneeDataReader;
import com.acme.Hello.DonneeDataWriter;
import com.acme.Hello.DonneeSeqHolder;


public class Donnee_UpdaterFacetImpl extends LocalObject implements CCM_Donnee_Updater {


    private DonneeDataWriter writer;
    private DonneeDataReader reader;
    private boolean is_lifecycle_checked = true;



    public Donnee_UpdaterFacetImpl(DonneeDataWriter talker,
            DonneeDataReader donneeReader) {
        this.writer = talker;
        this.reader = donneeReader;
    }


    public void create(Donnee an_instance) throws AlreadyCreated, InternalError {

        int status;

        if(this.is_lifecycle_checked) {

            DonneeSeqHolder msgSeq = new DonneeSeqHolder();
            SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();

            long handle = reader.lookup_instance(an_instance);

            if(handle != DDS.HANDLE_NIL.value) {
                
                status = reader.read_instance( 
                        msgSeq, 
                        infoSeq,
                        LENGTH_UNLIMITED.value, handle,
                        ANY_SAMPLE_STATE.value, 
                        ANY_VIEW_STATE.value, 
                        DDS.ALIVE_INSTANCE_STATE.value | DDS.NOT_ALIVE_NO_WRITERS_INSTANCE_STATE.value);

                if(status == DDS.RETCODE_OK.value) {
                    throw new AlreadyCreated();
                } else if(status != DDS.RETCODE_NO_DATA.value) {
                    InternalError e = new InternalError();
                    e.error_code = status;
                    throw e;
                }
            }

        }

        status = writer.write(an_instance, DDS.HANDLE_NIL.value);

        if(status != DDS.RETCODE_OK.value) {
            InternalError e = new InternalError();
            e.error_code = status;
            throw e;
        }



    }

    
    public void update(Donnee an_instance) throws NonExistent, InternalError {

        int status;

        if(this.is_lifecycle_checked) {

            DonneeSeqHolder msgSeq = new DonneeSeqHolder();
            SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();

            long handle = reader.lookup_instance(an_instance);

            if(handle != DDS.HANDLE_NIL.value) {

                status = reader.read_instance( 
                        msgSeq, 
                        infoSeq,
                        LENGTH_UNLIMITED.value, handle,
                        ANY_SAMPLE_STATE.value, 
                        ANY_VIEW_STATE.value, 
                        DDS.ALIVE_INSTANCE_STATE.value  | DDS.NOT_ALIVE_NO_WRITERS_INSTANCE_STATE.value);

                if(status == DDS.RETCODE_NO_DATA.value) {
                    throw new NonExistent();
                } else if(status != DDS.RETCODE_OK.value) {
                    InternalError e = new InternalError();
                    e.error_code = status;
                    throw e;
                }    

            } else {
                throw new NonExistent();
            }

        }

        status = writer.write(an_instance, DDS.HANDLE_NIL.value);

        if(status != DDS.RETCODE_OK.value) {
            InternalError e = new InternalError();
            e.error_code = status;
            throw e;
        }

    }


    public void delete(Donnee an_instance) throws NonExistent, InternalError {

        int status;

        if(this.is_lifecycle_checked) {

            DonneeSeqHolder msgSeq = new DonneeSeqHolder();
            SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();

            long handle = reader.lookup_instance(an_instance);

            if(handle != DDS.HANDLE_NIL.value) {

                status = reader.read_instance( 
                        msgSeq, 
                        infoSeq,
                        LENGTH_UNLIMITED.value, handle,
                        ANY_SAMPLE_STATE.value, 
                        ANY_VIEW_STATE.value, 
                        DDS.ALIVE_INSTANCE_STATE.value  | DDS.NOT_ALIVE_NO_WRITERS_INSTANCE_STATE.value);

                if(status == DDS.RETCODE_NO_DATA.value) {
                    throw new NonExistent();
                } else if(status != DDS.RETCODE_OK.value) {
                    InternalError e = new InternalError();
                    e.error_code = status;
                    throw e;
                }    

            } else {
                throw new NonExistent();
            }

        }

        status = writer.dispose(an_instance, DDS.HANDLE_NIL.value);

        if(status != DDS.RETCODE_OK.value) {
            InternalError e = new InternalError();
            e.error_code = status;
            throw e;
        }

    }



    public boolean is_lifecycle_checked() {
        return this.is_lifecycle_checked;
    }


    public Object getDDSEntity(DDSEntityKind arg0) throws NoSuchDDSEntity {
        // TODO Auto-generated method stub
        return null;
    }


}
