/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2000-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */


package cdmw.ccm.testqosenabler_recording;

//
// IDL:thalesgroup.com/RecordingTest/CCM_FacetTest:1.0
//
public class CCMFacetTestImpl extends org.omg.CORBA.LocalObject
    implements com.acme.RecordingTest.CCM_FacetTest {

    public CCMFacetTestImpl() {}

    //
    // IDL:thalesgroup.com/RecordingTest/FacetTest/sleep:1.0
    //
    public void sleep(int time_in_sec) {
        try {
            Thread.sleep(time_in_sec * 1000);
        } catch (InterruptedException e) {
            // ignore
        }

        System.out.println("RecordingTest::CCM_FacetTest_impl::sleep called!");
    }

    //
    // IDL:thalesgroup.com/RecordingTest/FacetTest/shutdown:1.0
    //
    public void shutdown() {
    }

    public void print(String msg){
        System.out.println("########### a Client sent me this message : "+msg);
    }
}

