/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2009-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package com.acme.Hello;

import org.omg.CCM_DDS.ListenerControl;
import org.omg.CORBA.Object;
import org.omg.Components.CCMException;
import org.omg.Components.EnterpriseComponent;
import org.omg.Components.SessionContext;

import com.acme.Hello.CCM_Donnee_RawListener;
import com.acme.Hello.CCM_Get_Donnee;
import com.acme.Hello.CCM_Send_Donnee;
import com.thalesgroup.UserHello.User_Composant;

public class ComposantExecutorImpl extends org.omg.CORBA.LocalObject implements
        User_Composant {

    private com.acme.Hello.CCM_Composant_Context sessionContext;

    private com.acme.Hello.Donnee_Writer p_Write_data;
//    private com.generated.DDS.DataWriter p_Write_dds_entity;
    private com.acme.Hello.CCM_Send_Donnee send_donnee;

    private com.acme.Hello.Donnee_Getter p_Get_data;
    private com.acme.Hello.CCM_Get_Donnee get_donnee;

    private com.acme.Hello.Donnee_Reader p_Composant_data;
    private ListenerControl p_Composant_control;
    private com.acme.Hello.CCM_Donnee_RawListener p_Composant_listener;
    //private CCM_Read_Donnee read_donnee;

    public ComposantExecutorImpl() {
        p_Composant_listener = new RawListenerFacetImpl();
    }

    /*
     * @Override public CCM_ConnectorStatusListener get_error_listener() {
     * return this.error_listener; }
     */

    public CCM_Send_Donnee get_send_donnee() {
        return this.send_donnee;
    }

    public CCM_Get_Donnee get_get_donnee() {
        return this.get_donnee;
    }

    public CCM_Donnee_RawListener get_p_Composant_listener() {
        return this.p_Composant_listener;
     }

    public void ccm_activate() throws CCMException {

        System.out.println("===> ccm_activate called!");

        try {
            System.out.println("Get connection to the Write port ...");
            p_Write_data = sessionContext.get_connection_p_Write_data();
            //this.send_donnee = new Send_DonneeImpl(p_Write_data);

            System.out.println("Get connection to the Get port...");
            p_Get_data = sessionContext.get_connection_p_Get_data();
            //this.get_donnee = new Get_DonneeImpl(p_Get_data);
            
            p_Composant_data = sessionContext.get_connection_p_Composant_data();
            
            p_Composant_control = sessionContext.get_connection_p_Composant_control();
                                    
            Demo demo = new Demo(p_Write_data, p_Get_data, p_Composant_data, p_Composant_control);
            Thread t = new Thread(demo);
            t.start();
            
            

        } catch (Exception e) {
            System.out.println("Unexpected exception raised!\n" + e.toString());
        }

    }

    public void ccm_passivate() throws CCMException {
        // TODO Auto-generated method stub

    }

    public void ccm_remove() throws CCMException {
        // TODO Auto-generated method stub

    }

    public void set_session_context(SessionContext ctx) throws CCMException {
        sessionContext = com.acme.Hello.CCM_Composant_ContextHelper
                .narrow((Object) ctx);
    }

}
