/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2009-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package com.acme.Hello;

import java.util.ArrayList;
import java.util.List;

import org.omg.CORBA.LocalObject;

import DDS.ConditionSeqHolder;
import DDS.Duration_t;
import DDS.LENGTH_UNLIMITED;
import DDS.RETCODE_OK;
import DDS.ReadCondition;
import DDS.SampleInfo;
import DDS.SampleInfoSeqHolder;
import DDS.WaitSet;

import org.omg.CCM_DDS.AccessStatus;
import org.omg.CCM_DDS.BadParameter;
import org.omg.CCM_DDS.InstanceStatus;
import org.omg.CCM_DDS.NonExistent;
import org.omg.CCM_DDS.QueryFilter;
import org.omg.CCM_DDS.ReadInfo;
import org.omg.CCM_DDS.ReadInfoHolder;
import org.omg.CCM_DDS.ReadInfoSeqHolder;
import org.omg.CCM_DDS.InternalError;

import static cdmw.ccm.qosenablers.dds.DataUtil.*;
import cdmw.ccm.qosenablers.dds.DDS_GetterImpl;
import cdmw.ccm.qosenablers.dds.DataSeqHolder;

public class Donnee_GetterFacetImpl extends DDS_GetterImpl implements
        CCM_Donnee_Getter {

//    private QueryFilter filter;
//    private Duration_t time_out = new Duration_t();
    private DonneeDataReader reader;
//    private WaitSet waits;
//    private ReadCondition readCond;
//    private ReadCondition userQuery;

    public Donnee_GetterFacetImpl(DonneeDataReader donneeReader) {
        super(donneeReader);
        this.reader = donneeReader;
//        waits = new WaitSet();
//
//        readCond = reader.create_readcondition(DDS.NOT_READ_SAMPLE_STATE.value,
//                DDS.NEW_VIEW_STATE.value | DDS.NOT_NEW_VIEW_STATE.value,
//                DDS.ALIVE_INSTANCE_STATE.value
//                        | DDS.NOT_ALIVE_INSTANCE_STATE.value);
//        if (readCond == null) {
//            System.out.println("Error on create_readcondition");
//            System.exit(-1);
//        }
//
//        userQuery = readCond;
//
//        int status = waits.attach_condition(readCond);
//        if (status != RETCODE_OK.value) {
//            System.out.println("Error on attach_condition : " + status);
//            System.exit(-1);
//        }

    }

//    public QueryFilter filter() {
//        return this.filter;
//    }
//
//    public void set_filter(QueryFilter arg) throws BadParameter {
//        if (arg == null) {
//            throw new BadParameter();
//        } else {
//            if (arg.query == null) {
//                throw new BadParameter();
//            } else {
//                if (arg.query == "") {
//                    userQuery = readCond;
//                } else {
//                    if (arg.query_parameters == null) {
//                        throw new BadParameter();
//                    } else {
//                        this.filter = arg;
//                        userQuery = reader.create_querycondition(
//                                DDS.NOT_READ_SAMPLE_STATE.value,
//                                DDS.NEW_VIEW_STATE.value
//                                        | DDS.NOT_NEW_VIEW_STATE.value,
//                                DDS.ALIVE_INSTANCE_STATE.value
//                                        | DDS.NOT_ALIVE_INSTANCE_STATE.value,
//                                filter.query, filter.query_parameters);
//                        if (userQuery == null) {
//                            throw new BadParameter();
//                        }
//                    }
//                }
//            }
//        }
//
//    }

//    private void fillReadInfo(SampleInfo sampleInfo, ReadInfo readInfo) {
//
//        if (sampleInfo.sample_state == DDS.NEW_VIEW_STATE.value) {
//            readInfo.access_status = AccessStatus.FRESH_INFO;
//        } else {
//            readInfo.access_status = AccessStatus.ALREADY_SEEN;
//        }
//
//        if (sampleInfo.instance_state == DDS.NOT_ALIVE_NO_WRITERS_INSTANCE_STATE.value
//                || sampleInfo.instance_state == DDS.NOT_ALIVE_DISPOSED_INSTANCE_STATE.value) {
//            readInfo.instance_status = InstanceStatus.INSTANCE_DELETED;
//        }
//
//        if (sampleInfo.view_state == DDS.NEW_VIEW_STATE.value) {
//            readInfo.instance_status = InstanceStatus.INSTANCE_CREATED;
//        }
//
//        if (sampleInfo.sample_state == DDS.NOT_READ_SAMPLE_STATE.value
//                && sampleInfo.valid_data == true
//                && sampleInfo.instance_state == DDS.ALIVE_INSTANCE_STATE.value) {
//            readInfo.instance_status = InstanceStatus.INSTANCE_UPDATED;
//        }
//
//        readInfo.instance_rank = sampleInfo.generation_rank;
//        readInfo.timestamp = sampleInfo.source_timestamp;
//
//    }


    /**
     * returns for all the instances their last sample
     */
    public boolean get_all(DonneeSeqHolder instances, ReadInfoSeqHolder infos)
            throws InternalError {
        Exception exp = null;

        try{
        try{
            initData(new DataSeqHolder<Donnee, DonneeSeqHolder>(Donnee[].class, instances), infos, null);
            super.waitData();
        }catch(InternalError e){
            if(e.error_code == DDS.RETCODE_TIMEOUT.value) return false;
            else throw e;
        }

        SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
        int status = reader.read_w_condition(instances, infoSeq,
                LENGTH_UNLIMITED.value, this.userQuery);

        return getAll(new DataSeqHolder<Donnee, DonneeSeqHolder>(Donnee[].class, instances), infos,
                infoSeq.value, status);

        }catch(Exception e){
            exp = e;
        }

        throw new InternalError("Operation Failed: "+ exp.getMessage(), DDS.RETCODE_ERROR.value, 0);

        ///
//        ConditionSeqHolder condList = new ConditionSeqHolder();
//
//        int status = waits._wait(condList, time_out);

//        if (status == RETCODE_OK.value && condList.value[0] == readCond) {

 /*           SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();

            status = reader.read_w_condition(instances, infoSeq,
                    LENGTH_UNLIMITED.value, this.userQuery);
*/
 /*           if (status != RETCODE_OK.value) {
                InternalError e = new InternalError();
                e.error_code = status;
                e.index = 0;
                throw e;
            }

            List<SampleInfo> listLastSampleInfo = new ArrayList<SampleInfo>();
            List<Donnee> listLastSample = new ArrayList<Donnee>();

            for (int i = 0; i < infoSeq.value.length; i++) {
                if (infoSeq.value[i].sample_rank == 0) {
                    listLastSampleInfo.add(infoSeq.value[i]);
                    listLastSample.add(instances.value[i]);
                } else {
                    i = i - 1 + infoSeq.value[i].sample_rank;
                }
            }

            instances.value = new Donnee[listLastSample.size()];
            infos.value = new ReadInfo[listLastSample.size()];

            for (int i = 0; i < listLastSampleInfo.size(); i++) {
                infos.value[i] = new ReadInfo();
                fillReadInfo(listLastSampleInfo.get(i), infos.value[i]);
                if (listLastSampleInfo.get(i).valid_data) {
                    instances.value[i] = listLastSample.get(i);
                }
            }
            return true;*/

   /*     } else {

            if (status == DDS.RETCODE_TIMEOUT.value) {
                return false;
            } else {
                InternalError e = new InternalError();
                e.error_code = DDS.RETCODE_ERROR.value;
                e.index = status;
                throw e;
            }
        }
*/
    }

    /**
     * returns all the samples of all instances
     * @param instances
     * @param infos
     * @return
     * @throws InternalError
     */
    public boolean get_all_history(DonneeSeqHolder instances,
            ReadInfoSeqHolder infos) throws InternalError {
        Exception exp = null;

        try{
        try{
            initData(new DataSeqHolder<Donnee, DonneeSeqHolder>(Donnee[].class, instances), infos, null);
            waitData();
        }catch(InternalError e){
            if(e.error_code == DDS.RETCODE_TIMEOUT.value) return false;
            else throw e;
        }
        SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
        int status = reader.read_w_condition(instances, infoSeq,
                LENGTH_UNLIMITED.value, this.userQuery);

        return getAllHistory(new DataSeqHolder<Donnee, DonneeSeqHolder>(Donnee[].class, instances), infos,
                infoSeq.value, status);
        }catch(Exception e){
            exp = e;
        }

        throw new InternalError("Operation Failed: "+ exp.getMessage(), DDS.RETCODE_ERROR.value, 0);



 /*       ConditionSeqHolder condList = new ConditionSeqHolder();

        int status = waits._wait(condList, time_out);

        if (status == RETCODE_OK.value && condList.value[0] == readCond) {

            SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();

            status = reader.read_w_condition(instances, infoSeq,
                    LENGTH_UNLIMITED.value, this.userQuery);

            if (status != RETCODE_OK.value) {
                InternalError e = new InternalError();
                e.error_code = status;
                e.index = 0;
                throw e;
            }

            infos.value = new ReadInfo[infoSeq.value.length];

            for (int i = 0; i < infos.value.length; i++) {
                infos.value[i] = new ReadInfo();
                fillReadInfo(infoSeq.value[i], infos.value[i]);
            }

            return true;
        }

        if (status == DDS.RETCODE_TIMEOUT.value) {
            return false;
        } else {
            InternalError e = new InternalError();
            e.error_code = status;
            e.index = 0;
            throw e;
        }*/

    }

    /**
     * returns each read sample one by one
     * @param an_instance
     * @param info
     * @return
     * @throws InternalError
     */
    public boolean get_next(DonneeHolder an_instance, ReadInfoHolder info)
            throws InternalError {
        Exception exp = null;

        try{
        try{
            initData(new DataSeqHolder<Donnee, DonneeHolder>(an_instance, Donnee.class), null, info);
            waitData();
        }catch(InternalError e){
            if(e.error_code == DDS.RETCODE_TIMEOUT.value) return false;
            else throw e;
        }
        SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
        DonneeSeqHolder instance = new DonneeSeqHolder();
        int status = reader.read_w_condition(instance, infoSeq, 1, this.userQuery);

        //FIXME:do we keep this
        if (infoSeq.value[0].valid_data) {
            an_instance.value = instance.value[0];
        }
        return getNext(info, infoSeq.value, status);
        }catch(Exception e){
            exp = e;
        }

        throw new InternalError("Operation Failed: "+ exp.getMessage(), DDS.RETCODE_ERROR.value, 0);


 /*       ConditionSeqHolder condList = new ConditionSeqHolder();

        int status = waits._wait(condList, time_out);

        if (status == RETCODE_OK.value && condList.value[0] == readCond) {

            DonneeSeqHolder tmp = new DonneeSeqHolder();
            SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();

            status = reader.read_w_condition(tmp, infoSeq, 1, this.userQuery);

            if (tmp.value.length != 1) {
                InternalError e = new InternalError();
                throw e;
            }

            if (status != RETCODE_OK.value) {
                InternalError e = new InternalError();
                e.error_code = status;
                e.index = 0;
                throw e;
            }

            info.value = new ReadInfo();

            fillReadInfo(infoSeq.value[0], info.value);

            if (infoSeq.value[0].valid_data) {
                an_instance.value = tmp.value[0];
            }

            return true;
        }

        if (status == DDS.RETCODE_TIMEOUT.value) {
            return false;
        } else {
            InternalError e = new InternalError();
            e.error_code = status;
            e.index = 0;
            throw e;
        }*/

    }

    /**
     * returns the last sample of the given instance
     * NOTA: userQuery is ignored because read_instance_with_condition is not implemented by Splice ...
     */
    public boolean get_one(DonneeHolder an_instance, ReadInfoHolder info)
            throws NonExistent, InternalError {
        Exception exp = null;

        try{
        try{
            initData(new DataSeqHolder<Donnee, DonneeHolder>(an_instance, Donnee.class), null, info);
            waitData();
        }catch(InternalError e){
            if(e.error_code == DDS.RETCODE_TIMEOUT.value) return false;
            else throw e;
        }

        long handle = reader.lookup_instance(an_instance.value);
        if (handle == DDS.HANDLE_NIL.value) {
            throw new NonExistent();
        }
        SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
        DonneeSeqHolder instances = new DonneeSeqHolder();
        int status = reader.read_instance(instances, infoSeq, LENGTH_UNLIMITED.value,
                handle,
                DDS.NOT_READ_SAMPLE_STATE.value,
                DDS.NEW_VIEW_STATE.value | DDS.NOT_NEW_VIEW_STATE.value,
                DDS.ALIVE_INSTANCE_STATE.value | DDS.NOT_ALIVE_INSTANCE_STATE.value);

        if (infoSeq.value[infoSeq.value.length - 1].valid_data) {
            an_instance.value = instances.value[infoSeq.value.length - 1];
        }
        return getOne(info, infoSeq.value, status);
        }catch(Exception e){
            exp = e;
        }

        throw new InternalError("Operation Failed: "+ exp.getMessage(), DDS.RETCODE_ERROR.value, 0);

 /*       ConditionSeqHolder condList = new ConditionSeqHolder();

        int status = waits._wait(condList, time_out);

        if (status == RETCODE_OK.value && condList.value[0] == readCond) {

            SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();

            long handle = reader.lookup_instance(an_instance.value);

            if (handle == DDS.HANDLE_NIL.value) {
                throw new NonExistent();
            }

            DonneeSeqHolder tmp = new DonneeSeqHolder();
            status = reader.read_instance(tmp, infoSeq, LENGTH_UNLIMITED.value,
                    handle,
                    DDS.NOT_READ_SAMPLE_STATE.value,
                    DDS.NEW_VIEW_STATE.value | DDS.NOT_NEW_VIEW_STATE.value,
                    DDS.ALIVE_INSTANCE_STATE.value | DDS.NOT_ALIVE_INSTANCE_STATE.value);



            if (status != RETCODE_OK.value) {
                InternalError e = new InternalError();
                e.error_code = status;
                e.index = 0;
                throw e;
            }

            int length = infoSeq.value.length;

            info.value = new ReadInfo();
            fillReadInfo(infoSeq.value[length - 1], info.value);

            if (infoSeq.value[length - 1].valid_data) {
                an_instance.value = tmp.value[length - 1];
            }

            return true;

        }

        if (status == DDS.RETCODE_TIMEOUT.value) {
            return false;
        } else {
            InternalError e = new InternalError();
            e.error_code = status;
            e.index = 0;
            throw e;
        }*/

    }

    /**
     * returns all the samples for the given instance
     * NOTA: userQuery ignored
     */
    public boolean get_one_history(Donnee an_instance,
            DonneeSeqHolder instances, ReadInfoSeqHolder infos)
            throws NonExistent, InternalError {
        Exception exp = null;

        try{
        try{
            initData(new DataSeqHolder<Donnee, DonneeSeqHolder>(Donnee[].class, instances), infos, null);
            waitData();
        }catch(InternalError e){
            if(e.error_code == DDS.RETCODE_TIMEOUT.value) return false;
            else throw e;
        }

        long handle = reader.lookup_instance(an_instance);

        if (handle == DDS.HANDLE_NIL.value) {
            throw new NonExistent();
        }
        SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();
        int status = reader.read_instance(instances, infoSeq,
                LENGTH_UNLIMITED.value, handle,
                DDS.NOT_READ_SAMPLE_STATE.value, DDS.NEW_VIEW_STATE.value
                        | DDS.NOT_NEW_VIEW_STATE.value,
                DDS.ALIVE_INSTANCE_STATE.value
                        | DDS.NOT_ALIVE_INSTANCE_STATE.value);

        return getOneHistory(infos, infoSeq.value, status);
        }catch(Exception e){
            exp = e;
        }

        throw new InternalError("Operation Failed: "+ exp.getMessage(), DDS.RETCODE_ERROR.value, 0);


  /*      ConditionSeqHolder condList = new ConditionSeqHolder();

        int status = waits._wait(condList, time_out);

        if (status == RETCODE_OK.value && condList.value[0] == readCond) {

            SampleInfoSeqHolder infoSeq = new SampleInfoSeqHolder();

            long handle = reader.lookup_instance(an_instance);

            if (handle == DDS.HANDLE_NIL.value) {
                throw new NonExistent();
            }

            status = reader.read_instance(instances, infoSeq,
                    LENGTH_UNLIMITED.value, handle,
                    DDS.NOT_READ_SAMPLE_STATE.value, DDS.NEW_VIEW_STATE.value
                            | DDS.NOT_NEW_VIEW_STATE.value,
                    DDS.ALIVE_INSTANCE_STATE.value
                            | DDS.NOT_ALIVE_INSTANCE_STATE.value);

            if (status != RETCODE_OK.value) {
                InternalError e = new InternalError();
                e.error_code = status;
                e.index = 0;
                throw e;
            }

            infos.value = new ReadInfo[infoSeq.value.length];

            for (int i = 0; i < infos.value.length; i++) {
                infos.value[i] = new ReadInfo();
                fillReadInfo(infoSeq.value[i], infos.value[i]);
            }

            return true;

        }

        if (status == DDS.RETCODE_TIMEOUT.value) {
            return false;
        } else {
            InternalError e = new InternalError();
            e.error_code = status;
            e.index = 0;
            throw e;
        }
*/
    }

//    public Duration_t time_out() {
//        return this.time_out;
//    }
//
//    public void time_out(Duration_t arg) {
//        this.time_out = arg;
//    }

}
