/* ===================================================================== */
/*
 * This file is part of MOSIC (R). MOSIC is a System@tic project.
 * 
 * MOSIC is derivative work based on CARDAMOM (R). CARDAMOM is jointly
 * developed by THALES and SELEX SISTEMI INTEGRATI.
 * CARDAMOM is derivative work based on PERCO.
 * Copyright (C) THALES 2009-2010. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */
package com.acme.Hello;

import DDS.RETCODE_NO_DATA;
import DDS.RETCODE_OK;

import org.omg.CCM_DDS.InternalError;
import org.omg.CCM_DDS.DDSEntityKind;
import org.omg.CCM_DDS.NoSuchDDSEntity;


public class Donnee_WriterFacetImpl extends org.omg.CORBA.LocalObject implements
        CCM_Donnee_Writer {

    private DonneeDataWriter talker;
    private int status;
    private long userHandle;

    public Donnee_WriterFacetImpl(DonneeDataWriter _talker) {
        this.talker = _talker;
    }

    public void write(Donnee an_instance) throws InternalError {
        userHandle = talker.register_instance(an_instance);
        status = talker.write(an_instance, userHandle);
        if (status != RETCODE_OK.value && status != RETCODE_NO_DATA.value) {
            InternalError e = new InternalError();
            e.error_code = status;
            throw e;
        }
    }

    public org.omg.CORBA.Object getDDSEntity(DDSEntityKind kind) throws NoSuchDDSEntity{
        return null;

    }

}